#pragma once
#include "Windows.h"
#include "GBMSAPI_Library.h"
#include "GBMSAPIExample_Util.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::IO;
using namespace System::Runtime::InteropServices;

extern unsigned char *CalibrationBuffer, *DummyCalibrationBuffer;


namespace GBMSAPICExample {

	/// <summary>
	/// Summary for CalibrationForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class CalibrationForm : public System::Windows::Forms::Form
	{
	public:
		CalibrationForm(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
			// default constructor not to be used
			// ver 2.10.0.0: use "2" function
			//FlatAreaRadioButton->Checked = true;
			this->rbFullFrameArea->Enabled = false;
			this->rbRollIqsArea->Enabled = false;
			this->rbRollGaArea->Enabled = false;
			this->rbRolledThenarArea->Enabled = false;
			this->rbRolledJointArea->Enabled = false;

			unsigned int scanA;
			int RetVal = GBMSAPI_GetSupportedScanAreas(&scanA);
			if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
			{
				GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(RetVal,"CalibrationForm,GBMSAPI_GetSupportedScanAreas");
				return;
			}
			if ((scanA & GBMSAPI_SA_FULL_FRAME) != 0)
			{
				this->rbFullFrameArea->Enabled = true;
			}
			if ((scanA & GBMSAPI_SA_ROLL_IQS) != 0)
			{
				this->rbRollIqsArea->Enabled = true;
			}
			if ((scanA & GBMSAPI_SA_ROLL_GA) != 0)
			{
				this->rbRollGaArea->Enabled = true;
			}
			if ((scanA & GBMSAPI_SA_ROLL_THENAR) != 0)
			{
				this->rbRolledThenarArea->Enabled = true;
			}
			if ((scanA & GBMSAPI_SA_ROLL_JOINT) != 0)
			{
				this->rbRolledJointArea->Enabled = true;
			}

			if (this->rbFullFrameArea->Enabled)
			{
				rbFullFrameArea->Checked = true;
				this->rbFullFrameArea_CheckedChanged(nullptr, nullptr);
			}
			else if (this->rbRollIqsArea->Enabled)
			{
				rbRollIqsArea->Checked = true;
				this->rbRollIqsArea_CheckedChanged(nullptr, nullptr);
			}
			else if (this->rbRollGaArea->Enabled)
			{
				rbRollGaArea->Checked = true;
				this->rbRollGaArea_CheckedChanged(nullptr, nullptr);
			}
			else if (this->rbRolledThenarArea->Enabled)
			{
				rbRolledThenarArea->Checked = true;
				this->rbRolledThenarArea_CheckedChanged(nullptr, nullptr);
			}
			else if (this->rbRolledJointArea->Enabled)
			{
				rbRolledJointArea->Checked = true;
				this->rbRolledJointArea_CheckedChanged(nullptr, nullptr);
			}
			else
			{
				MessageBox::Show("NO SCANNABLE AREAS AVAILABLE", "HEAVY ERROR!!!!");
				return;
			}
			// ver 2.10.0.0: use "2" function
			this->CalibrationImage = (IntPtr)CalibrationBuffer;
			this->OriginalImage = this->CalibrationImagePictureBox->Image;
		}
		
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~CalibrationForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::PictureBox^  CalibrationImagePictureBox;
	protected: 

	private: System::Windows::Forms::GroupBox^  groupBox1;

	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::TextBox^  ImSYTextBox;
	private: System::Windows::Forms::Label^  label13;

	private: System::Windows::Forms::TextBox^  ImSXTextBox;

	private: System::Windows::Forms::Label^  label14;
	private: System::Windows::Forms::Button^  CalibrateDeviceButton;
	private: System::Windows::Forms::Button^  SetFactoryCalibrationButton;
	private: System::Windows::Forms::ListBox^  DiagnosticListBox;
	private: System::Windows::Forms::Button^  SaveButton;
	private: System::Windows::Forms::Button^  GetNewCalibrationImageButton;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::GroupBox^  groupBox3;


	private: System::Windows::Forms::GroupBox^  groupBox4;
	private: System::Windows::Forms::GroupBox^  groupBox5;
	private: System::Windows::Forms::RadioButton^  rbRolledThenarArea;
	private: System::Windows::Forms::RadioButton^  rbRolledJointArea;
	private: System::Windows::Forms::RadioButton^  rbRollGaArea;
	private: System::Windows::Forms::RadioButton^  rbRollIqsArea;
	private: System::Windows::Forms::RadioButton^  rbFullFrameArea;

	// Needed properties
	protected:
		IntPtr CalibrationImage;
		int CalibrationImageSX;
		int CalibrationImageSY;
		unsigned int Diagnostic;
		// ver 2.10.0.0: use "2" functions for calibration
		//BOOL FlatScanArea;
		unsigned int ScanArea;
		// end ver 2.10.0.0: use "2" functions for calibration
		Image ^OriginalImage;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(CalibrationForm::typeid));
			this->CalibrationImagePictureBox = (gcnew System::Windows::Forms::PictureBox());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->DiagnosticListBox = (gcnew System::Windows::Forms::ListBox());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->ImSYTextBox = (gcnew System::Windows::Forms::TextBox());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->ImSXTextBox = (gcnew System::Windows::Forms::TextBox());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->CalibrateDeviceButton = (gcnew System::Windows::Forms::Button());
			this->SetFactoryCalibrationButton = (gcnew System::Windows::Forms::Button());
			this->SaveButton = (gcnew System::Windows::Forms::Button());
			this->GetNewCalibrationImageButton = (gcnew System::Windows::Forms::Button());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->rbRolledThenarArea = (gcnew System::Windows::Forms::RadioButton());
			this->rbRolledJointArea = (gcnew System::Windows::Forms::RadioButton());
			this->rbRollGaArea = (gcnew System::Windows::Forms::RadioButton());
			this->rbRollIqsArea = (gcnew System::Windows::Forms::RadioButton());
			this->rbFullFrameArea = (gcnew System::Windows::Forms::RadioButton());
			this->groupBox3 = (gcnew System::Windows::Forms::GroupBox());
			this->groupBox5 = (gcnew System::Windows::Forms::GroupBox());
			this->groupBox4 = (gcnew System::Windows::Forms::GroupBox());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->CalibrationImagePictureBox))->BeginInit();
			this->groupBox1->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->groupBox3->SuspendLayout();
			this->groupBox5->SuspendLayout();
			this->groupBox4->SuspendLayout();
			this->SuspendLayout();
			// 
			// CalibrationImagePictureBox
			// 
			this->CalibrationImagePictureBox->BackColor = System::Drawing::Color::White;
			this->CalibrationImagePictureBox->Location = System::Drawing::Point(28, 36);
			this->CalibrationImagePictureBox->Name = L"CalibrationImagePictureBox";
			this->CalibrationImagePictureBox->Size = System::Drawing::Size(600, 600);
			this->CalibrationImagePictureBox->TabIndex = 0;
			this->CalibrationImagePictureBox->TabStop = false;
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->DiagnosticListBox);
			this->groupBox1->Controls->Add(this->label1);
			this->groupBox1->Controls->Add(this->ImSYTextBox);
			this->groupBox1->Controls->Add(this->label13);
			this->groupBox1->Controls->Add(this->ImSXTextBox);
			this->groupBox1->Controls->Add(this->label14);
			this->groupBox1->Location = System::Drawing::Point(642, 244);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(310, 199);
			this->groupBox1->TabIndex = 1;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Calibration Image Info";
			// 
			// DiagnosticListBox
			// 
			this->DiagnosticListBox->FormattingEnabled = true;
			this->DiagnosticListBox->Location = System::Drawing::Point(8, 104);
			this->DiagnosticListBox->Name = L"DiagnosticListBox";
			this->DiagnosticListBox->Size = System::Drawing::Size(296, 82);
			this->DiagnosticListBox->TabIndex = 27;
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(6, 83);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(87, 13);
			this->label1->TabIndex = 26;
			this->label1->Text = L"Diagnostic Value";
			// 
			// ImSYTextBox
			// 
			this->ImSYTextBox->Location = System::Drawing::Point(111, 53);
			this->ImSYTextBox->Name = L"ImSYTextBox";
			this->ImSYTextBox->ReadOnly = true;
			this->ImSYTextBox->Size = System::Drawing::Size(100, 20);
			this->ImSYTextBox->TabIndex = 23;
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(5, 56);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(69, 13);
			this->label13->TabIndex = 22;
			this->label13->Text = L"Image Size Y";
			// 
			// ImSXTextBox
			// 
			this->ImSXTextBox->Location = System::Drawing::Point(112, 22);
			this->ImSXTextBox->Name = L"ImSXTextBox";
			this->ImSXTextBox->ReadOnly = true;
			this->ImSXTextBox->Size = System::Drawing::Size(100, 20);
			this->ImSXTextBox->TabIndex = 21;
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Location = System::Drawing::Point(6, 25);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(69, 13);
			this->label14->TabIndex = 20;
			this->label14->Text = L"Image Size X";
			// 
			// CalibrateDeviceButton
			// 
			this->CalibrateDeviceButton->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->CalibrateDeviceButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"CalibrateDeviceButton.Image")));
			this->CalibrateDeviceButton->Location = System::Drawing::Point(10, 20);
			this->CalibrateDeviceButton->Name = L"CalibrateDeviceButton";
			this->CalibrateDeviceButton->Size = System::Drawing::Size(127, 44);
			this->CalibrateDeviceButton->TabIndex = 2;
			this->CalibrateDeviceButton->Text = L"Calibrate";
			this->CalibrateDeviceButton->UseVisualStyleBackColor = true;
			this->CalibrateDeviceButton->Click += gcnew System::EventHandler(this, &CalibrationForm::CalibrateDeviceButton_Click);
			// 
			// SetFactoryCalibrationButton
			// 
			this->SetFactoryCalibrationButton->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
			this->SetFactoryCalibrationButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"SetFactoryCalibrationButton.Image")));
			this->SetFactoryCalibrationButton->Location = System::Drawing::Point(151, 20);
			this->SetFactoryCalibrationButton->Name = L"SetFactoryCalibrationButton";
			this->SetFactoryCalibrationButton->Size = System::Drawing::Size(119, 44);
			this->SetFactoryCalibrationButton->TabIndex = 3;
			this->SetFactoryCalibrationButton->Text = L"Set Factory";
			this->SetFactoryCalibrationButton->UseVisualStyleBackColor = true;
			this->SetFactoryCalibrationButton->Click += gcnew System::EventHandler(this, &CalibrationForm::SetFactoryCalibrationButton_Click);
			// 
			// SaveButton
			// 
			this->SaveButton->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->SaveButton->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"SaveButton.Image")));
			this->SaveButton->Location = System::Drawing::Point(16, 21);
			this->SaveButton->Name = L"SaveButton";
			this->SaveButton->Size = System::Drawing::Size(145, 46);
			this->SaveButton->TabIndex = 4;
			this->SaveButton->Text = L"SaveImage";
			this->SaveButton->UseVisualStyleBackColor = true;
			this->SaveButton->Click += gcnew System::EventHandler(this, &CalibrationForm::SaveButton_Click);
			// 
			// GetNewCalibrationImageButton
			// 
			this->GetNewCalibrationImageButton->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
			this->GetNewCalibrationImageButton->Location = System::Drawing::Point(153, 28);
			this->GetNewCalibrationImageButton->Name = L"GetNewCalibrationImageButton";
			this->GetNewCalibrationImageButton->Size = System::Drawing::Size(145, 46);
			this->GetNewCalibrationImageButton->TabIndex = 5;
			this->GetNewCalibrationImageButton->Text = L"Get New Image";
			this->GetNewCalibrationImageButton->UseVisualStyleBackColor = true;
			this->GetNewCalibrationImageButton->Click += gcnew System::EventHandler(this, &CalibrationForm::GetNewCalibrationImageButton_Click);
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->rbRolledThenarArea);
			this->groupBox2->Controls->Add(this->rbRolledJointArea);
			this->groupBox2->Controls->Add(this->rbRollGaArea);
			this->groupBox2->Controls->Add(this->rbRollIqsArea);
			this->groupBox2->Controls->Add(this->rbFullFrameArea);
			this->groupBox2->Controls->Add(this->GetNewCalibrationImageButton);
			this->groupBox2->Location = System::Drawing::Point(642, 39);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(310, 199);
			this->groupBox2->TabIndex = 6;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"Calibration Image Acquisition";
			// 
			// rbRolledThenarArea
			// 
			this->rbRolledThenarArea->AutoSize = true;
			this->rbRolledThenarArea->Location = System::Drawing::Point(12, 163);
			this->rbRolledThenarArea->Name = L"rbRolledThenarArea";
			this->rbRolledThenarArea->Size = System::Drawing::Size(148, 17);
			this->rbRolledThenarArea->TabIndex = 15;
			this->rbRolledThenarArea->TabStop = true;
			this->rbRolledThenarArea->Text = L"ROLLED THENAR AREA";
			this->rbRolledThenarArea->UseVisualStyleBackColor = true;
			this->rbRolledThenarArea->CheckedChanged += gcnew System::EventHandler(this, &CalibrationForm::rbRolledThenarArea_CheckedChanged);
			// 
			// rbRolledJointArea
			// 
			this->rbRolledJointArea->AutoSize = true;
			this->rbRolledJointArea->Location = System::Drawing::Point(12, 128);
			this->rbRolledJointArea->Name = L"rbRolledJointArea";
			this->rbRolledJointArea->Size = System::Drawing::Size(134, 17);
			this->rbRolledJointArea->TabIndex = 14;
			this->rbRolledJointArea->TabStop = true;
			this->rbRolledJointArea->Text = L"ROLLED JOINT AREA";
			this->rbRolledJointArea->UseVisualStyleBackColor = true;
			this->rbRolledJointArea->CheckedChanged += gcnew System::EventHandler(this, &CalibrationForm::rbRolledJointArea_CheckedChanged);
			// 
			// rbRollGaArea
			// 
			this->rbRollGaArea->AutoSize = true;
			this->rbRollGaArea->Location = System::Drawing::Point(12, 92);
			this->rbRollGaArea->Name = L"rbRollGaArea";
			this->rbRollGaArea->Size = System::Drawing::Size(103, 17);
			this->rbRollGaArea->TabIndex = 13;
			this->rbRollGaArea->TabStop = true;
			this->rbRollGaArea->Text = L"ROLL GA AREA";
			this->rbRollGaArea->UseVisualStyleBackColor = true;
			this->rbRollGaArea->CheckedChanged += gcnew System::EventHandler(this, &CalibrationForm::rbRollGaArea_CheckedChanged);
			// 
			// rbRollIqsArea
			// 
			this->rbRollIqsArea->AutoSize = true;
			this->rbRollIqsArea->Location = System::Drawing::Point(12, 57);
			this->rbRollIqsArea->Name = L"rbRollIqsArea";
			this->rbRollIqsArea->Size = System::Drawing::Size(106, 17);
			this->rbRollIqsArea->TabIndex = 12;
			this->rbRollIqsArea->TabStop = true;
			this->rbRollIqsArea->Text = L"ROLL IQS AREA";
			this->rbRollIqsArea->UseVisualStyleBackColor = true;
			this->rbRollIqsArea->CheckedChanged += gcnew System::EventHandler(this, &CalibrationForm::rbRollIqsArea_CheckedChanged);
			// 
			// rbFullFrameArea
			// 
			this->rbFullFrameArea->AutoSize = true;
			this->rbFullFrameArea->Location = System::Drawing::Point(12, 28);
			this->rbFullFrameArea->Name = L"rbFullFrameArea";
			this->rbFullFrameArea->Size = System::Drawing::Size(123, 17);
			this->rbFullFrameArea->TabIndex = 11;
			this->rbFullFrameArea->TabStop = true;
			this->rbFullFrameArea->Text = L"FULL FRAME AREA";
			this->rbFullFrameArea->UseVisualStyleBackColor = true;
			this->rbFullFrameArea->CheckedChanged += gcnew System::EventHandler(this, &CalibrationForm::rbFullFrameArea_CheckedChanged);
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->groupBox5);
			this->groupBox3->Controls->Add(this->groupBox4);
			this->groupBox3->Location = System::Drawing::Point(642, 449);
			this->groupBox3->Name = L"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(310, 185);
			this->groupBox3->TabIndex = 7;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = L"Calibration Image Setting";
			// 
			// groupBox5
			// 
			this->groupBox5->Controls->Add(this->CalibrateDeviceButton);
			this->groupBox5->Controls->Add(this->SetFactoryCalibrationButton);
			this->groupBox5->Location = System::Drawing::Point(12, 100);
			this->groupBox5->Name = L"groupBox5";
			this->groupBox5->Size = System::Drawing::Size(286, 72);
			this->groupBox5->TabIndex = 8;
			this->groupBox5->TabStop = false;
			this->groupBox5->Text = L"Device Calibration";
			// 
			// groupBox4
			// 
			this->groupBox4->Controls->Add(this->SaveButton);
			this->groupBox4->Location = System::Drawing::Point(12, 19);
			this->groupBox4->Name = L"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(200, 73);
			this->groupBox4->TabIndex = 8;
			this->groupBox4->TabStop = false;
			this->groupBox4->Text = L"Calibration Image Storage";
			// 
			// CalibrationForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(991, 666);
			this->Controls->Add(this->groupBox3);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->CalibrationImagePictureBox);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->Name = L"CalibrationForm";
			this->Text = L"Calibration Tool";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->CalibrationImagePictureBox))->EndInit();
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->groupBox3->ResumeLayout(false);
			this->groupBox5->ResumeLayout(false);
			this->groupBox4->ResumeLayout(false);
			this->ResumeLayout(false);

		}
#pragma endregion

	private:
		System::Void CalibrateDeviceButton_Click(System::Object^  sender, System::EventArgs^  e)
		{
			////////////////////////////
			// OPEN IMAGE FILE
			////////////////////////////
			OpenFileDialog ^ OFDlg = gcnew OpenFileDialog();
			OFDlg->Title = "Open Calibration Image";
			if (OFDlg->ShowDialog() != ::DialogResult::OK )
			{
				MessageBox::Show("Error in Opening File");
				return;
			}
			String ^fname = OFDlg->FileName;
			array<unsigned char,1> ^CalImageBytes = File::ReadAllBytes(fname);

			if (CalImageBytes->Length != (CalibrationImageSX) * (CalibrationImageSY))
			{
				MessageBox::Show("Error: file size not correct");
				return;
			}

			// allocate memory for image frame
			IntPtr ImageForCalibration = Marshal::AllocHGlobal((CalibrationImageSX) * (CalibrationImageSY));
			if (CalibrationImage == IntPtr::Zero) {
				MessageBox::Show("Not enough memory","ERROR");
				return;
			}

			// copy array into CalibrationImage
			Marshal::Copy(CalImageBytes,0,ImageForCalibration,CalImageBytes->Length);

			///////////////////////////////
			// CALIBRATE DEVICE
			///////////////////////////////
			// ver 2.10.0.0: use "2" functions
			//int RetVal = GBMSAPI_SetCalibrationImage(this->FlatScanArea,(unsigned char *)(ImageForCalibration.ToPointer()));
			int RetVal = GBMSAPI_SetCalibrationImage2(this->ScanArea,(unsigned char *)(ImageForCalibration.ToPointer()));
			// end ver 2.10.0.0: use "2" functions
			if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
			{
				GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(
					RetVal,"CalibrateDeviceButton_Click,GBMSAPI_SetCalibrationImage");
			}
			else
			{
				MessageBox::Show("Device Calibrated","Calibration results");
			}

			Marshal::FreeHGlobal(ImageForCalibration);
			return;			
		}

	private:
		System::Void SetFactoryCalibrationButton_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			///////////////////////////////
			// CALIBRATE DEVICE
			///////////////////////////////
			// ver 2.10.0.0: use "2" functions
			//int RetVal = GBMSAPI_SetCalibrationImage(this->FlatScanArea,(unsigned char *)(NULL));
			int RetVal = GBMSAPI_SetCalibrationImage2(this->ScanArea,(unsigned char *)NULL);
			// end ver 2.10.0.0: use "2" functions
			
			if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
			{
				GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(
					RetVal,"CalibrateDeviceButton_Click,GBMSAPI_SetCalibrationImage");
				return;
			}

			MessageBox::Show("Device Calibrated","Calibration results");
		}

	private:
		System::Void SaveButton_Click(System::Object^  sender, System::EventArgs^  e)
		{
			/////////////////////
			// SAVE FILE
			/////////////////////
			unsigned char DeviceID;
			char DeviceSerialNumber[GBMSAPI_MAX_SN_LENGHT];

			// Get Serial Number and ID
			int RetVal = GBMSAPI_GetCurrentDevice(
			 &DeviceID, DeviceSerialNumber);

			if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
			{
				GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(
					RetVal,"CalibrateDeviceButton_Click,GBMSAPI_GetCurrentDevice");
				return;
			}

			// build file name
			String ^FName = GBMSAPI_Example_Util::GBMSAPI_Example_GetDevNameFromDevID(DeviceID) + "_" +
				gcnew String(DeviceSerialNumber) + "_" +
				// ver 2.10.0.0
				//((this->FlatScanArea == TRUE)?("FLAT"):("ROLL")) +
				this->GetAreaNameFromCheckedRadioButton() +
				// end ver 2.10.0.0
				".raw";

			// build image array for saving
			array<unsigned char> ^CalImageArray = gcnew array<unsigned char>(this->CalibrationImageSX * this->CalibrationImageSY);
			if (CalImageArray == nullptr)
			{
				MessageBox::Show("MEMORY ALLOCATION ERROR in CalibrateDeviceButton_Click(): close application","HEAVY ERROR");
				return;
			}

			Marshal::Copy(this->CalibrationImage,CalImageArray,0,CalImageArray->Length);

			// save image on file
			System::IO::FileStream ^FS = System::IO::File::Create(FName);
			if (FS != nullptr)
			{
				FS->Write(CalImageArray,0,CalImageArray->Length);
				FS->Close();
				MessageBox::Show("Image saved in " + FName,"Calibration results");
			}
			else
			{
				MessageBox::Show("Cannot save file " + FName,"WARNING");
			}
		}

	private:
		System::Void GetNewCalibrationImageButton_Click(System::Object^  sender, System::EventArgs^  e)
		{
			try
			{
				unsigned int CalibrationDiagnostic;

				// ver 2.10.0.0: use "2" functions
				//int RetVal = GBMSAPI_GetCalibrationImage(
				//	this->FlatScanArea,
				//	CalibrationBuffer,
				//	&CalibrationDiagnostic);
				int RetVal = GBMSAPI_GetCalibrationImage2(
					this->ScanArea,
					CalibrationBuffer,
					&CalibrationDiagnostic);
				// end ver 2.10.0.0: use "2" functions
				if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
				{
					GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(
						RetVal,"CalibrateDeviceToolStripButton_Click,GBMSAPI_GetCalibrationImage");
					return;
				}

				// show diagnostic
				this->Diagnostic = CalibrationDiagnostic;
				this->DiagnosticListBox->Items->Clear();
				if (CalibrationDiagnostic != 0)
				{
					List<String ^> ^DiagList = GBMSAPI_Example_Util::GetDiagStringsFromDiagMask(CalibrationDiagnostic);
					if ((DiagList != nullptr) && (DiagList->Count > 0))
					{
						for (int i = 0; i < DiagList->Count; i ++)
						{
							this->DiagnosticListBox->Items->Add(DiagList[i]);
						}
					}
				}

				int stride;
				unsigned char *BmpBuffer;
				if ((CalibrationImageSX %4) != 0)
				{
					stride = CalibrationImageSX - (CalibrationImageSX %4);
					unsigned char *PtrToOriginal = CalibrationBuffer,
						* PtrToStrided = DummyCalibrationBuffer;
					for (int i = 0; i < CalibrationImageSY;
						i ++, PtrToOriginal += CalibrationImageSX, PtrToStrided += stride)
					{
						memcpy(PtrToStrided,PtrToOriginal,stride);
					}

					BmpBuffer = DummyCalibrationBuffer;
				}
				else
				{
					stride = CalibrationImageSX;
					BmpBuffer = CalibrationBuffer;
				}
				
				// draw image
				this->CalibrationImagePictureBox->Image = gcnew Bitmap(
					CalibrationImageSX, CalibrationImageSY,
					stride,
					Imaging::PixelFormat::Format8bppIndexed,
					(IntPtr)BmpBuffer
					);
				Imaging::ColorPalette ^ pal = this->CalibrationImagePictureBox->Image->Palette;
				for (int i = 0; i < pal->Entries->Length; i++)
				{
					pal->Entries[i] = Color::FromArgb(255, i, i, i);
				}
				this->CalibrationImagePictureBox->Image->Palette = pal;
				this->CalibrationImagePictureBox->SizeMode = PictureBoxSizeMode::StretchImage;

				this->SaveButton->Enabled = true;

				this->Update();
			}
			catch(Exception ^ex)
			{
				MessageBox::Show("Exception in GetNewCalibrationImageButton_Click: " + ex->Message);
			}
		}

	private: 
		// ver 2.10.0.0: use "2" functions for calibration
		//System::Void FlatAreaRadioButton_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		//	if (FlatAreaRadioButton->Checked == true)
		//	{
		//		this->FlatScanArea = TRUE;
		//	}
		//	else
		//	{
		//		this->FlatScanArea = FALSE;
		//	}
		//	unsigned int ImSX,ImSY;
		//	
		//	int RetVal = GBMSAPI_GetCalibrationImageSize(FlatScanArea,&ImSX,&ImSY);
		//	if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
		//	{
		//		GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(
		//			RetVal,"CalibrateDeviceToolStripButton_Click,GBMSAPI_GetCalibrationImageSize");
		//		this->Close();
		//		return;
		//	}
		//	CalibrationImageSX = ImSX;
		//	CalibrationImageSY = ImSY;

		//	this->ImSXTextBox->Text = "" + CalibrationImageSX;
		//	this->ImSYTextBox->Text = "" + CalibrationImageSY;

		//	this->DiagnosticListBox->Items->Clear();
		//	this->CalibrationImagePictureBox->Image = this->OriginalImage;

		//	this->SaveButton->Enabled = false;
		// }
		// end ver 2.10.0.0: use "2" functions for calibration


		// ver 2.10.0.0: use "2" functions for calibration
		private: String ^GetAreaNameFromCheckedRadioButton()
		{
			if (this->rbFullFrameArea->Enabled && this->rbFullFrameArea->Checked)
			{
				return "FULL_FRAME";
			}
			if (this->rbRolledJointArea->Enabled && this->rbRolledJointArea->Checked)
			{
				return "ROLL_JOINT";
			}
			if (this->rbRolledThenarArea->Enabled && this->rbRolledThenarArea->Checked)
			{
				return "ROLL_THENAR";
			}
			if (this->rbRollGaArea->Enabled && this->rbRollGaArea->Checked)
			{
				return "ROLL_GA";
			}
			if (this->rbRollIqsArea->Enabled && this->rbRollIqsArea->Checked)
			{
				return "ROLL_IQS";
			}
			return "";
		}
		private: void SetScanArea(unsigned int scanA)
		{
			this->ScanArea = scanA;
			unsigned int ImSX, ImSY;
			int RetVal = GBMSAPI_GetCalibrationImageSize2(
					this->ScanArea, &ImSX, &ImSY
				);

			if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
			{
				GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(RetVal,
					"FlatAreaRadioButton_CheckedChanged,GBMSAPI_NET_GetCalibrationImageSize");
				return;
			}

			CalibrationImageSX = (int)ImSX;
			CalibrationImageSY = (int)ImSY;

			if (CalibrationBuffer != NULL) free(CalibrationBuffer);
			if (DummyCalibrationBuffer != NULL) free(DummyCalibrationBuffer);

			CalibrationBuffer = new unsigned char [CalibrationImageSX * CalibrationImageSY];
			DummyCalibrationBuffer = new unsigned char [CalibrationImageSX * CalibrationImageSY];
			if (CalibrationBuffer == NULL ||
				DummyCalibrationBuffer == NULL)
			{
				MessageBox::Show("CalibrationForm, SetScanArea: Memory allocation failed", "FATAL ERROR");
				return;
			}

			this->CalibrationImage = (IntPtr)CalibrationBuffer;
			this->ImSXTextBox->Text = "" + CalibrationImageSX;
			this->ImSYTextBox->Text = "" + CalibrationImageSY;

			this->DiagnosticListBox->Items->Clear();
			this->CalibrationImagePictureBox->Image = this->OriginalImage;

			this->SaveButton->Enabled = false;
		}
private: 
	System::Void rbFullFrameArea_CheckedChanged(System::Object^  sender, System::EventArgs^  e){
		if (rbFullFrameArea->Checked == true)
		{
			SetScanArea(GBMSAPI_SA_FULL_FRAME);
		}
		else
		{
			return;
		}
	}
private: 
	System::Void rbRollIqsArea_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		if (rbRollIqsArea->Checked == true)
		{
			SetScanArea(GBMSAPI_SA_ROLL_IQS);
		}
		else
		{
			return;
		}
	}
private: 
	System::Void rbRollGaArea_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		if (rbRollGaArea->Checked == true)
		{
			SetScanArea(GBMSAPI_SA_ROLL_GA);
		}
		else
		{
			return;
		}
	}
private: 
	System::Void rbRolledJointArea_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		if (rbRolledJointArea->Checked == true)
		{
			SetScanArea(GBMSAPI_SA_ROLL_JOINT);
		}
		else
		{
			return;
		}
	}
private: 
	System::Void rbRolledThenarArea_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		if (rbRolledThenarArea->Checked == true)
		{
			SetScanArea(GBMSAPI_SA_ROLL_THENAR);
		}
		else
		{
			return;
		}
	}
	// end ver 2.10.0.0: use "2" functions for calibration
};
}
