#include "stdafx.h"
#include "windows.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "GBMSAPIExampleMainForm.h"
#include "GBMSAPI_Defines.h"
#include "GBMSAPI_Library.h"
#include "GBMSAPIExample_Util.h"

GBMSAPI_DeviceInfoStruct AttachedDeviceList[GBMSAPI_MAX_PLUGGED_DEVICE_NUM];// ver 2.10.0.0
// ver 2.10.0.0
bool IsRolled(unsigned int ObjTypeToScan)
{
	if (
		(ObjTypeToScan == GBMSAPI_SBT_ROLL_SINGLE_FINGER) ||
		(ObjTypeToScan == GBMSAPI_SBT_ROLLED_JOINT) ||
		(ObjTypeToScan == GBMSAPI_SBT_ROLLED_JOINT_CENTER) ||
		(ObjTypeToScan == GBMSAPI_SBT_ROLLED_THENAR) ||
		(ObjTypeToScan == GBMSAPI_SBT_ROLLED_TIP) ||
		// ver 3.2.0.0
		(ObjTypeToScan == GBMSAPI_SBT_ROLLED_UP) ||
		(ObjTypeToScan == GBMSAPI_SBT_ROLLED_DOWN) ||
		// end ver 3.2.0.0
		// ver 3.3.0.0
		(ObjTypeToScan == GBMSAPI_SBT_ROLLED_HYPOTHENAR)
		// end ver 3.3.0.0
		) return true;

	return false;
}
// end ver 2.10.0.0

namespace GBMSAPICExample {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Collections::Generic;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;

	String ^GBMSAPI_Example_Util::GBMSAPI_Example_GetDevNameFromDevID(Byte DevID)
	{
		try
		{
			String ^RetVal = nullptr;
			switch (DevID)
			{
			case GBMSAPI_DN_DS84:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::DS84_NameStr;
					break;
				}
			case GBMSAPI_DN_DS26:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::DS26_NameStr;
					break;
				}
			case GBMSAPI_DN_MS500:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::MS500_NameStr;
					break;
				}
			case GBMSAPI_DN_MS1000:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::MS1000_NameStr;
					break;
				}
			case GBMSAPI_DN_VS3:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::VS3_NameStr;
					break;
				}
			case GBMSAPI_DN_PS2:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::PS2_NameStr;
					break;
				}
			case GBMSAPI_DN_DS40:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::DS40_NameStr;
					break;
				}
			case GBMSAPI_DN_DS40I:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::DS40I_NameStr;
					break;
				}
			case GBMSAPI_DN_MC500:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::MC500_NameStr;
					break;
				}
			case GBMSAPI_DN_MSC500:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::MSC500_NameStr;
					break;
				}
			case GBMSAPI_DN_DS84C:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::DS84C_NameStr;
					break;
				}
			case GBMSAPI_DN_MC517:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::MC517_NameStr; // VER 2800
					break;
				}
			case GBMSAPI_DN_MSC517:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::MSC517_NameStr; // VER 2800
					break;
				}
			case GBMSAPI_DN_DS32:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::DS32_NameStr;
					break;
				}
			case GBMSAPI_DN_MS527:
				{
					RetVal = GBMSAPI_Example_DevNameStrings::MS527_NameStr; // Ver 2.10.0.0
					break;
				}
			default:
				break;
			}

			return RetVal;
		}
		catch (Exception ^ex)
		{
			MessageBox::Show("Exception in GBMSAPI_Example_GetDevNameFromDevID: " + ex->Message);
			return nullptr;
		}
	}

	Byte GBMSAPI_Example_Util::GBMSAPI_Example_GetDevIDFromDevName(String ^ DevName)
	{
		try
		{
			Byte RetVal = 0;

			if (DevName == GBMSAPI_Example_DevNameStrings::DS40_NameStr)
			{
				RetVal = GBMSAPI_DN_DS40;
			}
			if (DevName == GBMSAPI_Example_DevNameStrings::DS40I_NameStr)
			{
				RetVal = GBMSAPI_DN_DS40I;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::DS84_NameStr)
			{
				RetVal = GBMSAPI_DN_DS84;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::DS26_NameStr)
			{
				RetVal = GBMSAPI_DN_DS26;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::MS1000_NameStr)
			{
				RetVal = GBMSAPI_DN_MS1000;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::MS500_NameStr)
			{
				RetVal = GBMSAPI_DN_MS500;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::MC500_NameStr)
			{
				RetVal = GBMSAPI_DN_MC500;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::MSC500_NameStr)
			{
				RetVal = GBMSAPI_DN_MSC500;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::PS2_NameStr)
			{
				RetVal = GBMSAPI_DN_PS2;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::VS3_NameStr)
			{
				RetVal = GBMSAPI_DN_VS3;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::DS84C_NameStr)
			{
				RetVal = GBMSAPI_DN_DS84C;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::MC517_NameStr)
			{
				RetVal = GBMSAPI_DN_MC517;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::MSC517_NameStr)
			{
				RetVal = GBMSAPI_DN_MSC517;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::DS32_NameStr)
			{
				RetVal = GBMSAPI_DN_DS32;
			}
			else if (DevName == GBMSAPI_Example_DevNameStrings::MS527_NameStr)
			{
				RetVal = GBMSAPI_DN_MS527; // Ver 2.10.0.0
			}

			return RetVal;
		}
		catch (Exception ^ex)
		{
			MessageBox::Show("Exception in GBMSAPI_Example_GetDevIDFromDevName: " + ex->Message);
			return 0;
		}
	}

	// Ver 2300: get error string from error code
	String ^ GBMSAPI_Example_Util::GBMSAPI_Example_GetErrorStringFromCode(Int32 ErrorCode)
	{
		switch (ErrorCode)
		{
		case (GBMSAPI_ERROR_CODE_NO_ERROR):
			{
				return "NO_ERROR";
			}
			break;
		case (GBMSAPI_ERROR_CODE_USB_DRIVER):
			{
				return "USB_DRIVER";
			}
			break;
		case (GBMSAPI_ERROR_CODE_DEVICE_NOT_FOUND):
			{
				return "DEVICE_NOT_FOUND";
			}
			break;
		case (GBMSAPI_ERROR_CODE_USB_THREAD):
			{
				return "USB_THREAD";
			}
			break;
		case (GBMSAPI_ERROR_CODE_PARAMETER):
			{
				return "PARAMETER";
			}
			break;
		case (GBMSAPI_ERROR_CODE_SCANNER_NOT_CONFIGURED):
			{
				return "SCANNER_NOT_CONFIGURED";
			}
			break;
		case (GBMSAPI_ERROR_CODE_DEVICE_NOT_RESPONDING):
			{
				return "DEVICE_NOT_RESPONDING";
			}
			break;
		case (GBMSAPI_ERROR_CODE_SCANNER_COMMUNICATION):
			{
				return "SCANNER_COMMUNICATION";
			}
			break;
		case (GBMSAPI_ERROR_CODE_UNAVAILABLE_OPTION):
			{
				return "UNAVAILABLE_OPTION";
			}
			break;
		case (GBMSAPI_ERROR_CODE_INTERNAL):
			{
				return "INTERNAL";
			}
			break;
		case (GBMSAPI_ERROR_CODE_SPECIFIC_DLL_NOT_LOADED):
			{
				return "SPECIFIC_DLL_NOT_LOADED";
			}
			break;
		case (GBMSAPI_ERROR_CODE_METHOD_NOT_SUPPORTED):
			{
				return "METHOD_NOT_SUPPORTED";
			}
			break;
		case (GBMSAPI_ERROR_CODE_OBJECT_TYPE_NOT_SUPPORTED):
			{
				return "OBJECT_TYPE_NOT_SUPPORTED";
			}
			break;
		case (GBMSAPI_ERROR_CODE_SCAN_AREA_NOT_SUPPORTED):
			{
				return "SCAN_AREA_NOT_SUPPORTED";
			}
			break;
		case (GBMSAPI_ERROR_CODE_ACQUISITION_THREAD):
			{
				return "ACQUISITION_THREAD";
			}
			break;
		case (GBMSAPI_ERROR_CODE_ACQUISITION_ALREADY_STARTED):
			{
				return "ACQUISITION_ALREADY_STARTED";
			}
			break;
		case (GBMSAPI_ERROR_CODE_FEATURE_NOT_SUPPORTED):
			{
				return "FEATURE_NOT_SUPPORTED";
			}
			break;
		case (GBMSAPI_ERROR_CODE_CURRENT_DEV_NOT_SET):
			{
				return "CURRENT_DEV_NOT_SET";
			}
			break;
		case (GBMSAPI_ERROR_CODE_MEMORY_ALLOCATION):
			{
				return "MEMORY_ALLOCATION";
			}
			break;
		case (GBMSAPI_ERROR_CODE_GENERIC):
			{
				return "GENERIC";
			}
			break;
		}
		return "";
	}

	void GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(Int32 ErrorCode, String ^FunctionName)
	{
		try
		{
			String ^ StrToShow = "Error Code = " + GBMSAPI_Example_Util::GBMSAPI_Example_GetErrorStringFromCode(ErrorCode) +
				" in function " + FunctionName;
			if (ErrorCode == GBMSAPI_ERROR_CODE_USB_DRIVER)
			{
				UInt32 USBErrorCode = 0;
				int RetVal = GBMSAPI_GetUSBErrorCode((unsigned long *)(&USBErrorCode));
				if (RetVal == GBMSAPI_ERROR_CODE_NO_ERROR)
				{
					StrToShow += "; USB Error Code = 0x" + USBErrorCode.ToString("X8");
				}
			}
			MessageBox::Show(StrToShow);
		}
		catch (Exception ^ex)
		{
			MessageBox::Show("Exception in GBMSAPI_Example_ManageErrors: " + ex->Message);
			return;
		}
	}

	void GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(Int32 ErrorCode, unsigned long USBErrorCode, String ^FunctionName)
	{
		try
		{
			String ^ StrToShow = "Error Code = " + GBMSAPI_Example_Util::GBMSAPI_Example_GetErrorStringFromCode(ErrorCode) +
				" in function " + FunctionName;
			StrToShow += "; USB Error Code = 0x" + USBErrorCode.ToString("X8");

			MessageBox::Show(StrToShow);
		}
		catch (Exception ^ex)
		{
			MessageBox::Show("Exception in GBMSAPI_Example_ManageErrors: " + ex->Message);
			return;
		}
	}

	array<String ^> ^ GBMSAPI_Example_Util::GetObjectsToScanListFromObjectType(unsigned int ObjType)
	{
		// check that ObjType is supported
		unsigned int SupportedTypes = 0;

		int RetVal = GBMSAPI_GetScannableTypes(&SupportedTypes);
		if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
		{
			GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(
				RetVal,"GetObjectsToScanListFromObjectType,GBMSAPI_GetScannableTypes");
			return nullptr;
		}
		if ((ObjType & SupportedTypes) == 0)
		{
			MessageBox::Show("GetObjectsToScanListFromObjectType error: Object not supported");
			return nullptr;
		}

		switch (ObjType)
		{
		case GBMSAPI_SBT_ROLL_SINGLE_FINGER:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RollLeftIndex_Str;
				ObjToScanList[1] = ScannableObjectStrings::RollLeftMiddle_Str;
				ObjToScanList[2] = ScannableObjectStrings::RollLeftRing_Str;
				ObjToScanList[3] = ScannableObjectStrings::RollLeftLittle_Str;
				ObjToScanList[4] = ScannableObjectStrings::RollLeftThumb_Str;
				ObjToScanList[5] = ScannableObjectStrings::RollRightIndex_Str;
				ObjToScanList[6] = ScannableObjectStrings::RollRightMiddle_Str;
				ObjToScanList[7] = ScannableObjectStrings::RollRightRing_Str;
				ObjToScanList[8] = ScannableObjectStrings::RollRightLittle_Str;
				ObjToScanList[9] = ScannableObjectStrings::RollRightThumb_Str;

				return ObjToScanList;
			}

			// ver 3.2.0.0
		case GBMSAPI_SBT_ROLLED_UP:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RolledTopLeftThumb_Str;
				ObjToScanList[1] = ScannableObjectStrings::RolledTopLeftIndex_Str;
				ObjToScanList[2] = ScannableObjectStrings::RolledTopLeftLittle_Str;
				ObjToScanList[3] = ScannableObjectStrings::RolledTopLeftRing_Str;
				ObjToScanList[4] = ScannableObjectStrings::RolledTopLeftLittle_Str;
				ObjToScanList[5] = ScannableObjectStrings::RolledTopRightThumb_Str;
				ObjToScanList[6] = ScannableObjectStrings::RolledTopRightIndex_Str;
				ObjToScanList[7] = ScannableObjectStrings::RolledTopRightMiddle_Str;
				ObjToScanList[8] = ScannableObjectStrings::RolledTopRightRing_Str;
				ObjToScanList[9] = ScannableObjectStrings::RolledTopRightLittle_Str;

				return ObjToScanList;
			}
		case GBMSAPI_SBT_ROLLED_DOWN:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RolledDownLeftThumb_Str;
				ObjToScanList[1] = ScannableObjectStrings::RolledDownLeftIndex_Str;
				ObjToScanList[2] = ScannableObjectStrings::RolledDownLeftLittle_Str;
				ObjToScanList[3] = ScannableObjectStrings::RolledDownLeftRing_Str;
				ObjToScanList[4] = ScannableObjectStrings::RolledDownRightLittle_Str;
				ObjToScanList[5] = ScannableObjectStrings::RolledDownRightThumb_Str;
				ObjToScanList[6] = ScannableObjectStrings::RolledDownRightIndex_Str;
				ObjToScanList[7] = ScannableObjectStrings::RolledDownRightMiddle_Str;
				ObjToScanList[8] = ScannableObjectStrings::RolledDownRightRing_Str;
				ObjToScanList[9] = ScannableObjectStrings::RolledDownRightLittle_Str;

				return ObjToScanList;
			}
			// end ver 3.2.0.0

		case GBMSAPI_SBT_FLAT_SINGLE_FINGER:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::FlatLeftIndex_Str;
				ObjToScanList[1] = ScannableObjectStrings::FlatLeftMiddle_Str;
				ObjToScanList[2] = ScannableObjectStrings::FlatLeftRing_Str;
				ObjToScanList[3] = ScannableObjectStrings::FlatLeftLittle_Str;
				ObjToScanList[4] = ScannableObjectStrings::FlatLeftThumb_Str;
				ObjToScanList[5] = ScannableObjectStrings::FlatRightIndex_Str;
				ObjToScanList[6] = ScannableObjectStrings::FlatRightMiddle_Str;
				ObjToScanList[7] = ScannableObjectStrings::FlatRightRing_Str;
				ObjToScanList[8] = ScannableObjectStrings::FlatRightLittle_Str;
				ObjToScanList[9] = ScannableObjectStrings::FlatRightThumb_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_FLAT_THUMBS_2:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(1);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::Slap2Thumbs_Str;

				return ObjToScanList;
			}

			// VER 2000
		case GBMSAPI_SBT_FLAT_INDEXES_2:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(1);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::Slap2Indexes_Str;

				return ObjToScanList;
			}
			// end VER 2000

		case GBMSAPI_SBT_FLAT_SLAP_4:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(2);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::Slap4Right_Str;
				ObjToScanList[1] = ScannableObjectStrings::Slap4Left_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_FLAT_SLAP_2:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(2);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::Slap2Right_Str;
				ObjToScanList[1] = ScannableObjectStrings::Slap2Left_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_FLAT_UPPER_HALF_PALM:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(2);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::UpperHalfPalmRight_Str;
				ObjToScanList[1] = ScannableObjectStrings::UpperHalfPalmLeft_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_FLAT_LOWER_HALF_PALM:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(2);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::LowerHalfPalmRight_Str;
				ObjToScanList[1] = ScannableObjectStrings::LowerHalfPalmLeft_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_FLAT_WRITER_PALM:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(2);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::WriterPalmRight_Str;
				ObjToScanList[1] = ScannableObjectStrings::WriterPalmLeft_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_PHOTO:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(1);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::Photo_Str;

				return ObjToScanList;
			}
		// ver 3.3.0.0
		case GBMSAPI_SBT_ROLLED_HYPOTHENAR:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(2);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RolledHypoThenarRight_Str;
				ObjToScanList[1] = ScannableObjectStrings::RolledHypoThenarLeft_Str;

				return ObjToScanList;
			}
		// end ver 3.3.0.0

			// Ver 2.10.0.0
		case GBMSAPI_SBT_ROLLED_THENAR:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(2);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RolledThenarRight_Str;
				ObjToScanList[1] = ScannableObjectStrings::RolledThenarLeft_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_ROLLED_JOINT:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RolledJointLeftIndex_Str;
				ObjToScanList[1] = ScannableObjectStrings::RolledJointLeftMiddle_Str;
				ObjToScanList[2] = ScannableObjectStrings::RolledJointLeftRing_Str;
				ObjToScanList[3] = ScannableObjectStrings::RolledJointLeftLittle_Str;
				ObjToScanList[4] = ScannableObjectStrings::RolledJointLeftThumb_Str;
				ObjToScanList[5] = ScannableObjectStrings::RolledJointRightIndex_Str;
				ObjToScanList[6] = ScannableObjectStrings::RolledJointRightMiddle_Str;
				ObjToScanList[7] = ScannableObjectStrings::RolledJointRightRing_Str;
				ObjToScanList[8] = ScannableObjectStrings::RolledJointRightLittle_Str;
				ObjToScanList[9] = ScannableObjectStrings::RolledJointRightThumb_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_PLAIN_JOINT_LEFT_SIDE:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::PlainJointLeftSideLeftIndex_Str;
				ObjToScanList[1] = ScannableObjectStrings::PlainJointLeftSideLeftMiddle_Str;
				ObjToScanList[2] = ScannableObjectStrings::PlainJointLeftSideLeftRing_Str;
				ObjToScanList[3] = ScannableObjectStrings::PlainJointLeftSideLeftLittle_Str;
				ObjToScanList[4] = ScannableObjectStrings::PlainJointLeftSideLeftThumb_Str;
				ObjToScanList[5] = ScannableObjectStrings::PlainJointLeftSideRightIndex_Str;
				ObjToScanList[6] = ScannableObjectStrings::PlainJointLeftSideRightMiddle_Str;
				ObjToScanList[7] = ScannableObjectStrings::PlainJointLeftSideRightRing_Str;
				ObjToScanList[8] = ScannableObjectStrings::PlainJointLeftSideRightLittle_Str;
				ObjToScanList[9] = ScannableObjectStrings::PlainJointLeftSideRightThumb_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_PLAIN_JOINT_RIGHT_SIDE:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::PlainJointRightSideLeftIndex_Str;
				ObjToScanList[1] = ScannableObjectStrings::PlainJointRightSideLeftMiddle_Str;
				ObjToScanList[2] = ScannableObjectStrings::PlainJointRightSideLeftRing_Str;
				ObjToScanList[3] = ScannableObjectStrings::PlainJointRightSideLeftLittle_Str;
				ObjToScanList[4] = ScannableObjectStrings::PlainJointRightSideLeftThumb_Str;
				ObjToScanList[5] = ScannableObjectStrings::PlainJointRightSideRightIndex_Str;
				ObjToScanList[6] = ScannableObjectStrings::PlainJointRightSideRightMiddle_Str;
				ObjToScanList[7] = ScannableObjectStrings::PlainJointRightSideRightRing_Str;
				ObjToScanList[8] = ScannableObjectStrings::PlainJointRightSideRightLittle_Str;
				ObjToScanList[9] = ScannableObjectStrings::PlainJointRightSideRightThumb_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_ROLLED_JOINT_CENTER:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RolledJointCenterLeftIndex_Str;
				ObjToScanList[1] = ScannableObjectStrings::RolledJointCenterLeftMiddle_Str;
				ObjToScanList[2] = ScannableObjectStrings::RolledJointCenterLeftRing_Str;
				ObjToScanList[3] = ScannableObjectStrings::RolledJointCenterLeftLittle_Str;
				ObjToScanList[4] = ScannableObjectStrings::RolledJointCenterLeftThumb_Str;
				ObjToScanList[5] = ScannableObjectStrings::RolledJointCenterRightIndex_Str;
				ObjToScanList[6] = ScannableObjectStrings::RolledJointCenterRightMiddle_Str;
				ObjToScanList[7] = ScannableObjectStrings::RolledJointCenterRightRing_Str;
				ObjToScanList[8] = ScannableObjectStrings::RolledJointCenterRightLittle_Str;
				ObjToScanList[9] = ScannableObjectStrings::RolledJointCenterRightThumb_Str;

				return ObjToScanList;
			}

		case GBMSAPI_SBT_ROLLED_TIP:
			{
				array<String ^> ^ObjToScanList = gcnew array<String ^>(10);
				if (ObjToScanList == nullptr)
				{
					MessageBox::Show("MEMORY ERROR!!! Close application");
					return nullptr;
				}
				ObjToScanList[0] = ScannableObjectStrings::RolledTipLeftIndex_Str;
				ObjToScanList[1] = ScannableObjectStrings::RolledTipLeftMiddle_Str;
				ObjToScanList[2] = ScannableObjectStrings::RolledTipLeftRing_Str;
				ObjToScanList[3] = ScannableObjectStrings::RolledTipLeftLittle_Str;
				ObjToScanList[4] = ScannableObjectStrings::RolledTipLeftThumb_Str;
				ObjToScanList[5] = ScannableObjectStrings::RolledTipRightIndex_Str;
				ObjToScanList[6] = ScannableObjectStrings::RolledTipRightMiddle_Str;
				ObjToScanList[7] = ScannableObjectStrings::RolledTipRightRing_Str;
				ObjToScanList[8] = ScannableObjectStrings::RolledTipRightLittle_Str;
				ObjToScanList[9] = ScannableObjectStrings::RolledTipRightThumb_Str;

				return ObjToScanList;
			}
			// end Ver 2.10.0.0
		}

		return nullptr;
	}

	String ^ GBMSAPI_Example_Util::GetObjectToScanNameFromID(unsigned int ObjToScan)
	{
		switch (ObjToScan)
		{
			// FLAT FINGERS
		case GBMSAPI_SO_FLAT_RIGHT_THUMB:
			{
				return ScannableObjectStrings::FlatRightThumb_Str;
			}
		case GBMSAPI_SO_FLAT_RIGHT_INDEX:
			{
				return ScannableObjectStrings::FlatRightIndex_Str;
			}
		case GBMSAPI_SO_FLAT_RIGHT_MIDDLE:
			{
				return ScannableObjectStrings::FlatRightMiddle_Str;
			}
		case GBMSAPI_SO_FLAT_RIGHT_RING:
			{
				return ScannableObjectStrings::FlatRightRing_Str;
			}
		case GBMSAPI_SO_FLAT_RIGHT_LITTLE:
			{
				return ScannableObjectStrings::FlatRightLittle_Str;
			}
		case GBMSAPI_SO_FLAT_LEFT_THUMB:
			{
				return ScannableObjectStrings::FlatLeftThumb_Str;
			}
		case GBMSAPI_SO_FLAT_LEFT_INDEX:
			{
				return ScannableObjectStrings::FlatLeftIndex_Str;
			}
		case GBMSAPI_SO_FLAT_LEFT_MIDDLE:
			{
				return ScannableObjectStrings::FlatLeftMiddle_Str;
			}
		case GBMSAPI_SO_FLAT_LEFT_RING:
			{
				return ScannableObjectStrings::FlatLeftRing_Str;
			}
		case GBMSAPI_SO_FLAT_LEFT_LITTLE:
			{
				return ScannableObjectStrings::FlatLeftLittle_Str;
			}
			// ROLL FINGERS
		case GBMSAPI_SO_ROLL_RIGHT_THUMB:
			{
				return ScannableObjectStrings::RollRightThumb_Str;
			}
		case GBMSAPI_SO_ROLL_RIGHT_INDEX:
			{
				return ScannableObjectStrings::RollRightIndex_Str;
			}
		case GBMSAPI_SO_ROLL_RIGHT_MIDDLE:
			{
				return ScannableObjectStrings::RollRightMiddle_Str;
			}
		case GBMSAPI_SO_ROLL_RIGHT_RING:
			{
				return ScannableObjectStrings::RollRightRing_Str;
			}
		case GBMSAPI_SO_ROLL_RIGHT_LITTLE:
			{
				return ScannableObjectStrings::RollRightLittle_Str;
			}
		case GBMSAPI_SO_ROLL_LEFT_THUMB:
			{
				return ScannableObjectStrings::RollLeftThumb_Str;
			}
		case GBMSAPI_SO_ROLL_LEFT_INDEX:
			{
				return ScannableObjectStrings::RollLeftIndex_Str;
			}
		case GBMSAPI_SO_ROLL_LEFT_MIDDLE:
			{
				return ScannableObjectStrings::RollLeftMiddle_Str;
			}
		case GBMSAPI_SO_ROLL_LEFT_RING:
			{
				return ScannableObjectStrings::RollLeftRing_Str;
			}
		case GBMSAPI_SO_ROLL_LEFT_LITTLE:
			{
				return ScannableObjectStrings::RollLeftLittle_Str;
			}
			// TWO THUMBS 
		case GBMSAPI_SO_SLAP_2_THUMBS:
			{
				return ScannableObjectStrings::Slap2Thumbs_Str;
			}
			// VER 2000
			// TWO INDEXES 
		case GBMSAPI_SO_SLAP_2_INDEXES:
			{
				return ScannableObjectStrings::Slap2Indexes_Str;
			}
			// end VER 2000
			// FOUR FINGERS
		case GBMSAPI_SO_SLAP_4_LEFT:
			{
				return ScannableObjectStrings::Slap4Left_Str;
			}
		case GBMSAPI_SO_SLAP_4_RIGHT:
			{
				return ScannableObjectStrings::Slap4Right_Str;
			}
			// TWO FINGERS
		case GBMSAPI_SO_SLAP_2_LEFT:
			{
				return ScannableObjectStrings::Slap2Left_Str;
			}
		case GBMSAPI_SO_SLAP_2_RIGHT:
			{
				return ScannableObjectStrings::Slap2Right_Str;
			}
			// UPPER HALF PALM
		case GBMSAPI_SO_UPPER_HALF_PALM_LEFT:
			{
				return ScannableObjectStrings::UpperHalfPalmLeft_Str;
			}
		case GBMSAPI_SO_UPPER_HALF_PALM_RIGHT:
			{
				return ScannableObjectStrings::UpperHalfPalmRight_Str;
			}
			// LOWER HALF PALM
		case GBMSAPI_SO_LOWER_HALF_PALM_LEFT:
			{
				return ScannableObjectStrings::LowerHalfPalmLeft_Str;
			}
		case GBMSAPI_SO_LOWER_HALF_PALM_RIGHT:
			{
				return ScannableObjectStrings::LowerHalfPalmRight_Str;
			}
			// WRITER PALM
		case GBMSAPI_SO_WRITER_PALM_LEFT:
			{
				return ScannableObjectStrings::WriterPalmLeft_Str;
			}
		case GBMSAPI_SO_WRITER_PALM_RIGHT:
			{
				return ScannableObjectStrings::WriterPalmRight_Str;
			}
			// PHOTO
		case GBMSAPI_SO_PHOTO:
			{
				return ScannableObjectStrings::Photo_Str;
			}
			// Ver 2.10.0.0
			// ROLLED THENAR
		case GBMSAPI_SO_ROLLED_THENAR_LEFT:
			{
				return ScannableObjectStrings::RolledThenarLeft_Str;
			}
		case GBMSAPI_SO_ROLLED_THENAR_RIGHT:
			{
				return ScannableObjectStrings::RolledThenarRight_Str;
			}
			// ROLLED JOINT
		case GBMSAPI_SO_ROLLED_JOINT_RIGHT_THUMB:
			{
				return ScannableObjectStrings::RolledJointRightThumb_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_RIGHT_INDEX:
			{
				return ScannableObjectStrings::RolledJointRightIndex_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_RIGHT_MIDDLE:
			{
				return ScannableObjectStrings::RolledJointRightMiddle_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_RIGHT_RING:
			{
				return ScannableObjectStrings::RolledJointRightRing_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_RIGHT_LITTLE:
			{
				return ScannableObjectStrings::RolledJointRightLittle_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_LEFT_THUMB:
			{
				return ScannableObjectStrings::RolledJointLeftThumb_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_LEFT_INDEX:
			{
				return ScannableObjectStrings::RolledJointLeftIndex_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_LEFT_MIDDLE:
			{
				return ScannableObjectStrings::RolledJointLeftMiddle_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_LEFT_RING:
			{
				return ScannableObjectStrings::RolledJointLeftRing_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_LEFT_LITTLE:
			{
				return ScannableObjectStrings::RolledJointLeftLittle_Str;
			}
			// PLAIN JOINT LEFT SIDE
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_THUMB:
			{
				return ScannableObjectStrings::PlainJointLeftSideRightThumb_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_INDEX:
			{
				return ScannableObjectStrings::PlainJointLeftSideRightIndex_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_MIDDLE:
			{
				return ScannableObjectStrings::PlainJointLeftSideRightMiddle_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_RING:
			{
				return ScannableObjectStrings::PlainJointLeftSideRightRing_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_LITTLE:
			{
				return ScannableObjectStrings::PlainJointLeftSideRightLittle_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_THUMB:
			{
				return ScannableObjectStrings::PlainJointLeftSideLeftThumb_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_INDEX:
			{
				return ScannableObjectStrings::PlainJointLeftSideLeftIndex_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_MIDDLE:
			{
				return ScannableObjectStrings::PlainJointLeftSideLeftMiddle_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_RING:
			{
				return ScannableObjectStrings::PlainJointLeftSideLeftRing_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_LITTLE:
			{
				return ScannableObjectStrings::PlainJointLeftSideLeftLittle_Str;
			}
			// PLAIN JOINT RIGHT SIDE
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_THUMB:
			{
				return ScannableObjectStrings::PlainJointRightSideRightThumb_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_INDEX:
			{
				return ScannableObjectStrings::PlainJointRightSideRightIndex_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_MIDDLE:
			{
				return ScannableObjectStrings::PlainJointRightSideRightMiddle_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_RING:
			{
				return ScannableObjectStrings::PlainJointRightSideRightRing_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_LITTLE:
			{
				return ScannableObjectStrings::PlainJointRightSideRightLittle_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_THUMB:
			{
				return ScannableObjectStrings::PlainJointRightSideLeftThumb_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_INDEX:
			{
				return ScannableObjectStrings::PlainJointRightSideLeftIndex_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_MIDDLE:
			{
				return ScannableObjectStrings::PlainJointRightSideLeftMiddle_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_RING:
			{
				return ScannableObjectStrings::PlainJointRightSideLeftRing_Str;
			}
		case GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_LITTLE:
			{
				return ScannableObjectStrings::PlainJointRightSideLeftLittle_Str;
			}
			// ROLLED JOINT CENTER
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_THUMB:
			{
				return ScannableObjectStrings::RolledJointCenterRightThumb_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_INDEX:
			{
				return ScannableObjectStrings::RolledJointCenterRightIndex_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_MIDDLE:
			{
				return ScannableObjectStrings::RolledJointCenterRightMiddle_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_RING:
			{
				return ScannableObjectStrings::RolledJointCenterRightRing_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_LITTLE:
			{
				return ScannableObjectStrings::RolledJointCenterRightLittle_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_THUMB:
			{
				return ScannableObjectStrings::RolledJointCenterLeftThumb_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_INDEX:
			{
				return ScannableObjectStrings::RolledJointCenterLeftIndex_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_MIDDLE:
			{
				return ScannableObjectStrings::RolledJointCenterLeftMiddle_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_RING:
			{
				return ScannableObjectStrings::RolledJointCenterLeftRing_Str;
			}
		case GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_LITTLE:
			{
				return ScannableObjectStrings::RolledJointCenterLeftLittle_Str;
			}
			// ROLLED TIP
		case GBMSAPI_SO_ROLLED_TIP_RIGHT_THUMB:
			{
				return ScannableObjectStrings::RolledTipRightThumb_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_RIGHT_INDEX:
			{
				return ScannableObjectStrings::RolledTipRightIndex_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_RIGHT_MIDDLE:
			{
				return ScannableObjectStrings::RolledTipRightMiddle_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_RIGHT_RING:
			{
				return ScannableObjectStrings::RolledTipRightRing_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_RIGHT_LITTLE:
			{
				return ScannableObjectStrings::RolledTipRightLittle_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_LEFT_THUMB:
			{
				return ScannableObjectStrings::RolledTipLeftThumb_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_LEFT_INDEX:
			{
				return ScannableObjectStrings::RolledTipLeftIndex_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_LEFT_MIDDLE:
			{
				return ScannableObjectStrings::RolledTipLeftMiddle_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_LEFT_RING:
			{
				return ScannableObjectStrings::RolledTipLeftRing_Str;
			}
		case GBMSAPI_SO_ROLLED_TIP_LEFT_LITTLE:
			{
				return ScannableObjectStrings::RolledTipLeftLittle_Str;
			}
			// end Ver 2.10.0.0
		// Ver 3.3.0.0
		// ROLLED THENAR
		case GBMSAPI_SO_ROLLED_HYPOTHENAR_LEFT:
			{
				return ScannableObjectStrings::RolledHypoThenarLeft_Str;
			}
		case GBMSAPI_SO_ROLLED_HYPOTHENAR_RIGHT:
			{
				return ScannableObjectStrings::RolledHypoThenarRight_Str;
			}
		// end Ver 3.3.0.0
		}

		return nullptr;
	}

	unsigned int GBMSAPI_Example_Util::GetObjectToScanIDFromName(String ^ ObjToScanName)
	{
		// FLAT FINGERS
		if (ObjToScanName == ScannableObjectStrings::FlatRightThumb_Str) 
		{
			return GBMSAPI_SO_FLAT_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatRightIndex_Str)
		{
			return GBMSAPI_SO_FLAT_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatRightMiddle_Str)
		{
			return GBMSAPI_SO_FLAT_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatRightRing_Str)
		{
			return GBMSAPI_SO_FLAT_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatRightLittle_Str)
		{
			return GBMSAPI_SO_FLAT_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatLeftThumb_Str)
		{
			return GBMSAPI_SO_FLAT_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatLeftIndex_Str)
		{
			return GBMSAPI_SO_FLAT_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatLeftMiddle_Str)
		{
			return GBMSAPI_SO_FLAT_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatLeftRing_Str)
		{
			return GBMSAPI_SO_FLAT_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::FlatLeftLittle_Str)
		{
			return GBMSAPI_SO_FLAT_LEFT_LITTLE;
		}
		// ROLL FINGERS
		else if (ObjToScanName == ScannableObjectStrings::RollRightThumb_Str) 
		{
			return GBMSAPI_SO_ROLL_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollRightIndex_Str)
		{
			return GBMSAPI_SO_ROLL_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollRightMiddle_Str)
		{
			return GBMSAPI_SO_ROLL_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollRightRing_Str)
		{
			return GBMSAPI_SO_ROLL_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollRightLittle_Str)
		{
			return GBMSAPI_SO_ROLL_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollLeftThumb_Str)
		{
			return GBMSAPI_SO_ROLL_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollLeftIndex_Str)
		{
			return GBMSAPI_SO_ROLL_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollLeftMiddle_Str)
		{
			return GBMSAPI_SO_ROLL_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollLeftRing_Str)
		{
			return GBMSAPI_SO_ROLL_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RollLeftLittle_Str)
		{
			return GBMSAPI_SO_ROLL_LEFT_LITTLE;
		}
		// ver 3.2.0.0
		// ROLLED UPFINGERS
		else if (ObjToScanName == ScannableObjectStrings::RolledTopRightThumb_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopRightIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopRightMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopRightRing_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopRightLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopLeftThumb_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopLeftIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopLeftMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopLeftRing_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTopLeftLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_UP_LEFT_LITTLE;
		}
		// ROLLED DOWN FINGERS
		else if (ObjToScanName == ScannableObjectStrings::RolledDownRightThumb_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownRightIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownRightMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownRightRing_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownRightLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownLeftThumb_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownLeftIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownLeftMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownLeftRing_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledDownLeftLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_DOWN_LEFT_LITTLE;
		}
		// end ver 3.2.0.0
		// TWO THUMBS
		else if (ObjToScanName == ScannableObjectStrings::Slap2Thumbs_Str)
		{
			return GBMSAPI_SO_SLAP_2_THUMBS;
		}
		// VER 2000
		// TWO THUMBS
		else if (ObjToScanName == ScannableObjectStrings::Slap2Indexes_Str)
		{
			return GBMSAPI_SO_SLAP_2_INDEXES;
		}
		// end VER 2000
		// FOUR FINGERS
		else if (ObjToScanName == ScannableObjectStrings::Slap4Left_Str)
		{
			return GBMSAPI_SO_SLAP_4_LEFT;
		}
		else if (ObjToScanName == ScannableObjectStrings::Slap4Right_Str)
		{
			return GBMSAPI_SO_SLAP_4_RIGHT;
		}
		// TWO FINGERS
		else if (ObjToScanName == ScannableObjectStrings::Slap2Left_Str)
		{
			return GBMSAPI_SO_SLAP_2_LEFT;
		}
		else if (ObjToScanName == ScannableObjectStrings::Slap2Right_Str)
		{
			return GBMSAPI_SO_SLAP_2_RIGHT;
		}
		// UPPER HALF PALM
		else if (ObjToScanName == ScannableObjectStrings::UpperHalfPalmLeft_Str)
		{
			return GBMSAPI_SO_UPPER_HALF_PALM_LEFT;
		}
		else if (ObjToScanName == ScannableObjectStrings::UpperHalfPalmRight_Str)
		{
			return GBMSAPI_SO_UPPER_HALF_PALM_RIGHT;
		}
		// LOWER HALF PALM
		else if (ObjToScanName == ScannableObjectStrings::LowerHalfPalmLeft_Str)
		{
			return GBMSAPI_SO_LOWER_HALF_PALM_LEFT;
		}
		else if (ObjToScanName == ScannableObjectStrings::LowerHalfPalmRight_Str)
		{
			return GBMSAPI_SO_LOWER_HALF_PALM_RIGHT;
		}
		// WRITER PALM
		else if (ObjToScanName == ScannableObjectStrings::WriterPalmLeft_Str)
		{
			return GBMSAPI_SO_WRITER_PALM_LEFT;
		}
		else if (ObjToScanName == ScannableObjectStrings::WriterPalmRight_Str)
		{
			return GBMSAPI_SO_WRITER_PALM_RIGHT;
		}
		// PHOTO
		else if (ObjToScanName == ScannableObjectStrings::Photo_Str)
		{
			return GBMSAPI_SO_PHOTO;
		}
		// Ver 3.3.0.0
		// ROLLED THENAR
		else if (ObjToScanName == ScannableObjectStrings::RolledHypoThenarLeft_Str)
		{
			return GBMSAPI_SO_ROLLED_HYPOTHENAR_LEFT;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledHypoThenarRight_Str)
		{
			return GBMSAPI_SO_ROLLED_HYPOTHENAR_RIGHT;
		}
		// end Ver 3.3.0.0
		// Ver 2.10.0.0
		// ROLLED THENAR
		else if (ObjToScanName == ScannableObjectStrings::RolledThenarLeft_Str)
		{
			return GBMSAPI_SO_ROLLED_THENAR_LEFT;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledThenarRight_Str)
		{
			return GBMSAPI_SO_ROLLED_THENAR_RIGHT;
		}
		// ROLLED JOINT
		else if (ObjToScanName == ScannableObjectStrings::RolledJointRightThumb_Str) 
		{
			return GBMSAPI_SO_ROLLED_JOINT_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointRightIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointRightMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointRightRing_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointRightLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointLeftThumb_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointLeftIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointLeftMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointLeftRing_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointLeftLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_LEFT_LITTLE;
		}
		// PLAIN JOINT LEFT SIDE
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideRightThumb_Str) 
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideRightIndex_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideRightMiddle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideRightRing_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideRightLittle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideLeftThumb_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideLeftIndex_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideLeftMiddle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideLeftRing_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointLeftSideLeftLittle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_LITTLE;
		}
		// PLAIN JOINT RIGHT SIDE
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideRightThumb_Str) 
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideRightIndex_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideRightMiddle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideRightRing_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideRightLittle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideLeftThumb_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideLeftIndex_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideLeftMiddle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideLeftRing_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::PlainJointRightSideLeftLittle_Str)
		{
			return GBMSAPI_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_LITTLE;
		}
		// ROLLED JOINT CENTER
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterRightThumb_Str) 
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterRightIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterRightMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterRightRing_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterRightLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterLeftThumb_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterLeftIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterLeftMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterLeftRing_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledJointCenterLeftLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_JOINT_CENTER_LEFT_LITTLE;
		}
		// ROLLED TIP
		else if (ObjToScanName == ScannableObjectStrings::RolledTipRightThumb_Str) 
		{
			return GBMSAPI_SO_ROLLED_TIP_RIGHT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipRightIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_RIGHT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipRightMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_RIGHT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipRightRing_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_RIGHT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipRightLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_RIGHT_LITTLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipLeftThumb_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_LEFT_THUMB;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipLeftIndex_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_LEFT_INDEX;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipLeftMiddle_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_LEFT_MIDDLE;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipLeftRing_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_LEFT_RING;
		}
		else if (ObjToScanName == ScannableObjectStrings::RolledTipLeftLittle_Str)
		{
			return GBMSAPI_SO_ROLLED_TIP_LEFT_LITTLE;
		}
		// end Ver 2.10.0.0
		else return 0;
	}

	List<String ^> ^GBMSAPI_Example_Util::GetFeaturesListFromMask(unsigned int DeviceFeaturesMask)
	{
		List<String ^> ^RetVal = gcnew List<String ^> ();
		if (DeviceFeaturesMask & GBMSAPI_DF_MULTIPLE_USB_CONNECTIONS_ALLOWED)
		{
			RetVal->Add(DeviceFeaturesStrings::MultipleUSBConnectionsAllowed);
		}
		if (DeviceFeaturesMask & GBMSAPI_DF_AUTO_CAPTURE_BLOCKING)
		{
			RetVal->Add(DeviceFeaturesStrings::AutoCaptureBlocking);
		}
		if (DeviceFeaturesMask & GBMSAPI_DF_1000DPI_RESOLUTION)
		{
			RetVal->Add(DeviceFeaturesStrings::Resolution1000DPI);
		}
		return RetVal;
	}

	List<String ^> ^GBMSAPI_Example_Util::GetScannableTypesListFromMask(unsigned int ScannableTypesMask)
	{
		List<String ^> ^RetVal = gcnew List<String ^> ();
		if (ScannableTypesMask & GBMSAPI_SBT_ROLL_SINGLE_FINGER)
		{
			RetVal->Add(ScannableTypesStrings::RollSingleFinger);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_SINGLE_FINGER)
		{
			RetVal->Add(ScannableTypesStrings::FlatSingleFinger);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_SLAP_4)
		{
			RetVal->Add(ScannableTypesStrings::FlatSlap4);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_SLAP_2)
		{
			RetVal->Add(ScannableTypesStrings::FlatSlap2);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_THUMBS_2)
		{
			RetVal->Add(ScannableTypesStrings::FlatThumbs2);
		}
		// VER 2000
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_INDEXES_2)
		{
			RetVal->Add(ScannableTypesStrings::FlatIndexes2);
		}
		// end VER 2000
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_LOWER_HALF_PALM)
		{
			RetVal->Add(ScannableTypesStrings::FlatLHP);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_UPPER_HALF_PALM)
		{
			RetVal->Add(ScannableTypesStrings::FlatUHP);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_FLAT_WRITER_PALM)
		{
			RetVal->Add(ScannableTypesStrings::FlatWP);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_PHOTO)
		{
			RetVal->Add(ScannableTypesStrings::Photo);
		}
		// Ver 3.3.0.0
		if (ScannableTypesMask & GBMSAPI_SBT_ROLLED_HYPOTHENAR)
		{
			RetVal->Add(ScannableTypesStrings::RolledHypoThenar);
		}
		// Ver 3.3.0.0
		// Ver 2.10.0.0
		if (ScannableTypesMask & GBMSAPI_SBT_ROLLED_THENAR)
		{
			RetVal->Add(ScannableTypesStrings::RolledThenar);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_ROLLED_JOINT)
		{
			RetVal->Add(ScannableTypesStrings::RolledJoint); 
		}
		if (ScannableTypesMask & GBMSAPI_SBT_ROLLED_JOINT_CENTER)
		{
			RetVal->Add(ScannableTypesStrings::RolledJointCenter);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_PLAIN_JOINT_LEFT_SIDE)
		{
			RetVal->Add(ScannableTypesStrings::PlainJointLeftSide);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_PLAIN_JOINT_RIGHT_SIDE)
		{
			RetVal->Add(ScannableTypesStrings::PlainJointRightSide);
		}
		if (ScannableTypesMask & GBMSAPI_SBT_ROLLED_TIP)
		{
			RetVal->Add(ScannableTypesStrings::RolledTip);
		}
		// end Ver 2.10.0.0
		// ver 3.2.0.0
		if ((ScannableTypesMask & GBMSAPI_SBT_ROLLED_UP) != 0)
		{
			RetVal->Add(ScannableTypesStrings::RolledTop);
		}
		if ((ScannableTypesMask & GBMSAPI_SBT_ROLLED_DOWN) != 0)
		{
			RetVal->Add(ScannableTypesStrings::RolledDown);
		}
		// end ver 3.2.0.0
		return RetVal;
	}

	List<String ^> ^GBMSAPI_Example_Util::GetDiagStringsFromDiagMask(unsigned int DiagMask)
	{
		List<String ^> ^RetVal = gcnew List<String ^> ();

		if (DiagMask & GBMSAPI_DM_SCANNER_SURFACE_NOT_NORMA)
		{
			RetVal->Add(DiagnosticStrings::ScannerSurfaceNotNormalDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_SCANNER_FAILURE)
		{
			RetVal->Add(DiagnosticStrings::ScannerFailureDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_COMPOSITION_SLOW)
		{
			RetVal->Add(DiagnosticStrings::CompositionSlowDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_FLAT_FINGER_SLIDING)
		{
			RetVal->Add(DiagnosticStrings::FlatFingerSlidingDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_EXT_LIGHT_TOO_STRONG)
		{
			RetVal->Add(DiagnosticStrings::ExternalLightDiagMessString);
		}
		if ((DiagMask & GBMSAPI_DM_FLAT_FINGER_OUT_OF_REGION_LEFT) ||
			(DiagMask & GBMSAPI_DM_VSROLL_OUTSIDE_BORDER_LEFT))
		{
			RetVal->Add(DiagnosticStrings::FingerOutOfRegionLeftDiagMessString);
		}
		if ((DiagMask & GBMSAPI_DM_FLAT_FINGER_OUT_OF_REGION_RIGHT) ||
			(DiagMask & GBMSAPI_DM_VSROLL_OUTSIDE_BORDER_RIGHT))
		{
			RetVal->Add(DiagnosticStrings::FingerOutOfRegionRightDiagMessString);
		}
		if ((DiagMask & GBMSAPI_DM_FLAT_FINGER_OUT_OF_REGION_TOP) ||
			(DiagMask & GBMSAPI_DM_VSROLL_OUTSIDE_BORDER_TOP))
		{
			RetVal->Add(DiagnosticStrings::FingerOutOfRegionTopDiagMessString);
		}
		if ((DiagMask & GBMSAPI_DM_VSROLL_DISPLACED_DOWN) ||
			(DiagMask & GBMSAPI_DM_FLAT_FINGER_DISPLACED_DOWN))
		{
			RetVal->Add(DiagnosticStrings::FingerDisplacedDownDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_VSROLL_IMPROPER_ROLL)
		{
			RetVal->Add(DiagnosticStrings::ImproperRollDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_VSROLL_TOO_FAST_ROLL)
		{
			RetVal->Add(DiagnosticStrings::TooFastRollDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_VSROLL_TOO_NARROW_ROLL)
		{
			RetVal->Add(DiagnosticStrings::TooNarrowRollDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_VSROLL_ROLL_DIRECTION_LEFT)
		{
			RetVal->Add(DiagnosticStrings::RollDirLeftDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_VSROLL_ROLL_DIRECTION_RIGHT)
		{
			RetVal->Add(DiagnosticStrings::RollDirRightDiagMessString);
		}
		// VER 2.9.0.0
		if (DiagMask & GBMSAPI_DM_DRY_FINGER)
		{
			RetVal->Add(DiagnosticStrings::DryFingerDiagMessString);
		}
		// VER 2.9.0.0
		if (DiagMask & GBMSAPI_DM_WET_FINGER)
		{
			RetVal->Add(DiagnosticStrings::WetFingerDiagMessString);
		}
		// VER 3.1.0.0
		if (DiagMask & GBMSAPI_DM_TOO_SHORT_VERTICAL_ROLL)
		{
			RetVal->Add(DiagnosticStrings::TooShortVerticalRollDiagMessString);
		}
		// end VER 3.1.0.0
		// VER 3.2.0.0
		if (DiagMask & GBMSAPI_DM_VSROLL_ROLL_DIRECTION_UP)
		{
			RetVal->Add(DiagnosticStrings::RollDirUpDiagMessString);
		}
		if (DiagMask & GBMSAPI_DM_VSROLL_ROLL_DIRECTION_DOWN)
		{
			RetVal->Add(DiagnosticStrings::RollDirDownDiagMessString);
		}
		// end VER 3.2.0.0

		return RetVal;
	}

	String ^GBMSAPI_Example_Util::GetAutoCapturePhaseStringFromValue(int AutoCapturePhaseValue)
	{
		switch (AutoCapturePhaseValue)
		{
		case (GBMSAPI_ACP_OFF):
			{
				return AutoCapturePhaseStrings::AutoCaptureOffString;
			}
		case (GBMSAPI_ACP_WAIT_FINGER):
			{
				return AutoCapturePhaseStrings::AutoCaptureWaitFingerString;
			}
		case (GBMSAPI_ACP_SELECT_IMAGE):
			{
				return AutoCapturePhaseStrings::AutoCaptureSelectImageString;
			}
		case (GBMSAPI_ACP_BEST_IMAGE_STOP):
			{
				return AutoCapturePhaseStrings::AutoCaptureBestImageStop;
			}
		case (-1):
			{
				return AutoCapturePhaseStrings::AutoCaptureBlocked;
			}
		default:
			return AutoCapturePhaseStrings::AutoCaptureOffString;
		}
	}

	Bitmap ^GBMSAPI_Example_Util::ClipFrame(
		IntPtr Frame,
		unsigned int FrameSX, unsigned int FrameSY,
		unsigned int ClipPosX, unsigned int ClipPosY,
		unsigned int ClipSX, unsigned int ClipSY,
		IntPtr ClippedFrame
		)
	{
		///////////////////////
		// Check Params
		///////////////////////
		// above all frames
		if (Frame == IntPtr::Zero ||
			ClippedFrame == IntPtr::Zero)
		{
			MessageBox::Show("Cannot clip the image: null frame","WARNING");
			return nullptr;
		}
		// ClipSX must be a multiple of 4
		if ((ClipSX % 4) != 0)
		{
			ClipSX = ((ClipSX >> 2) * 4) + 4;
		}

		// check clip region not outside frame
		if (ClipPosX >= FrameSX ||
			ClipPosY >= FrameSY ||
			ClipSX > FrameSX ||
			ClipSY > FrameSY)
		{
			MessageBox::Show("Cannot clip the image: clipping region outside frame: " 
				+ ClipPosX + ","
				+ ClipPosY + ","
				+ ClipSX + ","
				+ ClipSY
				,"WARNING");
			return nullptr;
		}

		// now calculate clip borders
		if ((ClipPosX + ClipSX) > FrameSX)
		{
			ClipSX = FrameSX - ClipPosX;
		}
		if ((ClipPosY + ClipSY) > FrameSY)
		{
			ClipSY = FrameSY - ClipPosY;
		}

		/////////////////////////////
		// Cut Image
		/////////////////////////////
		unsigned char * FramePtr = (unsigned char *)(Frame.ToPointer());
		unsigned char * ClippedFramePtr = (unsigned char *)(ClippedFrame.ToPointer()),*DummyPtr = ClippedFramePtr;

		// Set FramePtr to the first clip row coordinate
		FramePtr += (ClipPosX + ClipPosY * FrameSX);
		for (unsigned int y = 0; y < ClipSY; y ++)
		{
			memcpy(DummyPtr,FramePtr,ClipSX);
			FramePtr += FrameSX;
			DummyPtr += ClipSX;
		}

		// now build bitmap
		Bitmap ^RetVal = gcnew Bitmap(ClipSX,ClipSY,ClipSX,System::Drawing::Imaging::PixelFormat::Format8bppIndexed,(IntPtr)ClippedFramePtr);
		if (RetVal == nullptr) return nullptr;

		Imaging::ColorPalette ^pal = RetVal->Palette;
		for (int i = 0; i < pal->Entries->Length; i++)
		{
			pal->Entries[i] = Color::FromArgb(255, i, i, i);
		}
		RetVal->Palette = pal;

		return RetVal;
	}

	// ver 2.10.0.0
	unsigned int GBMSAPI_Example_Util::GetScanAreaFromObjectType(unsigned int objType, bool flatFingerOnRollArea, bool rollAreaGA)
	{
		switch (objType)
		{
		case GBMSAPI_SBT_FLAT_INDEXES_2: return GBMSAPI_SA_FULL_FRAME;
		case GBMSAPI_SBT_FLAT_LOWER_HALF_PALM: return GBMSAPI_SA_FULL_FRAME;
		case GBMSAPI_SBT_FLAT_SINGLE_FINGER:
			{
				if (flatFingerOnRollArea)
				{
					if (rollAreaGA) return GBMSAPI_SA_ROLL_GA;
					else return GBMSAPI_SA_ROLL_IQS;
				}
				else
				{
					return GBMSAPI_SA_FULL_FRAME;
				}
			}
		// ver 3.2.0.0
		case GBMSAPI_SBT_ROLLED_UP: 
			{
				if (rollAreaGA) return GBMSAPI_SA_ROLL_GA;
				else return GBMSAPI_SA_ROLL_IQS;
			}
		case GBMSAPI_SBT_ROLLED_DOWN: 
			{
				if (rollAreaGA) return GBMSAPI_SA_ROLL_GA;
				else return GBMSAPI_SA_ROLL_IQS;
			}
		// end ver 3.2.0.0
		case GBMSAPI_SBT_FLAT_SLAP_2: return GBMSAPI_SA_FULL_FRAME;
		case GBMSAPI_SBT_FLAT_SLAP_4: return GBMSAPI_SA_FULL_FRAME;
		case GBMSAPI_SBT_FLAT_THUMBS_2: return GBMSAPI_SA_FULL_FRAME;
		case GBMSAPI_SBT_FLAT_UPPER_HALF_PALM: return GBMSAPI_SA_FULL_FRAME;
		case GBMSAPI_SBT_FLAT_WRITER_PALM: return GBMSAPI_SA_FULL_FRAME;
		case GBMSAPI_SBT_PHOTO: return GBMSAPI_SA_PHOTO;
		case GBMSAPI_SBT_PLAIN_JOINT_LEFT_SIDE: return GBMSAPI_SA_ROLL_JOINT;
		case GBMSAPI_SBT_PLAIN_JOINT_RIGHT_SIDE: return GBMSAPI_SA_ROLL_JOINT;
		case GBMSAPI_SBT_ROLL_SINGLE_FINGER: 
			{
				if (rollAreaGA) return GBMSAPI_SA_ROLL_GA;
				else return GBMSAPI_SA_ROLL_IQS;
			}
		case GBMSAPI_SBT_ROLLED_JOINT: return GBMSAPI_SA_ROLL_JOINT;
		case GBMSAPI_SBT_ROLLED_JOINT_CENTER: return GBMSAPI_SA_ROLL_JOINT;
		case GBMSAPI_SBT_ROLLED_THENAR: return GBMSAPI_SA_ROLL_THENAR;
		case GBMSAPI_SBT_ROLLED_TIP: return GBMSAPI_SA_ROLL_IQS;
		// ver 3.3.0.0
		case GBMSAPI_SBT_ROLLED_HYPOTHENAR: return GBMSAPI_SA_ROLL_THENAR;
		// end ver 3.3.0.0
		default:return 0;
		}
	}


	// end ver 2.10.0.0

	// ver 3.1.0.0
	void GBMSAPI_Example_Util::CalculatePaintBoxSizeAndLocation(
		unsigned int imsx, unsigned int imsy,
		System::Drawing::Size pbOriginalSize, System::Drawing::Point pbOriginalPoint,
		System::Drawing::Size % pbSize, System::Drawing::Point % pbLocation)
	{
		if (imsx == imsy)
		{
			pbLocation = pbOriginalPoint;
			pbSize = pbOriginalSize;
			return;
		}
		if (imsx > imsy)
		{
			pbLocation = pbOriginalPoint;
			double dIsx = (double)imsx, dIsy = (double)imsy,
				orSx = (double)pbOriginalSize.Width, orSy = (double)pbOriginalSize.Height,
				nSx, nsY;

			nSx = orSx;
			nsY = orSy * (dIsy / dIsx);
			pbSize.Width = (int)nSx;
			pbSize.Height = (int)nsY;
			return;
		}
		else
		{
			double dIsx = (double)imsx, dIsy = (double)imsy,
				orSx = (double)pbOriginalSize.Width, orSy = (double)pbOriginalSize.Height,
				nSx, nSy;
			double orLx = (double)pbOriginalPoint.X, orLy = (double)pbOriginalPoint.Y,
				nLx, nLy;

			nSy = orSy;
			nSx = orSx * (dIsx / dIsy);
			pbSize.Width = (int)nSx;
			pbSize.Height = (int)nSy;
			nLy = orLy;
			nLx = orLx + (orSx - nSx) / 2;
			pbLocation.X = (int)nLx;
			pbLocation.Y = (int)nLy;
			return;
		}
	}
	// end ver 3.1.0.0
}