#ifndef GBMSAPI_UTIL_H
#define GBMSAPI_UTIL_H
using namespace System::Drawing;
using namespace System::Drawing::Imaging;

extern GBMSAPI_DeviceInfoStruct AttachedDeviceList[GBMSAPI_MAX_PLUGGED_DEVICE_NUM];

// ver 2.10.0.0
bool IsRolled(unsigned int ObjTypeToScan);
// end ver 2.10.0.0

namespace GBMSAPICExample {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Collections::Generic;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Strings identifying devices' name
	/// </summary>
	public ref class GBMSAPI_Example_DevNameStrings
	{
	public:
		static String ^ DS84_NameStr = "DactyScan84";
	public:
		static String ^ DS26_NameStr = "DactyScan26";
	public:
		static String ^ DS40_NameStr = "DactyScan40";
	public:
		static String ^ VS3_NameStr = "Visascan3";
	public:
		static String ^ PS2_NameStr = "Poliscan2";
	public:
		static String ^ MS500_NameStr = "MultiScan500";
	public:
		static String ^ MS1000_NameStr = "MultiScan1000";
	public:
		static String ^ MC500_NameStr = "MC500";
	public:
		static String ^ MSC500_NameStr = "MSC500";
	public:
		static String ^ DS40I_NameStr = "DactyScan40I";
	public:
		static String ^ DS84C_NameStr = "DactyScan84C";
	public:
		static String ^ MC517_NameStr = "MC517"; // Ver 2800
	public:
		static String ^ MSC517_NameStr = "MSC517"; // Ver 2800
	public:
		static String ^ DS32_NameStr = "DactyScan32"; // Ver 2800
	public:
		static String ^ MS527_NameStr = "MS527"; // Ver 2.10.0.0
	};

	/// <summary>
    /// Strings identifying objects to scan name
    /// </summary>
    public ref class ScannableObjectStrings
	{
		// flat fingers
		public:
			static String ^FlatRightThumb_Str = "FLAT RIGHT THUMB";
		public:
			static String ^FlatRightIndex_Str = "FLAT RIGHT INDEX";
		public:
			static String ^FlatRightMiddle_Str = "FLAT RIGHT MIDDLE";
		public:
			static String ^FlatRightRing_Str = "FLAT RIGHT RING";
		public:
			static String ^FlatRightLittle_Str = "FLAT RIGHT LITTLE";
		public:
			static String ^FlatLeftThumb_Str = "FLAT LEFT THUMB";
		public:
			static String ^FlatLeftIndex_Str = "FLAT LEFT INDEX";
		public:
			static String ^FlatLeftMiddle_Str = "FLAT LEFT MIDDLE";
		public:
			static String ^FlatLeftRing_Str = "FLAT LEFT RING";
		public:
			static String ^FlatLeftLittle_Str = "FLAT LEFT LITTLE";

		// Roll fingers
		public:
			static String ^RollRightThumb_Str = "ROLL RIGHT THUMB";
		public:
			static String ^RollRightIndex_Str = "ROLL RIGHT INDEX";
		public:
			static String ^RollRightMiddle_Str = "ROLL RIGHT MIDDLE";
		public:
			static String ^RollRightRing_Str = "ROLL RIGHT RING";
		public:
			static String ^RollRightLittle_Str = "ROLL RIGHT LITTLE";
		public:
			static String ^RollLeftThumb_Str = "ROLL LEFT THUMB";
		public:
			static String ^RollLeftIndex_Str = "ROLL LEFT INDEX";
		public:
			static String ^RollLeftMiddle_Str = "ROLL LEFT MIDDLE";
		public:
			static String ^RollLeftRing_Str = "ROLL LEFT RING";
		public:
			static String ^RollLeftLittle_Str = "ROLL LEFT LITTLE";

		// two thumbs
		public:
			static String ^Slap2Thumbs_Str = "2 THUMBS";

		// VER 2000
		// two indexes
		public:
			static String ^Slap2Indexes_Str = "2 INDEXES";
		// end VER 2000

		// four fingers
		public:
			static String ^Slap4Right_Str = "4 FINGERS RIGHT";
		public:
			static String ^Slap4Left_Str = "4 FINGERS LEFT";

		// two fingers (index and middle)
		public:
			static String ^Slap2Right_Str = "2 FINGERS RIGHT";
		public:
			static String ^Slap2Left_Str = "2 FINGERS LEFT";

		// upper half palm
		public:
			static String ^UpperHalfPalmRight_Str = "UPPER HALF PALM RIGHT";
		public:
			static String ^UpperHalfPalmLeft_Str = "UPPER HALF PALM LEFT";

		// lower half palm
		public:
			static String ^LowerHalfPalmRight_Str = "LOWER HALF PALM RIGHT";
		public:
			static String ^LowerHalfPalmLeft_Str = "LOWER HALF PALM LEFT";

		// writer palm
		public:
			static String ^WriterPalmRight_Str = "WRITER PALM RIGHT";
		public:
			static String ^WriterPalmLeft_Str = "WRITER PALM LEFT";

		// photo
		public:
			static String ^Photo_Str = "PHOTO";
	// Ver 3.3.0.0
		// rolled thenar
		public:
			static String ^RolledHypoThenarRight_Str = "ROLLED HYPOTHENAR RIGHT";
		public:
			static String ^RolledHypoThenarLeft_Str = "ROLLED HYPOTHENAR LEFT";
	// end Ver 3.3.0.0

	// Ver 2.10.0.0
		// rolled thenar
		public:
			static String ^RolledThenarRight_Str = "ROLLED THENAR RIGHT";
		public:
			static String ^RolledThenarLeft_Str = "ROLLED THENAR LEFT";
		
		// rolled joint
		public:
			static String ^RolledJointRightThumb_Str = "ROLLED JOINT RIGHT THUMB";
		public:
			static String ^RolledJointRightIndex_Str = "ROLLED JOINT RIGHT INDEX";
		public:
			static String ^RolledJointRightMiddle_Str = "ROLLED JOINT RIGHT MIDDLE";
		public:
			static String ^RolledJointRightRing_Str = "ROLLED JOINT RIGHT RING";
		public:
			static String ^RolledJointRightLittle_Str = "ROLLED JOINT RIGHT LITTLE";
		public:
			static String ^RolledJointLeftThumb_Str = "ROLLED JOINT LEFT THUMB";
		public:
			static String ^RolledJointLeftIndex_Str = "ROLLED JOINT LEFT INDEX";
		public:
			static String ^RolledJointLeftMiddle_Str = "ROLLED JOINT LEFT MIDDLE";
		public:
			static String ^RolledJointLeftRing_Str = "ROLLED JOINT LEFT RING";
		public:
			static String ^RolledJointLeftLittle_Str = "ROLLED JOINT LEFT LITTLE";
		
		// plain joint left side
		public:
			static String ^PlainJointLeftSideRightThumb_Str = "PLAIN JOINT LEFT SIDE RIGHT THUMB";
		public:
			static String ^PlainJointLeftSideRightIndex_Str = "PLAIN JOINT LEFT SIDE RIGHT INDEX";
		public:
			static String ^PlainJointLeftSideRightMiddle_Str = "PLAIN JOINT LEFT SIDE RIGHT MIDDLE";
		public:
			static String ^PlainJointLeftSideRightRing_Str = "PLAIN JOINT LEFT SIDE RIGHT RING";
		public:
			static String ^PlainJointLeftSideRightLittle_Str = "PLAIN JOINT LEFT SIDE RIGHT LITTLE";
		public:
			static String ^PlainJointLeftSideLeftThumb_Str = "PLAIN JOINT LEFT SIDE LEFT THUMB";
		public:
			static String ^PlainJointLeftSideLeftIndex_Str = "PLAIN JOINT LEFT SIDE LEFT INDEX";
		public:
			static String ^PlainJointLeftSideLeftMiddle_Str = "PLAIN JOINT LEFT SIDE LEFT MIDDLE";
		public:
			static String ^PlainJointLeftSideLeftRing_Str = "PLAIN JOINT LEFT SIDE LEFT RING";
		public:
			static String ^PlainJointLeftSideLeftLittle_Str = "PLAIN JOINT LEFT SIDE LEFT LITTLE";
		
		// plain joint right side
		public:
			static String ^PlainJointRightSideRightThumb_Str = "PLAIN JOINT RIGHT SIDE RIGHT THUMB";
		public:
			static String ^PlainJointRightSideRightIndex_Str = "PLAIN JOINT RIGHT SIDE RIGHT INDEX";
		public:
			static String ^PlainJointRightSideRightMiddle_Str = "PLAIN JOINT RIGHT SIDE RIGHT MIDDLE";
		public:
			static String ^PlainJointRightSideRightRing_Str = "PLAIN JOINT RIGHT SIDE RIGHT RING";
		public:
			static String ^PlainJointRightSideRightLittle_Str = "PLAIN JOINT RIGHT SIDE RIGHT LITTLE";
		public:
			static String ^PlainJointRightSideLeftThumb_Str = "PLAIN JOINT RIGHT SIDE LEFT THUMB";
		public:
			static String ^PlainJointRightSideLeftIndex_Str = "PLAIN JOINT RIGHT SIDE LEFT INDEX";
		public:
			static String ^PlainJointRightSideLeftMiddle_Str = "PLAIN JOINT RIGHT SIDE LEFT MIDDLE";
		public:
			static String ^PlainJointRightSideLeftRing_Str = "PLAIN JOINT RIGHT SIDE LEFT RING";
		public:
			static String ^PlainJointRightSideLeftLittle_Str = "PLAIN JOINT RIGHT SIDE LEFT LITTLE";
		
		// rolled joint center
		public:
			static String ^RolledJointCenterRightThumb_Str = "ROLLED JOINT CENTER RIGHT THUMB";
		public:
			static String ^RolledJointCenterRightIndex_Str = "ROLLED JOINT CENTER RIGHT INDEX";
		public:
			static String ^RolledJointCenterRightMiddle_Str = "ROLLED JOINT CENTER RIGHT MIDDLE";
		public:
			static String ^RolledJointCenterRightRing_Str = "ROLLED JOINT CENTER RIGHT RING";
		public:
			static String ^RolledJointCenterRightLittle_Str = "ROLLED JOINT CENTER RIGHT LITTLE";
		public:
			static String ^RolledJointCenterLeftThumb_Str = "ROLLED JOINT CENTER LEFT THUMB";
		public:
			static String ^RolledJointCenterLeftIndex_Str = "ROLLED JOINT CENTER LEFT INDEX";
		public:
			static String ^RolledJointCenterLeftMiddle_Str = "ROLLED JOINT CENTER LEFT MIDDLE";
		public:
			static String ^RolledJointCenterLeftRing_Str = "ROLLED JOINT CENTER LEFT RING";
		public:
			static String ^RolledJointCenterLeftLittle_Str = "ROLLED JOINT CENTER LEFT LITTLE";
		
		// rolled tip
		public:
			static String ^RolledTipRightThumb_Str = "ROLLED TIP RIGHT THUMB";
		public:
			static String ^RolledTipRightIndex_Str = "ROLLED TIP RIGHT INDEX";
		public:
			static String ^RolledTipRightMiddle_Str = "ROLLED TIP RIGHT MIDDLE";
		public:
			static String ^RolledTipRightRing_Str = "ROLLED TIP RIGHT RING";
		public:
			static String ^RolledTipRightLittle_Str = "ROLLED TIP RIGHT LITTLE";
		public:
			static String ^RolledTipLeftThumb_Str = "ROLLED TIP LEFT THUMB";
		public:
			static String ^RolledTipLeftIndex_Str = "ROLLED TIP LEFT INDEX";
		public:
			static String ^RolledTipLeftMiddle_Str = "ROLLED TIP LEFT MIDDLE";
		public:
			static String ^RolledTipLeftRing_Str = "ROLLED TIP LEFT RING";
		public:
			static String ^RolledTipLeftLittle_Str = "ROLLED TIP LEFT LITTLE";
	// end Ver 2.10.0.0

    // ver 3.2.0.0
		// Rolled top
		public: static String ^ RolledTopRightThumb_Str = "ROLLED UPRIGHT THUMB";
		public: static String ^ RolledTopRightIndex_Str = "ROLLED UPRIGHT INDEX";
		public: static String ^ RolledTopRightMiddle_Str = "ROLLED UPRIGHT MIDDLE";
		public: static String ^ RolledTopRightRing_Str = "ROLLED UPRIGHT RING";
		public: static String ^ RolledTopRightLittle_Str = "ROLLED UPRIGHT LITTLE";
		public: static String ^ RolledTopLeftThumb_Str = "ROLLED UPLEFT THUMB";
		public: static String ^ RolledTopLeftIndex_Str = "ROLLED UPLEFT INDEX";
		public: static String ^ RolledTopLeftMiddle_Str = "ROLLED UPLEFT MIDDLE";
		public: static String ^ RolledTopLeftRing_Str = "ROLLED UPLEFT RING";
		public: static String ^ RolledTopLeftLittle_Str = "ROLLED UPLEFT LITTLE";
		// Rolled down
		public: static String ^ RolledDownRightThumb_Str = "ROLLED DOWN RIGHT THUMB";
		public: static String ^ RolledDownRightIndex_Str = "ROLLED DOWN RIGHT INDEX";
		public: static String ^ RolledDownRightMiddle_Str = "ROLLED DOWN RIGHT MIDDLE";
		public: static String ^ RolledDownRightRing_Str = "ROLLED DOWN RIGHT RING";
		public: static String ^ RolledDownRightLittle_Str = "ROLLED DOWN RIGHT LITTLE";
		public: static String ^ RolledDownLeftThumb_Str = "ROLLED DOWN LEFT THUMB";
		public: static String ^ RolledDownLeftIndex_Str = "ROLLED DOWN LEFT INDEX";
		public: static String ^ RolledDownLeftMiddle_Str = "ROLLED DOWN LEFT MIDDLE";
		public: static String ^ RolledDownLeftRing_Str = "ROLLED DOWN LEFT RING";
		public: static String ^ RolledDownLeftLittle_Str = "ROLLED DOWN LEFT LITTLE";
    // end ver 3.2.0.0

	};

	public ref class DeviceFeaturesStrings
	{
	public:
		static String ^MultipleUSBConnectionsAllowed = "MULTIPLE USB CONNECTIONS ALLOWED";
	public:
		static String ^AutoCaptureBlocking = "AUTO-CAPTURE-BLOCKING";
	public:
		static String ^Resolution1000DPI = "1000 DPI RESOLUTION";
	};

	public ref class ScannableTypesStrings
	{
	public:
		static String ^RollSingleFinger = "ROLL SINGLE FINGER";
	public:
		static String ^FlatSingleFinger = "FLAT SINGLE FINGER";
	public:
		static String ^FlatSlap4 = "FLAT 4 SLAP";
	public:
		static String ^FlatSlap2 = "FLAT 2 SLAP";
	public:
		static String ^FlatThumbs2 = "FLAT 2 THUMBS";
	// VER 2000
	public:
		static String ^FlatIndexes2 = "FLAT 2 INDEXES";
	// end VER 2000
	public:
		static String ^FlatLHP = "FLAT LOWER HALF PALM";
	public:
		static String ^FlatUHP = "FLAT UPPER HALF PALM";
	public:
		static String ^FlatWP = "FLAT WRITER PALM";
	public:
		static String ^Photo = "PHOTO";
	// Ver 3.3.0.0
	public:
		static String ^RolledHypoThenar = "ROLLED HYPOTHENAR";
	// end Ver 3.3.0.0
	// Ver 2.10.0.0
	public:
		static String ^RolledThenar = "ROLLED THENAR";
	public:
		static String ^RolledJoint = "ROLLED JOINT";
	public:
		static String ^PlainJointLeftSide = "PLAIN JOINT LEFT SIDE";
	public:
		static String ^PlainJointRightSide = "PLAIN JOINT RIGHT SIDE";
	public:
		static String ^RolledJointCenter = "ROLLED JOINT CENTER";
	public:
		static String ^RolledTip = "ROLLED TIP";
	// end Ver 2.10.0.0
    // ver 3.2.0.0
    public: static String ^ RolledTop = "ROLLED TOP";
    public: static String ^ RolledDown = "ROLLED DOWN";
    // end ver 3.2.0.0
	};

	public ref class DiagnosticStrings
	{
	public:
		static String ^ScannerSurfaceNotNormalDiagMessString = "Finger placed too early or scanner surface dirty";
	public:
		static String ^ScannerFailureDiagMessString = "Parameters of acquired image do not conform to quality standard";
	public:
		static String ^CompositionSlowDiagMessString = "Frame rate is too slow to ensure proper composition image of rolled fingerprint";
	public:
		static String ^FlatFingerSlidingDiagMessString = "Flat finger(s) sliding has been detected";
	public:
		static String ^ExternalLightDiagMessString = "Too much strong external light influence";
	public:
		static String ^FingerOutOfRegionLeftDiagMessString = "Finger goes out on the left border";
	public:
		static String ^FingerOutOfRegionRightDiagMessString = "Finger goes out on the right border";
	public:
		static String ^FingerOutOfRegionTopDiagMessString = "Finger goes out on the top border";
	public:
		static String ^FingerDisplacedDownDiagMessString = "Finger significantly displaced to the down border";
	public:
		static String ^ImproperRollDiagMessString = "Finger has been rolled improperly";
	public:
		static String ^TooFastRollDiagMessString = "Finger has been rolled too much rapidly";
	public:
		static String ^TooNarrowRollDiagMessString = "Finger has been rolled too much narrowly";
	public:
		static String ^RollDirLeftDiagMessString = "Roll Finger to left direction";
	public:
		static String ^RollDirRightDiagMessString = "Roll Finger to right direction";
	// VER 2.9.0.0
	public:
		static String ^DryFingerDiagMessString = "Warning: Dry Finger";
	// VER 2.9.0.0
	public:
		static String ^WetFingerDiagMessString = "Warning: Wet Finger";
	// VER 3.1.0.0
	public:
		static String ^TooShortVerticalRollDiagMessString = "Finger has been rolled too much shortly in vertical direction";
	// end VER 3.1.0.0
	// ver 3.2.0.0
	public:
		static String ^RollDirUpDiagMessString = "Roll up the finger";
	public:
		static String ^RollDirDownDiagMessString = "Roll down the finger";
	// ver 3.2.0.0
	};

	public ref class AutoCapturePhaseStrings
	{
	public:
		static String ^AutoCaptureOffString = "OFF";
	public:
		static String ^AutoCaptureWaitFingerString = "WAIT FINGER";
	public:
		static String ^AutoCaptureSelectImageString = "SELECT IMAGE";
	public:
		static String ^AutoCaptureBestImageStop = "BEST IMAGE STOP";
	public:
		static String ^AutoCaptureBlocked = "BLOCKED";
	};

	/// <summary>
	/// In this class useful routines are defined
	/// </summary>
	public ref class GBMSAPI_Example_Util
	{
	public:
		/// <summary>
		/// This function returns the device name as a string from the
		/// device ID
		/// </summary>
		/// <param name="DevID">
		/// Must be one of those defined in SDK GBMSAPI_NET_DeviceName class
		/// </param>
		/// <returns>
		/// - a number > 0: success
		/// - 0: failure
		/// </returns>
		static String ^GBMSAPI_Example_GetDevNameFromDevID(Byte DevID);

		/// <summary>
		/// This function returns the device ID from the
		/// device name given as a string
		/// </summary>
		/// <param name="DevName">
		/// Must be one of those defined in SDK GBMSAPI_Example_Util class
		/// </param>
		/// <returns>
		/// - a valid string: success
		/// - null: failure
		/// </returns>
		static Byte GBMSAPI_Example_GetDevIDFromDevName(String ^ DevName);

		// Ver 2300: get error string from error code
		/// <summary>
        /// This function gets a meaningful string from the error code
        /// </summary>
        /// <param name="ErrorCode">
        /// Error code
        /// </param>
		static String ^GBMSAPI_Example_GetErrorStringFromCode(Int32 ErrorCode);

		/// <summary>
        /// This function shows the last error occurred passed as a parameter
        /// </summary>
        /// <param name="ErrorCode">
        /// Error code to be shown
        /// </param>
		static void GBMSAPI_Example_ManageErrors(Int32 ErrorCode, String ^FunctionName);

		/// <summary>
        /// Similar to GBMSAPI_Example_ManageErrors(ErrorCode), but USBError showing is forced.
        /// It's useful when calling GBMSAPI_GetAttachedDeviceList function.
        /// </summary>
        /// <param name="ErrorCode"></param>
        /// <param name="USBErrorCode"></param>
        static void GBMSAPI_Example_ManageErrors(Int32 ErrorCode, unsigned long USBErrorCode, String ^FunctionName);

		/// <summary>
        /// Returns a list of scannable objects from a given type
        /// </summary>
        /// <param name="ObjType"></param>
        /// <returns></returns>
        static array<String ^> ^GetObjectsToScanListFromObjectType(unsigned int ObjType);

		/// <summary>
        /// returns a string identifying the object to scan from its ID
        /// </summary>
        /// <param name="ObjToScan"></param>
        /// <returns></returns>
        static String ^GetObjectToScanNameFromID(unsigned int ObjToScan);

		/// <summary>
        /// returns the object to scan ID from its name.
        /// </summary>
        /// <param name="ObjToScanName">
        /// must be one of the objects defined in the 
        /// ScannableObjectStrings class
        /// </param>
        /// <returns></returns>
        static unsigned int GetObjectToScanIDFromName(String ^ ObjToScanName);

		static List<String ^> ^GetFeaturesListFromMask(unsigned int DeviceFeaturesMask);

		static List<String ^> ^GetScannableTypesListFromMask(unsigned int ScannableTypesMask);

		static List<String ^> ^GetDiagStringsFromDiagMask(unsigned int DiagMask);

		static String ^GetAutoCapturePhaseStringFromValue(int AutoCapturePhaseValue);

		static Bitmap ^ClipFrame(
			IntPtr Frame,
			unsigned int FrameSX, unsigned int FrameSY,
			unsigned int ClipPosX, unsigned int ClipPosY,
			unsigned int ClipSX, unsigned int ClipSY,
			IntPtr ClippedFrame
			);

		// ver 2.10.0.0
		static unsigned int GetScanAreaFromObjectType(unsigned int objType, bool flatFingerOnRollArea, bool rollAreaGA);

		// ver 3.1.0.0
		static void CalculatePaintBoxSizeAndLocation(
			unsigned int imsx, unsigned int imsy,
			System::Drawing::Size pbOriginalSize, System::Drawing::Point pbOriginalPoint,
			System::Drawing::Size % pbSize, System::Drawing::Point % pbLocation);

		static void CopyRawImageIntoBitmap(IntPtr RawImage, Bitmap^ % bmpImage)
		{
			try
			{
				BitmapData ^bmData;
				System::Drawing::Rectangle bmpRect = System::Drawing::Rectangle(0, 0, bmpImage->Width, bmpImage->Height);

				bmData = bmpImage->LockBits(bmpRect,
					ImageLockMode::WriteOnly,
					PixelFormat::Format8bppIndexed);

				int diff = bmData->Stride - bmpImage->Width;
				if (diff == 0)
				{
					memcpy((void *)bmData->Scan0.ToPointer(), RawImage.ToPointer(), bmpImage->Width * bmpImage->Height);
				}
				else
				{
					unsigned char * dstPtr = (unsigned char *)bmData->Scan0.ToPointer();
					unsigned char * srcPtr = (unsigned char *)RawImage.ToPointer();
					for (int i = 0; i < bmpImage->Height; i++, dstPtr += bmData->Stride, srcPtr+= bmpImage->Width)
					{
						memcpy((void *)dstPtr, srcPtr, bmpImage->Width);
					}
				}

				// Unlock the bits
				bmpImage->UnlockBits(bmData);

				Imaging::ColorPalette ^pal = bmpImage->Palette;
				for (int i = 0; i < pal->Entries->Length; i++)
				{
					pal->Entries[i] = Color::FromArgb(255, i, i, i);
				}
				bmpImage->Palette = pal;
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message + " in CopyRawImageIntoBitmap", "Error", MessageBoxButtons::OK, MessageBoxIcon::Error);
				return;
			}
		}
		// end ver 2.10.0.0
	};
}

#endif GBMSAPI_UTIL_H