#pragma once
#include "windows.h"
#include "GBMSAPIExampleMainForm.h"
#include "GBMSAPI_Defines.h"
#include "GBMSAPI_Library.h"
#include "GBMSAPIExample_Util.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Runtime::InteropServices;


namespace GBMSAPICExample {

	/// <summary>
	/// Summary for SelectDeviceForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class SelectDeviceForm : public System::Windows::Forms::Form
	{
	public:
		SelectDeviceForm(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//// This form can be opened only with a MainForm as a "father"
			this->Close();
		}

	protected:
		GBMSAPIExampleMainForm	^SelectDeviceCallingWindow;

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~SelectDeviceForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Label^  label1;
	protected: 
	private: System::Windows::Forms::Button^  CancelButton;
	private: System::Windows::Forms::Button^  OKButton;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::ComboBox^  DeviceTypeComboBox;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->CancelButton = (gcnew System::Windows::Forms::Button());
			this->OKButton = (gcnew System::Windows::Forms::Button());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->DeviceTypeComboBox = (gcnew System::Windows::Forms::ComboBox());
			this->SuspendLayout();
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->BackColor = System::Drawing::SystemColors::Desktop;
			this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label1->ForeColor = System::Drawing::SystemColors::ActiveCaptionText;
			this->label1->Location = System::Drawing::Point(10, 80);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(57, 20);
			this->label1->TabIndex = 14;
			this->label1->Text = L"Device";
			// 
			// CancelButton
			// 
			this->CancelButton->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->CancelButton->Location = System::Drawing::Point(167, 165);
			this->CancelButton->Name = L"CancelButton";
			this->CancelButton->Size = System::Drawing::Size(75, 23);
			this->CancelButton->TabIndex = 13;
			this->CancelButton->Text = L"&Cancel";
			this->CancelButton->UseVisualStyleBackColor = true;
			// 
			// OKButton
			// 
			this->OKButton->Location = System::Drawing::Point(14, 165);
			this->OKButton->Name = L"OKButton";
			this->OKButton->Size = System::Drawing::Size(102, 23);
			this->OKButton->TabIndex = 12;
			this->OKButton->Text = L"&Select Device";
			this->OKButton->UseVisualStyleBackColor = true;
			this->OKButton->Click += gcnew System::EventHandler(this, &SelectDeviceForm::OKButton_Click);
			// 
			// label3
			// 
			this->label3->BackColor = System::Drawing::Color::White;
			this->label3->Font = (gcnew System::Drawing::Font(L"Franklin Gothic Medium", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label3->Location = System::Drawing::Point(0, 0);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(268, 69);
			this->label3->TabIndex = 11;
			this->label3->Text = L"Select Device type and serial number, then click Select Device; Cancel To quit";
			this->label3->TextAlign = System::Drawing::ContentAlignment::MiddleLeft;
			// 
			// DeviceTypeComboBox
			// 
			this->DeviceTypeComboBox->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->DeviceTypeComboBox->FormattingEnabled = true;
			this->DeviceTypeComboBox->Location = System::Drawing::Point(10, 112);
			this->DeviceTypeComboBox->Name = L"DeviceTypeComboBox";
			this->DeviceTypeComboBox->Size = System::Drawing::Size(247, 24);
			this->DeviceTypeComboBox->TabIndex = 10;
			// 
			// SelectDeviceForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(270, 207);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->CancelButton);
			this->Controls->Add(this->OKButton);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->DeviceTypeComboBox);
			this->Name = L"SelectDeviceForm";
			this->Text = L"Select Device";
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	public:
		SelectDeviceForm(GBMSAPIExampleMainForm ^CallingWindow)
		{		

			try {
				InitializeComponent();

				if (CallingWindow == nullptr)
				{
					this->Close();
					return;
				}

				this->SelectDeviceCallingWindow = CallingWindow;

				////////////////////////////////
				///// Get device list
				////////////////////////////////
				GBMSAPI_DeviceInfoStruct AttachedDeviceList[GBMSAPI_MAX_PLUGGED_DEVICE_NUM];
				int AttachedDeviceNumber;
				unsigned long USBErrorCode;

				int RetVal = GBMSAPI_GetAttachedDeviceList(AttachedDeviceList,&AttachedDeviceNumber,&USBErrorCode);
				if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR || AttachedDeviceNumber <= 0)
				{
					if (RetVal != GBMSAPI_ERROR_CODE_NO_ERROR)
					{
						GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(RetVal,USBErrorCode,"SelectDeviceForm Constructor");
					}
					
					this->Close();
				}

				////////////////////////////////
				//// Store device list
				////////////////////////////////
				for (int i = 0; i < AttachedDeviceNumber; i ++)
				{
					String ^StrToAdd = GBMSAPI_Example_Util::GBMSAPI_Example_GetDevNameFromDevID(
						AttachedDeviceList[i].DeviceID);
					StrToAdd += " " + gcnew String(AttachedDeviceList[i].DeviceSerialNumber);
					this->DeviceTypeComboBox->Items->Add(StrToAdd);
				}
				if (AttachedDeviceNumber > 0)
				{
					this->DeviceTypeComboBox->SelectedIndex = 0;
				}
			}
			catch (Exception ^ex)
			{
				MessageBox::Show("Error in opening SelectDeviceForm: " + ex->Message);
				this->Close();
			}
		}

	private:
		System::Void OKButton_Click(System::Object^  sender, System::EventArgs^  e) {
			String ^CurrentChoosenDev = (String ^)(this->DeviceTypeComboBox->SelectedItem);

			if (CurrentChoosenDev != nullptr)
			{
				// Parse string: <DevName><Space character><DevSerialNumber>
				int SpacePosition = CurrentChoosenDev->IndexOf(" ");
				String ^DevName = CurrentChoosenDev->Substring(0,SpacePosition);

				String ^DevSerialNumber = CurrentChoosenDev->Substring(SpacePosition);

				if (DevName != nullptr && DevSerialNumber!= nullptr)
				{
					unsigned char DevID = GBMSAPI_Example_Util::GBMSAPI_Example_GetDevIDFromDevName(DevName);
					char *ANSIDevSerialNumber = (char *)(Marshal::StringToHGlobalAnsi(DevSerialNumber)).ToPointer();

					if (DevID != 0)
					{
						int RetVal = GBMSAPI_SetCurrentDevice(DevID,ANSIDevSerialNumber);
						if (RetVal == GBMSAPI_ERROR_CODE_NO_ERROR)
						{
							this->SelectDeviceCallingWindow->GBMSAPIExample_InitMainForm();
						}
						else
						{
							GBMSAPI_Example_Util::GBMSAPI_Example_ManageErrors(RetVal,"SelectDeviceForm OK Button");
						}
					}
				}
			}

			this->Close();
		}
	};
}
