package examples;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.DataBuffer;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Graphics2D;

import com.sun.jna.Pointer;

import GBMSAPI_JAVA_LibraryFunctions.GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library;
import GBMSAPI_JAVA_LibraryFunctions.*;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_ErrorCodesDefines.GBMSAPI_JAVA_ErrorCodes;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_DeviceCharacteristicsDefines.*;
import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_AcquisitionProcessDefines.*;
import com.sun.jna.ptr.ByteByReference;
import java.awt.Color;
import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.awt.Font;

public class AcquisitionGui extends javax.swing.JFrame {

    public static BufferedImage imgFromScanner;
    JLabel lFramePictureBox;
    Timer acquisitionTimer;
    public static int idle = 0;
    public static int preview = 1;
    public static int acquisition = 2;
    public static int scannerStart = 3;
    public static int scannerError = 4;

    public static int acquisitionState = idle;
    public static boolean FrameIsReady = false;
    public static boolean AcquisitionEnded = false;

    public static int imgSx = 0, imgSy = 0;

    public static GB_ExampleAcquisitionCallback AcqCallb = new GB_ExampleAcquisitionCallback();

    public static String GetAcquisitionStateString(int acqState) {
        if (acqState == idle) {
            return "IDLE";
        }
        if (acqState == preview) {
            return "PREVIEW";
        }
        if (acqState == acquisition) {
            return "ACQUISITION";
        }
        if (acqState == scannerStart) {
            return "SCANNER START";
        }
        if (acqState == scannerError) {
            return "ERROR";
        }
        return "UNKNOWN";
    }

    public void drawImage(int x, int y) {
        if (x < 0 || y < 0) {
            return;
        }
        if (imgFromScanner != null && FrameIsReady == true) {
            BufferedImage imgToPaint = new BufferedImage(400, 375, imgFromScanner.getType());
            Graphics2D g = imgToPaint.createGraphics();
            g.drawImage(imgFromScanner, 0, 0, 400, 375, null);
            g.setColor(Color.BLACK);
            g.drawString(GetAcquisitionStateString(acquisitionState), 10, 10);
            g.dispose();
            if (lFramePictureBox != null) {
                this.remove(lFramePictureBox);
            }
            lFramePictureBox = new JLabel(new ImageIcon(imgToPaint));
            lFramePictureBox.setSize(400, 375);
            lFramePictureBox.setLocation(10, 10);
            add(lFramePictureBox);
            lFramePictureBox.setVisible(true);
            FrameIsReady = false;
            System.out.println("Frame drawn!");
            this.repaint();
        }
    }

    public static BufferedImage getImageFromFramePtr(Pointer framePtr, int width, int height) {
        byte[] temp = framePtr.getByteArray(0L, width * height);
        if (temp != null && temp.length > 0) {
            BufferedImage bImage = new BufferedImage(width, height, BufferedImage.TYPE_BYTE_GRAY);
            DataBuffer dataBuf = bImage.getRaster().getDataBuffer();
            for (int i = 0; i < temp.length - 4; i++) {
                int pix = temp[i] & 0xff | (temp[i + 1] & 0xff) << 8;
                dataBuf.setElem(i, pix);
            }
            return bImage;
        }
        return null;
    }

    public BufferedImage CreateBlankImage(int w, int h) {
        BufferedImage bi = new BufferedImage(w, h, BufferedImage.TYPE_BYTE_GRAY);
        DataBuffer dataBuf = bi.getRaster().getDataBuffer();
        for (int i = 0; i < w * h; i++) {
            int pix = 0xFFFFFFFF;
            dataBuf.setElem(i, pix);
        }
        return bi;
    }

    /**
     * Creates new form Antenna
     */
    public AcquisitionGui() {
        initComponents();
        int imgSize = 100;
        this.imgFromScanner = CreateBlankImage(imgSize, imgSize);
        FrameIsReady = true;
        this.drawImage(imgSize, imgSize);
        this.bStartAcquisition.setEnabled(true);
        this.bStopButton.setEnabled(false);
    }

    ActionListener taskPerformer = new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
            //...Perform a task...
            acquisitionTimer.stop();
            if (acquisitionState != idle) {
                drawImage(imgSx, imgSy);
            }
            if (!AcquisitionEnded) {
                acquisitionTimer.start();
            } else {
                acquisitionState = idle;
                FrameIsReady = true;
                drawImage(imgSx, imgSy);
                bStartAcquisition.setEnabled(true);
                bStopButton.setEnabled(false);
            }
        }
    };

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        bStopButton = new javax.swing.JButton();
        bStartAcquisition = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("GBMSAPI JAVA");
        setPreferredSize(new java.awt.Dimension(800, 650));

        bStopButton.setText("STOP");
        bStopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bStopButtonActionPerformed(evt);
            }
        });

        bStartAcquisition.setText("START");
        bStartAcquisition.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bStartAcquisitionActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap(542, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, bStartAcquisition)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, bStopButton))
                .addContainerGap())
        );

        layout.linkSize(new java.awt.Component[] {bStartAcquisition, bStopButton}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(bStartAcquisition)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(bStopButton)
                .addContainerGap(334, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bStartAcquisitionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bStartAcquisitionActionPerformed
        // TODO add your handling code here:
        int RetVal = 0;
        AcquisitionGui.acquisitionState = AcquisitionGui.idle;
        if (acquisitionTimer != null) {
            acquisitionTimer.stop();
        }

        imgSx = -1;
        imgSy = -1;
        AcquisitionEnded = false;

        RetVal = GBMSAPI_Library.INSTANCE.GBMSAPI_StartAcquisition(
                GBMSAPI_JAVA_ScannableObjects.GBMSAPI_JAVA_SO_SLAP_4_LEFT,
                GBMSAPI_JAVA_AcquisitionOptions.GBMSAPI_JAVA_AO_AUTOCAPTURE,
                (GBMSAPI_JAVA_AcquisitionEventsManagerCallbackInterface) AcqCallb, Pointer.NULL,
                0, (byte) 0, (byte) 0);

        if (RetVal != GBMSAPI_JAVA_ErrorCodes.GBMSAPI_JAVA_ERROR_CODE_NO_ERROR) {
            System.out.println("FAILURE in GBMSAPI_StartAcquisition, exit");
            AcquisitionGui.acquisitionState = AcquisitionGui.idle;
            return;
        }
        AcquisitionGui.acquisitionState = AcquisitionGui.scannerStart;
        this.imgFromScanner = CreateBlankImage(100, 100);
        FrameIsReady = true;
        this.drawImage(100, 100);
        this.bStartAcquisition.setEnabled(false);
        this.bStopButton.setEnabled(true);
        acquisitionTimer = new Timer(100, taskPerformer);
        acquisitionTimer.start();
    }//GEN-LAST:event_bStartAcquisitionActionPerformed

    private void bStopButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bStopButtonActionPerformed
        // TODO add your handling code here:
        GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_StopAcquisition();
        this.bStartAcquisition.setEnabled(true);
        this.bStopButton.setEnabled(false);
    }//GEN-LAST:event_bStopButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            javax.swing.UIManager.LookAndFeelInfo[] installedLookAndFeels = javax.swing.UIManager.getInstalledLookAndFeels();
            for (int idx = 0; idx < installedLookAndFeels.length; idx++) {
                if ("Nimbus".equals(installedLookAndFeels[idx].getName())) {
                    javax.swing.UIManager.setLookAndFeel(installedLookAndFeels[idx].getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(AcquisitionGui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(AcquisitionGui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(AcquisitionGui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(AcquisitionGui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AcquisitionGui().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bStartAcquisition;
    private javax.swing.JButton bStopButton;
    // End of variables declaration//GEN-END:variables

}
