/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package examples;

import GBMSAPI_JAVA_Defines.GBMSAPI_JAVA_AcquisitionProcessDefines.GBMSAPI_JAVA_AcquisitionEvents;
import GBMSAPI_JAVA_LibraryFunctions.GBMSAPI_JAVA_AcquisitionEventsManagerCallbackInterface;
import GBMSAPI_JAVA_LibraryFunctions.GBMSAPI_JAVA_DLL_WRAPPER;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.ByteByReference;
import java.io.DataOutputStream;
import java.io.FileOutputStream;

import examples.AcquisitionGui;
import static examples.AcquisitionGui.FrameIsReady;

/**
 *
 * @author andrea
 */
public class GB_ExampleAcquisitionCallback implements GBMSAPI_JAVA_AcquisitionEventsManagerCallbackInterface {

    public int invoke(
	    int OccurredEventCode,
	    int GetFrameErrorCode,
	    int EventInfo,
	    Pointer FramePtr,
	    int FrameSizeX,
	    int FrameSizeY,
	    double CurrentFrameRate,
	    double NominalFrameRate,
	    int GB_Diagnostic,
	    Pointer UserDefinedParameters) {
	if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_VALID_FRAME_ACQUIRED) {
	    if (GB_Diagnostic != 0)
	    {
		System.out.println("Diagnostic: " + GB_Diagnostic);
		GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_VUI_LED_BlinkDuringAcquisition(1);
		//GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_SetAutoCaptureBlocking(1);
	    }
	    else
	    {
		GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_VUI_LED_BlinkDuringAcquisition(0);
		GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_SetAutoCaptureBlocking(0);
	    }
	    //////////////////////////////////////////////
	    // Following contrast calculation shows how
	    // the fact that in Java unsigned types don't
	    // exist should be treated and the
	    // 2-complement calculation for a byte
	    //////////////////////////////////////////////
	    ByteByReference pContrast = new ByteByReference();
	    GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_GetFingerprintContrast(pContrast);
	    int Contrast;
	    if (pContrast.getValue() >= 0)
	    {
		Contrast = pContrast.getValue();
	    }
	    else
	    {
		Contrast = 256 + pContrast.getValue();
	    }
            AcquisitionGui.imgSx = FrameSizeX;
            AcquisitionGui.imgSy = FrameSizeY;

            AcquisitionGui.imgFromScanner = AcquisitionGui.getImageFromFramePtr(FramePtr, FrameSizeX, FrameSizeY);
            AcquisitionGui.FrameIsReady = true;
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_ACQUISITION_END) {
	    System.out.println("Acquisition end!");
	    GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_ImageFinalization(FramePtr);
            AcquisitionGui.imgSx = FrameSizeX;
            AcquisitionGui.imgSy = FrameSizeY;
            AcquisitionGui.imgFromScanner = AcquisitionGui.getImageFromFramePtr(FramePtr, FrameSizeX, FrameSizeY);
            AcquisitionGui.FrameIsReady = true;
            AcquisitionGui.AcquisitionEnded = true;
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_ACQUISITION_ERROR) {
	    System.out.println("Acquisition error!");
            AcquisitionGui.acquisitionState = AcquisitionGui.scannerError;
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_PREVIEW_PHASE_END) {
            GBMSAPI_JAVA_DLL_WRAPPER.GBMSAPI_Library.INSTANCE.GBMSAPI_Sound((byte)12,(byte)2,(byte)1);
            AcquisitionGui.acquisitionState = AcquisitionGui.acquisition;
	}
	else if (OccurredEventCode == GBMSAPI_JAVA_AcquisitionEvents.GBMSAPI_JAVA_AE_SCANNER_STARTED) {
            AcquisitionGui.acquisitionState = AcquisitionGui.preview;
	}
	else {
	    return 0;
	}

	return 1;
    }
}
