#ifndef GB_WIN_VER_H
#define GB_WIN_VER_H

/*
#ifdef GB_WINVER_EXPORTS
#define GB_WINVER_API __declspec(dllexport)
#else
#define GB_WINVER_API __declspec(dllimport)
#endif
*/
#define GB_WINVER_API

//---------------------------------------------------------
//---------------------------------------------------------
//	SECTION 1: RETURN CODES
//---------------------------------------------------------
//---------------------------------------------------------
#define GB_SUCCESS	(BOOL)TRUE
#define GB_FAILURE	(BOOL)FALSE
//---------------------------------------------------------
//---------------------------------------------------------
//	SECTION 2: TYPEDEFS
//---------------------------------------------------------
//---------------------------------------------------------
typedef enum GB_WINVER_ENUM_TAG
{
	GB_WinVer_Unknown = 0,
	GB_WinVer_Win7 = 1,
	GB_WinVer_WinServ2008R2 = 2,
	GB_WinVer_WinServ2008 = 3,
	GB_WinVer_WinVista = 4,
	GB_WinVer_WinServ2003 = 5,
	GB_WinVer_WinXP = 6,
	GB_WinVer_Win2K = 7,
	GB_WinVer_WinNT40 = 8
}GB_WinVer_Enum;

typedef enum GB_OS_BITS_TAG
{
	GB_OsBits_Unknown = 0,
	GB_OsBits_32 = 32,
	GB_OsBits_64 = 64
}GB_OsBits_Enum;

typedef struct GB_OS_INFO_TAG
{
	int Version; // can be one within GB_WinVer_Enum
	int	OsBits; // can be one within GB_WinVer_Enum
}GB_OsInfo_Struct;

//---------------------------------------------------------
//---------------------------------------------------------
//	SECTION 3: ROUTINES
//---------------------------------------------------------
//---------------------------------------------------------
///////////////////////////////////////////////////////////
// - Remarks:
//		values into "OsInfoToRetrieve" output parameter are
//		valid only if function returns "GB_SUCCESS"
//
// - Return values:
//		see section 1
///////////////////////////////////////////////////////////
extern "C" GB_WINVER_API BOOL GB_GetWindowsInfo(GB_OsInfo_Struct *OsInfoToRetrieve);

#endif // GB_WIN_VER_H