using System;
using System.Collections.Generic;
using System.Text;

namespace GBMSAPI_NET
{
    namespace GBMSAPI_NET_Defines
    {
        //////////////////////////////////////////////////////////////////////
        //////// ERROR CODES /////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////
        namespace GBMSAPI_NET_ErrorCodesDefines
        {
            //////////////////////////////////////////////////////////////////////
            //////// ERROR CODES /////////////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See ERROR CODES section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_ErrorCodes
            {
                // Low level errors
                public const Int32 GBMSAPI_NET_ERROR_CODE_NO_ERROR = 0;
                public const Int32 GBMSAPI_NET_ERROR_CODE_USB_DRIVER = 1;
                public const Int32 GBMSAPI_NET_ERROR_CODE_DEVICE_NOT_FOUND = 2;
                public const Int32 GBMSAPI_NET_ERROR_CODE_USB_THREAD = 3;
                public const Int32 GBMSAPI_NET_ERROR_CODE_PARAMETER = 4;
                public const Int32 GBMSAPI_NET_ERROR_CODE_SCANNER_NOT_CONFIGURED = 5;
                public const Int32 GBMSAPI_NET_ERROR_CODE_DEVICE_NOT_RESPONDING = 6;
                public const Int32 GBMSAPI_NET_ERROR_CODE_SCANNER_COMMUNICATION = 7;
                public const Int32 GBMSAPI_NET_ERROR_CODE_UNAVAILABLE_OPTION = 8;
                public const Int32 GBMSAPI_NET_ERROR_CODE_INTERNAL = 9;
                // VER 2.7.1.0: MC517
                public const Int32 GBMSAPI_NET_ERROR_CODE_USB_FULLSPEED_NOT_SUPPORTED = 10; // Mc517

                // GBMSAPI_NET errors
                public const Int32 GBMSAPI_NET_ERROR_CODE_SPECIFIC_DLL_NOT_LOADED = 30;
                public const Int32 GBMSAPI_NET_ERROR_CODE_METHOD_NOT_SUPPORTED = 31;
                public const Int32 GBMSAPI_NET_ERROR_CODE_OBJECT_TYPE_NOT_SUPPORTED = 32;
                public const Int32 GBMSAPI_NET_ERROR_CODE_SCAN_AREA_NOT_SUPPORTED = 33;
                public const Int32 GBMSAPI_NET_ERROR_CODE_ACQUISITION_THREAD = 34;
                public const Int32 GBMSAPI_NET_ERROR_CODE_ACQUISITION_ALREADY_STARTED = 35;
                public const Int32 GBMSAPI_NET_ERROR_CODE_FEATURE_NOT_SUPPORTED = 36;
                public const Int32 GBMSAPI_NET_ERROR_CODE_CURRENT_DEV_NOT_SET = 37;
                public const Int32 GBMSAPI_NET_ERROR_CODE_MEMORY_ALLOCATION = 38;
                public const Int32 GBMSAPI_NET_ERROR_CODE_GENERIC = 39;
                // ver 3.3.0.0
                public static Int32 GBMSAPI_NET_ERROR_CODE_OUTSIDE_ACQUISITION = 40;
                // end ver 3.3.0.0

                // Exception
                public const Int32 GBMSAPI_NET_ERROR_CODE_EXCEPTION = 255;
                public static String GBMSAPI_NET_ERROR_CODE_EXCEPTION_STRING;
            }
        }

        //////////////////////////////////////////////////////////////////////
        //////// DEVICE CHARACTERISTICS //////////////////////////////////////
        //////////////////////////////////////////////////////////////////////
        namespace GBMSAPI_NET_DeviceCharacteristicsDefines
        {
            //////////////////////////////////////////////////////////////////////
            //////// DEVICE NAME /////////////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See DEVICE NAME section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_DeviceName
            {
                public const Byte GBMSAPI_NET_DN_DS84 = 1; // DactyScan84
                public const Byte GBMSAPI_NET_DN_MS500 = 2; // MultiScan500
                public const Byte GBMSAPI_NET_DN_MS1000 = 3; // MultiScan1000
                public const Byte GBMSAPI_NET_DN_VS3 = 4; // VisaScan3
                public const Byte GBMSAPI_NET_DN_PS2 = 5; // PoliScan2
                public const Byte GBMSAPI_NET_DN_DS40 = 6; // DactyScan40
                public const Byte GBMSAPI_NET_DN_DS26 = 7; // DactyScan26
                // VER 2400
                // Added for Chinese Market Version of MS500 device
                public const Byte GBMSAPI_NET_DN_MC500 = 8;
                public const Byte GBMSAPI_NET_DN_MSC500 = 9;
                // VER 2500:
                public const Byte GBMSAPI_NET_DN_DS40I = 10;	// DactyScan40i
                // VER 2700: DS84C
                public const Byte GBMSAPI_NET_DN_DS84C = 11; // DactyScan84c
                // VER 2.7.1.0: MC517
                public const Byte GBMSAPI_NET_DN_MC517 = 12; // Mc517
                // VER 2.8.0.0: MSC517
                public const Byte GBMSAPI_NET_DN_MSC517 = 13; // MSC517
                // VER 2.8.0.0: DS32
				public const Byte GBMSAPI_NET_DN_DS32 = 14; // DactyScan 32
				// Ver 2.10.0.0: add MS527 device
				public const Byte GBMSAPI_NET_DN_MS527 = 15; // MS527
				// end Ver 2.10.0.0
            }

            ///////////////////////////////////////////////////////////////////////
            //////// DEVICE INFO //////////////////////////////////////////////////
            ///////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See DEVICE INFO section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_DeviceInfoConstants
            {
                public const Int32 GBMSAPI_NET_MAX_PLUGGED_DEVICE_NUM = 127;
                public const Int32 GBMSAPI_NET_MAX_SN_LENGHT = 20;
                public const Int32 GBMSAPI_NET_MAX_CHARS_IN_DEVICE_NAME_AND_INFO = 512;
            }

            /// <summary>
            /// See GBMSAPI_DEVICE_INFO_STRUCT structure in DEVICE INFO section in 
            /// GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_DeviceInfoStruct
            {
                public Byte DeviceID;
                public String DeviceSerialNumber;
            }

            //////////////////////////////////////////////////////////////////////
            //////// SCANNABLE BIOMETRIC TYPES ///////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See SCANNABLE BIOMETRIC TYPES section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_ScannableBiometricTypes
            {
                public const UInt32 GBMSAPI_NET_SBT_NO_OBJECT_TYPE = 0x00000000;

                public const UInt32 GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER = 0x00000001;

                public const UInt32 GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER = 0x00000002;

                public const UInt32 GBMSAPI_NET_SBT_FLAT_SLAP_4 = 0x00000004;

                public const UInt32 GBMSAPI_NET_SBT_FLAT_SLAP_2 = 0x00000008;

                public const UInt32 GBMSAPI_NET_SBT_FLAT_THUMBS_2 = 0x00000010;

                // VER 2000
                public const UInt32 GBMSAPI_NET_SBT_FLAT_INDEXES_2 = 0x00000100;

                public const UInt32 GBMSAPI_NET_SBT_FLAT_LOWER_HALF_PALM = 0x00000020;

                public const UInt32 GBMSAPI_NET_SBT_FLAT_UPPER_HALF_PALM = 0x00000040;

                public const UInt32 GBMSAPI_NET_SBT_FLAT_WRITER_PALM = 0x00000080;

				// VER 2.10.0.0 Addition of supplemental objects (see EBTS standard)
                public const UInt32 GBMSAPI_NET_SBT_ROLLED_THENAR = 0x00000200;

                public const UInt32 GBMSAPI_NET_SBT_ROLLED_JOINT = 0x00000400;

                public const UInt32 GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE = 0x00000800;

                public const UInt32 GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE = 0x00001000;

                public const UInt32 GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER = 0x00002000;

                public const UInt32 GBMSAPI_NET_SBT_ROLLED_TIP = 0x00004000;
				// end Ver 2.10.0.0
                // Ver 3.2.0.0
                public const UInt32 GBMSAPI_NET_SBT_ROLLED_UP = 0x00008000;

                public const UInt32 GBMSAPI_NET_SBT_ROLLED_DOWN = 0x00010000;
                // end Ver 3.2.0.0
                
                // Ver 3.3.0.0
                public const UInt32 GBMSAPI_NET_SBT_ROLLED_HYPOTHENAR = 0x00020000;
                // end Ver 3.3.0.0

                public const UInt32 GBMSAPI_NET_SBT_PHOTO = 0x80000000;
            }

            //////////////////////////////////////////////////////////////////////
            ///// SCANNABLE OBJECTS //////////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See SCANNABLE OBJECTS section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_ScannableObjects
            {
                public const UInt32 GBMSAPI_NET_SBT_NO_OBJECT = 0;
                /********************************************************************
                *	FLAT FINGERS													*
                ********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_FLAT_RIGHT_THUMB = 1;
                public const UInt32 GBMSAPI_NET_SO_FLAT_RIGHT_INDEX = 2;
                public const UInt32 GBMSAPI_NET_SO_FLAT_RIGHT_MIDDLE = 3;
                public const UInt32 GBMSAPI_NET_SO_FLAT_RIGHT_RING = 4;
                public const UInt32 GBMSAPI_NET_SO_FLAT_RIGHT_LITTLE = 5;
                public const UInt32 GBMSAPI_NET_SO_FLAT_LEFT_THUMB = 6;
                public const UInt32 GBMSAPI_NET_SO_FLAT_LEFT_INDEX = 7;
                public const UInt32 GBMSAPI_NET_SO_FLAT_LEFT_MIDDLE = 8;
                public const UInt32 GBMSAPI_NET_SO_FLAT_LEFT_RING = 9;
                public const UInt32 GBMSAPI_NET_SO_FLAT_LEFT_LITTLE = 10;
                /********************************************************************
                *	ROLL FINGERS													*
                ********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_ROLL_RIGHT_THUMB = 11;
                public const UInt32 GBMSAPI_NET_SO_ROLL_RIGHT_INDEX = 12;
                public const UInt32 GBMSAPI_NET_SO_ROLL_RIGHT_MIDDLE = 13;
                public const UInt32 GBMSAPI_NET_SO_ROLL_RIGHT_RING = 14;
                public const UInt32 GBMSAPI_NET_SO_ROLL_RIGHT_LITTLE = 15;
                public const UInt32 GBMSAPI_NET_SO_ROLL_LEFT_THUMB = 16;
                public const UInt32 GBMSAPI_NET_SO_ROLL_LEFT_INDEX = 17;
                public const UInt32 GBMSAPI_NET_SO_ROLL_LEFT_MIDDLE = 18;
                public const UInt32 GBMSAPI_NET_SO_ROLL_LEFT_RING = 19;
                public const UInt32 GBMSAPI_NET_SO_ROLL_LEFT_LITTLE = 20;
                /********************************************************************
                *	SLAPS		        											*
                ********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_SLAP_2_THUMBS = 21;
                public const UInt32 GBMSAPI_NET_SO_SLAP_4_LEFT = 22;
                public const UInt32 GBMSAPI_NET_SO_SLAP_4_RIGHT = 23;
                public const UInt32 GBMSAPI_NET_SO_SLAP_2_LEFT = 24;
                public const UInt32 GBMSAPI_NET_SO_SLAP_2_RIGHT = 25;
                // VER 2000
                public const UInt32 GBMSAPI_NET_SO_SLAP_2_INDEXES = 33;
                /********************************************************************
                *	PALM/WRITER 													*
                ********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_UPPER_HALF_PALM_LEFT = 26;
                public const UInt32 GBMSAPI_NET_SO_UPPER_HALF_PALM_RIGHT = 27;
                public const UInt32 GBMSAPI_NET_SO_LOWER_HALF_PALM_LEFT = 28;
                public const UInt32 GBMSAPI_NET_SO_LOWER_HALF_PALM_RIGHT = 29;
                public const UInt32 GBMSAPI_NET_SO_WRITER_PALM_LEFT = 30;
                public const UInt32 GBMSAPI_NET_SO_WRITER_PALM_RIGHT = 31;
                /********************************************************************
                *	PHOTO        													*
                ********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_PHOTO = 32;
				// Ver 2.10.0.0
				/********************************************************************
				*	THENAR															*
				********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_ROLLED_THENAR_LEFT		 = 85;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_THENAR_RIGHT		 = 34;
				/********************************************************************
				*	ROLL JOINTS														*
				********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_THUMB			 = 35;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_INDEX			 = 36;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_MIDDLE		 = 37;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_RING			 = 38;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_LITTLE		 = 39;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_THUMB			 = 40;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_INDEX			 = 41;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_MIDDLE			 = 42;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_RING			 = 43;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_LITTLE			 = 44;
				/********************************************************************
				*	PLAIN LEFT JOINTS												*
				********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_THUMB			 = 45;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_INDEX			 = 46;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_MIDDLE			 = 47;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_RING			 = 48;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_LITTLE			 = 49;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_THUMB			 = 50;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_INDEX			 = 51;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_MIDDLE			 = 52;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_RING				 = 53;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_LITTLE			 = 54;
				/********************************************************************
				*	PLAIN RIGHT JOINTS												*
				********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_THUMB			 = 55;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_INDEX			 = 56;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_MIDDLE			 = 57;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_RING			 = 58;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_LITTLE			 = 59;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_THUMB			 = 60;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_INDEX			 = 61;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_MIDDLE			 = 62;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_RING			 = 63;
                public const UInt32 GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_LITTLE			 = 64;
				/********************************************************************
				*	PLAIN CENTER JOINTS												*
				********************************************************************/
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_THUMB			 = 65;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_INDEX			 = 66;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_MIDDLE		 = 67;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_RING			 = 68;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_LITTLE		 = 69;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_THUMB			 = 70;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_INDEX			 = 71;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_MIDDLE			 = 72;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_RING			 = 73;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_LITTLE			 = 74;
				/********************************************************************
				*	ROLL TIPS														*
				********************************************************************/
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_THUMB			 = 75;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_INDEX			 = 76;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_MIDDLE			 = 77;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_RING			 = 78;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_LITTLE			 = 79;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_LEFT_THUMB			 = 80;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_LEFT_INDEX			 = 81;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_LEFT_MIDDLE			 = 82;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_LEFT_RING				 = 83;
				public const UInt32 GBMSAPI_NET_SO_ROLLED_TIP_LEFT_LITTLE			 = 84;
				// end Ver 2.10.0.0
                // Ver 3.2.0.0
                /********************************************************************
                *	ROLL TOP														*
                ********************************************************************/
                // These objects belong to GBMSAPI_SBT_ROLLED_UP type
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_RIGHT_THUMB			 = 86;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_RIGHT_INDEX			 = 87;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_RIGHT_MIDDLE			 = 88;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_RIGHT_RING			 = 89;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_RIGHT_LITTLE			 = 90;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_LEFT_THUMB			 = 91;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_LEFT_INDEX			 = 92;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_LEFT_MIDDLE			 = 93;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_LEFT_RING				 = 94;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_UP_LEFT_LITTLE			 = 95;
                /********************************************************************
                *	ROLL DOWN														*
                ********************************************************************/
                // These objects belong to GBMSAPI_SBT_ROLLED_DOWN type
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_THUMB			 = 96;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_INDEX			 = 97;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_MIDDLE			 = 98;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_RING			 = 99;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_LITTLE			 = 100;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_THUMB			 = 101;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_INDEX			 = 102;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_MIDDLE			 = 103;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_RING			 = 104;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_LITTLE			 = 105;
                // end Ver 3.2.0.0
                // Ver 3.3.0.0
                /********************************************************************
                *	ROLLED HYPOTHENAR												*
                ********************************************************************/
                // These objects belong to GBMSAPI_SBT_ROLLED_HYPOTHENAR type
                public const UInt32 GBMSAPI_NET_SO_ROLLED_HYPOTHENAR_LEFT			 = 106;
                public const UInt32 GBMSAPI_NET_SO_ROLLED_HYPOTHENAR_RIGHT			 = 107;
                // end Ver 3.3.0.0
            }

			/// <summary>
            /// In this class some useful routines dealing with objects that can
            /// be scanned are given.
            /// </summary>
            public class GBMSAPI_NET_ScanObjectsUtilities
            {
                /// <summary>
                /// Given a <paramref name="ObjToScan"/> object, this function
                /// returns its type (<seealso cref="GBMSAPI_NET_ScannableObjects"/> and
                /// <seealso cref="GBMSAPI_NET_ScannableBiometricTypes"/> classes.
                /// </summary>
                /// 
                /// <param name="ObjToScan">
                /// Object whose type is wanted. Must be one of the objects
                /// defined in <see cref="GBMSAPI_NET_ScannableObjects"/> class,
                /// otherwise 0 is returned.
                /// </param>
                /// 
                /// <returns>
                /// -   Different from 0:
                ///     Type of the <paramref name="ObjToScan"/> object.
                /// -   0:
                ///     <paramref name="ObjToScan"/> was wrong.
                /// </returns>
                public static UInt32 GBMSAPI_NET_GetTypeFromObject(UInt32 ObjToScan)
                {

                    switch (ObjToScan)
                    {
                        // FLAT FING
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_RIGHT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_RIGHT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_RIGHT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_RIGHT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_RIGHT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_LEFT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_LEFT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_LEFT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_LEFT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_FLAT_LEFT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SINGLE_FINGER;
                        // ROLL FING
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_RIGHT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_RIGHT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_RIGHT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_RIGHT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_RIGHT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_LEFT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_LEFT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_LEFT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_LEFT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLL_LEFT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLL_SINGLE_FINGER;
                        // FLAT_THUMBS_2
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_SLAP_2_THUMBS:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_THUMBS_2;
                        // VER 2000
                        // FLAT_THUMBS_2
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_SLAP_2_INDEXES:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_INDEXES_2;
                        // end VER 2000
                        // FLAT_SLAP_4
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_SLAP_4_LEFT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SLAP_4;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_SLAP_4_RIGHT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SLAP_4;
                        // FLAT_SLAP_2
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_SLAP_2_LEFT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SLAP_2;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_SLAP_2_RIGHT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_SLAP_2;
                        // UPPER_HALF_PALM
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_UPPER_HALF_PALM_LEFT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_UPPER_HALF_PALM;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_UPPER_HALF_PALM_RIGHT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_UPPER_HALF_PALM;
                        // LOWER_HALF_PALM
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_LOWER_HALF_PALM_LEFT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_LOWER_HALF_PALM;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_LOWER_HALF_PALM_RIGHT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_LOWER_HALF_PALM;
                        // WRITER_PALM
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_WRITER_PALM_LEFT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_WRITER_PALM;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_WRITER_PALM_RIGHT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_FLAT_WRITER_PALM;
                        // PHOTO
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PHOTO:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PHOTO;
                        // Ver 3.3.0.0
                        // GBMSAPI_SBT_ROLLED_HYPOTHENAR
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_HYPOTHENAR_LEFT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_HYPOTHENAR;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_HYPOTHENAR_RIGHT:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_HYPOTHENAR;
                        // end Ver 3.3.0.0
                        // Ver 2.10.0.0
						// GBMSAPI_SBT_ROLLED_THENAR
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_THENAR_LEFT:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_THENAR;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_THENAR_RIGHT:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_THENAR;
						// GBMSAPI_SBT_ROLLED_JOINT
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_RIGHT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_LEFT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT;
						// GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_RIGHT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_LEFT_SIDE_LEFT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_LEFT_SIDE;
						// GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_RIGHT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_PLAIN_JOINT_RIGHT_SIDE_LEFT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_PLAIN_JOINT_RIGHT_SIDE;
						// GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_RIGHT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_JOINT_CENTER_LEFT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_JOINT_CENTER;
						// GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_RIGHT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_LEFT_THUMB:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_LEFT_INDEX:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_LEFT_MIDDLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_LEFT_RING:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
						case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_TIP_LEFT_LITTLE:
							return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_TIP;
                        // end Ver 2.10.0.0
                        // Ver 3.2.0.0
                        // _ROLLED_UP
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_RIGHT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_RIGHT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_RIGHT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_RIGHT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_RIGHT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_LEFT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_LEFT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_LEFT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_LEFT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_UP_LEFT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_UP;
                        // ROLLED_DOWN
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_RIGHT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_THUMB:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_INDEX:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_MIDDLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_RING:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        case GBMSAPI_NET_ScannableObjects.GBMSAPI_NET_SO_ROLLED_DOWN_LEFT_LITTLE:
                            return GBMSAPI_NET_ScannableBiometricTypes.GBMSAPI_NET_SBT_ROLLED_DOWN;
                        // end Ver 3.2.0.0
                        // DEFAULT
                        default:
                            return 0;
                    }
                }
			}

			// Ver 2.10.0.0
			/// <summary>
			/// see "SCANNER ACQUISITION AREAS" section in GBMSAPI_Defines.h file
			/// </summary>
			public class GBMSAPI_NET_ScanAreas
			{
				public const UInt32 GBMSAPI_NET_SA_FULL_FRAME = 0x00000001;
				public const UInt32 GBMSAPI_NET_SA_ROLL_IQS = 0x00000002;
				public const UInt32 GBMSAPI_NET_SA_ROLL_GA = 0x00000004;
				public const UInt32 GBMSAPI_NET_SA_ROLL_THENAR = 0x00000008;
				public const UInt32 GBMSAPI_NET_SA_ROLL_JOINT = 0x00000010;
				public const UInt32 GBMSAPI_NET_SA_PHOTO = 0x10000000;
			}
			// end Ver 2.10.0.0

            //////////////////////////////////////////////////////////////////////
            ////// DEVICE FEATURES ///////////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See DEVICE FEATURES section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_DeviceFeatures
            {
                public const UInt32 GBMSAPI_NET_DF_MULTIPLE_USB_CONNECTIONS_ALLOWED = 0x00000001;
                public const UInt32 GBMSAPI_NET_DF_AUTO_CAPTURE_BLOCKING = 0x00000002;
                public const UInt32 GBMSAPI_NET_DF_1000DPI_RESOLUTION = 0x00000004;
                // Ver 2500: added Image rotation feature
                public const UInt32 GBMSAPI_NET_DF_IMAGE_ROTATION = 0x00000008;
                // Ver 2700: added permanent data storage feature
                public const UInt32 GBMSAPI_NET_DF_PERMANENT_USER_DATA_STORAGE = 0x00000010;
                // Ver 2700: added frame rate setting capability
                public const UInt32 GBMSAPI_NET_DF_FRAME_RATE_SETTING = 0x00000020;
                // Ver 2700: FIRMWARE INFO RETRIEVING CAPABILITY
                public const UInt32 GBMSAPI_NET_DF_FW_INFO_RETRIEVE = 0x00000040;
                // Ver 2.7.1.0: ROLL AREA STANDARDS
                public const UInt32 GBMSAPI_NET_DF_ROLL_AREA_IQS = 0x00000080;
                // Ver 2.7.1.0: ROLL AREA STANDARDS
                public const UInt32 GBMSAPI_NET_DF_ROLL_AREA_GA = 0x00000100;
				// VER 2.9.0.0: added enhancement for dry skin images
                public const UInt32 GBMSAPI_NET_DF_DRY_SKIN_IMG_ENHANCE = 0x00000200;
                // VER 3.1.0.0
                public const UInt32 GBMSAPI_NET_DF_ROLL_OBJECT_STRIPE = 0x00000400;
                public const UInt32 GBMSAPI_NET_DF_UPDATE_BACKGROUND_IMAGE = 0x00000800;
                // end VER 3.1.0.0
                // VER 3.2.0.0
                public const UInt32 GBMSAPI_NET_DF_ENABLE_BLOCK_ROLL_COMPOSITION = 0x00001000;
                // end VER 3.2.0.0
            }

            // Ver 2500: added Image rotation feature
            public class GBMSAPI_NET_ImageRotationValues
            {
                public const Int32 GBMSAPI_NET_IMG_ROTATE_NO = 0;
                public const Int32 GBMSAPI_NET_IMG_ROTATE_90_CW = 1;
                public const Int32 GBMSAPI_NET_IMG_ROTATE_90_CCW = 2;
                public const Int32 GBMSAPI_NET_IMG_ROTATE_180 = 3;
            }

            //////////////////////////////////////////////////////////////////////
            ////// AVAILABLE IMAGE INFO //////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See AVAILABLE IMAGE INFO section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_AvailableImageInfo
            {
                public const UInt32 GBMSAPI_NET_AII_FINGERPRINT_SIZE = 0x00000001;
                public const UInt32 GBMSAPI_NET_AII_FINGERPRINT_CONTRAST = 0x00000002;
                public const UInt32 GBMSAPI_NET_AII_LOWER_HALF_PALM_COMPLETENESS = 0x00000004;
            }

            //////////////////////////////////////////////////////////////////////
            ////// FRAME RATE OPTIONS ///////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See FRAME RATE OPTIONS section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_FrameRateOptions
            {
                public const UInt32 GBMSAPI_NET_FRO_ROLL_AREA = 0x00000001;
                public const UInt32 GBMSAPI_NET_FRO_FULL_RESOLUTION_MODE = 0x00000002;
                public const UInt32 GBMSAPI_NET_FRO_FLAT_OBJECT_ON_ROLL_AREA = 0x00000004;
                // ver 3.1.0.0
                public const UInt32 GBMSAPI_NET_FRO_ADAPT_ROLL_AREA_POSITION = 0x00000008;
                public const UInt32 GBMSAPI_NET_FRO_HIGH_RES_IN_PREVIEW = 0x00000010;
                // end ver 3.1.0.0
            }

            // VER 2700
            // VER 2800: CONSIDER THE FOLLOWING DEFINES AS OBSOLETE: they will be
            // commented, and Green Bit recommends to use the
            // GBMSAPI_NET_GetFrameRateRange_Global(...) function instead of them
            //////////////////////////////////////////////////////////////////////
            ////// FRAME RATE RANGE FOR DEVICES //////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See FRAME RATE RANGE FOR DEVICES section in GBMSAPI_Defines.h file.
            /// </summary>
            //public class GBMSAPI_NET_FrameRateRangeLimits
            //{
            //    /////////////////////////////////////////////////////////////////////
            //    // DactyScan 84
            //    /////////////////////////////////////////////////////////////////////
            //    // Flat Area - Flat Mode - High Resolution Frame
            //    public const Double GBMSAPI_NET_DS84_FLAT_FLAT_FULLRES_MAX_FRAME_RATE = ((double)5.0);
            //    public const Double GBMSAPI_NET_DS84_FLAT_FLAT_FULLRES_MIN_FRAME_RATE = ((double)2.5);
            //    public const Double GBMSAPI_NET_DS84_FLAT_FLAT_FULLRES_DEF_FRAME_RATE = ((double)5.0);
            //    // Roll Area - Roll Mode - High Resolution Frame
            //    public const Double GBMSAPI_NET_DS84_ROLL_ROLL_FULLRES_MAX_FRAME_RATE = ((double)15.0);
            //    public const Double GBMSAPI_NET_DS84_ROLL_ROLL_FULLRES_MIN_FRAME_RATE = ((double)11.0);
            //    public const Double GBMSAPI_NET_DS84_ROLL_ROLL_FULLRES_DEF_FRAME_RATE = ((double)15.0);
            //    // Roll Area - Flat Mode - High Resolution Frame;
            //    public const Double GBMSAPI_NET_DS84_ROLL_FLAT_FULLRES_MAX_FRAME_RATE = ((double)15.0);
            //    public const Double GBMSAPI_NET_DS84_ROLL_FLAT_FULLRES_MIN_FRAME_RATE = ((double)5.0);
            //    public const Double GBMSAPI_NET_DS84_ROLL_FLAT_FULLRES_DEF_FRAME_RATE = ((double)15.0);

            //    ///////////////////////
            //    // DactyScan 26
            //    ///////////////////////
            //    // Flat Area - Flat Mode - High Resolution Frame
            //    public const Double GBMSAPI_NET_DS26_FLAT_FLAT_FULLRES_MAX_FRAME_RATE = ((double)10.0);
            //    public const Double GBMSAPI_NET_DS26_FLAT_FLAT_FULLRES_MIN_FRAME_RATE = ((double)2.5);
            //    public const Double GBMSAPI_NET_DS26_FLAT_FLAT_FULLRES_DEF_FRAME_RATE = ((double)5.0);

            //    /////////////////////////////////////////////////////////////////////
            //    // DactyScan 40i
            //    /////////////////////////////////////////////////////////////////////
            //    // Roll Area - Roll Mode - High Resolution Frame;
            //    public const Double GBMSAPI_NET_DS40I_ROLL_ROLL_FULLRES_MAX_FRAME_RATE = ((double)16.0);
            //    public const Double GBMSAPI_NET_DS40I_ROLL_ROLL_FULLRES_MIN_FRAME_RATE = ((double)2.5);
            //    public const Double GBMSAPI_NET_DS40I_ROLL_ROLL_FULLRES_DEF_FRAME_RATE = ((double)12.0);
            //    // Flat Area - Flat Mode - High Resolution Frame;
            //    public const Double GBMSAPI_NET_DS40I_FLAT_FLAT_FULLRES_MAX_FRAME_RATE = ((double)16.0);
            //    public const Double GBMSAPI_NET_DS40I_FLAT_FLAT_FULLRES_MIN_FRAME_RATE = ((double)2.5);
            //    public const Double GBMSAPI_NET_DS40I_FLAT_FLAT_FULLRES_DEF_FRAME_RATE = ((double)5.0);

            //    /////////////////////////////////////////////////////////////////////
            //    // DactyScan 84C
            //    /////////////////////////////////////////////////////////////////////
            //    // Flat Area - Flat Mode - High Resolution Frame;
            //    public const Double GBMSAPI_NET_DS84C_FLAT_FLAT_FULLRES_MAX_FRAME_RATE = ((double)8.6);
            //    public const Double GBMSAPI_NET_DS84C_FLAT_FLAT_FULLRES_MIN_FRAME_RATE = ((double)1.4);
            //    public const Double GBMSAPI_NET_DS84C_FLAT_FLAT_FULLRES_DEF_FRAME_RATE = ((double)4.3);
            //    // Flat Area - Flat Mode - Low Resolution Frame;
            //    public const Double GBMSAPI_NET_DS84C_FLAT_FLAT_PREVIEW_MAX_FRAME_RATE = ((double)27.0);
            //    public const Double GBMSAPI_NET_DS84C_FLAT_FLAT_PREVIEW_MIN_FRAME_RATE = ((double)3.1);
            //    public const Double GBMSAPI_NET_DS84C_FLAT_FLAT_PREVIEW_DEF_FRAME_RATE = ((double)13.5);
            //    // Roll Area - Roll Mode - High Resolution Frame;
            //    public const Double GBMSAPI_NET_DS84C_ROLL_ROLL_FULLRES_MAX_FRAME_RATE = ((double)25.0);
            //    public const Double GBMSAPI_NET_DS84C_ROLL_ROLL_FULLRES_MIN_FRAME_RATE = ((double)2.9);
            //    public const Double GBMSAPI_NET_DS84C_ROLL_ROLL_FULLRES_DEF_FRAME_RATE = ((double)12.5);
            //    // Roll Area - Flat Mode - High Resolution Frame;
            //    public const Double GBMSAPI_NET_DS84C_ROLL_FLAT_FULLRES_MAX_FRAME_RATE = ((double)25.0);
            //    public const Double GBMSAPI_NET_DS84C_ROLL_FLAT_FULLRES_MIN_FRAME_RATE = ((double)2.9);
            //    public const Double GBMSAPI_NET_DS84C_ROLL_FLAT_FULLRES_DEF_FRAME_RATE = ((double)12.5);

            //    // VER 2.8.0.0
            //    /////////////////////////////////////////////////////////////////////
            //    // Mc517
            //    /////////////////////////////////////////////////////////////////////
            //    // Flat Area - Flat Mode - High Resolution Frame
            //    public const Double GBMSAPI_NET_MC517_FLAT_FLAT_FULLRES_MAX_FRAME_RATE = ((double)4.2);
            //    public const Double GBMSAPI_NET_MC517_FLAT_FLAT_FULLRES_MIN_FRAME_RATE = ((double)0.2);
            //    public const Double GBMSAPI_NET_MC517_FLAT_FLAT_FULLRES_DEF_FRAME_RATE = ((double)2.1);
            //    // Flat Area - Flat Mode - Low Resolution Frame
            //    public const Double GBMSAPI_NET_MC517_FLAT_FLAT_PREVIEW_MAX_FRAME_RATE = ((double)9.4);
            //    public const Double GBMSAPI_NET_MC517_FLAT_FLAT_PREVIEW_MIN_FRAME_RATE = ((double)0.2);
            //    public const Double GBMSAPI_NET_MC517_FLAT_FLAT_PREVIEW_DEF_FRAME_RATE = ((double)2.1);
            //    // Roll Area - Roll Mode - High Resolution Frame - GA STANDARD
            //    public const Double GBMSAPI_NET_MC517_ROLL_ROLL_FULLRES_MAX_FRAME_RATE_GA = ((double)35.0);
            //    public const Double GBMSAPI_NET_MC517_ROLL_ROLL_FULLRES_MIN_FRAME_RATE_GA = ((double)1.0);
            //    public const Double GBMSAPI_NET_MC517_ROLL_ROLL_FULLRES_DEF_FRAME_RATE_GA = ((double)17.5);
            //    // Roll Area - Roll Mode - High Resolution Frame - IQS STANDARD
            //    public const Double GBMSAPI_NET_MC517_ROLL_ROLL_FULLRES_MAX_FRAME_RATE_IQS = ((double)25.4);
            //    public const Double GBMSAPI_NET_MC517_ROLL_ROLL_FULLRES_MIN_FRAME_RATE_IQS = ((double)1.0);
            //    public const Double GBMSAPI_NET_MC517_ROLL_ROLL_FULLRES_DEF_FRAME_RATE_IQS = ((double)12.7);
            //    // Roll Area - Flat Mode - High Resolution Frame - GA STANDARD
            //    public const Double GBMSAPI_NET_MC517_ROLL_FLAT_FULLRES_MAX_FRAME_RATE_GA = ((double)35.0);
            //    public const Double GBMSAPI_NET_MC517_ROLL_FLAT_FULLRES_MIN_FRAME_RATE_GA = ((double)1.0);
            //    public const Double GBMSAPI_NET_MC517_ROLL_FLAT_FULLRES_DEF_FRAME_RATE_GA = ((double)17.5);
            //    // Roll Area - Flat Mode - High Resolution Frame - IQS STANDARD
            //    public const Double GBMSAPI_NET_MC517_ROLL_FLAT_FULLRES_MAX_FRAME_RATE_IQS = ((double)25.4);
            //    public const Double GBMSAPI_NET_MC517_ROLL_FLAT_FULLRES_MIN_FRAME_RATE_IQS = ((double)1.0);
            //    public const Double GBMSAPI_NET_MC517_ROLL_FLAT_FULLRES_DEF_FRAME_RATE_IQS = ((double)12.7);
            //}

            // VER 2700
            //////////////////////////////////////////////////////////////////////
            ////// OPTIONAL EXTERNAL EQUIPMENT ///////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See OPTIONAL EXTERNAL EQUIPMENT section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_OptionalExternalEquipment
            {
                public const UInt32 GBMSAPI_NET_OED_PEDAL = 0x00000001;
                public const UInt32 GBMSAPI_NET_OED_SOUND = 0x00000002;
                public const UInt32 GBMSAPI_NET_OED_VUI_LED = 0x00000004;
                public const UInt32 GBMSAPI_NET_OED_VUI_LCD = 0x00000008;
            }

        }

        //////////////////////////////////////////////////////////////////////
        ////// ACQUISITION PROCESS ///////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////
        namespace GBMSAPI_NET_AcquisitionProcessDefines
        {
            //////////////////////////////////////////////////////////////////////
            ////// ACQUISITION OPTIONS ///////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See ACQUISITION OPTIONS section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_AcquisitionOptions
            {
                public const UInt32 GBMSAPI_NET_AO_AUTOCAPTURE = 0x00000001;
                public const UInt32 GBMSAPI_NET_AO_NO_ROLL_PREVIEW = 0x00000002;
                public const UInt32 GBMSAPI_NET_AO_MANUAL_ROLL_PREVIEW_STOP = 0x00000004;
                public const UInt32 GBMSAPI_NET_AO_ROLL_PREVIEW_TYPE = 0x00000008;
                public const UInt32 GBMSAPI_NET_AO_FULL_RES_PREVIEW = 0x000000010;
                public const UInt32 GBMSAPI_NET_AO_FLAT_SINGLE_FINGER_ON_ROLL_AREA = 0x000000020;
                // Ver 2600: added High Speed Preview for M(S)C 500 devices
                public const UInt32 GBMSAPI_NET_AO_HIGH_SPEED_PREVIEW = 0x000000040;
                // Ver 3.1.0.0
                public const UInt32 GBMSAPI_NET_AO_ADAPT_ROLL_AREA_POSITION = 0x000000080;
                public const UInt32 GBMSAPI_NET_AO_FORCE_ROLL_TO_LEFT = 0x000000100;
                public const UInt32 GBMSAPI_NET_AO_FORCE_ROLL_TO_RIGHT = 0x000000200;
                public const UInt32 GBMSAPI_NET_AO_EXTERNAL_ROLL_COMPOSITION = 0x000000400;
                // end Ver 3.1.0.0
            }

            //////////////////////////////////////////////////////////////////////
            ////// DISPLAY OPTIONS ///////////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See DISPLAY OPTIONS section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_DisplayOptions
            {
                public const UInt32 GBMSAPI_NET_DO_CUSTOMIZED_CONTRAST = 0x00000001;
                public const UInt32 GBMSAPI_NET_DO_CUSTOMIZED_COMPLETENESS = 0x00000002;
                public const UInt32 GBMSAPI_NET_DO_FINAL_SCREEN = 0x00000004;
            }

            //////////////////////////////////////////////////////////////////////
            ////// ACQUISITION EVENTS MANAGER CALLBACK ///////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See ACQUISITION EVENTS MANAGER CALLBACK paragraph in SCAN CALLBACK
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public delegate Int32 GBMSAPI_NET_AcquisitionEventsManagerCallback
            (
                UInt32 OccurredEventCode,
                Int32 GetFrameErrorCode,
                UInt32 EventInfo,
                Byte[] FramePtr,
                Int32 FrameSizeX,
                Int32 FrameSizeY,
                Double CurrentFrameRate,
                Double NominalFrameRate,
                UInt32 GB_Diagnostic,
                System.IntPtr UserDefinedParameters
            );

            //////////////////////////////////////////////////////////////////////
            ////// ACQUISITION EVENTS ////////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See ACQUISITION EVENTS section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_AcquisitionEvents
            {
                public const UInt32 GBMSAPI_NET_AE_SCANNER_STARTED = 0x00000001;
                public const UInt32 GBMSAPI_NET_AE_VALID_FRAME_ACQUIRED = 0x00000002;
                public const UInt32 GBMSAPI_NET_AE_PREVIEW_PHASE_END = 0x00000004;
                public const UInt32 GBMSAPI_NET_AE_ACQUISITION_END = 0x00000008;
                public const UInt32 GBMSAPI_NET_AE_ACQUISITION_ERROR = 0x00000010;
            }

            //////////////////////////////////////////////////////////////////////
            ////// EVENT INFO ////////////////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See EVENT INFO section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_EventInfo
            {
                public const UInt32 GBMSAPI_NET_EI_ACQUISITION_PHASE = 0x00000001;
                public const UInt32 GBMSAPI_NET_EI_STOP_TYPE = 0x00000002;
                public const UInt32 GBMSAPI_NET_EI_PREVIEW_RES = 0x00000004;
                public const UInt32 GBMSAPI_NET_EI_ACQUISITION_TIMEOUT = 0x00000008;
            }

            //////////////////////////////////////////////////////////////////////
            ////// DIAGNOSTIC MESSAGES ///////////////////////////////////////////
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// See DIAGNOSTIC MESSAGES section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_DiagnosticMessages
            {
                public const UInt32 GBMSAPI_NET_DM_SCANNER_SURFACE_NOT_NORMA = 0x00000001;
                public const UInt32 GBMSAPI_NET_DM_SCANNER_FAILURE = 0x00000002;
                public const UInt32 GBMSAPI_NET_DM_COMPOSITION_SLOW = 0x00000004;
                public const UInt32 GBMSAPI_NET_DM_FLAT_FINGER_SLIDING = 0x00000008;
                public const UInt32 GBMSAPI_NET_DM_EXT_LIGHT_TOO_STRONG = 0x00000010;
                public const UInt32 GBMSAPI_NET_DM_FLAT_FINGER_OUT_OF_REGION_LEFT = 0x00000020;
                public const UInt32 GBMSAPI_NET_DM_FLAT_FINGER_OUT_OF_REGION_RIGHT = 0x00000040;
                public const UInt32 GBMSAPI_NET_DM_FLAT_FINGER_OUT_OF_REGION_TOP = 0x00000080;
                public const UInt32 GBMSAPI_NET_DM_FLAT_FINGER_DISPLACED_DOWN = 0x00000100;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_IMPROPER_ROLL = 0x00020000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_TOO_FAST_ROLL = 0x00040000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_TOO_NARROW_ROLL = 0x00080000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_OUTSIDE_BORDER_LEFT = 0x00100000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_OUTSIDE_BORDER_RIGHT = 0x00200000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_OUTSIDE_BORDER_TOP = 0x00400000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_DISPLACED_DOWN = 0x00800000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_ROLL_DIRECTION_RIGHT = 0x40000000;
				public const UInt32 GBMSAPI_NET_DM_VSROLL_ROLL_DIRECTION_LEFT = 0x80000000;
				// VER 2.9.0.0: added diagnostics for dry and wet fingers
				public const UInt32 GBMSAPI_NET_DM_DRY_FINGER = 0x01000000;
				// VER 2.9.0.0: added diagnostics for dry and wet fingers
                public const UInt32 GBMSAPI_NET_DM_WET_FINGER = 0x02000000;
                // VER 3.1.0.0:
                public const UInt32 GBMSAPI_NET_DM_TOO_SHORT_VERTICAL_ROLL = 0x20000000;
                // VER 3.2.0.0
                public const UInt32 GBMSAPI_NET_DM_VSROLL_ROLL_DIRECTION_DOWN	 = 0x08000000;
                public const UInt32 GBMSAPI_NET_DM_VSROLL_ROLL_DIRECTION_UP	 = 0x10000000;
                // end VER 3.2.0.0
            }

            ///////////////////////////////////////////////////
            ///////// AUTO-CAPTURE PHASE //////////////////////
            ///////////////////////////////////////////////////
            /// <summary>
            /// See AUTO-CAPTURE PHASE section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_AutoCapturePhase
            {
                public const Int32 GBMSAPI_NET_ACP_OFF = 0;
                public const Int32 GBMSAPI_NET_ACP_WAIT_FINGER = 1;
                public const Int32 GBMSAPI_NET_ACP_SELECT_IMAGE = 2;
                public const Int32 GBMSAPI_NET_ACP_BEST_IMAGE_STOP = 3;
            }
        }

        ///////////////////////////////////////////////////
        ///////// ROLL FUNCTIONALITY DEFINES //////////////
        ///////////////////////////////////////////////////
        namespace GBMSAPI_NET_RollFunctionalityDefines
        {
            /// <summary>
            /// See Cleaning Depth paragraph in ROLL FUNCTIONALITY DEFINES
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_CleaningDepth
            {
                public const Byte GBMSAPI_NET_ARTEFACT_CLEANING_DEPTH_ZERO = 0;
                public const Byte GBMSAPI_NET_ARTEFACT_CLEANING_DEPTH_MAX = 3;
                public const Byte GBMSAPI_NET_ARTEFACT_CLEANING_DEPTH_UNLIMITED = 255;
            }

            /// <summary>
            /// See ARTEFACT REGION MARKERS paragraph in ROLL FUNCTIONALITY DEFINES
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_ArtefactRegionMarkers
            {
                public const Byte GBMSAPI_NET_ARTEFACT_REGION_WIPED_BORDER = 0x10;
                public const Byte GBMSAPI_NET_ARTEFACT_REGION_MARKED_BORDER = 0x20;
                public const Byte GBMSAPI_NET_ARTEFACT_REGION_WIPED = 0x40;
                public const Byte GBMSAPI_NET_ARTEFACT_REGION_MARKED = 0x80;
            }
        }

        ///////////////////////////////////////////////////
        ///////// VISUAL INTERFACE LEDS ///////////////////
        ///////////////////////////////////////////////////
        namespace GBMSAPI_NET_VisualInterfaceLEDsDefines
        {
            /// <summary>
            /// See LED MASK paragraph in VISUAL INTERFACE LEDS
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_LEDMaskValues
            {
                public const UInt32 GBMSAPI_NET_VIL_THUMB_RIGHT = 0x0001;
                public const UInt32 GBMSAPI_NET_VIL_INDEX_RIGHT = 0x0002;
                public const UInt32 GBMSAPI_NET_VIL_MIDDLE_RIGHT = 0x0004;
                public const UInt32 GBMSAPI_NET_VIL_RING_RIGHT = 0x0008;
                public const UInt32 GBMSAPI_NET_VIL_LITTLE_RIGHT = 0x0010;
                public const UInt32 GBMSAPI_NET_VIL_THUMB_LEFT = 0x0020;
                public const UInt32 GBMSAPI_NET_VIL_INDEX_LEFT = 0x0040;
                public const UInt32 GBMSAPI_NET_VIL_MIDDLE_LEFT = 0x0080;
                public const UInt32 GBMSAPI_NET_VIL_RING_LEFT = 0x0100;
                public const UInt32 GBMSAPI_NET_VIL_LITTLE_LEFT = 0x0200;
                public const UInt32 GBMSAPI_NET_VIL_ROLL = 0x0400;
                public const UInt32 GBMSAPI_NET_VIL_STATUS = 0x0800;
            }

            /// <summary>
            /// See LED COLORS paragraph in VISUAL INTERFACE LEDS
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_LEDColors
            {
                public const Int32 GBMSAPI_NET_COLOR_OFF = 0;
                public const Int32 GBMSAPI_NET_COLOR_GREEN = 1;
                public const Int32 GBMSAPI_NET_COLOR_RED = 2;
                public const Int32 GBMSAPI_NET_COLOR_YELLOW = 3;
            }
        }

        ///////////////////////////////////////////////////
        ///////// VISUAL INTERFACE LCD ////////////////////
        ///////////////////////////////////////////////////
        namespace GBMSAPI_NET_VisualInterfaceLCDDefines
        {
            // VER 2.8.0.0
            /// <summary>
            /// See DISPLAY FEATURES paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_DisplayFeatures
            {
                public const UInt32 GBMSAPI_NET_VILCD_LF_INTERMEDIATE_LIMIT = 0x00000001;
                public const UInt32 GBMSAPI_NET_VILCD_LF_LANGUAGE_SETTING = 0x00000002;
            }
            /// <summary>
            /// See PRELOADED DIAGNOSTIC MESSAGES paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_PreloadedDiagnosticMessages
            {
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_SCANNER_SURFACE_NOT_NORMA = 5;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_SCANNER_FAILURE = 6;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_COMPOSITION_SLOW = 7;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_FLAT_FINGER_SLIDING = 8;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_EXT_LIGHT_TOO_STRONG = 9;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_FINGER_OUT_OF_REGION_LEFT = 10;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_FINGER_OUT_OF_REGION_RIGHT = 11;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_FINGER_OUT_OF_REGION_TOP = 12;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_FINGER_DISPLACED_DOWN = 13;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_VSROLL_IMPROPER_ROLL = 14;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_VSROLL_TOO_FAST_ROLL = 15;
                public const Byte GBMSAPI_NET_VILCD_DIAGNOSTIC_VSROLL_TOO_NARROW_ROLL = 16;
            }

            /// <summary>
            /// See PRELOADED GENERAL MESSAGES paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_PreloadedGeneralMessages
            {
                public const Byte GBMSAPI_NET_VILCD_MSG_ACQUISITION_PROGRESS = 17;
                public const Byte GBMSAPI_NET_VILCD_MSG_ACQUISITION_STOPPED = 18;
                public const Byte GBMSAPI_NET_VILCD_MSG_ACQUISITION_SUCCESSFUL = 19;
                public const Byte GBMSAPI_NET_VILCD_MSG_AUTOACEPT_CONDITION_NO_SATISFIED = 20;
                public const Byte GBMSAPI_NET_VILCD_MSG_AND_DIAG_EMPTY = 21;
                public const Byte GBMSAPI_NET_VILCD_MSG_DIAG_PROGRESS_DONT_PUT_FINGER = 22;
                public const Byte GBMSAPI_NET_VILCD_MSG_FINGER_INCLINATION_DETECTED = 23;
                public const Byte GBMSAPI_NET_VILCD_MSG_INCOMPLETE_PATTERN_DETECTED = 24;
                public const Byte GBMSAPI_NET_VILCD_MSG_INVALID_PATTERN_DETECTED = 25;
                public const Byte GBMSAPI_NET_VILCD_MSG_NO_FINGERPRINT_DETECTED = 26;
                public const Byte GBMSAPI_NET_VILCD_MSG_RELEASE_PEDAL = 27;
                public const Byte GBMSAPI_NET_VILCD_MSG_ROTATION_NO_COMPLETED = 28;
                public const Byte GBMSAPI_NET_VILCD_MSG_SEGMENTATION_FAILED = 29;
                public const Byte GBMSAPI_NET_VILCD_MSG_SEGMENT_BOUNDING_PROBLEM = 30;
                public const Byte GBMSAPI_NET_VILCD_MSG_SEQUENCE_CHECK_FAILED = 31;
                public const Byte GBMSAPI_NET_VILCD_MSG_PREVIEW = 64;
                public const Byte GBMSAPI_NET_VILCD_MSG_PROCESSING = 65;
                public const Byte GBMSAPI_NET_VILCD_MSG_LEFT_RIGHT_MIXUP = 66;
                public const Byte GBMSAPI_NET_VILCD_MSG_POSSIBLE_LEFT_RIGHT_MIXUP = 67;
                public const Byte GBMSAPI_NET_VILCD_MSG_EVALUATE_THE_RESULT = 68;
                public const Byte GBMSAPI_NET_VILCD_MSG_REPEATING = 69;
                public const Byte GBMSAPI_NET_VILCD_MSG_SAVING_IMAGE = 70;
                public const Byte GBMSAPI_NET_VILCD_MSG_AMBIGUOUS_SLAP = 71;
                public const Byte GBMSAPI_NET_VILCD_MSG_INCOMPLETE_SLAP = 72;
                public const Byte GBMSAPI_NET_VILCD_MSG_POSSIBLE_INCOMPLETE_SLAP = 73;
				public const Byte GBMSAPI_NET_VILCD_MSG_ACQUISITION_TIME_OUT = 74;
				// VER 2.9.0.0
				public const Byte GBMSAPI_NET_VILCD_MSG_DRY_FINGER = 78;
				public const Byte GBMSAPI_NET_VILCD_MSG_WET_FINGER = 79;
            }

            /// <summary>
            /// See PRELOADED MESSAGES AREA paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_PreloadedMessagesArea
            {
                public const Byte GBMSAPI_NET_VILCD_MSG_AREA = 0;
                public const Byte GBMSAPI_NET_VILCD_DIAG_AREA = 1;
            }

            /// <summary>
            /// See CUSTOM MESSAGES DEFINES paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_CustomMessagesDefines
            {
                public const Byte GBMSAPI_NET_VILCD_MAX_CUSTOM_MSG_LEN = 15;
                public const Byte GBMSAPI_NET_VILCD_CUSTOM_MSG_TYPE_INFO_MSG = 0;
                public const Byte GBMSAPI_NET_VILCD_CUSTOM_MSG_TYPE_ERROR_MSG = 1;
            }

            /// <summary>
            /// See LIMITS DIRECTION paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_LimitsDirection
            {
                public const Byte GBMSAPI_NET_VILCD_GREATER_THAN_LIMIT_DIRECTION = 2;
                public const Byte GBMSAPI_NET_VILCD_SMALLER_THAN_LIMIT_DIRECTION = 3;
            }

            /// <summary>
            /// See SEGMENTATION RESULTS VALUE paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_SegmentationResultsValues
            {
                public const Byte GBMSAPI_NET_VILCD_SEG_EMPTY = 0;
                public const Byte GBMSAPI_NET_VILCD_SEG_OK = 1;
                public const Byte GBMSAPI_NET_VILCD_SEG_NOT_OK = 2;
                public const Byte GBMSAPI_NET_VILCD_SEG_UNAVAILABLE = 3;
            }

            /// <summary>
            /// See PRESSED BUTTON IDs paragraph in VISUAL INTERFACE LCD
            /// section in GBMSAPI_Defines.h file.
            /// </summary>
            public class GBMSAPI_NET_PressedButtonIDs
            {
                public const Byte GBMSAPI_NET_VILCD_TOUCHSCREEN_OK_BUTTON = 0x18;
                public const Byte GBMSAPI_NET_VILCD_TOUCHSCREEN_REPEAT_BUTTON = 0x20;
                public const Byte GBMSAPI_NET_VILCD_TOUCHSCREEN_START_BUTTON = 0x07;
            }

        }
    }
}
