#ifndef GB_UTIL_H
#define GB_UTIL_H

/********************************************************************************************/
// Reads an image from a bitmap file
// valid for:
// - BM file (first two bytes must be 0x42 0x4d)
// - RGB compressed (no compression)
// - pixel depth = 8 bit
// - palette: 32 bit and 256 colors
/********************************************************************************************/
int ReadSingleBMP(char *FName,unsigned char **pFrame,unsigned int *SizeX,unsigned int *SizeY);

/********************************************************************************************/
// Given an ObjID choosen between values defined in ImageProcessing.h, this function loads
// the image from the corresponding bmp file. To free this image call FreeImage(...)
/********************************************************************************************/
int		LoadImageFromObject(unsigned char ObjID, // ID of the Obj to be processed (input)
							unsigned char **pFrame, // pointer to the image buffer (output)
							unsigned int *SizeX,unsigned int *SizeY // image dimensions (output)
							);

/********************************************************************************************/
// Frees an image previously allocated
/********************************************************************************************/
void	FreeImage(unsigned char *pImage);

#endif GB_UTIL_H