using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace EFTSRecGen_ImgProcTool_Cs
{
    class ObjectIDValues
    {
        public static Int32 RightSlap = 1;
        public static Int32 TwoThSlap = 2;
    }

    class FileNameGlobals
    {
        public static String LEFT_SLAP_F_NAME       = "Samples\\LeftSlap.bmp";
        public static String RIGHT_SLAP_F_NAME      = "Samples\\RightSlap.bmp";
        public static String TWO_THUMBS_F_NAME      = "Samples\\2Thumbs.bmp";
        public static String LEFT_THUMB_F_NAME      = "Samples\\RollThumbLeft.bmp";
        public static String LEFT_INDEX_F_NAME      = "Samples\\RollIndexLeft.bmp";
        public static String LEFT_MIDDLE_F_NAME     = "Samples\\RollMiddleLeft.bmp";
        public static String LEFT_RING_F_NAME       = "Samples\\RollRingLeft.bmp";
        public static String LEFT_LITTLE_F_NAME     = "Samples\\RollLittleLeft.bmp";
        public static String RIGHT_THUMB_F_NAME     = "Samples\\RollThumbRIGHT.bmp";
        public static String RIGHT_INDEX_F_NAME     = "Samples\\RollIndexRIGHT.bmp";
        public static String RIGHT_MIDDLE_F_NAME    = "Samples\\RollMiddleRIGHT.bmp";
        public static String RIGHT_RING_F_NAME      = "Samples\\RollRingRIGHT.bmp";
        public static String RIGHT_LITTLE_F_NAME    = "Samples\\RollLittleRIGHT.bmp";
    }

    class FingerCenterGlobals
    {
        public static UInt32 LITTLE_CENTER_X = 473;
        public static UInt32 LITTLE_CENTER_Y = 971;
        public static UInt32 MIDDLE_CENTER_X = 1005;
        public static UInt32 MIDDLE_CENTER_Y = 654;
        public static UInt32 INDEX_CENTER_X = 1272;
        public static UInt32 INDEX_CENTER_Y = 787;
    }

    class SegmentSizeGlobals
    {
        public static UInt32 SEGM_SIZE_X = (UInt32)800;
        public static UInt32 SEGM_SIZE_Y = (UInt32)800;
    }

    class GreenBit_IBIA_Parameters
    {
        public static UInt16 GB_VendorID = 0x0040;
        public static UInt16 GB_QualAlgID = 0x0001;
    }

    /// <summary>
    /// <para>pattern validity, completeness, quality and inclination thresholds</para>
    /// <para>These are recommended thresholds for a correct interpretation</para>
    /// <para>of segmentation results</para>
    /// </summary>
    class SegmentationRecommendedThresholds
    {
        public static Int32 GB_PATTERN_COMPLETENESS_MIN_THRESH = 85;
        public static Int32 GB_PATTERN_VALIDITY_MIN_THRESH = 75;
        public static Int32 GB_PATTERN_QUALITY_MIN_THRESH = 70;
        public static Int32 GB_PATTERN_INCLINATION_MAX_THRESH = 35;
        public static Int32 GB_PATTERN_INCLINATION_MIN_THRESH = -35;
    }

    class MinutiaeStorage 
    {
        public static List<LFS_NET_WRAPPER.NW_LFS_MINUTIA>[] MinVector = new List<LFS_NET_WRAPPER.NW_LFS_MINUTIA>[10];

        public static Int32 GetIndexFromFingerID(String FingID)
        {
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_INDEX) return 0;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_MIDDLE) return 1;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_RING) return 2;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_LITTLE) return 3;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_INDEX) return 4;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_MIDDLE) return 5;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_RING) return 6;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_LITTLE) return 7;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_THUMB ||
                FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_PLAIN_LEFT_THUMB) return 8;
            if (FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_THUMB ||
                FingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_PLAIN_RIGHT_THUMB) return 9;

            return -1;
        }

        public static Int32 GBMinComparisonScore = 24;
    }
}
