// TestGBMSGUI.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "GBMSAPI_Library.h"
#include "GBMSGUI.h"
#include "GBJpeg.h"
#include "WSQpack.h"

#define CheckMask(Val,maskPred) ( Val &   (maskPred) )

bool FAR PASCAL AfterStartCallback(void *Param)
{
    //printf("%s\n", "AfterStartCallback called!");
	// for example
	GBMSAPI_ROLL_SetPreviewTimeout(2000);

	return true;
}

// objects for the sequence
unsigned int ObjectsSequence[] = {
	// flat single fingers
	GBMSAPI_SO_FLAT_LEFT_THUMB,
	GBMSAPI_SO_FLAT_LEFT_INDEX,
	GBMSAPI_SO_FLAT_LEFT_MIDDLE,
	GBMSAPI_SO_FLAT_LEFT_RING,
	GBMSAPI_SO_FLAT_LEFT_LITTLE,
	GBMSAPI_SO_FLAT_RIGHT_THUMB,
	GBMSAPI_SO_FLAT_RIGHT_INDEX,
	GBMSAPI_SO_FLAT_RIGHT_MIDDLE,
	GBMSAPI_SO_FLAT_RIGHT_RING,
	GBMSAPI_SO_FLAT_RIGHT_LITTLE
	// slaps
	//GBMSAPI_SO_SLAP_4_LEFT,
	//GBMSAPI_SO_SLAP_4_RIGHT,
	//GBMSAPI_SO_SLAP_2_THUMBS,
	//// rolled
	//GBMSAPI_SO_ROLL_LEFT_THUMB,
	//GBMSAPI_SO_ROLL_LEFT_INDEX,
	//GBMSAPI_SO_ROLL_LEFT_MIDDLE,
	//GBMSAPI_SO_ROLL_LEFT_RING,
	//GBMSAPI_SO_ROLL_LEFT_LITTLE,
	//GBMSAPI_SO_ROLL_RIGHT_THUMB,
	//GBMSAPI_SO_ROLL_RIGHT_INDEX,
	//GBMSAPI_SO_ROLL_RIGHT_MIDDLE,
	//GBMSAPI_SO_ROLL_RIGHT_RING,
	//GBMSAPI_SO_ROLL_RIGHT_LITTLE,
	//// palms
	//GBMSAPI_SO_LOWER_HALF_PALM_LEFT,
	//GBMSAPI_SO_WRITER_PALM_LEFT,
	//GBMSAPI_SO_LOWER_HALF_PALM_RIGHT,
	//GBMSAPI_SO_WRITER_PALM_RIGHT
	// Slap 2 (DactyScan40)
	//GBMSAPI_SO_SLAP_2_LEFT,
	//GBMSAPI_SO_SLAP_2_RIGHT
};

// utility function: get string of object name for filename
static wchar_t ObjectName[100];
void SetObjectName(unsigned int ObjectID)
{
	switch (ObjectID)
	{
		case GBMSAPI_SO_FLAT_LEFT_THUMB:
			swprintf(ObjectName, L"%s", L"Flat left thumb");
			break;
		case GBMSAPI_SO_FLAT_LEFT_INDEX:
			swprintf(ObjectName, L"%s", L"Flat left index");
			break;
		case GBMSAPI_SO_FLAT_LEFT_MIDDLE:
			swprintf(ObjectName, L"%s", L"Flat left middle");
			break;
		case GBMSAPI_SO_FLAT_LEFT_RING:
			swprintf(ObjectName, L"%s", L"Flat left ring");
			break;
		case GBMSAPI_SO_FLAT_LEFT_LITTLE:
			swprintf(ObjectName, L"%s", L"Flat left little");
			break;
		case GBMSAPI_SO_FLAT_RIGHT_THUMB:
			swprintf(ObjectName, L"%s", L"Flat right thumb");
			break;
		case GBMSAPI_SO_FLAT_RIGHT_INDEX:
			swprintf(ObjectName, L"%s", L"Flat right index");
			break;
		case GBMSAPI_SO_FLAT_RIGHT_MIDDLE:
			swprintf(ObjectName, L"%s", L"Flat right middle");
			break;
		case GBMSAPI_SO_FLAT_RIGHT_RING:
			swprintf(ObjectName, L"%s", L"Flat right ring");
			break;
		case GBMSAPI_SO_FLAT_RIGHT_LITTLE:
			swprintf(ObjectName, L"%s", L"Flat right little");
			break;
		case GBMSAPI_SO_SLAP_4_LEFT:
			swprintf(ObjectName, L"%s", L"Left four fingers");
			break;
		case GBMSAPI_SO_SLAP_4_RIGHT:
			swprintf(ObjectName, L"%s", L"Right four fingers");
			break;
		case GBMSAPI_SO_SLAP_2_THUMBS:
			swprintf(ObjectName, L"%s", L"Two thumbs");
			break;
		case GBMSAPI_SO_ROLL_LEFT_THUMB:
			swprintf(ObjectName, L"%s", L"Rolled left thumb");
			break;
		case GBMSAPI_SO_ROLL_LEFT_INDEX:
			swprintf(ObjectName, L"%s", L"Rolled left index");
			break;
		case GBMSAPI_SO_ROLL_LEFT_MIDDLE:
			swprintf(ObjectName, L"%s", L"Rolled left middle");
			break;
		case GBMSAPI_SO_ROLL_LEFT_RING:
			swprintf(ObjectName, L"%s", L"Rolled left ring");
			break;
		case GBMSAPI_SO_ROLL_LEFT_LITTLE:
			swprintf(ObjectName, L"%s", L"Rolled left little");
			break;
		case GBMSAPI_SO_ROLL_RIGHT_THUMB:
			swprintf(ObjectName, L"%s", L"Rolled right thumb");
			break;
		case GBMSAPI_SO_ROLL_RIGHT_INDEX:
			swprintf(ObjectName, L"%s", L"Rolled right index");
			break;
		case GBMSAPI_SO_ROLL_RIGHT_MIDDLE:
			swprintf(ObjectName, L"%s", L"Rolled right middle");
			break;
		case GBMSAPI_SO_ROLL_RIGHT_RING:
			swprintf(ObjectName, L"%s", L"Rolled right ring");
			break;
		case GBMSAPI_SO_ROLL_RIGHT_LITTLE:
			swprintf(ObjectName, L"%s", L"Rolled right little");
			break;
		case GBMSAPI_SO_LOWER_HALF_PALM_LEFT:
			swprintf(ObjectName, L"%s", L"Left lower palm");
			break;
		case GBMSAPI_SO_WRITER_PALM_LEFT:
			swprintf(ObjectName, L"%s", L"Left writer palm");
			break;
		case GBMSAPI_SO_LOWER_HALF_PALM_RIGHT:
			swprintf(ObjectName, L"%s", L"Right lower palm");
			break;
		case GBMSAPI_SO_WRITER_PALM_RIGHT:
			swprintf(ObjectName, L"%s", L"Right writer palm");
			break;
		case GBMSAPI_SO_SLAP_2_LEFT:
			swprintf(ObjectName, L"%s", L"Left Slap Two");
			break;
		case GBMSAPI_SO_SLAP_2_RIGHT:
			swprintf(ObjectName, L"%s", L"Right Slap Two");
			break;
	}
}

// 
const char *GetScannerName(unsigned char DeviceID)
{
	switch(DeviceID)
	{
		case GBMSAPI_DN_DS84:
			return "DactyScan84";
		case GBMSAPI_DN_MS500:
			return "MultiScan500";
		case GBMSAPI_DN_MS1000:
			return "MultiScan1000";
		case GBMSAPI_DN_VS3:
			return "VisaScan3";
		case GBMSAPI_DN_PS2:
			return "PoliScan2";
		case GBMSAPI_DN_DS40:
			return "DactyScan40";
		case GBMSAPI_DN_MC500:
			return "MC500";
		case GBMSAPI_DN_MSC500:
			return "MSC500";
		case GBMSAPI_DN_DS40I:
			return "DactyScan40i";
		case GBMSAPI_DN_DS84C:
			return "DactyScan84c";
		case GBMSAPI_DN_MC517:
			return "MC517";
		case GBMSAPI_DN_MSC517:
			return "MSC517";
		case GBMSAPI_DN_DS32:
			return "DactyScan32";
		case GBMSAPI_DN_MS527:
			return "MS527";
	}

	return "";
}

// saves image to file
bool SaveImageToFile(wchar_t *FileName, unsigned char *Image, int ImageWidth, int ImageHeight, int Dpi)
{
	unsigned char *CompressedBuffer;
	unsigned long CompressedBufferLen;
	bool result = true;
	int ret;

	// if 500 dpi, compress to WSQ, if 1000 dpi to JPEG2000
	if (Dpi == 1000)
	{
		// JPEG2000
	    printf("%s\n", "Compressing to JPEG2000...");
		ret = GBJPEG_JP2_Encode(&CompressedBuffer, &CompressedBufferLen, 
			Image,
			(unsigned long)ImageWidth, (unsigned long)ImageHeight,
			8, 
			14);	// 14:1 compression

		if(ret != GBJPEG_OK) 
		{
	        printf("%s\n", "GBJPEG_JP2_Encode Error");
			result = false;
		}
	}
	else
	{
		// WSQ
	    printf("%s\n", "Compressing to WSQ...");
		try {
			ret = WSQPACK_Compress(&CompressedBuffer, (int *)&CompressedBufferLen,
				0.75,//15:1
				Image, ImageWidth, ImageHeight, 8, 500, NULL);
		}
		catch( char *str ) {
			printf("%s %s\n", "WSQPACK_Compress exception:", str);
			result = false;
		}

		if (ret != WSQPACK_OK)
		{
	        printf("%s\n", "WSQPACK_Compress Error");
			result = false;
		}

	}

	if (result)
	{
		FILE *fp = _wfopen(FileName, L"wb");
		if (fp != NULL)
		{
			fwrite(CompressedBuffer, CompressedBufferLen, 1, fp);
			fclose(fp);
		}

		// free buffer
		if (Dpi == 1000)
			GBJPEG_Free(CompressedBuffer);
		else
			WSQPACK_Free(CompressedBuffer);
	}

	return result;
}

int _tmain(int argc, _TCHAR* argv[])
{
	int ret;
	unsigned char *ImageBuffer;
	unsigned long ImageBufferSize;
	bool LCDAvailable;

	// get GBMSAPI version
	unsigned char V1, V2, V3, V4;
	GBMSAPI_GetMultiScanAPIVersion(&V1, &V2, &V3, &V4);
	printf("GBMSAPI ver. %d.%d.%d.%d\n", V1, V2, V3, V4);

	// get GBMSGUI version
	int Major, Minor, Build, Revision;
	GBMSGUI_GetVersion(&Major, &Minor, &Build, &Revision);
	printf("GBMSGUI ver. %d.%d.%d.%d\n", Major, Minor, Build, Revision);

	// set language
	ret = GBMSGUI_SetLanguage("it");
	if (ret != GBMSGUI_RET_SUCCESS)
	{
		wprintf(L"%s (GBMSGUI_SetLanguage)\n", GBMSGUI_GetErrorMessage());
		getchar();
		return 1;
	}

	// get available devices
	GBMSAPI_DeviceInfoStruct DevList[GBMSAPI_MAX_PLUGGED_DEVICE_NUM];
	int DeviceNumber;
	unsigned long USBErr;
	
    printf("%s\n", "Loading devices list...");
	ret = GBMSAPI_GetAttachedDeviceList(DevList, &DeviceNumber, &USBErr);
    if (ret != GBMSAPI_ERROR_CODE_NO_ERROR)
    {
		wprintf(L"%s\n", GBMSGUI_GetMSAPIErrorMessage(L"GBMSAPI_GetAttachedDeviceList", ret));
		getchar();
        return 1;
    }

    if (DeviceNumber == 0)
    {
        printf("%s\n", "No attached device found!");
		getchar();
        return 1;
    }

	// select first device
	printf("Selecting %s...\n", GetScannerName(DevList[0].DeviceID));
	ret = GBMSAPI_SetCurrentDevice(DevList[0].DeviceID, DevList[0].DeviceSerialNumber);
    if (ret != GBMSAPI_ERROR_CODE_NO_ERROR)
    {
		wprintf(L"%s\n", GBMSGUI_GetMSAPIErrorMessage(L"GBMSAPI_SetCurrentDevice", ret));
		getchar();
        return 1;
    }

	// get device features
	unsigned int Features;
	ret = GBMSAPI_GetDeviceFeatures(&Features);
    if (ret != GBMSAPI_ERROR_CODE_NO_ERROR)
    {
		wprintf(L"%s\n", GBMSGUI_GetMSAPIErrorMessage(L"GBMSAPI_GetDeviceFeatures", ret));
		getchar();
        return 1;
    }

	// get external equipment
	unsigned int Equipment;
	ret = GBMSAPI_GetOptionalExternalEquipment(&Equipment);
    if (ret != GBMSAPI_ERROR_CODE_NO_ERROR)
    {
		wprintf(L"%s\n", GBMSGUI_GetMSAPIErrorMessage(L"GBMSAPI_GetOptionalExternalEquipment", ret));
		getchar();
        return 1;
    }

	// check LCD presence
	if (CheckMask(Equipment, GBMSAPI_OED_VUI_LCD))
		LCDAvailable = true;
	else
		LCDAvailable = false;

	// get max image size
	unsigned int SizeX, SizeY;
	GBMSAPI_GetMaxImageSize(&SizeX, &SizeY);
	ImageBufferSize = SizeX * SizeY;
	// allocate the buffer
	ImageBuffer = (unsigned char *)malloc(ImageBufferSize);
	if (ImageBuffer == NULL)
	{
        printf("%s\n", "Not enough memory!");
		getchar();
        return 1;
	}

	if (LCDAvailable)
	{
		// use touchscreen to start acquisition
		BYTE PressedButton = 0;
		GBMSAPI_VUI_LCD_SetLogoScreen();
		GBMSAPI_VUI_LCD_EnableStartButtonOnLogoScreen();

		printf("%s\n", "Press button on LCD to start...");
		while ((PressedButton != GBMSAPI_VILCD_TOUCHSCREEN_START_BUTTON) &&
			(ret == GBMSAPI_ERROR_CODE_NO_ERROR))
		{
			ret = GBMSAPI_VUI_LCD_GetPressedButton(&PressedButton);
			// avoid to call too frequently
			Sleep(50);
		}

		if (ret != GBMSAPI_ERROR_CODE_NO_ERROR)
		{
			wprintf(L"%s\n", GBMSGUI_GetMSAPIErrorMessage(L"GBMSAPI_VUI_LCD_GetPressedButton", ret));
			getchar();
			return 1;
		}
	}

	printf("%s\n", "Starting acquisition...");

	// set AfterStart callback, if needed
	GBMSGUI_SetAfterStartCallback(AfterStartCallback, NULL);

	// general settings
	ret = GBMSGUI_SetArtefactsThresholds(7, 14);
	if (ret != GBMSGUI_RET_SUCCESS)
	{
		wprintf(L"%s (GBMSGUI_SetArtefactsThresholds)\n", GBMSGUI_GetErrorMessage());
		getchar();
		return 1;
	}
	
	ret = GBMSGUI_SetLowerPalmCompletenessThresholds(80, 90);
	if (ret != GBMSGUI_RET_SUCCESS)
	{
		wprintf(L"%s (GBMSGUI_SetLowerPalmCompletenessThresholds)\n", GBMSGUI_GetErrorMessage());
		getchar();
		return 1;
	}

	// start acquisition session
	unsigned int SessionOptions = 0;
	// activate sequence check
	SessionOptions |= GBMSGUI_SESSION_OPTION_SEQUENCE_CHECK;
	ret = GBMSGUI_StartSession(GBMSGUI_AM_MULTIPLE_ACQUISITION, L"Person Name", SessionOptions);
	if (ret != GBMSGUI_RET_SUCCESS)
	{
		if (ret == GBMSGUI_RET_FAILURE)
			wprintf(L"%s (GBMSGUI_StartSession)\n", GBMSGUI_GetErrorMessage());
		else if (ret == GBMSGUI_RET_BUSY_ACQUIRING)
			printf("%s\n", "Error opening session: an acquisition is still in progress");

		free (ImageBuffer);
		getchar();
		return 1;
	}

	ret = GBMSGUI_SetRollArea(GBMSGUI_ROLL_AREA_IQS);
	if (ret != GBMSGUI_RET_SUCCESS)
	{
		wprintf(L"%s (GBMSGUI_SetRollArea)\n", GBMSGUI_GetErrorMessage());
		getchar();
		return 1;
	}

	// activate some acquisition options
	unsigned int AcquisitionOptions = 0;
	AcquisitionOptions |= GBMSGUI_ACQUISITION_OPTION_SEGMENTATION
		| GBMSGUI_ACQUISITION_OPTION_AUTOCAPTURE
		| GBMSGUI_ACQUISITION_OPTION_SOUND
		| GBMSGUI_ACQUISITION_OPTION_SOUND_ON_ROLL_PREVIEW_END
		| GBMSGUI_ACQUISITION_OPTION_BLOCK_AUTOCAPTURE
		| GBMSGUI_ACQUISITION_OPTION_REMOVE_HALO_LATENT
		| GBMSGUI_ACQUISITION_OPTION_DETECT_INVALID_PATTERN
		| GBMSGUI_ACQUISITION_OPTION_DETECT_INCOMPLETE_PATTERN
		| GBMSGUI_ACQUISITION_OPTION_DETECT_INCLINATION
		| GBMSGUI_ACQUISITION_OPTION_ROTATE_FINGER
		| GBMSGUI_ACQUISITION_OPTION_PALM_PRINT_QUALITY_CALCULATION
		| GBMSGUI_ACQUISITION_OPTION_NO_ROLL_PREVIEW;

	// acquire sequence
	int ImageSizeX, ImageSizeY, Dpi;
	int i, NumObjects;
	NumObjects = sizeof(ObjectsSequence)/sizeof(unsigned int);
	unsigned int ObjectID;
	int UnavailReason, Quality;

	for (i=0; i<NumObjects; i++)
	{
		ObjectID = ObjectsSequence[i];

		// per object settings
		ret = GBMSGUI_SetContrastThresholds(ObjectID, 100, 130);
		if (ret != GBMSGUI_RET_SUCCESS)
		{
			wprintf(L"%s (GBMSGUI_SetContrastThresholds)\n", GBMSGUI_GetErrorMessage());
			GBMSGUI_StopSession();
			free (ImageBuffer);
			getchar();
			return 1;
		}

		// quality thresholds, for NFIQ (default)
		GBMSGUI_SetQualityThresholds(ObjectID, 3, 4);

		// for slaps, settings for segments
		if (GBMSGUI_IsSlap(ObjectID))
		{
			GBMSGUI_SetSegmentQualityThresholds(ObjectID, 0, 3, 4);
			GBMSGUI_SetSegmentQualityThresholds(ObjectID, 1, 3, 4);
			if (ObjectID != GBMSAPI_SO_SLAP_2_THUMBS)
			{
				GBMSGUI_SetSegmentQualityThresholds(ObjectID, 2, 3, 4);
				GBMSGUI_SetSegmentQualityThresholds(ObjectID, 3, 3, 4);
			}
		}

		// set image size that fits in every scanner (500x500)
		if (GBMSGUI_IsFlatSingleFinger(ObjectID))
		{
			ret = GBMSGUI_SetImageSize(ObjectID, 500, 500);
			if (ret == GBMSGUI_RET_FAILURE)
			{
				wprintf(L"%s (GBMSGUI_SetImageSize)\n", GBMSGUI_GetErrorMessage());
				GBMSGUI_StopSession();
				free (ImageBuffer);
				getchar();
				return 1;
			}
		}

		ret = GBMSGUI_Acquire(ObjectID, AcquisitionOptions, ImageBuffer, ImageBufferSize,
			&ImageSizeX, &ImageSizeY, &Dpi);
		if (ret == GBMSGUI_RET_FAILURE)
		{
			wprintf(L"%s (GBMSGUI_Acquire)\n", GBMSGUI_GetErrorMessage());
			GBMSGUI_StopSession();
			free (ImageBuffer);
			getchar();
			return 1;
		}
		else if (ret == GBMSGUI_RET_SKIP_IMAGE)
		{
	        printf("%s\n", "Image skipped by user");
		}
		else if (ret == GBMSGUI_RET_GO_BACK)
		{
            if (i > 0)
            {
				i--;
				i--;
				continue;
			}
		}
		else if (ret == GBMSGUI_RET_BREAK_SEQUENCE)
		{
	        printf("%s\n", "Sequence broken by user");
			break;
		}
		else if (ret == GBMSGUI_RET_SUCCESS)
		{
			// save image to file
			wchar_t ImageFileName[MAX_PATH];
			wcscpy(ImageFileName, argv[0]);
			wchar_t *PathEnd = wcsrchr(ImageFileName, L'\\');
			PathEnd++;
			SetObjectName(ObjectID);
			if (Dpi == 1000)
				swprintf(PathEnd, L"%s.jp2", ObjectName);
			else
				swprintf(PathEnd, L"%s.wsq", ObjectName);

			if (SaveImageToFile(ImageFileName, ImageBuffer, ImageSizeX, ImageSizeY, Dpi))
				wprintf(L"Image saved in %s\n", ImageFileName);
			else
				wprintf(L"Error saving image\n");

			// for slaps, get segmentation result
			if (GBMSGUI_IsSlap(ObjectID))
			{
                int index, num;
                int SegmLeft, SegmTop, SegmRight, SegmBottom,
                    SegmSizeX, SegmSizeY;
                bool SegmAvailable;
                if ((ObjectID == GBMSAPI_SO_SLAP_4_LEFT) || (ObjectID == GBMSAPI_SO_SLAP_4_RIGHT))
                    num = 4;
                else
                    num = 2;
                for (index = 0; index < num; index++)
                {
					ret = GBMSGUI_GetSegmentationResult(index, GBMSGUI_NFIQ_ALGORITHM, 
						&SegmAvailable, &SegmLeft, &SegmTop, &SegmRight, &SegmBottom, 
						&UnavailReason, &Quality,
						ImageBuffer, ImageBufferSize,
						&SegmSizeX, &SegmSizeY, &Dpi);
					if (ret == GBMSGUI_RET_FAILURE)
					{
						wprintf(L"%s (GBMSGUI_GetSegmentationResult)\n", GBMSGUI_GetErrorMessage());
						GBMSGUI_StopSession();
						free (ImageBuffer);
						getchar();
						return 1;
					}
					// if available, save segment
					if (SegmAvailable)
					{
						// set file name
						if (Dpi == 1000)
							swprintf(PathEnd, L"%s_%d.jp2", ObjectName, index);
						else
							swprintf(PathEnd, L"%s_%d.wsq", ObjectName, index);

						if (SaveImageToFile(ImageFileName, ImageBuffer, SegmSizeX, SegmSizeY, Dpi))
							wprintf(L"Segment image saved in %s\n", ImageFileName);
						else
							wprintf(L"Error saving segment image\n");
					}
				}
			}
			else
			{
				// other objects
				ret = GBMSGUI_GetIAFISQuality(ObjectID, GBMSGUI_NFIQ_ALGORITHM, &Quality);
				if (ret == GBMSGUI_RET_FAILURE)
				{
					wprintf(L"%s (GBMSGUI_GetIAFISQuality)\n", GBMSGUI_GetErrorMessage());
					GBMSGUI_StopSession();
					free (ImageBuffer);
					getchar();
					return 1;
				}
				printf("Image NFIQ quality=%d\n", Quality);
			}
		}
	}

	// close session
	GBMSGUI_StopSession();

	free (ImageBuffer);

	printf("%s\n", "Acquisition finished.");
	getchar();
	return 0;
}

