﻿using System;
using An2k_2011_NetWrapper;
using An2k_Engine_Net_Wrapper;
using AN2K_NET_WRAPPER;

namespace GbAnEngineExample_Console_Cs
{
	public class GbAnEngineExample_Console_Cs_Globals
	{
		public const int IMG_SX = 500;
		public const int IMG_SY	= 500;

		public static int GB_AN_ENGINE_EXAMPLE_CreateImageBuffer(out byte [] imgBuff, out int pSx, out int pSy)
		{
			byte dummyCounter;
			imgBuff = new byte[IMG_SX * IMG_SY];
			if (imgBuff == null)
			{
				pSx = -1;
				pSy = -1;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
			}
			pSx = IMG_SX;
			pSy = IMG_SY;

			dummyCounter = 0;
			for (int i = 0; i < IMG_SX * IMG_SY; i++, dummyCounter++)
			{
				imgBuff[i] = dummyCounter;
			}
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}
	}

	public class GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct
	{
		public GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct()
		{
			dor = new An2k2011_Date();
		}
		public An2k2011_Date dor;
		public string rsr;
	}

	public class GB_AN_ENGINE_EXAMPLE_Record2 : An2kEngineNw_TaggedRecord
	{
		public const int Rec2NameFieldId = 3;
		public const int Rec2DobFieldId = 4;
		public const int Rec2DocFieldId = 5;
		public const int Rec2RsnFieldId = 6;
		public const int Rec2PlrFieldId = 7;

		public int Create(int idc, string name,	string surname,	An2k2011_Date dateOfBirth, An2k2011_Date dateOfCourtReporting,
			string courtReportingReason, GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct [] policeRecordsArray)
		{
			///////////////////////////
			// check parameters
			///////////////////////////
			if (
				(name == null) || (surname == null) ||
				(dateOfBirth == null) || (courtReportingReason == null) ||
				(dateOfCourtReporting == null) || (courtReportingReason == null)
			)
			{
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			if (policeRecordsArray != null && policeRecordsArray.Length > 0)
			{
				if (policeRecordsArray.Length > 2)
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				}
			}

			/////////////////////////////////////////
			// CREATE RECORD
			/////////////////////////////////////////
			int Retval = this.CreateEmpty(2, idc);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: CreateEmpty");
				return Retval;
			}

			/////////////////////////////////////////
			// INSERT NAME FIELD
			/////////////////////////////////////////
			An2kEngineNw_FieldForTaggedRecord dummyField = new An2kEngineNw_FieldForTaggedRecord();
			string[] strArray = new string[2];
			strArray[0] = name;
			strArray[1] = surname;
			Retval = dummyField.CreateFromValues(2, Rec2NameFieldId, strArray);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: dummyField.CreateFromValues");
				return Retval;
			}
			Retval = this.InsertField(dummyField);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: InsertField");
				return Retval;
			}

			/////////////////////////////////////////
			// INSERT DATE OF BIRTH FIELD
			/////////////////////////////////////////
			dummyField = new An2kEngineNw_FieldForTaggedRecord();
			strArray = new string[1];
			strArray[0] = "" + dateOfBirth.Year.ToString("D4") 
				+ dateOfBirth.Month.ToString("D2")+ dateOfBirth.Day.ToString("D2");
			Retval = dummyField.CreateFromValues(2, Rec2DobFieldId, strArray);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: dummyField.CreateFromValues");
				return Retval;
			}
			Retval = this.InsertField(dummyField);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: InsertField");
				return Retval;
			}

			/////////////////////////////////////////
			// INSERT DATE OF COURT REPORTING FIELD
			/////////////////////////////////////////
			dummyField = new An2kEngineNw_FieldForTaggedRecord();
			strArray = new string[1];
			strArray[0] = "" + dateOfCourtReporting.Year.ToString("D4")
				+ dateOfCourtReporting.Month.ToString("D2") + dateOfCourtReporting.Day.ToString("D2");
			Retval = dummyField.CreateFromValues(2, Rec2DocFieldId, strArray);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: dummyField.CreateFromValues");
				return Retval;
			}
			Retval = this.InsertField(dummyField);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: InsertField");
				return Retval;
			}

			/////////////////////////////////////////
			// INSERT REASON OF COURT REPORTING FIELD
			/////////////////////////////////////////
			dummyField = new An2kEngineNw_FieldForTaggedRecord();
			strArray = new string[1];
			strArray[0] = courtReportingReason;
			Retval = dummyField.CreateFromValues(2, Rec2RsnFieldId, strArray);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: dummyField.CreateFromValues");
				return Retval;
			}
			Retval = this.InsertField(dummyField);
			if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: InsertField");
				return Retval;
			}			

			/////////////////////////////////////////
			// INSERT COURT REPORTING REASON FIELD
			/////////////////////////////////////////
			if (policeRecordsArray != null && policeRecordsArray.Length > 0)
			{
				dummyField = new An2kEngineNw_FieldForTaggedRecord();
				Retval = dummyField.CreateEmpty(2,Rec2PlrFieldId);
				if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: CreateEmpty field");
					return Retval;
				}
				for (int i = 0; i < policeRecordsArray.Length; i ++)
				{	
					An2kEngineNw_SubfieldForTaggedRecord dummySubfield = new An2kEngineNw_SubfieldForTaggedRecord();
					strArray = new string[2];
					strArray[0] = "" + (policeRecordsArray[i].dor).Year.ToString("D4")
						+ (policeRecordsArray[i].dor).Month.ToString("D2") + (policeRecordsArray[i].dor).Day.ToString("D2");
					strArray[1] = policeRecordsArray[i].rsr;
					
					Retval = dummySubfield.CreateFromValues(strArray);
					if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
					{
						GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: CreateFromValues subfield");
						return Retval;
					}

					Retval = dummyField.InsertSubfield(dummySubfield);
					if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
					{
						GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: InsertSubfield");
						return Retval;
					}
				}
				
				Retval = this.InsertField(dummyField);
				if (Retval != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					GbAnEngineExample_Console_Cs.ShowError(Retval, "GB_AN_ENGINE_EXAMPLE_Record2: InsertField");
					return Retval;
				}
			}


			/////////////////////////////////////////
			// RETURN
			/////////////////////////////////////////
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}

		public int GetInfo(out int idc, out string name, out string surname,
			out An2k2011_Date dob, out An2k2011_Date doc, out string reason,
			out GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct[] polRecArray)
		{
			name = null;
			surname = null;
			dob = null;
			idc = -1;
			doc = null;
			reason = null;
			polRecArray = null;
			/////////////////////////////////////////
			// IDC
			/////////////////////////////////////////
			An2kEngineNw_FieldForTaggedRecord dummyField = this.SearchField(2);
			if (dummyField == null)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: SearchField IDC");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			string[] strArray;
			int RetVal = dummyField.GetValuesFromItems(out strArray);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(RetVal,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems IDC");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			if (strArray == null || strArray.Length < 1)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems IDC");
				
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			if (!(int.TryParse(strArray[0], out idc)))
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;

			/////////////////////////////////////////
			// NAME AND SURNAME
			/////////////////////////////////////////
			dummyField = this.SearchField(Rec2NameFieldId);
			if (dummyField == null)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: SearchField NAME");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			RetVal = dummyField.GetValuesFromItems(out strArray);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(RetVal,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems NAME");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			if (strArray == null || strArray.Length < 2)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems NAME");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			name = strArray[0];
			surname = strArray[1];

			/////////////////////////////////////////
			// DATE OF BIRTH
			/////////////////////////////////////////
			dummyField = this.SearchField(Rec2DobFieldId);
			if (dummyField == null)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: SearchField DOB");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			RetVal = dummyField.GetValuesFromItems(out strArray);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(RetVal,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems DOB");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			if (strArray == null || strArray.Length < 1 || strArray[0].Length != 8)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: parameter not conform for DOB");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			dob = new An2k2011_Date();
			RetVal = dob.Parse(strArray[0]);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(RetVal,
					"GB_AN_ENGINE_EXAMPLE_Record2:  dob.Parse for DOB");
				return RetVal;
			}

			/////////////////////////////////////////
			// DATE OF COURT REPORTING
			/////////////////////////////////////////
			dummyField = this.SearchField(Rec2DocFieldId);
			if (dummyField == null)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: SearchField DOC");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			RetVal = dummyField.GetValuesFromItems(out strArray);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(RetVal,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems DOC");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			if (strArray == null || strArray.Length < 1 || strArray[0].Length != 8)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: parameter not conform for DOC");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			doc = new An2k2011_Date();
			RetVal = doc.Parse(strArray[0]);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(RetVal,
					"GB_AN_ENGINE_EXAMPLE_Record2:  dob.Parse for DOC");
				return RetVal;
			}

			/////////////////////////////////////////
			// REASON OF COURT REPORTING
			/////////////////////////////////////////
			dummyField = this.SearchField(Rec2RsnFieldId);
			if (dummyField == null)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: SearchField RSN");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			RetVal = dummyField.GetValuesFromItems(out strArray);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				GbAnEngineExample_Console_Cs.ShowError(RetVal,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems RSN");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			if (strArray == null || strArray.Length < 1)
			{
				GbAnEngineExample_Console_Cs.ShowError(NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER,
					"GB_AN_ENGINE_EXAMPLE_Record2: GetValuesFromItems RSN");
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			reason = strArray[0];

			/////////////////////////////////////////
			// POLICE RECORDS
			/////////////////////////////////////////
			dummyField = this.SearchField(Rec2PlrFieldId);
			if (dummyField != null)
			{
				An2kEngineNw_SubfieldForTaggedRecord[] subfieldsList = dummyField.GetSubfields();
				if (subfieldsList.Length > 0)
				{
					polRecArray = new GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct[subfieldsList.Length];
					for (int i = 0; i < subfieldsList.Length; i ++)
					{
						RetVal = subfieldsList[i].GetValuesFromItems(out strArray);
						if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
						{
							GbAnEngineExample_Console_Cs.ShowError(RetVal,
								"GB_AN_ENGINE_EXAMPLE_Record2: subfieldsList[i] GetValuesFromItems PLR");
							return RetVal;
						}
						if (strArray.Length < 2)
						{
							GbAnEngineExample_Console_Cs.ShowError(RetVal,
								"GB_AN_ENGINE_EXAMPLE_Record2: subfieldsList[i] GetValuesFromItems strArray.Length < 2 PLR");
							return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
						}
						polRecArray[i] = new GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct();
						polRecArray[i].dor = new An2k2011_Date();
						polRecArray[i].dor.Parse(strArray[0]);
						polRecArray[i].rsr = strArray[1];
					}
				}
			}

			/////////////////////////////////////////
			// RETURN
			/////////////////////////////////////////
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}
	}
	class GbAnEngineExample_Console_Cs
	{
		public static int idc, positionInAnsiNist;
		public static void ShowError(int RetVal, String FunctionName)
		{
			Console.WriteLine("Function " + FunctionName +  " returned " + RetVal);
			if (RetVal == NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION)
			{
				Console.WriteLine("Exception Text: " + NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING);
			}
			Console.ReadLine();
			Console.ReadLine();
		}
		static void Main(string[] args)
		{
			idc = 0; positionInAnsiNist = 1;
			////////////////////////////////////////////////
			//// CREATE ANSI NIST STRUCT
			////////////////////////////////////////////////
			Console.WriteLine("//////////////////////////////////////////////");
			Console.WriteLine("// CREATE ANSI NIST STRUCT");
			Console.WriteLine("//////////////////////////////////////////////");

			An2k2011_Type1Record ansinistStruct = new An2k2011_Type1Record();

			An2k2011_Date DateOfTransaction1_1 = new An2k2011_Date();
			DateOfTransaction1_1.Year = 2013;
			DateOfTransaction1_1.Month = 1;
			DateOfTransaction1_1.Day = 29;

			An2k2011_ApplicationProfile[] aps1_1 = new An2k2011_ApplicationProfile[2];
			aps1_1[0] = new An2k2011_ApplicationProfile();
			aps1_1[1] = new An2k2011_ApplicationProfile();
			aps1_1[0].AppProfName = "apn0";
			aps1_1[0].AppProfOrg = "apo0";
			aps1_1[0].AppProfVer = "apv0";
			aps1_1[1].AppProfName = "apn1";
			aps1_1[1].AppProfOrg = "apo1";
			aps1_1[1].AppProfVer = "apv1";

			An2k2011_Gmt gmt1_1 = new An2k2011_Gmt();
			gmt1_1.Year = 2014;
			gmt1_1.Month = 2;
			gmt1_1.Day = 21;
			gmt1_1.hour = 9;
			gmt1_1.minute = 57;
			gmt1_1.second = 25;

			int RetVal = ansinistStruct.Create(
				"TestTot", DateOfTransaction1_1, 8, "DestAg", "OrAg", "TCN1234", null, (float)19.69, (float)19.69,
				"DomName", "DV1.0.0.0", gmt1_1,
                An2k2011_Table4.CHAR_ENCODING_INDEX_ASCII, An2k2011_Table4.CHAR_ENCODING_NAME_ASCII, "1.0", aps1_1, "DAN", "OAN");

            Console.WriteLine("ansinistStruct.Create");

			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "GB_AN2011_CreateAnsiNistStruct");
				return;
            }

			string Tot_1_2, DestAg_1_2, OrigAg_1_2, Tcn_1_2, Tcr_1_2, DomName_1_2, 
				DomVer_1_2, Cen_1_2, Cev_1_2, DestAgName_1_2, OrigAgName_1_2;
			An2k2011_Date DateOfTransaction1_2;
			int Ver_1_2, Pry_1_2, Cei_1_2;
			An2k2011_Gmt gmt_1_2;
			An2k2011_ApplicationProfile[] aps_1_2;
			float Nsr_1_2, Ntr_1_2;
			RetVal = ansinistStruct.GetInfo(out Ver_1_2,out Tot_1_2, out DateOfTransaction1_2, out Pry_1_2,
				out DestAg_1_2, out OrigAg_1_2, out Tcn_1_2, out Tcr_1_2, out Nsr_1_2, out Ntr_1_2,
				out DomName_1_2, out DomVer_1_2, out gmt_1_2, out Cei_1_2, out Cen_1_2, out Cev_1_2,
                out aps_1_2, out DestAgName_1_2, out OrigAgName_1_2);

            Console.WriteLine("ansinistStruct.GetInfo");

			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "ansinistStruct.GetInfo");
				return;
            }

			///////////////////////////////////////////////////
			// CUSTOM TYPE-2 RECORD
			///////////////////////////////////////////////////
			Console.WriteLine("///////////////////////////////////////////////////");
			Console.WriteLine("// CREATE CUSTOM TYPE-2 RECORD");
			Console.WriteLine("///////////////////////////////////////////////////");
			An2k2011_Date dob2_1 = new An2k2011_Date(), doc2_1 = new An2k2011_Date();
			dob2_1.Year = 1984; dob2_1.Month = 2; dob2_1.Day = 22;
			doc2_1.Year = 2013; doc2_1.Month = 10; doc2_1.Day = 11;

			GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct[] polRecArray2_1 = new GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct[2];
			polRecArray2_1[0] = new GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct();
			polRecArray2_1[0].dor.Year = 2000; polRecArray2_1[0].dor.Month = 5; polRecArray2_1[0].dor.Day = 7;
			polRecArray2_1[0].rsr = "Drug Possession";
			polRecArray2_1[1] = new GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct();
			polRecArray2_1[1].dor.Year = 2009; polRecArray2_1[1].dor.Month = 7; polRecArray2_1[1].dor.Day = 27;
			polRecArray2_1[1].rsr = "Drug Dealing";

			GB_AN_ENGINE_EXAMPLE_Record2 rec2 = new GB_AN_ENGINE_EXAMPLE_Record2();
            RetVal = rec2.Create(idc++, "John", "Smith", dob2_1, doc2_1, "Robbery", polRecArray2_1);

            Console.WriteLine("rec2.Create");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "Create record 2");
				return;
            }

            RetVal = ansinistStruct.InsertRecord(rec2, positionInAnsiNist++, false);

            Console.WriteLine("ansinistStruct.InsertRecord");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "InsertRecord record 2");
				return;
            }

			int idc_2_2;
			string name_2_2, surname_2_2, reason_2_2; 
			An2k2011_Date dob_2_2, doc_2_2;
			GB_AN_ENGINE_EXAMPLE_PoliceRecordStruct[] polRecArray2_2;
			RetVal = rec2.GetInfo(out idc_2_2, out name_2_2, out surname_2_2, out dob_2_2, out doc_2_2,
                out reason_2_2, out polRecArray2_2);

            Console.WriteLine("rec2.GetInfo");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "GetInfo idc record 2");
				return;
			}

			
			///////////////////////////////////////////////////
			// TYPE-4 RECORD (USING BINARY RECORD CREATION)
			///////////////////////////////////////////////////
			Console.WriteLine("/////////////////////////////////////////////////////////");
			Console.WriteLine("// CREATE TYPE-4 RECORD (USING BINARY RECORD CREATION)");
			Console.WriteLine("/////////////////////////////////////////////////////////");
			byte [] fgp_4_1 = new byte[6];
			fgp_4_1[0] = An2k2011_Table8.RIGHT_LITTLE;
			for (int i = 1; i < 6; i ++)
			{
				fgp_4_1[i] = 255;
			}

			byte [] imgBuff;
			int sx, sy;
			RetVal = GbAnEngineExample_Console_Cs_Globals.GB_AN_ENGINE_EXAMPLE_CreateImageBuffer(
                out imgBuff, out sx, out sy);

            Console.WriteLine("GB_AN_ENGINE_EXAMPLE_CreateImageBuffer");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "GB_AN_ENGINE_EXAMPLE_CreateImageBuffer for type-4");
				return;
			}

			An2kEngineNw_BinaryRecord rec4Bin = new An2kEngineNw_BinaryRecord();
			rec4Bin.Create(4, idc++, An2k2011_Table7.FRIT_LS_UNKNOWN_PLAIN, fgp_4_1, 0, sx, sy,
                An2k2011_Table15.CODE_UNCOMPRESSED, imgBuff);

            Console.WriteLine("rec4Bin.Create");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "rec4Bin.Create");
				return;
			}

            RetVal = ansinistStruct.InsertRecord(rec4Bin, positionInAnsiNist++, false);

            Console.WriteLine("InsertRecord record 4");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "InsertRecord record 4");
				return;
			}


			///////////////////////////////////////////////////
			// TYPE-4 RECORD (USING TYPE-4 REC FUNCTIONS)
			///////////////////////////////////////////////////
			Console.WriteLine("/////////////////////////////////////////////////////////");
			Console.WriteLine("// CREATE TYPE-4 RECORD  (USING TYPE-4 REC FUNCTIONS)");
			Console.WriteLine("/////////////////////////////////////////////////////////");
			An2k2011_Type4Record rec4An2011 = new An2k2011_Type4Record();
			byte fgp_4a_1 = An2k2011_Table8.LEFT_MIDDLE;

			RetVal = GbAnEngineExample_Console_Cs_Globals.GB_AN_ENGINE_EXAMPLE_CreateImageBuffer(
				out imgBuff, out sx, out sy);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "GB_AN_ENGINE_EXAMPLE_CreateImageBuffer for type-4 an2011");
				return;
			}

			RetVal = rec4An2011.Create(idc++, An2k2011_Table7.FRIT_LS_UNKNOWN_PLAIN, fgp_4a_1, 0, sx, sy,
                An2k2011_Table15.CODE_UNCOMPRESSED, imgBuff);

            Console.WriteLine("rec4An2011.Create");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "rec4An2011.Create");
				return;
			}

			int Idc_4a_2, ImpressionType_4a_2,ImageScanResolution_4a_2,HorizontalNumberOfPixels_4a_2,
				VerticalNumberOfPixels_4a_2,CompressionAlgorithm_4a_2;
			byte Fgp_4a_2; byte []ImageBuffer_4a_2;
			RetVal = rec4An2011.GetInfo(out  Idc_4a_2, out ImpressionType_4a_2, out Fgp_4a_2, out ImageScanResolution_4a_2,
				out HorizontalNumberOfPixels_4a_2, out VerticalNumberOfPixels_4a_2, out CompressionAlgorithm_4a_2,
                out ImageBuffer_4a_2);

            Console.WriteLine("GetInfo record rec4An2011");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "GetInfo record rec4An2011");
				return;
			}

            RetVal = ansinistStruct.InsertRecord(rec4An2011, positionInAnsiNist++, false);

            Console.WriteLine("InsertRecord record rec4An2011");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "InsertRecord record rec4An2011");
				return;
			}

			///////////////////////////////////////////////////
			// TYPE-14 RECORD
			///////////////////////////////////////////////////
			Console.WriteLine("///////////////////////////////////////////////////");
			Console.WriteLine("// CREATE TYPE-14 RECORD");
			Console.WriteLine("///////////////////////////////////////////////////");
			An2k2011_Type14Record rec14 = new An2k2011_Type14Record();

			byte[] ImageBuffer_14_1;
			RetVal = GbAnEngineExample_Console_Cs_Globals.GB_AN_ENGINE_EXAMPLE_CreateImageBuffer(
				out ImageBuffer_14_1, out sx, out sy);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "GB_AN_ENGINE_EXAMPLE_CreateImageBuffer for type-4");
				return;
			}

			int ImpressionType_14_1 = An2k2011_Table7.FRIT_LS_UNKNOWN_PLAIN;
			String SourceAgency_14_1 = "SrcAg14";
			An2k2011_Date FingerprintCaptureDate_14_1 = new An2k2011_Date(2013,5,6);
			int HorizontalNumberOfPixels_14_1 = sx;
			int VerticalNumberOfPixels_14_1 = sy;
			int ScaleUnits_14_1 = 1;
			int TransmittedHorizontalPixelScale_14_1 = 500;
			int TransmittedVerticalPixelScale_14_1 = 500;
			int CompressionAlgorithm_14_1 = An2k2011_Table15.CODE_UNCOMPRESSED;
			int BitsPerPixel_14_1 = 8;
			int FingerprintPosition_14_1 = An2k2011_Table8.EJI_OR_TIP;

			An2k2011_PrintPositionDescriptors Ppd_14_1 = new An2k2011_PrintPositionDescriptors();
			Ppd_14_1.DecimalFingerPosition = An2k2011_Table8.RIGHT_MIDDLE;
			Ppd_14_1.FingerImageCode = An2k2011_Table9.FULL_FINGER_LEFT_SIDE;

			An2k2011_PrintPositionCoordinates[] Ppc_14_1 = new An2k2011_PrintPositionCoordinates[2];
			Ppc_14_1[0] = new An2k2011_PrintPositionCoordinates(
				An2k2011_Table9.FULL_FINGER_LEFT_SIDE, An2k2011_Table9.FVC_ONLY_NA,
				11, 22, 30, 31);
			Ppc_14_1[1] = new An2k2011_PrintPositionCoordinates(
				An2k2011_Table9.LOS_ONLY_NA, An2k2011_Table9.LOS_DISTAL,
				12, 23, 32, 33);
			int ScannedHorizontalPixelScale_14_1 = -1;
			int ScannedVerticalPixelScale_14_1 = -1;

			An2k2011_AmputatedBandagedCode[] Amp_14_1 = new An2k2011_AmputatedBandagedCode[2];
			Amp_14_1[0] = new An2k2011_AmputatedBandagedCode(An2k2011_Table8.RIGHT_THUMB, "XX");
			Amp_14_1[1] = new An2k2011_AmputatedBandagedCode(An2k2011_Table8.RIGHT_INDEX, "UP");

			String Comment_14_1 = "Com_14";

			An2k2011_FingerSegmentPosition[] Seg_14_1 = new An2k2011_FingerSegmentPosition[2];
			Seg_14_1[0] = new An2k2011_FingerSegmentPosition(An2k2011_Table8.LEFT_INDEX, 11, 22, 30, 31);
			Seg_14_1[1] = new An2k2011_FingerSegmentPosition(An2k2011_Table8.LEFT_MIDDLE, 12, 23, 32, 33);

			An2k2011_NistQualityMetric[] Nqm_14_1 = new An2k2011_NistQualityMetric[2];
			Nqm_14_1[0] = new An2k2011_NistQualityMetric(An2k2011_Table8.RIGHT_THUMB, 3);
			Nqm_14_1[1] = new An2k2011_NistQualityMetric(An2k2011_Table8.RIGHT_INDEX, 4);

			An2k2011_FingerOrSegmentQualityMetric[] Sqm_14_1 = new An2k2011_FingerOrSegmentQualityMetric[2];
			Sqm_14_1[0] = new An2k2011_FingerOrSegmentQualityMetric(An2k2011_Table8.RIGHT_THUMB, 27, 3, 4);
			Sqm_14_1[1] = new An2k2011_FingerOrSegmentQualityMetric(An2k2011_Table8.RIGHT_INDEX, 89, 13, 14);

			An2k2011_FingerOrSegmentQualityMetric[] Fqm_14_1 = new An2k2011_FingerOrSegmentQualityMetric[2];
			Fqm_14_1[0] = new An2k2011_FingerOrSegmentQualityMetric(An2k2011_Table8.RIGHT_THUMB, 27, 3, 4);
			Fqm_14_1[1] = new An2k2011_FingerOrSegmentQualityMetric(An2k2011_Table8.RIGHT_INDEX, 89, 13, 14);

			An2k2011_AlternateSegmentPosition[] Aseg_14_1 = new An2k2011_AlternateSegmentPosition[2];
			An2k2011_PointOffset[] PointsForAseg_14_1_0 = new An2k2011_PointOffset[3];
			for (int i = 0; i < PointsForAseg_14_1_0.Length; i++)
			{
				PointsForAseg_14_1_0[i] = new An2k2011_PointOffset(i, i+1);
			}
			Aseg_14_1[0] = new An2k2011_AlternateSegmentPosition(An2k2011_Table8.RIGHT_THUMB, PointsForAseg_14_1_0);
			An2k2011_PointOffset[] PointsForAseg_14_1_1 = new An2k2011_PointOffset[4];
			for (int i = 0; i < PointsForAseg_14_1_1.Length; i++)
			{
				PointsForAseg_14_1_1[i] = new An2k2011_PointOffset(i, i + 1);
			}
			Aseg_14_1[1] = new An2k2011_AlternateSegmentPosition(An2k2011_Table8.RIGHT_INDEX, PointsForAseg_14_1_1);

			int SimultaneousCaptureFingerprint_14_1 = 3;
			bool StitchedImageFlag_14_1 = true;
			String DeviceMonitoringMode_14_1 = An2k2011_Table5.DMM_OBSERVED;
			int FingerprintAcquisitionProfile_14_1 = An2k2011_Table12.FAP_40;

			RetVal = rec14.Create(idc++, ImpressionType_14_1, SourceAgency_14_1, FingerprintCaptureDate_14_1, HorizontalNumberOfPixels_14_1,
				VerticalNumberOfPixels_14_1, ScaleUnits_14_1, TransmittedHorizontalPixelScale_14_1, TransmittedVerticalPixelScale_14_1,
				CompressionAlgorithm_14_1, BitsPerPixel_14_1, FingerprintPosition_14_1, Ppd_14_1, Ppc_14_1, ScannedHorizontalPixelScale_14_1,
				ScannedVerticalPixelScale_14_1, Amp_14_1, Comment_14_1, Seg_14_1, Nqm_14_1, Sqm_14_1, Fqm_14_1, Aseg_14_1,
				SimultaneousCaptureFingerprint_14_1, StitchedImageFlag_14_1, DeviceMonitoringMode_14_1, FingerprintAcquisitionProfile_14_1,
                ImageBuffer_14_1);

            Console.WriteLine("rec14.Create");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "rec14.Create");
				return;
			}

			int Idc_14_2, ImpressionType_14_2, HorizontalNumberOfPixels_14_2, VerticalNumberOfPixels_14_2, ScaleUnits_14_2,
				TransmittedHorizontalPixelScale_14_2, TransmittedVerticalPixelScale_14_2, CompressionAlgorithm_14_2, BitsPerPixel_14_2,
				FingerprintPosition_14_2, ScannedHorizontalPixelScale_14_2, ScannedVerticalPixelScale_14_2,
				SimultaneousCaptureFingerprint_14_2, FingerprintAcquisitionProfile_14_2;
			string SourceAgency_14_2, Comment_14_2, DeviceMonitoringMode_14_2;
			An2k2011_Date FingerprintCaptureDate_14_2;
			An2k2011_PrintPositionDescriptors Ppd_14_2;
			An2k2011_PrintPositionCoordinates[] Ppc_14_2;
			An2k2011_AmputatedBandagedCode[] Amp_14_2;
			An2k2011_FingerSegmentPosition[] Seg_14_2;
			An2k2011_NistQualityMetric[] Nqm_14_2;
			An2k2011_FingerOrSegmentQualityMetric[] Sqm_14_2;
			An2k2011_FingerOrSegmentQualityMetric[] Fqm_14_2;
			An2k2011_AlternateSegmentPosition[] Aseg_14_2;
			bool StitchedImageFlag_14_2;
			byte[] ImageBuffer_14_2;

			RetVal = rec14.GetInfo(
				out Idc_14_2,
				out ImpressionType_14_2,
				out SourceAgency_14_2,
				out FingerprintCaptureDate_14_2,
				out HorizontalNumberOfPixels_14_2,
				out VerticalNumberOfPixels_14_2,
				out ScaleUnits_14_2,
				out TransmittedHorizontalPixelScale_14_2,
				out TransmittedVerticalPixelScale_14_2,
				out CompressionAlgorithm_14_2,
				out BitsPerPixel_14_2,
				out FingerprintPosition_14_2,
				out Ppd_14_2,
				out  Ppc_14_2,
				out ScannedHorizontalPixelScale_14_2,
				out ScannedVerticalPixelScale_14_2,
				out  Amp_14_2,
				out Comment_14_2, // String *
				out  Seg_14_2,
				out  Nqm_14_2,
				out  Sqm_14_2,
				out  Fqm_14_2,
				out  Aseg_14_2,
				out SimultaneousCaptureFingerprint_14_2,
				out StitchedImageFlag_14_2,
				out DeviceMonitoringMode_14_2,
				out FingerprintAcquisitionProfile_14_2,
				out ImageBuffer_14_2
                );

            Console.WriteLine("rec14.GetInfo");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "rec14.GetInfo");
				return;
			}

            RetVal = ansinistStruct.InsertRecord(rec14, positionInAnsiNist++, false);

            Console.WriteLine("rec14.InsertRecord");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "InsertRecord record 14");
				return;
			}

			///////////////////////////////////////////////////
			// TYPE-15 RECORD
			///////////////////////////////////////////////////
			Console.WriteLine("///////////////////////////////////////////////////");
			Console.WriteLine("// CREATE TYPE-15 RECORD");
			Console.WriteLine("///////////////////////////////////////////////////");
			An2k2011_Type15Record rec15 = new An2k2011_Type15Record();

			byte[] ImageBuffer_15_1;
			RetVal = GbAnEngineExample_Console_Cs_Globals.GB_AN_ENGINE_EXAMPLE_CreateImageBuffer(
				out ImageBuffer_15_1, out sx, out sy);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "GB_AN_ENGINE_EXAMPLE_CreateImageBuffer for type-4");
				return;
			}

			int ImpressionType_15_1 = An2k2011_Table7.FRIT_LS_UNKNOWN_PALM;
			String SourceAgency_15_1 = "SrcAg15";
			An2k2011_Date PalmprintCaptureDate_15_1 = new An2k2011_Date(2013, 5, 6);
			int HorizontalNumberOfPixels_15_1 = sx;
			int VerticalNumberOfPixels_15_1 = sy;
			int ScaleUnits_15_1 = 1;
			int TransmittedHorizontalPixelScale_15_1 = 500;
			int TransmittedVerticalPixelScale_15_1 = 500;
			int CompressionAlgorithm_15_1 = An2k2011_Table15.CODE_UNCOMPRESSED;
			int BitsPerPixel_15_1 = 8;
			int FingerprintPosition_15_1 = An2k2011_Table8.RIGHT_FULL_PALM;
			int ScannedHorizontalPixelScale_15_1 = -1;
			int ScannedVerticalPixelScale_15_1 = -1;
			//An2k2011_AmputatedBandagedCode[] Amp_15_1 = new An2k2011_AmputatedBandagedCode[2];
			//Amp_15_1[0] = new An2k2011_AmputatedBandagedCode(An2k2011_Table8.RIGHT_OTHER, "XX");
			//Amp_15_1[1] = new An2k2011_AmputatedBandagedCode(An2k2011_Table8.RIGHT_OTHER, "UP");
			String Comment_15_1 = "Com_15";
			An2k2011_FingerOrSegmentQualityMetric[] Pqm_15_1 = new An2k2011_FingerOrSegmentQualityMetric[2];
			Pqm_15_1[0] = new An2k2011_FingerOrSegmentQualityMetric(An2k2011_Table8.RIGHT_FULL_PALM, 27, 3, 4);
			Pqm_15_1[1] = new An2k2011_FingerOrSegmentQualityMetric(An2k2011_Table8.RIGHT_OTHER, 89, 13, 15);
			An2k2011_AmputatedBandagedCode[] Amp_15_1 = null;

			String DeviceMonitoringMode_15_1 = An2k2011_Table5.DMM_ASSISTED;

			RetVal = rec15.Create(idc++, ImpressionType_15_1, SourceAgency_15_1, PalmprintCaptureDate_15_1, HorizontalNumberOfPixels_15_1,
				VerticalNumberOfPixels_15_1, ScaleUnits_15_1, TransmittedHorizontalPixelScale_15_1, TransmittedVerticalPixelScale_15_1,
				CompressionAlgorithm_15_1, BitsPerPixel_15_1, FingerprintPosition_15_1, ScannedHorizontalPixelScale_15_1,
				ScannedVerticalPixelScale_15_1, Amp_15_1, Comment_15_1, Pqm_15_1,
                DeviceMonitoringMode_15_1, ImageBuffer_15_1);

            Console.WriteLine("rec15.Create");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "rec15.Create");
				return;
			}

			int Idc_15_2, ImpressionType_15_2, HorizontalNumberOfPixels_15_2, VerticalNumberOfPixels_15_2, ScaleUnits_15_2,
				TransmittedHorizontalPixelScale_15_2, TransmittedVerticalPixelScale_15_2, CompressionAlgorithm_15_2, BitsPerPixel_15_2,
				FingerprintPosition_15_2, ScannedHorizontalPixelScale_15_2, ScannedVerticalPixelScale_15_2;
			string SourceAgency_15_2, Comment_15_2, DeviceMonitoringMode_15_2;
			An2k2011_Date PalmprintCaptureDate_15_2;
			An2k2011_AmputatedBandagedCode[] Amp_15_2;
			An2k2011_FingerOrSegmentQualityMetric[] Pqm_15_2;
			byte[] ImageBuffer_15_2;

			RetVal = rec15.GetInfo(
				out Idc_15_2,
				out ImpressionType_15_2,
				out SourceAgency_15_2,
				out PalmprintCaptureDate_15_2,
				out HorizontalNumberOfPixels_15_2,
				out VerticalNumberOfPixels_15_2,
				out ScaleUnits_15_2,
				out TransmittedHorizontalPixelScale_15_2,
				out TransmittedVerticalPixelScale_15_2,
				out CompressionAlgorithm_15_2,
				out BitsPerPixel_15_2,
				out FingerprintPosition_15_2,
				out ScannedHorizontalPixelScale_15_2,
				out ScannedVerticalPixelScale_15_2,
				out  Amp_15_2,
				out Comment_15_2, // String *
				out  Pqm_15_2,
				out DeviceMonitoringMode_15_2,
				out ImageBuffer_15_2
                );

            Console.WriteLine("rec15.GetInfo");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "rec15.GetInfo");
				return;
			}

            RetVal = ansinistStruct.InsertRecord(rec15, positionInAnsiNist++, false);

            Console.WriteLine("rec15.InsertRecord");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "InsertRecord record 15");
				return;
			}

			////////////////////////////////////////////////
			//// WRITE TO BUFFER
			////////////////////////////////////////////////
			Console.WriteLine("//////////////////////////////////////////////");
			Console.WriteLine("// WRITE TO BUFFER");
			Console.WriteLine("//////////////////////////////////////////////");
            byte[] anBuff = ansinistStruct.WriteToBuffer();

            Console.WriteLine("ansinistStruct.WriteToBuffer");
			System.IO.File.WriteAllBytes("TestAnsiNistNET.an2", anBuff);

			An2k2011_Type1Record anToRead = new An2k2011_Type1Record();
            RetVal = anToRead.Create(anBuff);

            Console.WriteLine("anToRead.Create");
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				ShowError(RetVal, "An2k2011_Type1Record.Create");
				return;
			}

			Console.ReadLine();
			Console.ReadLine();			
		}
	}
}
