/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gban2k_2011_java_console;

import com.sun.jna.Memory;
import com.sun.jna.Pointer;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import com.sun.jna.PointerType;
import com.sun.jna.ptr.FloatByReference;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.ByteByReference;

import GBAN2K_2011_Structures.*;
import GBAN2K_JAVA_Defines.GBAN2K_ErrorDefines;
import GBAN2K_2011_LibraryFunctions.GBAN2K_2011_DllWrapper;
import GBAN2K_JAVA_Structures.GBAN2K_AnsiNistStructure;
import GBAN2K_2011_Defines.*;

import GBAN2K_ENGINE_LibraryFunctions.GBAN2K_ENGINE_DllWrapper;
import GBAN2K_JAVA_Structures.*;

/**
 *
 * @author andrea
 */
public class GbAn2k_2011_Java_Console {

    public static byte[] CreateImageBuffer(int pSx, int pSy) {
        byte dummyCounter;
        byte[] imgBuff = new byte[pSx * pSy];
        if (imgBuff == null) {
            pSx = -1;
            pSy = -1;
            return null;
        }

        dummyCounter = 0;
        for (int i = 0; i < pSx * pSy; i++, dummyCounter++) {
            imgBuff[i] = dummyCounter;
        }
        return imgBuff;
    }

    private static void WriteAllBytes(String fileName, byte[] BufferToSave) {
        FileOutputStream fos = null;
        DataOutputStream ds = null;
        try {
            fos = new FileOutputStream(fileName);
            ds = new DataOutputStream(fos);
            ds.write(BufferToSave);
        } catch (Exception e) {
            System.out.println("Error in SaveOnFile");
        } finally {
            try {
                ds.close();
            } catch (IOException ex) {
                System.out.println("Error in closing ds");
            }
            try {
                fos.close();
            } catch (IOException ex) {
                System.out.println("Error in closing fos");
            }
        }
    }

    private static byte[] loadFile(File file) {
        FileInputStream fin = null;

        byte[] fileContent = null;
        try {
            fin = new FileInputStream(file);
            fileContent = new byte[(int) file.length()];
            fin.read(fileContent);

        } catch (IOException ex) {
            System.out.println("Error in getting file: ");
        } finally {
            try {
                fin.close();

            } catch (IOException ex) {
                System.out.println("Error in closing file: ");
            }

        }
        return fileContent;
    }

    private static byte[] ReadAllBytes(String fileName) {
        File file = new File(fileName);
        return loadFile(file);
    }

    public static boolean PrintErrorMessage(int RetVal, String FunctionName) {
        System.out.println(FunctionName + " returned: " + RetVal);
        if (RetVal != GBAN2K_ErrorDefines.AN2K_DLL_NO_ERROR) {
            return false;
        }
        return true;
    }

    public static String ExtractStringFromPtrToRef(PointerByReference myRef) {
        Pointer pApp = myRef.getValue();
        String strToDisplay = pApp.getString(0);
        return strToDisplay;
    }

    private static void ShowValues(GBAN2K_AnsiNistStructure ansinist) {
        GBAN2K_RecordStructure[] recordsArray = ansinist.GetRecordsArray();
        System.out.println("num_records = " + ansinist.num_records);
        if (ansinist.num_records > 0) {
            for (GBAN2K_RecordStructure r : recordsArray) {
                ShowValues(r);
            }
        }
    }

    private static void ShowValues(GBAN2K_RecordStructure record) {
        System.out.println("type = " + record.type);
        GBAN2K_FieldStructure[] fieldsArray = record.GetFieldsArray();
        System.out.println("num_f = " + record.num_fields);
        for (GBAN2K_FieldStructure f : fieldsArray) {
            ShowValues(f);
        }
    }

    private static void ShowValues(GBAN2K_FieldStructure field) {
        System.out.println("\trecord_type = " + field.record_type);
        System.out.println("\tfield_int = " + field.field_int);
        System.out.println("\tid = " + field.getId());
        GBAN2K_SubfieldStructure[] sfArray = field.GetSubfieldsArray();
        System.out.println("\tnum_sf = " + field.num_subfields);
        for (GBAN2K_SubfieldStructure s : sfArray) {
            ShowValues(s);
        }
    }

    private static void ShowValues(GBAN2K_SubfieldStructure subfield) {
        GBAN2K_ItemStructure[] iA = subfield.GetItemsArray();
        System.out.println("\t\tnum_items = " + subfield.num_items);
        for (GBAN2K_ItemStructure i : iA) {
            ShowValues(i);
        }
    }

    private static void ShowValues(GBAN2K_ItemStructure i) {
        System.out.println("\t\t\tvalue = " + i.getVal());
    }

    private static GBAN2K_RecordStructure CreateRec2(String name, String Surname, int idc) {
        PointerByReference outRecord = new PointerByReference();

        int RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_CreateEmptyTaggedRecord(
                outRecord, 2, idc);
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_CreateEmptyTaggedRecord") != true) {
            System.out.println("FAILURE");
            return null;
        }

        PointerByReference outField_2 = new PointerByReference();
        String[] valuesToInsertArray_2 = new String[2];
        valuesToInsertArray_2[0] = name;
        valuesToInsertArray_2[1] = Surname;

        RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_CreateFieldFromValuesForTaggedRecords(
                outField_2, 2, 3, valuesToInsertArray_2, valuesToInsertArray_2.length);
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_CreateFieldFromValuesForTaggedRecords") != true) {
            System.out.println("FAILURE, exit");
            return null;
        }
        Pointer pfield_2 = outField_2.getValue();
        GBAN2K_FieldStructure field_2 = new GBAN2K_FieldStructure(pfield_2);

        GBAN2K_RecordStructure record = new GBAN2K_RecordStructure(outRecord.getValue());
        RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_InsertFieldIntoTaggedRecord(record, field_2);
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_InsertFieldIntoTaggedRecord") != true) {
            System.out.println("FAILURE, exit");
            return null;
        }
        return record;
    }

    public static class Type2Rec {

        String Name;
        String Surname;
        int idc;

        public Type2Rec(String n, String s, int i) {
            Name = n;
            Surname = s;
            idc = i;
        }

        public String ToString() {
            return "Name = " + Name + ", Surname = " + Surname + ", idc = " + idc;
        }
    }

    private static String[] getStringArrayFromField(GBAN2K_FieldStructure field) {
        PointerByReference pValues = new PointerByReference();
        IntByReference pNumValues = new IntByReference();
        int RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_GetValuesFromFieldForTaggedRecords(
                field, pValues, pNumValues);
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_GetValuesFromFieldForTaggedRecords") != true) {
            System.out.println("FAILURE");
            return null;
        }
        Pointer Values = pValues.getValue();
        int nValues = pNumValues.getValue();
        Pointer[] ValuesArray = Values.getPointerArray(0, nValues);
        String[] strArray = new String[nValues];
        for (int i = 0; i < nValues; i++) {
            String s = ValuesArray[i].getString(0, false);
            strArray[i] = s;
        }
        GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_FreeStringArray(Values, nValues);
        return strArray;
    }

    private static Type2Rec GetType2Info(GBAN2K_RecordStructure rec2) {
        PointerByReference outField = new PointerByReference();
        
        System.out.println("GetType2Info Start");

        // IDC
        int RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_SearchFieldInTaggedRecord(
                rec2, 2, outField);
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_SearchFieldInTaggedRecord") != true) {
            System.out.println("FAILURE");
            return null;
        }
        Pointer pField = outField.getValue();
        GBAN2K_FieldStructure field = new GBAN2K_FieldStructure(pField);
        String[] idcValues = getStringArrayFromField(field);
        if (idcValues == null) {
            System.out.println("getStringArrayFromPointer FAILURE");
            return null;
        }
        //GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_Free(null, null, field, null, null);

        // Name, Surname
        RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_SearchFieldInTaggedRecord(
                rec2, 3, outField);
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_SearchFieldInTaggedRecord") != true) {
            System.out.println("FAILURE");
            return null;
        }
        pField = outField.getValue();
        field = new GBAN2K_FieldStructure(pField);
        String[] AnagraphicValues = getStringArrayFromField(field);
        if (AnagraphicValues == null) {
            System.out.println("getStringArrayFromPointer FAILURE");
            return null;
        }
        Type2Rec ret = new Type2Rec(AnagraphicValues[0], AnagraphicValues[1], Integer.valueOf(idcValues[0]));
        return ret;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        int idc = 0, positionInAnsiNist = 1;
        /////////////////////////////////////////
        // CREATE ANSI NIST BUFFER
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE ANSI NIST BUFFER *************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pAnsiNist = new Memory(Pointer.SIZE);
        An2k2011_DateStruct DateOfTransaction = new An2k2011_DateStruct(2014, 7, 22);
        An2k2011_GmtStruct Gmt = new An2k2011_GmtStruct(2014, 7, 22, 9, 57, 35);
        An2k2011_ApplicationProfileStruct[] Aps = (An2k2011_ApplicationProfileStruct[]) new An2k2011_ApplicationProfileStruct("Aps0Org", "Aps0Name", "Aps0Ver").toArray(2);
        Aps[1].SetValues("Aps1Org", "Aps1Name", "Aps1Ver");
        String Tot = "Tot1", DestAgency = "DestAgency1", OrigAgency = "OrigAgency1",
                TransContrNum = "TransContrNum1", TransContrRef = "TransContrRef1",
                DomainName = "DomainName1", DomainVersion = "DomainVersion1",
                CharEncName = An2k2011_Table4.CHAR_ENCODING_NAME_ASCII, CharEncVersion = "1.0",
                DestAgName = "DestAgName1", OrigAgName = "OrigAgName1";
        int Pry = 1, CharEncIndex = An2k2011_Table4.CHAR_ENCODING_INDEX_ASCII;
        float NativeScanRes = (float) 19.69, NominalTxRes = (float) 19.69;

        int RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_CreateAnsiNistStruct(
                pAnsiNist, // ANSI_NIST **
                Tot,
                DateOfTransaction,
                Pry,
                DestAgency,
                OrigAgency,
                TransContrNum,
                TransContrRef,
                NativeScanRes,
                NominalTxRes,
                DomainName,
                DomainVersion,
                Gmt,
                CharEncIndex,
                CharEncName,
                CharEncVersion,
                Aps,
                Aps.length,
                DestAgName,
                OrigAgName
        );
        if (PrintErrorMessage(RetVal, "GB_AN2011_CreateAnsiNistStruct") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        System.out.println();
        /////////////////////////////////////////
        // READ ANSI NIST BUFFER
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ ANSI NIST BUFFER *************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pan = pAnsiNist.getPointer(0);
        GBAN2K_AnsiNistStructure MyAnsiNist = new GBAN2K_AnsiNistStructure(pan);
        System.out.println("MyAnsiNist.alloc_records: " + MyAnsiNist.alloc_records);
        System.out.println("MyAnsiNist.num_bytes: " + MyAnsiNist.num_bytes);
        System.out.println("MyAnsiNist.num_records: " + MyAnsiNist.num_records);

        Pointer pRec1 = (MyAnsiNist.records.getPointerArray(0, MyAnsiNist.alloc_records))[0];
        IntByReference pVersion = new IntByReference(), pPriority = new IntByReference(),
                pCharEncIndex = new IntByReference(), pApsNum = new IntByReference();
        PointerByReference pTypeOfTransaction = new PointerByReference(), pDestAgency = new PointerByReference(),
                pOrigAgency = new PointerByReference(), pTransContrNum = new PointerByReference(),
                pTransContrRef = new PointerByReference(),
                pDomainName = new PointerByReference(), pDomainVersion = new PointerByReference(),
                pCharEncName = new PointerByReference(), pCharEncVersion = new PointerByReference(),
                pAps = new PointerByReference(),
                pDestAgName = new PointerByReference(), pOrigAgName = new PointerByReference();
        FloatByReference pNativeScanRes = new FloatByReference(), pNominalTxRes = new FloatByReference();
        An2k2011_DateStruct DateOfTransaction1 = new An2k2011_DateStruct();
        An2k2011_GmtStruct Gmt1 = new An2k2011_GmtStruct();

        RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_GetType1RecordInfo(
                pRec1, // RECORD *
                pVersion, // int *
                pTypeOfTransaction, // char **
                DateOfTransaction1, // GB_AN2011_DateStruct *
                pPriority, // int *
                pDestAgency, // char **
                pOrigAgency, // char **
                pTransContrNum, // char **
                pTransContrRef, // char **
                pNativeScanRes, // float*
                pNominalTxRes, // float*
                pDomainName, // char **
                pDomainVersion, // char **
                Gmt1, // GB_AN2011_GmtStruct *
                pCharEncIndex, // int *
                pCharEncName, // char **
                pCharEncVersion, // char **
                pAps, // GB_AN2011_ApplicationProfileStruct **
                pApsNum, // int *
                pDestAgName, // char **
                pOrigAgName // char **
        );
        if (PrintErrorMessage(RetVal, "GB_AN2011_GetType1RecordInfo") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        /**
         * ****************************************
         * Extract Numbers
         */
        System.out.println("pVersion = " + pVersion.getValue());
        System.out.println("pPriority = " + pPriority.getValue());
        System.out.println("pNativeScanRes = " + pNativeScanRes.getValue());
        System.out.println("pNominalTxRes = " + pNominalTxRes.getValue());
        System.out.println("pCharEncIndex = " + pCharEncIndex.getValue());

        /**
         * ****************************************
         * Show date and gmt
         */
        System.out.println("Date = " + DateOfTransaction1.Year
                + "-" + DateOfTransaction1.Month
                + "-" + DateOfTransaction1.Day);
        System.out.println("Gmt = " + Gmt1.Year
                + "-" + Gmt1.Month
                + "-" + Gmt1.Day
                + "," + Gmt1.hour
                + ":" + Gmt1.minute
                + ":" + Gmt1.second);

        /**
         * ****************************************
         * Extract Strings
         */
        String strToDisplay = ExtractStringFromPtrToRef(pTypeOfTransaction);
        System.out.println("pTypeOfTransaction: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pDestAgency);
        System.out.println("pDestAgency: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pOrigAgency);
        System.out.println("pOrigAgency: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pTransContrNum);
        System.out.println("pTransContrNum: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pTransContrRef);
        System.out.println("pTransContrRef: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pDomainName);
        System.out.println("pDomainName: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pDomainVersion);
        System.out.println("pDomainVersion: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pCharEncName);
        System.out.println("pCharEncName: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pCharEncVersion);
        System.out.println("pCharEncVersion: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pDestAgName);
        System.out.println("pDestAgName: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pOrigAgName);
        System.out.println("pOrigAgName: " + strToDisplay);

        /**
         * ****************************************
         * Extract Structures
         */
        int numVals = pApsNum.getValue();
        // extract the pointed-to pointer
        Pointer pVals = pAps.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_ApplicationProfileStruct[] apsValsArray = (An2k2011_ApplicationProfileStruct[]) new An2k2011_ApplicationProfileStruct(pVals).toArray(numVals);
            System.out.println("pApsNum = " + pApsNum.getValue());
            for (An2k2011_ApplicationProfileStruct apsval : apsValsArray) {
                System.out.println("\t" + apsval.AppProfOrg + ", "
                        + apsval.AppProfName + ", "
                        + apsval.AppProfVer);
            }
        } else {
            System.out.println("Structure pAps not valid");
        }
        System.out.println();

        /////////////////////////////////////////
        // CREATE Type-4
        /////////////////////////////////////////
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE Type-4 *************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        int IMG_SX = 10, IMG_SY = 10;
        byte[] imgBuff = CreateImageBuffer(IMG_SX, IMG_SY);
        if (imgBuff == null) {
            System.out.println("Cannot create ImgBuffer for type-4");
            return;
        }
        Pointer pRec4 = new Memory(Pointer.SIZE);
        RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_CreateType4Record(
                pRec4,
                idc,
                An2k2011_Table7.FRIT_LS_UNKNOWN_PLAIN,
                (byte) An2k2011_Table8.LEFT_MIDDLE,
                0,
                IMG_SX,
                IMG_SY,
                An2k2011_Table15.CODE_UNCOMPRESSED,
                imgBuff,
                IMG_SX * IMG_SY);
        if (PrintErrorMessage(RetVal, "GB_AN2011_CreateType4Record") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        System.out.println();

        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-4 RECORD ******************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        PointerByReference pImageBuffer = new PointerByReference();
        Pointer rec4 = pRec4.getPointer(0);
        IntByReference pIdc = new IntByReference(), pImageScanResolution = new IntByReference(),
                pImpressionType = new IntByReference(),
                pHorizontalNumberOfPixels = new IntByReference(), pVerticalNumberOfPixels = new IntByReference(),
                pCompressionAlgorithm = new IntByReference(), pImageBufferLen = new IntByReference();
        ByteByReference fgp = new ByteByReference();

        RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_GetType4RecordInfo(
                rec4,
                pIdc,
                pImpressionType,
                fgp,
                pImageScanResolution,
                pHorizontalNumberOfPixels,
                pVerticalNumberOfPixels,
                pCompressionAlgorithm,
                pImageBuffer, // unsigned char **
                pImageBufferLen
        );
        if (PrintErrorMessage(RetVal, "GB_AN2011_GetType4RecordInfo") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        /**
         * ****************************************
         * Extract Numbers
         */
        System.out.println("pIdc = " + pIdc.getValue());
        System.out.println("pImpressionType = " + pImpressionType.getValue());
        System.out.println("fgp = " + fgp.getValue());
        System.out.println("pImageScanResolution = " + pImageScanResolution.getValue());
        System.out.println("pHorizontalNumberOfPixels = " + pHorizontalNumberOfPixels.getValue());
        System.out.println("pVerticalNumberOfPixels = " + pVerticalNumberOfPixels.getValue());
        System.out.println("pImageBufferLen = " + pImageBufferLen.getValue());
        /**
         * ****************************************
         * Extract image
         */
        byte[] ImgPixels = pImageBuffer.getValue().getByteArray(0, pHorizontalNumberOfPixels.getValue() * pVerticalNumberOfPixels.getValue());
        for (int i = 0; i < pHorizontalNumberOfPixels.getValue() * pVerticalNumberOfPixels
                .getValue(); i++) {
            System.out.println("\tbyte " + (i + 1) + " of image is " + ImgPixels[i]);
        }

        RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_InsertRecordInAnsiNist(
                new GBAN2K_RecordStructure(rec4), MyAnsiNist, MyAnsiNist.num_records, 0
        );
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_InsertRecordInAnsiNist") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        /////////////////////////////////////////
        // CREATE TYPE-14 Record
        /////////////////////////////////////////
        idc++;
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE TYPE-14 Record ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pRec14 = new Memory(Pointer.SIZE);
        String sourceAgency = "sourceAgency", comment = "comment", deviceMonitoringMode = An2k2011_Table5.DMM_OBSERVED;
        An2k2011_DateStruct fingerprintCaptureDate = new An2k2011_DateStruct(2014, 7, 22);
        int scaleUnits = 1;
        int transmittedHorizontalPixelScale = 500;
        int transmittedVerticalPixelScale = 500;
        int compressionAlgorithm = An2k2011_Table15.CODE_UNCOMPRESSED;
        int bitsPerPixel = 8;
        int fingerprintPosition = An2k2011_Table8.EJI_OR_TIP;
        int scannedHorizontalPixelScale = -1;
        int scannedVerticalPixelScale = -1;
        int simultaneousCaptureFingerprint = 3;
        int stitchedImageFlag = 1;
        int fingerprintAcquisitionProfile = An2k2011_Table12.FAP_40;

        // PPD
        An2k2011_PrintPositionDescriptorsStruct ppd = new An2k2011_PrintPositionDescriptorsStruct(
                An2k2011_Table8.RIGHT_MIDDLE, An2k2011_Table9.FULL_FINGER_LEFT_SIDE);

        // PPC
        An2k2011_PrintPositionCoordinatesStruct ppc_firstElement = new An2k2011_PrintPositionCoordinatesStruct();
        An2k2011_PrintPositionCoordinatesStruct[] ppc = (An2k2011_PrintPositionCoordinatesStruct[]) ppc_firstElement.toArray(2);
        ppc[0].SetValues(
                An2k2011_Table9.FULL_FINGER_LEFT_SIDE, An2k2011_Table9.FVC_ONLY_NA,
                11, 22, 30, 31);
        ppc[1].SetValues(
                An2k2011_Table9.LOS_ONLY_NA, An2k2011_Table9.LOS_DISTAL,
                12, 23, 32, 33);

        // AMP
        An2k2011_AmputatedBandagedCodeStruct amp_firstElement = new An2k2011_AmputatedBandagedCodeStruct();
        An2k2011_AmputatedBandagedCodeStruct[] amp = (An2k2011_AmputatedBandagedCodeStruct[]) amp_firstElement.toArray(2);
        amp[0].SetValues(An2k2011_Table8.RIGHT_THUMB, "XX");
        amp[1].SetValues(An2k2011_Table8.RIGHT_INDEX, "UP");

        // SEG
        An2k2011_FingerSegmentPositionStruct seg_firstElement = new An2k2011_FingerSegmentPositionStruct();
        An2k2011_FingerSegmentPositionStruct[] seg = (An2k2011_FingerSegmentPositionStruct[]) seg_firstElement.toArray(2);
        seg[0].SetValues(An2k2011_Table8.LEFT_INDEX, 11, 22, 30, 31);
        seg[1].SetValues(An2k2011_Table8.LEFT_MIDDLE, 12, 23, 32, 33);

        // NQM
        An2k2011_NistQualityMetricStruct nqm_firstElement = new An2k2011_NistQualityMetricStruct();
        An2k2011_NistQualityMetricStruct[] nqm = (An2k2011_NistQualityMetricStruct[]) nqm_firstElement.toArray(2);
        nqm[0].SetValues(An2k2011_Table8.RIGHT_THUMB, 3);
        nqm[1].SetValues(An2k2011_Table8.RIGHT_INDEX, 4);

        // SQM
        An2k2011_FingerOrSegmentQualityMetricStruct sqm_firstElement = new An2k2011_FingerOrSegmentQualityMetricStruct();
        An2k2011_FingerOrSegmentQualityMetricStruct[] sqm = (An2k2011_FingerOrSegmentQualityMetricStruct[]) sqm_firstElement.toArray(2);
        sqm[0].SetValues(An2k2011_Table8.RIGHT_THUMB, 27, 1, 2);
        sqm[1].SetValues(An2k2011_Table8.RIGHT_INDEX, 89, 11, 12);

        // FQM
        An2k2011_FingerOrSegmentQualityMetricStruct fqm_firstElement = new An2k2011_FingerOrSegmentQualityMetricStruct();
        An2k2011_FingerOrSegmentQualityMetricStruct[] fqm = (An2k2011_FingerOrSegmentQualityMetricStruct[]) fqm_firstElement.toArray(2);
        fqm[0].SetValues(An2k2011_Table8.LEFT_INDEX, 25, 3, 4);
        fqm[1].SetValues(An2k2011_Table8.LEFT_THUMB, 90, 13, 14);

        // ASEG
        An2k2011_AlternateSegmentPositionStruct aseg_firstElement = new An2k2011_AlternateSegmentPositionStruct();
        An2k2011_AlternateSegmentPositionStruct[] aseg = (An2k2011_AlternateSegmentPositionStruct[]) aseg_firstElement.toArray(2);

        An2k2011_PointOffsetStruct.ByReference firstElement_0 = new An2k2011_PointOffsetStruct.ByReference();
        An2k2011_PointOffsetStruct[] PointsForAseg_14_1_0 = (An2k2011_PointOffsetStruct[]) firstElement_0.toArray(3);
        for (int i = 0; i < PointsForAseg_14_1_0.length; i++) {
            PointsForAseg_14_1_0[i].SetValues(i, i + 1);
        }
        aseg[0].SetValues(An2k2011_Table8.RIGHT_THUMB, firstElement_0, 3);

        An2k2011_PointOffsetStruct.ByReference firstElement_1 = new An2k2011_PointOffsetStruct.ByReference();
        An2k2011_PointOffsetStruct[] PointsForAseg_14_1_1 = (An2k2011_PointOffsetStruct[]) firstElement_1.toArray(4);
        for (int i = 0; i < PointsForAseg_14_1_1.length; i++) {
            PointsForAseg_14_1_1[i].SetValues(i, i + 1);
        }
        aseg[1].SetValues(An2k2011_Table8.RIGHT_INDEX, firstElement_1, 4);

        IMG_SX = 500;
        IMG_SY = 500;
        imgBuff = CreateImageBuffer(IMG_SX, IMG_SY);
        if (imgBuff == null) {
            System.out.println("Cannot create ImgBuffer for type-4");
            return;
        }

        RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_CreateType14Record(
                pRec14,
                idc,
                An2k2011_Table7.FRIT_LS_UNKNOWN_PLAIN,
                sourceAgency,
                fingerprintCaptureDate,
                IMG_SX,
                IMG_SY,
                scaleUnits,
                transmittedHorizontalPixelScale,
                transmittedVerticalPixelScale,
                compressionAlgorithm,
                bitsPerPixel,
                fingerprintPosition,
                ppd,
                ppc, ppc.length,
                scannedHorizontalPixelScale,
                scannedVerticalPixelScale,
                amp, amp.length,
                comment,
                seg, seg.length,
                nqm, nqm.length,
                sqm, sqm.length,
                fqm, fqm.length,
                aseg, aseg.length,
                simultaneousCaptureFingerprint,
                stitchedImageFlag,
                deviceMonitoringMode,
                fingerprintAcquisitionProfile,
                imgBuff,
                IMG_SX * IMG_SY
        );
        if (PrintErrorMessage(RetVal, "GB_AN2011_CreateType14Record") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-14 RECORD *****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer rec14 = pRec14.getPointer(0);
        An2k2011_DateStruct fingerprintCaptureDate1 = new An2k2011_DateStruct();
        IntByReference pScaleUnits = new IntByReference(), pTransmittedHorizontalPixelScale = new IntByReference(),
                pTransmittedVerticalPixelScale = new IntByReference(),
                pBitsPerPixel = new IntByReference(), pScannedHorizontalPixelScale = new IntByReference(),
                pScannedVerticalPixelScale = new IntByReference(), pFingerprintPosition = new IntByReference(),
                pPpcNum = new IntByReference(), pAmpNum = new IntByReference(),
                pSegNum = new IntByReference(), pNqmNum = new IntByReference(),
                pSqmNum = new IntByReference(), pFqmNum = new IntByReference(),
                pAsegNum = new IntByReference(), pStitchedImageFlag = new IntByReference(),
                pFingerprintAcquisitionProfile = new IntByReference(), pSimultaneousCaptureFingerprint = new IntByReference();
        An2k2011_PrintPositionDescriptorsStruct ppd1 = new An2k2011_PrintPositionDescriptorsStruct();
        PointerByReference pImageBuffer_14 = new PointerByReference(), pSourceAgency = new PointerByReference(),
                pDeviceMonitoringMode = new PointerByReference(),
                pPpc = new PointerByReference(), pAmp = new PointerByReference(),
                pComment = new PointerByReference(), pSqm = new PointerByReference(),
                pNqm = new PointerByReference(), pSeg = new PointerByReference(),
                pFqm = new PointerByReference(), pAseg = new PointerByReference();
        RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_GetType14RecordInfo(
                rec14, // RECORD *
                pIdc,
                pImpressionType,
                pSourceAgency, // char **
                fingerprintCaptureDate1, // An2k2011_DateStruct *
                pHorizontalNumberOfPixels,
                pVerticalNumberOfPixels,
                pScaleUnits,
                pTransmittedHorizontalPixelScale,
                pTransmittedVerticalPixelScale,
                pCompressionAlgorithm,
                pBitsPerPixel,
                pFingerprintPosition,
                ppd1,
                pPpc, pPpcNum, // GB_AN2011_PrintPositionCoordinatesStruct **
                pScannedHorizontalPixelScale,
                pScannedVerticalPixelScale,
                pAmp, pAmpNum, // GB_AN2011_AmputatedBandagedCodeStruct **
                pComment, // char **
                pSeg, pSegNum, // GB_AN2011_FingerSegmentPositionStruct **
                pNqm, pNqmNum, // GB_AN2011_NistQualityMetricStruct **
                pSqm, pSqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
                pFqm, pFqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
                pAseg, pAsegNum, // GB_AN2011_AlternateSegmentPositionStruct **
                pSimultaneousCaptureFingerprint,
                pStitchedImageFlag,
                pDeviceMonitoringMode, // char **
                pFingerprintAcquisitionProfile,
                pImageBuffer_14, // unsigned char **
                pImageBufferLen
        );
        if (PrintErrorMessage(RetVal, "GB_AN2011_GetType14RecordInfo") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        /**
         * ****************************************
         * Extract Numbers
         */
        System.out.println("pIdc = " + pIdc.getValue());
        System.out.println("pImpressionType = " + pImpressionType.getValue());
        System.out.println("pHorizontalNumberOfPixels = " + pHorizontalNumberOfPixels.getValue());
        System.out.println("pVerticalNumberOfPixels = " + pVerticalNumberOfPixels.getValue());
        System.out.println("pScaleUnits = " + pScaleUnits.getValue());
        System.out.println("pTransmittedHorizontalPixelScale = " + pTransmittedHorizontalPixelScale.getValue());
        System.out.println("pTransmittedVerticalPixelScale = " + pTransmittedVerticalPixelScale.getValue());
        System.out.println("pBitsPerPixel = " + pBitsPerPixel.getValue());
        System.out.println("pFingerprintPosition = " + pFingerprintPosition.getValue());
        System.out.println("pStitchedImageFlag = " + pStitchedImageFlag.getValue());
        System.out.println("pFingerprintAcquisitionProfile = " + pFingerprintAcquisitionProfile.getValue());
        System.out.println("pSimultaneousCaptureFingerprint = " + pSimultaneousCaptureFingerprint.getValue());

        /**
         * ****************************************
         * Show date and gmt
         */
        System.out.println("fingerprintCaptureDate = " + fingerprintCaptureDate1.Year
                + "-" + fingerprintCaptureDate1.Month
                + "-" + fingerprintCaptureDate1.Day);

        /**
         * ****************************************
         * Extract Strings
         */
        strToDisplay = ExtractStringFromPtrToRef(pSourceAgency);
        System.out.println("pSourceAgency: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pComment);
        System.out.println("pComment: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pDeviceMonitoringMode);
        System.out.println("pDeviceMonitoringMode: " + strToDisplay);

        /**
         * ****************************************
         * Extract Structures
         */
        //////////////////////////
        // ppd
        //////////////////////////
        try {
            System.out.println("ppd values");
            System.out.println("\tDecimalFingerPosition: " + ppd1.DecimalFingerPosition);
            System.out.println("\tFingerImageCode: " + new String(ppd1.FingerImageCodeInBytes, "US-ASCII").split("\0")[0]);
        } catch (Exception ex) {
            System.out.println("exception for An2k2011_PrintPositionDescriptorsStruct: " + ex.getMessage());
        }
        //////////////////////////
        // pPpc
        //////////////////////////
        numVals = pPpcNum.getValue();
        // extract the pointed-to pointer
        pVals = pPpc.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_PrintPositionCoordinatesStruct[] ppcValsArray
                    = (An2k2011_PrintPositionCoordinatesStruct[]) new An2k2011_PrintPositionCoordinatesStruct(pVals).toArray(numVals);
            System.out.println("pPpcNum = " + pPpcNum.getValue());
            for (An2k2011_PrintPositionCoordinatesStruct apsval : ppcValsArray) {
                try {
                    System.out.println("\t" + apsval.LeftHorizontalCoordinate + ", "
                            + apsval.RightHorizontalCoordinate + ", "
                            + apsval.TopVerticalCoordinate + ", "
                            + apsval.BottomVerticalCoordinate + ", "
                            + new String(apsval.LocationOfASegmentInBytes, "US-ASCII").split("\0")[0] + ", "
                            + new String(apsval.FullFingerViewInBytes, "US-ASCII").split("\0")[0]);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_PrintPositionCoordinatesStruct: " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pPpc not valid");
        }
        //////////////////////////
        // pAmp
        //////////////////////////
        numVals = pAmpNum.getValue();
        // extract the pointed-to pointer
        pVals = pAmp.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_AmputatedBandagedCodeStruct[] AmpValsArray
                    = (An2k2011_AmputatedBandagedCodeStruct[]) new An2k2011_AmputatedBandagedCodeStruct(pVals).toArray(numVals);
            System.out.println("pAmpNum = " + pAmpNum.getValue());
            for (An2k2011_AmputatedBandagedCodeStruct apsval : AmpValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + new String(apsval.AmpBandCodeInBytes, "US-ASCII").split("\0")[0]);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_AmputatedBandagedCodeStruct: " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pAmp not valid");
        }
        //////////////////////////
        // pSeg
        //////////////////////////
        numVals = pSegNum.getValue();
        // extract the pointed-to pointer
        pVals = pSeg.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_FingerSegmentPositionStruct[] SegValsArray
                    = (An2k2011_FingerSegmentPositionStruct[]) new An2k2011_FingerSegmentPositionStruct(pVals).toArray(numVals);
            System.out.println("pSegNum = " + pSegNum.getValue());
            for (An2k2011_FingerSegmentPositionStruct apsval : SegValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + "\t" + apsval.LeftHorizontalCoordinate + ", "
                            + apsval.RightHorizontalCoordinate + ", "
                            + apsval.TopVerticalCoordinate + ", "
                            + apsval.BottomVerticalCoordinate);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_FingerSegmentPositionStruct: " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pseg not valid (check pFingerprintPosition value)");
        }
        //////////////////////////
        // pNqm
        //////////////////////////
        numVals = pNqmNum.getValue();
        // extract the pointed-to pointer
        pVals = pNqm.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_NistQualityMetricStruct[] NqmValsArray
                    = (An2k2011_NistQualityMetricStruct[]) new An2k2011_NistQualityMetricStruct(pVals).toArray(numVals);
            System.out.println("pNqmNum = " + pNqmNum.getValue());
            for (An2k2011_NistQualityMetricStruct apsval : NqmValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + "\t" + apsval.Quality);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_NistQualityMetricStruct: " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pNqm not valid");
        }
        //////////////////////////
        // pSqm
        //////////////////////////
        numVals = pSqmNum.getValue();
        // extract the pointed-to pointer
        pVals = pSqm.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_FingerOrSegmentQualityMetricStruct[] SqmValsArray
                    = (An2k2011_FingerOrSegmentQualityMetricStruct[]) new An2k2011_FingerOrSegmentQualityMetricStruct(pVals).toArray(numVals);
            System.out.println("pSqmNum = " + pSqmNum.getValue());
            for (An2k2011_FingerOrSegmentQualityMetricStruct apsval : SqmValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + "\t" + apsval.Quality + ", "
                            + "\t" + apsval.AlgorithmVendorId + ", "
                            + "\t" + apsval.AlgorithmProductId);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_FingerOrSegmentQualityMetricStruct: " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pSqm not valid");
        }
        //////////////////////////
        // pFqm
        //////////////////////////
        numVals = pFqmNum.getValue();
        // extract the pointed-to pointer
        pVals = pFqm.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_FingerOrSegmentQualityMetricStruct[] FqmValsArray
                    = (An2k2011_FingerOrSegmentQualityMetricStruct[]) new An2k2011_FingerOrSegmentQualityMetricStruct(pVals).toArray(numVals);
            System.out.println("pFqmNum = " + pFqmNum.getValue());
            for (An2k2011_FingerOrSegmentQualityMetricStruct apsval : FqmValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + "\t" + apsval.Quality + ", "
                            + "\t" + apsval.AlgorithmVendorId + ", "
                            + "\t" + apsval.AlgorithmProductId);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_FingerOrSegmentQualityMetricStruct (Fqm): " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pFqm not valid");
        }
        //////////////////////////
        // pAseg
        //////////////////////////
        numVals = pAsegNum.getValue();
        // extract the pointed-to pointer
        pVals = pAseg.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_AlternateSegmentPositionStruct[] AsegValsArray
                    = (An2k2011_AlternateSegmentPositionStruct[]) new An2k2011_AlternateSegmentPositionStruct(pVals).toArray(numVals);
            System.out.println("pAsegNum = " + pAsegNum.getValue());
            for (An2k2011_AlternateSegmentPositionStruct apsval : AsegValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + "\t" + apsval.NumberOfPoints);
                    An2k2011_PointOffsetStruct[] points = apsval.GetPointsFromPointsArray();
                    for (An2k2011_PointOffsetStruct pointsval : points) {
                        System.out.println("\t\t" + pointsval.HorizontalPointOffset + ", "
                                + pointsval.VerticalPointOffset);
                    }
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_AlternateSegmentPositionStruct: " + ex.getMessage());
                }
            }
            // free memory
            GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_FreeAsegArray(pVals, numVals);
        } else {
            System.out.println("Structure pAseg not valid");
        }
        System.out.println();

        RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_InsertRecordInAnsiNist(
                new GBAN2K_RecordStructure(rec14), MyAnsiNist, MyAnsiNist.num_records, 0
        );
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_InsertRecordInAnsiNist") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        /////////////////////////////////////////
        // CREATE TYPE-15 Record
        /////////////////////////////////////////
        idc++;
        System.out.println("//////////////////////////////////////////");
        System.out.println("**** CREATE TYPE-15 Record ****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();

        Pointer pRec15 = new Memory(Pointer.SIZE);
        String sourceAgency_15 = "sourceAgency_15", comment_15 = "comment_15", deviceMonitoringMode_15 = An2k2011_Table5.DMM_CONTROLLED;
        An2k2011_DateStruct fingerprintCaptureDate_15 = new An2k2011_DateStruct(2014, 8, 11);
        int scaleUnits_15 = 1;
        int transmittedHorizontalPixelScale_15 = 500;
        int transmittedVerticalPixelScale_15 = 500;
        int compressionAlgorithm_15 = An2k2011_Table15.CODE_UNCOMPRESSED;
        int bitsPerPixel_15 = 8;
        int fingerprintPosition_15 = An2k2011_Table8.LEFT_LOWER_PALM;
        int scannedHorizontalPixelScale_15 = -1;
        int scannedVerticalPixelScale_15 = -1;

        // AMP
        An2k2011_AmputatedBandagedCodeStruct amp_firstElement_15 = new An2k2011_AmputatedBandagedCodeStruct();
        An2k2011_AmputatedBandagedCodeStruct[] amp_15 = (An2k2011_AmputatedBandagedCodeStruct[]) amp_firstElement_15.toArray(2);
        amp_15[0].SetValues(An2k2011_Table8.LEFT_UPPER_PALM, "XX");
        amp_15[1].SetValues(An2k2011_Table8.RIGHT_UPPER_PALM, "UP");

        // SQM
        An2k2011_FingerOrSegmentQualityMetricStruct pqm_firstElement_15 = new An2k2011_FingerOrSegmentQualityMetricStruct();
        An2k2011_FingerOrSegmentQualityMetricStruct[] pqm_15 = (An2k2011_FingerOrSegmentQualityMetricStruct[]) pqm_firstElement_15.toArray(2);
        pqm_15[0].SetValues(An2k2011_Table8.LEFT_LOWER_PALM, 27, 1, 2);
        pqm_15[1].SetValues(An2k2011_Table8.RIGHT_LOWER_PALM, 89, 11, 12);

        IMG_SX = 500;
        IMG_SY = 500;
        imgBuff = CreateImageBuffer(IMG_SX, IMG_SY);
        if (imgBuff == null) {
            System.out.println("Cannot create ImgBuffer for type-15");
            return;
        }

        RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_CreateType15Record(
                pRec15,
                idc,
                An2k2011_Table7.FRIT_LS_UNKNOWN_PALM,
                sourceAgency_15,
                fingerprintCaptureDate_15,
                IMG_SX,
                IMG_SY,
                scaleUnits_15,
                transmittedHorizontalPixelScale_15,
                transmittedVerticalPixelScale_15,
                compressionAlgorithm_15,
                bitsPerPixel_15,
                fingerprintPosition_15,
                scannedHorizontalPixelScale_15,
                scannedVerticalPixelScale_15,
                amp_15, amp_15.length,
                comment_15,
                pqm_15, pqm_15.length,
                deviceMonitoringMode_15,
                imgBuff,
                IMG_SX * IMG_SY
        );
        if (PrintErrorMessage(RetVal, "GB_AN2011_CreateType15Record") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        Pointer rec15 = pRec15.getPointer(0);
        RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_InsertRecordInAnsiNist(
                new GBAN2K_RecordStructure(rec15), MyAnsiNist, MyAnsiNist.num_records, 0
        );
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_InsertRecordInAnsiNist") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        System.out.println("//////////////////////////////////////////");
        System.out.println("**** READ TYPE-15 RECORD *****************");
        System.out.println("//////////////////////////////////////////");
        System.out.println();
        An2k2011_DateStruct pfingerprintCaptureDate_15 = new An2k2011_DateStruct();
        IntByReference pScaleUnits_15 = new IntByReference(), pTransmittedHorizontalPixelScale_15 = new IntByReference(),
                pTransmittedVerticalPixelScale_15 = new IntByReference(),
                pBitsPerPixel_15 = new IntByReference(), pScannedHorizontalPixelScale_15 = new IntByReference(),
                pScannedVerticalPixelScale_15 = new IntByReference(), pFingerprintPosition_15 = new IntByReference(),
                pAmpNum_15 = new IntByReference(),
                pPqmNum_15 = new IntByReference();
        PointerByReference pImageBuffer_15 = new PointerByReference(), pSourceAgency_15 = new PointerByReference(),
                pDeviceMonitoringMode_15 = new PointerByReference(),
                pAmp_15 = new PointerByReference(), pPqm_15 = new PointerByReference();
        RetVal = GBAN2K_2011_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN2011_GetType15RecordInfo(
                rec15, // RECORD *
                pIdc,
                pImpressionType,
                pSourceAgency_15, // char **
                pfingerprintCaptureDate_15, // An2k2011_DateStruct *
                pHorizontalNumberOfPixels,
                pVerticalNumberOfPixels,
                pScaleUnits_15,
                pTransmittedHorizontalPixelScale_15,
                pTransmittedVerticalPixelScale_15,
                pCompressionAlgorithm,
                pBitsPerPixel_15,
                pFingerprintPosition_15,
                pScannedHorizontalPixelScale_15,
                pScannedVerticalPixelScale_15,
                pAmp_15, pAmpNum_15, // GB_AN2011_AmputatedBandagedCodeStruct **
                pComment, // char **
                pPqm_15, pPqmNum_15, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
                pDeviceMonitoringMode_15, // char **
                pImageBuffer_15, // unsigned char **
                pImageBufferLen
        );
        if (PrintErrorMessage(RetVal, "GB_AN2011_GetType15RecordInfo") != true) {
            System.out.println("FAILURE, exit");
            return;
        }
        /**
         * ****************************************
         * Extract Numbers
         */
        System.out.println("pIdc = " + pIdc.getValue());
        System.out.println("pImpressionType = " + pImpressionType.getValue());
        System.out.println("pHorizontalNumberOfPixels = " + pHorizontalNumberOfPixels.getValue());
        System.out.println("pVerticalNumberOfPixels = " + pVerticalNumberOfPixels.getValue());
        System.out.println("pScaleUnits_15 = " + pScaleUnits_15.getValue());
        System.out.println("pTransmittedHorizontalPixelScale_15 = " + pTransmittedHorizontalPixelScale_15.getValue());
        System.out.println("pTransmittedVerticalPixelScale_15 = " + pTransmittedVerticalPixelScale_15.getValue());
        System.out.println("pBitsPerPixel_15 = " + pBitsPerPixel_15.getValue());
        System.out.println("pFingerprintPosition_15 = " + pFingerprintPosition_15.getValue());

        /**
         * ****************************************
         * Show date and gmt
         */
        System.out.println("fingerprintCaptureDate = " + fingerprintCaptureDate_15.Year
                + "-" + fingerprintCaptureDate_15.Month
                + "-" + fingerprintCaptureDate_15.Day);

        /**
         * ****************************************
         * Extract Strings
         */
        strToDisplay = ExtractStringFromPtrToRef(pSourceAgency_15);
        System.out.println("pSourceAgency_15: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pComment);
        System.out.println("pComment: " + strToDisplay);
        strToDisplay = ExtractStringFromPtrToRef(pDeviceMonitoringMode_15);
        System.out.println("pDeviceMonitoringMode_15: " + strToDisplay);

        /**
         * ****************************************
         * Extract Structures
         */
        //////////////////////////
        // pAmp
        //////////////////////////
        numVals = pAmpNum_15.getValue();
        // extract the pointed-to pointer
        pVals = pAmp_15.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_AmputatedBandagedCodeStruct[] AmpValsArray
                    = (An2k2011_AmputatedBandagedCodeStruct[]) new An2k2011_AmputatedBandagedCodeStruct(pVals).toArray(numVals);
            System.out.println("pAmpNum_15 = " + pAmpNum_15.getValue());
            for (An2k2011_AmputatedBandagedCodeStruct apsval : AmpValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + new String(apsval.AmpBandCodeInBytes, "US-ASCII").split("\0")[0]);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_AmputatedBandagedCodeStruct: " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pAmp_15 not valid");
        }
        //////////////////////////
        // pPqm
        //////////////////////////
        numVals = pPqmNum_15.getValue();
        // extract the pointed-to pointer
        pVals = pPqm_15.getValue();
        if (numVals > 0 && pVals != Pointer.NULL) {
            // read the pointed-to memory into an Example7Struct        
            An2k2011_FingerOrSegmentQualityMetricStruct[] FqmValsArray
                    = (An2k2011_FingerOrSegmentQualityMetricStruct[]) new An2k2011_FingerOrSegmentQualityMetricStruct(pVals).toArray(numVals);
            System.out.println("pPqmNum_15 = " + pPqmNum_15.getValue());
            for (An2k2011_FingerOrSegmentQualityMetricStruct apsval : FqmValsArray) {
                try {
                    System.out.println("\t" + apsval.FrictionRidgePosition + ", "
                            + "\t" + apsval.Quality + ", "
                            + "\t" + apsval.AlgorithmVendorId + ", "
                            + "\t" + apsval.AlgorithmProductId);
                } catch (Exception ex) {
                    System.out.println("exception for An2k2011_FingerOrSegmentQualityMetricStruct (pPqm_15): " + ex.getMessage());
                }
            }
        } else {
            System.out.println("Structure pPqm_15 not valid");
        }
        System.out.println();

        ///////////////////////////////////////
        // GBAN2K_ENGINE
        ///////////////////////////////////////
        GBAN2K_RecordStructure rec2 = CreateRec2("John", "Smith", idc);
        if (rec2 == null) {
            System.out.println("CreateRec2 error, exit");
            return;
        }
        idc++;

        RetVal = GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_InsertRecordInAnsiNist(
                rec2, MyAnsiNist, MyAnsiNist.num_records, 0
        );
        if (PrintErrorMessage(RetVal, "GB_AN_ENGINE_InsertRecordInAnsiNist") != true) {
            System.out.println("FAILURE, exit");
            return;
        }

        Type2Rec t2Rec = GetType2Info(rec2);
        if (t2Rec == null) {
            System.out.println("GetType2Info error, exit");
            return;
        }
        System.out.println(t2Rec.ToString());
        System.out.println("ShowValues Ansi nist");
        ShowValues(MyAnsiNist);
        System.out.println("GB_AN_ENGINE_Free Ansi nist");
        GBAN2K_ENGINE_DllWrapper.GBAN2K_Library.INSTANCE.GB_AN_ENGINE_Free(MyAnsiNist, null, null, null, null);

    }

}
