#pragma once
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <windows.h>

#include "gbfinimg.h"


namespace GbFinImgExample_Cpp {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Riepilogo per Form1
	///
	/// AVVISO: se si modifica il nome della classe, sar necessario modificare la
	///          propriet 'Nome file di risorse' relativa allo strumento Compilatore di risorse gestite
	///          associato a tutti i file RESX da cui dipende la classe. In caso contrario,
	///          le finestre di progettazione non saranno in grado di interagire correttamente con le
	///          risorse localizzate associate al form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
		/////////////////////////////////
		// USER VARIABLES
		/////////////////////////////////
	public:
		bool SlowProcessOptionsEnabled;
		unsigned int ObjToDetect;

		ref class ColorLegenda
        {
		public:
			static Color IndexColor = Color::Green;
			static Color MiddleColor = Color::Red;
			static Color RingColor = Color::Blue;
			static Color LittleColor = Color::Orange;
			static Color ThumbColor = Color::Olive;
        };

        ref class ObjectTypes
        {
		public:
			static String ^Left_4_Str = "LEFT 4";
			static String ^Left_2_Str = "LEFT 2";
			static String ^Right_4_Str = "RIGHT 4";
			static String ^Right_2_Str = "RIGHT 2";
			static String ^Thmb_2_Str = "THUMBS 2";
			static String ^Single_Str = "SINGLE";
			static String ^FlatSingle_Str = "FLAT SINGLE";
			// Ver 3.1.0.0
			static String ^Left_LowerPalm_Str = "LEFT L-PALM";
			static String ^Right_LowerPalm_Str = "RIGHT L-PALM";
			static String ^Left_WriterPalm_Str = "LEFT W-PALM";
			static String ^Right_WriterPalm_Str = "RIGHT W-PALM";
			static String ^Left_Thenar_Str = "LEFT THENAR";
			static String ^Right_Thenar_Str = "RIGHT THENAR";
			static String ^Joint_FV1_Str = "JOINT FV1";
			static String ^Joint_FV2_Str = "JOINT FV2";
			static String ^Joint_FV3_Str = "JOINT FV3";
			static String ^Joint_FV4_Str = "JOINT FV4";
			static String ^Rolled_Tip_Str = "ROLLED TIP";
			// end Ver 3.1.0.0
            // Ver 3.3.0.0
            static String ^Left_UpperPalm_Str = "LEFT U-PALM";
            static String ^Right_UpperPalm_Str = "RIGHT U-PALM";
            // end Ver 3.3.0.0
        };

	private:
		array<int > ^BBL;
		array<int > ^BBR;
		array<int > ^BBT;
		array<int > ^BBB;
		// Ver 3.1.0.0
		array<int > ^mBBL;
		array<int > ^mBBR;
		array<int > ^mBBT;
		array<int > ^mBBB;
		array<int > ^pBBL;
		array<int > ^pBBR;
		array<int > ^pBBT;
		array<int > ^pBBB;
		// end Ver 3.1.0.0
		// ver 3.3.0.0
		int PalmPrintInterdigitalAreaBBL;
		int PalmPrintInterdigitalAreaBBR;
		int PalmPrintInterdigitalAreaBBT;
		int PalmPrintInterdigitalAreaBBB;

		int UpperPalmFingerPhalangesBBL;
		int UpperPalmFingerPhalangesBBR;
		int UpperPalmFingerPhalangesBBT;
		int UpperPalmFingerPhalangesBBB;
		// end ver 3.3.0.0
		array <Color> ^FingerColorForLegenda;
		int NumberOfSegmentsDetected;
		bool ReadyForPaint;
		bool ObjAllows180DegRotationCheck;
        bool ObjAllowsIncompleteSlapDetection;
		// Ver 3.1.0.0
		bool ObjAllowsJointFingerIsThumbOption;
		bool ObjAllowsMissingDeltaCalculation;
		bool ObjAllowsRolledFingerTopCornerPercentCalculation;
		bool ObjAllowsJointFingerBoundingBoxCalculation;
		// end Ver 3.1.0.0
	private: System::Windows::Forms::CheckBox^  IncompleteSlapDataGenerationCheckBox;
	private: System::Windows::Forms::CheckBox^  RefineFpContrastCleanBgCheckBox;
	private: System::Windows::Forms::CheckBox^  RefineDryFingerCheckBox;
	private: System::Windows::Forms::CheckBox^  cbDoNotCorrectAgeCreases;
	private: System::Windows::Forms::CheckBox^  cbPaperInkPrint;
	private: System::Windows::Forms::CheckBox^  cbJointFingerIsThumb;
	private: System::Windows::Forms::CheckBox^  cbGetMissingDeltaNumber;
	private: System::Windows::Forms::CheckBox^  cbGetRolledFingerTopCornerPercent;
	private: System::Windows::Forms::CheckBox^  cbGetJointFingerBoundingBox;
	private: System::Windows::Forms::CheckBox^  cbSegmentAsBB;






			 bool ObjAllowsMissingFingersMasking;

	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: aggiungere qui il codice del costruttore.
			//
			this->Text = "GBFinimgExample C++";
			SlowProcessOptionsEnabled = true;

            ObjAllows180DegRotationCheck = false;
            ObjAllowsIncompleteSlapDetection = false;
            ObjAllowsMissingFingersMasking = false;
			// ver 3.1.0.0
			ObjAllowsJointFingerIsThumbOption = false;
			ObjAllowsMissingDeltaCalculation = false;
			ObjAllowsRolledFingerTopCornerPercentCalculation = false;
			ObjAllowsJointFingerBoundingBoxCalculation = false;
			// end ver 3.1.0.0

            ObjTypesCombo->Items->Clear();
			ObjTypesCombo->Items->Add(ObjectTypes::Left_2_Str);
            ObjTypesCombo->Items->Add(ObjectTypes::Left_4_Str);
            ObjTypesCombo->Items->Add(ObjectTypes::Right_2_Str);
            ObjTypesCombo->Items->Add(ObjectTypes::Right_4_Str);
            ObjTypesCombo->Items->Add(ObjectTypes::Thmb_2_Str);
            ObjTypesCombo->Items->Add(ObjectTypes::Single_Str);
            ObjTypesCombo->Items->Add(ObjectTypes::FlatSingle_Str);
			// Ver 3.1.0.0
			ObjTypesCombo->Items->Add(ObjectTypes::Left_LowerPalm_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Right_LowerPalm_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Left_WriterPalm_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Right_WriterPalm_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Left_Thenar_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Right_Thenar_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Joint_FV1_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Joint_FV2_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Joint_FV3_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Joint_FV4_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Rolled_Tip_Str);
			// end Ver 3.1.0.0
            // Ver 3.3.0.0
			ObjTypesCombo->Items->Add(ObjectTypes::Left_UpperPalm_Str);
			ObjTypesCombo->Items->Add(ObjectTypes::Right_UpperPalm_Str);
            // end Ver 3.3.0.0

            ObjTypesCombo->SelectedIndex = 0;

            this->IndexCheckBox->BackColor = ColorLegenda::IndexColor;
            this->MiddleCheckBox->BackColor = ColorLegenda::MiddleColor;
            this->RingCheckBox->BackColor = ColorLegenda::RingColor;
            this->LittleCheckBox->BackColor = ColorLegenda::LittleColor;

            this->ImageProcessGroupBox->Enabled = false;
            this->ProcessButton->Enabled = false;
            ObjTypesCombo->Enabled = false;
            ReadyForPaint = false;

            BBL = gcnew array <int>(4);
            BBR = gcnew array <int>(4);
            BBT = gcnew array <int>(4);
            BBB = gcnew array <int>(4);

			// ver 3.1.0.0
            mBBL = gcnew array <int>(4);
            mBBR = gcnew array <int>(4);
            mBBT = gcnew array <int>(4);
            mBBB = gcnew array <int>(4);
            pBBL = gcnew array <int>(4);
            pBBR = gcnew array <int>(4);
            pBBT = gcnew array <int>(4);
            pBBB = gcnew array <int>(4);
			// end ver 3.1.0.0

            FingerColorForLegenda = gcnew array <Color>(4);

            NumberOfSegmentsDetected = 0;
		}

	protected:
		/// <summary>
		/// Liberare le risorse in uso.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::GroupBox^  MissingFingersGroupBox;
	protected: 
	private: System::Windows::Forms::CheckBox^  MiddleCheckBox;
	protected: System::Windows::Forms::CheckBox^  LittleCheckBox;
	private: 
	private: System::Windows::Forms::CheckBox^  RingCheckBox;
	protected: 
	private: System::Windows::Forms::CheckBox^  IndexCheckBox;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::CheckBox^  Check180RotationCheckBox;
	private: System::Windows::Forms::CheckBox^  FastProcessWithSegmentCheckBox;
	private: System::Windows::Forms::ComboBox^  ObjTypesCombo;
	private: System::Windows::Forms::CheckBox^  LeftRightCheckBox;
	private: System::Windows::Forms::GroupBox^  ImageProcessGroupBox;
	private: System::Windows::Forms::CheckBox^  FastProcessCheckBox;
	private: System::Windows::Forms::CheckBox^  ImageRes1000DpiCheckBox;
	private: System::Windows::Forms::CheckBox^  PalmQualCheckBox;
	private: System::Windows::Forms::CheckBox^  HaloCheckBox;
	private: System::Windows::Forms::CheckBox^  DeleteFingersCheckBox;
	private: System::Windows::Forms::CheckBox^  RotationCheckBox;
	private: System::Windows::Forms::Button^  ProcessButton;
	private: System::Windows::Forms::ListBox^  UserMessagesListBox;
	private: System::Windows::Forms::Button^  LoadImageButton;
	private: System::Windows::Forms::PictureBox^  FingerprintPictureBox;

	private:
		/// <summary>
		/// Variabile di progettazione necessaria.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Metodo necessario per il supporto della finestra di progettazione. Non modificare
		/// il contenuto del metodo con l'editor di codice.
		/// </summary>
		void InitializeComponent(void)
		{
			this->MissingFingersGroupBox = (gcnew System::Windows::Forms::GroupBox());
			this->MiddleCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->LittleCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->RingCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->IndexCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->Check180RotationCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->FastProcessWithSegmentCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->ObjTypesCombo = (gcnew System::Windows::Forms::ComboBox());
			this->LeftRightCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->ImageProcessGroupBox = (gcnew System::Windows::Forms::GroupBox());
			this->cbGetJointFingerBoundingBox = (gcnew System::Windows::Forms::CheckBox());
			this->cbGetRolledFingerTopCornerPercent = (gcnew System::Windows::Forms::CheckBox());
			this->cbGetMissingDeltaNumber = (gcnew System::Windows::Forms::CheckBox());
			this->cbJointFingerIsThumb = (gcnew System::Windows::Forms::CheckBox());
			this->cbPaperInkPrint = (gcnew System::Windows::Forms::CheckBox());
			this->cbDoNotCorrectAgeCreases = (gcnew System::Windows::Forms::CheckBox());
			this->RefineFpContrastCleanBgCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->RefineDryFingerCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->IncompleteSlapDataGenerationCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->FastProcessCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->ImageRes1000DpiCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->PalmQualCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->HaloCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->DeleteFingersCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->RotationCheckBox = (gcnew System::Windows::Forms::CheckBox());
			this->ProcessButton = (gcnew System::Windows::Forms::Button());
			this->UserMessagesListBox = (gcnew System::Windows::Forms::ListBox());
			this->LoadImageButton = (gcnew System::Windows::Forms::Button());
			this->FingerprintPictureBox = (gcnew System::Windows::Forms::PictureBox());
			this->cbSegmentAsBB = (gcnew System::Windows::Forms::CheckBox());
			this->MissingFingersGroupBox->SuspendLayout();
			this->ImageProcessGroupBox->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->FingerprintPictureBox))->BeginInit();
			this->SuspendLayout();
			// 
			// MissingFingersGroupBox
			// 
			this->MissingFingersGroupBox->Controls->Add(this->MiddleCheckBox);
			this->MissingFingersGroupBox->Controls->Add(this->LittleCheckBox);
			this->MissingFingersGroupBox->Controls->Add(this->RingCheckBox);
			this->MissingFingersGroupBox->Controls->Add(this->IndexCheckBox);
			this->MissingFingersGroupBox->Location = System::Drawing::Point(468, 144);
			this->MissingFingersGroupBox->Name = L"MissingFingersGroupBox";
			this->MissingFingersGroupBox->Size = System::Drawing::Size(116, 215);
			this->MissingFingersGroupBox->TabIndex = 21;
			this->MissingFingersGroupBox->TabStop = false;
			this->MissingFingersGroupBox->Text = L"Missing fingers";
			// 
			// MiddleCheckBox
			// 
			this->MiddleCheckBox->CheckAlign = System::Drawing::ContentAlignment::BottomCenter;
			this->MiddleCheckBox->Location = System::Drawing::Point(35, 78);
			this->MiddleCheckBox->Name = L"MiddleCheckBox";
			this->MiddleCheckBox->Size = System::Drawing::Size(52, 31);
			this->MiddleCheckBox->TabIndex = 3;
			this->MiddleCheckBox->Text = L"MIDDLE";
			this->MiddleCheckBox->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->MiddleCheckBox->UseVisualStyleBackColor = true;
			// 
			// LittleCheckBox
			// 
			this->LittleCheckBox->CheckAlign = System::Drawing::ContentAlignment::BottomCenter;
			this->LittleCheckBox->Location = System::Drawing::Point(35, 179);
			this->LittleCheckBox->Name = L"LittleCheckBox";
			this->LittleCheckBox->Size = System::Drawing::Size(52, 31);
			this->LittleCheckBox->TabIndex = 2;
			this->LittleCheckBox->Text = L"LITTLE";
			this->LittleCheckBox->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->LittleCheckBox->UseVisualStyleBackColor = true;
			// 
			// RingCheckBox
			// 
			this->RingCheckBox->CheckAlign = System::Drawing::ContentAlignment::BottomCenter;
			this->RingCheckBox->Location = System::Drawing::Point(35, 124);
			this->RingCheckBox->Name = L"RingCheckBox";
			this->RingCheckBox->Size = System::Drawing::Size(52, 31);
			this->RingCheckBox->TabIndex = 1;
			this->RingCheckBox->Text = L"RING";
			this->RingCheckBox->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->RingCheckBox->UseVisualStyleBackColor = true;
			// 
			// IndexCheckBox
			// 
			this->IndexCheckBox->CheckAlign = System::Drawing::ContentAlignment::BottomCenter;
			this->IndexCheckBox->Location = System::Drawing::Point(35, 30);
			this->IndexCheckBox->Name = L"IndexCheckBox";
			this->IndexCheckBox->Size = System::Drawing::Size(52, 31);
			this->IndexCheckBox->TabIndex = 0;
			this->IndexCheckBox->Text = L"INDEX";
			this->IndexCheckBox->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->IndexCheckBox->UseVisualStyleBackColor = true;
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(465, 71);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(70, 13);
			this->label1->TabIndex = 20;
			this->label1->Text = L"Objects Type";
			// 
			// Check180RotationCheckBox
			// 
			this->Check180RotationCheckBox->AutoSize = true;
			this->Check180RotationCheckBox->Location = System::Drawing::Point(203, 92);
			this->Check180RotationCheckBox->Name = L"Check180RotationCheckBox";
			this->Check180RotationCheckBox->Size = System::Drawing::Size(119, 17);
			this->Check180RotationCheckBox->TabIndex = 12;
			this->Check180RotationCheckBox->Text = L"Check 180 degrees";
			this->Check180RotationCheckBox->UseVisualStyleBackColor = true;
			// 
			// FastProcessWithSegmentCheckBox
			// 
			this->FastProcessWithSegmentCheckBox->AutoSize = true;
			this->FastProcessWithSegmentCheckBox->Location = System::Drawing::Point(11, 46);
			this->FastProcessWithSegmentCheckBox->Name = L"FastProcessWithSegmentCheckBox";
			this->FastProcessWithSegmentCheckBox->Size = System::Drawing::Size(162, 17);
			this->FastProcessWithSegmentCheckBox->TabIndex = 11;
			this->FastProcessWithSegmentCheckBox->Text = L"Fast Process With Segments";
			this->FastProcessWithSegmentCheckBox->UseVisualStyleBackColor = true;
			this->FastProcessWithSegmentCheckBox->CheckedChanged += gcnew System::EventHandler(this, &Form1::FastProcessWithSegmentCheckBox_CheckedChanged);
			// 
			// ObjTypesCombo
			// 
			this->ObjTypesCombo->FormattingEnabled = true;
			this->ObjTypesCombo->Location = System::Drawing::Point(468, 96);
			this->ObjTypesCombo->Name = L"ObjTypesCombo";
			this->ObjTypesCombo->Size = System::Drawing::Size(116, 21);
			this->ObjTypesCombo->TabIndex = 19;
			this->ObjTypesCombo->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::ObjTypesCombo_SelectedIndexChanged);
			// 
			// LeftRightCheckBox
			// 
			this->LeftRightCheckBox->AutoSize = true;
			this->LeftRightCheckBox->Location = System::Drawing::Point(11, 69);
			this->LeftRightCheckBox->Name = L"LeftRightCheckBox";
			this->LeftRightCheckBox->Size = System::Drawing::Size(123, 17);
			this->LeftRightCheckBox->TabIndex = 10;
			this->LeftRightCheckBox->Text = L"No Left-Right Check";
			this->LeftRightCheckBox->UseVisualStyleBackColor = true;
			// 
			// ImageProcessGroupBox
			// 
			this->ImageProcessGroupBox->Controls->Add(this->cbSegmentAsBB);
			this->ImageProcessGroupBox->Controls->Add(this->cbGetJointFingerBoundingBox);
			this->ImageProcessGroupBox->Controls->Add(this->cbGetRolledFingerTopCornerPercent);
			this->ImageProcessGroupBox->Controls->Add(this->cbGetMissingDeltaNumber);
			this->ImageProcessGroupBox->Controls->Add(this->cbJointFingerIsThumb);
			this->ImageProcessGroupBox->Controls->Add(this->cbPaperInkPrint);
			this->ImageProcessGroupBox->Controls->Add(this->cbDoNotCorrectAgeCreases);
			this->ImageProcessGroupBox->Controls->Add(this->RefineFpContrastCleanBgCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->RefineDryFingerCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->IncompleteSlapDataGenerationCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->Check180RotationCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->FastProcessWithSegmentCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->LeftRightCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->FastProcessCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->ImageRes1000DpiCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->PalmQualCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->HaloCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->DeleteFingersCheckBox);
			this->ImageProcessGroupBox->Controls->Add(this->RotationCheckBox);
			this->ImageProcessGroupBox->Location = System::Drawing::Point(12, 473);
			this->ImageProcessGroupBox->Name = L"ImageProcessGroupBox";
			this->ImageProcessGroupBox->Size = System::Drawing::Size(940, 176);
			this->ImageProcessGroupBox->TabIndex = 18;
			this->ImageProcessGroupBox->TabStop = false;
			this->ImageProcessGroupBox->Text = L"Image Process Options";
			// 
			// cbGetJointFingerBoundingBox
			// 
			this->cbGetJointFingerBoundingBox->AutoSize = true;
			this->cbGetJointFingerBoundingBox->Location = System::Drawing::Point(582, 69);
			this->cbGetJointFingerBoundingBox->Name = L"cbGetJointFingerBoundingBox";
			this->cbGetJointFingerBoundingBox->Size = System::Drawing::Size(169, 17);
			this->cbGetJointFingerBoundingBox->TabIndex = 23;
			this->cbGetJointFingerBoundingBox->Text = L"Get Joint Finger Bounding Box";
			this->cbGetJointFingerBoundingBox->UseVisualStyleBackColor = true;
			// 
			// cbGetRolledFingerTopCornerPercent
			// 
			this->cbGetRolledFingerTopCornerPercent->AutoSize = true;
			this->cbGetRolledFingerTopCornerPercent->Location = System::Drawing::Point(582, 48);
			this->cbGetRolledFingerTopCornerPercent->Name = L"cbGetRolledFingerTopCornerPercent";
			this->cbGetRolledFingerTopCornerPercent->Size = System::Drawing::Size(187, 17);
			this->cbGetRolledFingerTopCornerPercent->TabIndex = 22;
			this->cbGetRolledFingerTopCornerPercent->Text = L"Get Rolled Fill Top Corner Percent";
			this->cbGetRolledFingerTopCornerPercent->UseVisualStyleBackColor = true;
			// 
			// cbGetMissingDeltaNumber
			// 
			this->cbGetMissingDeltaNumber->AutoSize = true;
			this->cbGetMissingDeltaNumber->Location = System::Drawing::Point(582, 25);
			this->cbGetMissingDeltaNumber->Name = L"cbGetMissingDeltaNumber";
			this->cbGetMissingDeltaNumber->Size = System::Drawing::Size(149, 17);
			this->cbGetMissingDeltaNumber->TabIndex = 21;
			this->cbGetMissingDeltaNumber->Text = L"Get Missing Delta Number";
			this->cbGetMissingDeltaNumber->UseVisualStyleBackColor = true;
			// 
			// cbJointFingerIsThumb
			// 
			this->cbJointFingerIsThumb->AutoSize = true;
			this->cbJointFingerIsThumb->Location = System::Drawing::Point(383, 115);
			this->cbJointFingerIsThumb->Name = L"cbJointFingerIsThumb";
			this->cbJointFingerIsThumb->Size = System::Drawing::Size(127, 17);
			this->cbJointFingerIsThumb->TabIndex = 20;
			this->cbJointFingerIsThumb->Text = L"Joint Finger Is Thumb";
			this->cbJointFingerIsThumb->UseVisualStyleBackColor = true;
			// 
			// cbPaperInkPrint
			// 
			this->cbPaperInkPrint->AutoSize = true;
			this->cbPaperInkPrint->Location = System::Drawing::Point(383, 92);
			this->cbPaperInkPrint->Name = L"cbPaperInkPrint";
			this->cbPaperInkPrint->Size = System::Drawing::Size(96, 17);
			this->cbPaperInkPrint->TabIndex = 19;
			this->cbPaperInkPrint->Text = L"Paper Ink Print";
			this->cbPaperInkPrint->UseVisualStyleBackColor = true;
			// 
			// cbDoNotCorrectAgeCreases
			// 
			this->cbDoNotCorrectAgeCreases->AutoSize = true;
			this->cbDoNotCorrectAgeCreases->Location = System::Drawing::Point(383, 69);
			this->cbDoNotCorrectAgeCreases->Name = L"cbDoNotCorrectAgeCreases";
			this->cbDoNotCorrectAgeCreases->Size = System::Drawing::Size(155, 17);
			this->cbDoNotCorrectAgeCreases->TabIndex = 18;
			this->cbDoNotCorrectAgeCreases->Text = L"Do not correct age creases";
			this->cbDoNotCorrectAgeCreases->UseVisualStyleBackColor = true;
			this->cbDoNotCorrectAgeCreases->CheckedChanged += gcnew System::EventHandler(this, &Form1::cbDoNotCorrectAgeCreases_CheckedChanged);
			// 
			// RefineFpContrastCleanBgCheckBox
			// 
			this->RefineFpContrastCleanBgCheckBox->AutoSize = true;
			this->RefineFpContrastCleanBgCheckBox->Location = System::Drawing::Point(383, 48);
			this->RefineFpContrastCleanBgCheckBox->Name = L"RefineFpContrastCleanBgCheckBox";
			this->RefineFpContrastCleanBgCheckBox->Size = System::Drawing::Size(181, 17);
			this->RefineFpContrastCleanBgCheckBox->TabIndex = 17;
			this->RefineFpContrastCleanBgCheckBox->Text = L"Refine FP contrast and Clean Bg";
			this->RefineFpContrastCleanBgCheckBox->UseVisualStyleBackColor = true;
			// 
			// RefineDryFingerCheckBox
			// 
			this->RefineDryFingerCheckBox->AutoSize = true;
			this->RefineDryFingerCheckBox->Location = System::Drawing::Point(383, 25);
			this->RefineDryFingerCheckBox->Name = L"RefineDryFingerCheckBox";
			this->RefineDryFingerCheckBox->Size = System::Drawing::Size(160, 17);
			this->RefineDryFingerCheckBox->TabIndex = 16;
			this->RefineDryFingerCheckBox->Text = L"Refine Dry Fingerprint Image";
			this->RefineDryFingerCheckBox->UseVisualStyleBackColor = true;
			// 
			// IncompleteSlapDataGenerationCheckBox
			// 
			this->IncompleteSlapDataGenerationCheckBox->AutoSize = true;
			this->IncompleteSlapDataGenerationCheckBox->Location = System::Drawing::Point(203, 115);
			this->IncompleteSlapDataGenerationCheckBox->Name = L"IncompleteSlapDataGenerationCheckBox";
			this->IncompleteSlapDataGenerationCheckBox->Size = System::Drawing::Size(151, 17);
			this->IncompleteSlapDataGenerationCheckBox->TabIndex = 14;
			this->IncompleteSlapDataGenerationCheckBox->Text = L"Incomplete Slap Data Gen";
			this->IncompleteSlapDataGenerationCheckBox->UseVisualStyleBackColor = true;
			this->IncompleteSlapDataGenerationCheckBox->CheckedChanged += gcnew System::EventHandler(this, &Form1::IncompleteSlapDataGenerationCheckBox_CheckedChanged);
			// 
			// FastProcessCheckBox
			// 
			this->FastProcessCheckBox->AutoSize = true;
			this->FastProcessCheckBox->Location = System::Drawing::Point(11, 25);
			this->FastProcessCheckBox->Name = L"FastProcessCheckBox";
			this->FastProcessCheckBox->Size = System::Drawing::Size(177, 17);
			this->FastProcessCheckBox->TabIndex = 4;
			this->FastProcessCheckBox->Text = L"Fast Process Without Segments";
			this->FastProcessCheckBox->UseVisualStyleBackColor = true;
			this->FastProcessCheckBox->CheckedChanged += gcnew System::EventHandler(this, &Form1::FastProcessCheckBox_CheckedChanged);
			// 
			// ImageRes1000DpiCheckBox
			// 
			this->ImageRes1000DpiCheckBox->AutoSize = true;
			this->ImageRes1000DpiCheckBox->Location = System::Drawing::Point(203, 69);
			this->ImageRes1000DpiCheckBox->Name = L"ImageRes1000DpiCheckBox";
			this->ImageRes1000DpiCheckBox->Size = System::Drawing::Size(69, 17);
			this->ImageRes1000DpiCheckBox->TabIndex = 9;
			this->ImageRes1000DpiCheckBox->Text = L"1000 Dpi";
			this->ImageRes1000DpiCheckBox->UseVisualStyleBackColor = true;
			// 
			// PalmQualCheckBox
			// 
			this->PalmQualCheckBox->AutoSize = true;
			this->PalmQualCheckBox->Location = System::Drawing::Point(203, 46);
			this->PalmQualCheckBox->Name = L"PalmQualCheckBox";
			this->PalmQualCheckBox->Size = System::Drawing::Size(84, 17);
			this->PalmQualCheckBox->TabIndex = 8;
			this->PalmQualCheckBox->Text = L"Palm Quality";
			this->PalmQualCheckBox->UseVisualStyleBackColor = true;
			// 
			// HaloCheckBox
			// 
			this->HaloCheckBox->AutoSize = true;
			this->HaloCheckBox->Location = System::Drawing::Point(11, 92);
			this->HaloCheckBox->Name = L"HaloCheckBox";
			this->HaloCheckBox->Size = System::Drawing::Size(101, 17);
			this->HaloCheckBox->TabIndex = 5;
			this->HaloCheckBox->Text = L"Halo Elimination";
			this->HaloCheckBox->UseVisualStyleBackColor = true;
			// 
			// DeleteFingersCheckBox
			// 
			this->DeleteFingersCheckBox->AutoSize = true;
			this->DeleteFingersCheckBox->Location = System::Drawing::Point(203, 25);
			this->DeleteFingersCheckBox->Name = L"DeleteFingersCheckBox";
			this->DeleteFingersCheckBox->Size = System::Drawing::Size(94, 17);
			this->DeleteFingersCheckBox->TabIndex = 7;
			this->DeleteFingersCheckBox->Text = L"Delete Fingers";
			this->DeleteFingersCheckBox->UseVisualStyleBackColor = true;
			// 
			// RotationCheckBox
			// 
			this->RotationCheckBox->AutoSize = true;
			this->RotationCheckBox->Location = System::Drawing::Point(11, 115);
			this->RotationCheckBox->Name = L"RotationCheckBox";
			this->RotationCheckBox->Size = System::Drawing::Size(66, 17);
			this->RotationCheckBox->TabIndex = 6;
			this->RotationCheckBox->Text = L"Rotation";
			this->RotationCheckBox->UseVisualStyleBackColor = true;
			// 
			// ProcessButton
			// 
			this->ProcessButton->Location = System::Drawing::Point(468, 408);
			this->ProcessButton->Name = L"ProcessButton";
			this->ProcessButton->Size = System::Drawing::Size(116, 59);
			this->ProcessButton->TabIndex = 17;
			this->ProcessButton->Text = L"Process";
			this->ProcessButton->UseVisualStyleBackColor = true;
			this->ProcessButton->Click += gcnew System::EventHandler(this, &Form1::ProcessButton_Click);
			// 
			// UserMessagesListBox
			// 
			this->UserMessagesListBox->FormattingEnabled = true;
			this->UserMessagesListBox->HorizontalScrollbar = true;
			this->UserMessagesListBox->Location = System::Drawing::Point(604, 34);
			this->UserMessagesListBox->Name = L"UserMessagesListBox";
			this->UserMessagesListBox->Size = System::Drawing::Size(348, 433);
			this->UserMessagesListBox->TabIndex = 16;
			// 
			// LoadImageButton
			// 
			this->LoadImageButton->Location = System::Drawing::Point(468, 34);
			this->LoadImageButton->Name = L"LoadImageButton";
			this->LoadImageButton->Size = System::Drawing::Size(116, 34);
			this->LoadImageButton->TabIndex = 14;
			this->LoadImageButton->Text = L"Load Image";
			this->LoadImageButton->UseVisualStyleBackColor = true;
			this->LoadImageButton->Click += gcnew System::EventHandler(this, &Form1::LoadImageButton_Click);
			// 
			// FingerprintPictureBox
			// 
			this->FingerprintPictureBox->Location = System::Drawing::Point(12, 34);
			this->FingerprintPictureBox->Name = L"FingerprintPictureBox";
			this->FingerprintPictureBox->Size = System::Drawing::Size(400, 400);
			this->FingerprintPictureBox->TabIndex = 15;
			this->FingerprintPictureBox->TabStop = false;
			this->FingerprintPictureBox->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &Form1::FingerprintPictureBox_Paint);
			// 
			// cbSegmentAsBB
			// 
			this->cbSegmentAsBB->AutoSize = true;
			this->cbSegmentAsBB->Location = System::Drawing::Point(582, 92);
			this->cbSegmentAsBB->Name = L"cbSegmentAsBB";
			this->cbSegmentAsBB->Size = System::Drawing::Size(200, 17);
			this->cbSegmentAsBB->TabIndex = 31;
			this->cbSegmentAsBB->Text = L"Limit Segment Size To Bounding Box";
			this->cbSegmentAsBB->UseVisualStyleBackColor = true;
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(979, 675);
			this->Controls->Add(this->MissingFingersGroupBox);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->ObjTypesCombo);
			this->Controls->Add(this->ImageProcessGroupBox);
			this->Controls->Add(this->ProcessButton);
			this->Controls->Add(this->UserMessagesListBox);
			this->Controls->Add(this->LoadImageButton);
			this->Controls->Add(this->FingerprintPictureBox);
			this->Name = L"Form1";
			this->Text = L"Form1";
			this->MissingFingersGroupBox->ResumeLayout(false);
			this->ImageProcessGroupBox->ResumeLayout(false);
			this->ImageProcessGroupBox->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->FingerprintPictureBox))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private:
		void EnableSlowProcessOptions(bool Enable)
        {
            this->RotationCheckBox->Enabled = Enable;
            this->HaloCheckBox->Enabled = Enable;
            this->PalmQualCheckBox->Enabled = Enable;
            this->DeleteFingersCheckBox->Enabled = Enable;
            this->FastProcessWithSegmentCheckBox->Enabled = Enable;
			// ver 3.1.0.0
			this->cbGetJointFingerBoundingBox->Enabled = ObjAllowsJointFingerBoundingBoxCalculation;
			// end ver 3.1.0.0
            if (Enable)
            {
                if (this->FastProcessWithSegmentCheckBox->Checked)
                {
                    this->Check180RotationCheckBox->Enabled = false;
                    this->IncompleteSlapDataGenerationCheckBox->Enabled = false;
                }
                else
                {
                    this->Check180RotationCheckBox->Enabled = ObjAllows180DegRotationCheck;
                    this->IncompleteSlapDataGenerationCheckBox->Enabled = ObjAllowsIncompleteSlapDetection;
                }
            }
            else
            {
                this->Check180RotationCheckBox->Enabled = false;
				this->IncompleteSlapDataGenerationCheckBox->Enabled = false;
            }
            SlowProcessOptionsEnabled = Enable;
        }

		unsigned int GetProcessOptions()
        {
            unsigned int RetVal = 0;
            if (SlowProcessOptionsEnabled)
            {
                if (this->RotationCheckBox->Enabled && this->RotationCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_SEGMENT_VERTICAL_ROTATION;
                }
                if (this->HaloCheckBox->Enabled && this->HaloCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_HALO_LATENT_ELIMINATION;
                }
                if (this->PalmQualCheckBox->Enabled && this->PalmQualCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_PALM_PRINT_IMAGE_QUALITY_CALCULATION;
                }
                if (this->ImageRes1000DpiCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_1000DPI_PRINT_IMAGE_PROCESSING;
                }
                if (this->DeleteFingersCheckBox->Enabled && this->DeleteFingersCheckBox->Checked)
                {
                    RetVal |=
                        GBFINIMG_PALM_PRINT_IMAGE_DELETE_FINGER_SEGMENTS;
                }
                if (this->LeftRightCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK;
                }
                if (this->FastProcessWithSegmentCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_FAST_PROCESSING_PRELIMINARY_SEGMENT_DATA;
                }
                if (this->IncompleteSlapDataGenerationCheckBox->Enabled && this->IncompleteSlapDataGenerationCheckBox->Checked)
                {
                    RetVal |=
                        GBFINIMG_ALLOW_INCOMPLETE_SLAP_SEGMENTS_DATA_GENERATION;
                    // NW_GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK must be used 
                    RetVal |= GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK;
                }
            }
            else
            {
                if (this->FastProcessCheckBox->Enabled && this->FastProcessCheckBox->Checked)
                {
                    RetVal |=
                        GBFINIMG_FAST_PROCESSING_SEGMENT_NUMBER_ONLY;
                }
                if (this->LeftRightCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK;
                }
                if (this->ImageRes1000DpiCheckBox->Checked)
                {
                    RetVal |= GBFINIMG_1000DPI_PRINT_IMAGE_PROCESSING;
                }
            }
			if (this->RefineDryFingerCheckBox->Enabled && this->RefineDryFingerCheckBox->Checked)
			{
				RetVal |= GBFINIMG_REFINE_DRY_FINGERPRINT_IMAGE;
			}
			if (this->RefineFpContrastCleanBgCheckBox->Enabled && this->RefineFpContrastCleanBgCheckBox->Checked)
			{
				RetVal |= 
					GBFINIMG_REFINE_FINGERPRINT_CONTRAST_AND_CLEAN_BACKGROUND;
			}
			// ver 3.1.0.0
            if (this->cbDoNotCorrectAgeCreases->Enabled && this->cbDoNotCorrectAgeCreases->Checked)
            {
                RetVal |=
                    GBFINIMG_REFINE_DRY_FINGERPRINT_IMAGE_AGE_CREASES_UNTOUCHED;
            }
			if (this->cbPaperInkPrint->Enabled && this->cbPaperInkPrint->Checked)
            {
                RetVal |=
                    GBFINIMG_PAPER_CARD_INK_PRINT;
            }
			if (this->cbJointFingerIsThumb->Enabled && this->cbJointFingerIsThumb->Checked)
            {
                RetVal |= GBFINIMG_JOINT_FINGER_IS_THUMB;
            }
			// end ver 3.1.0.0

            // ver 3.3.0.0
            if (this->cbSegmentAsBB->Checked)
            {
                RetVal |= GBFINIMG_SEGMENT_IMAGE_AS_BOUNDING_BOX;
            }
            // end ver 3.3.0.0
            return RetVal;
        }

		void EliminateStrideDistorsion(byte * ImgBuffer,
            int bmpW, int bmpH, int bmpS, int *newWidth)
        {
            *newWidth = (bmpW / 4) * 4;
            if (bmpW > bmpS)
                return;

			byte *ImgS = ImgBuffer, *ImgW = ImgBuffer;

            int IndexS = 0, ImgBuffLen = bmpS * bmpH;
            while ((IndexS + bmpS) < ImgBuffLen)
            {
				memcpy(ImgW,ImgS,*newWidth);
                IndexS += bmpS;
				ImgS += bmpS;
                ImgW += (*newWidth);
            }
        }
		
		System::Void LoadImageButton_Click(System::Object^  sender, System::EventArgs^  e)
		{
            OpenFileDialog ^FD = gcnew OpenFileDialog();

            FD->ShowDialog();

            String ^fn = FD->FileName;
            if (fn != nullptr && fn != "")
            {
                Bitmap ^x = gcnew Bitmap(fn);

                if ((x != nullptr)  && (x->PixelFormat == System::Drawing::Imaging::PixelFormat::Format8bppIndexed))
                {
					// Lock the bitmap's bits->
					System::Drawing::Rectangle rect = System::Drawing::Rectangle(0, 0, x->Width, x->Height);
					System::Drawing::Imaging::BitmapData ^bmpData =
						x->LockBits(rect, System::Drawing::Imaging::ImageLockMode::ReadWrite,
						x->PixelFormat);

					if (bmpData->Stride != x->Width)
					{
						// Get the address of the first line->
						IntPtr ptr = bmpData->Scan0;

						int newW = 0;

						EliminateStrideDistorsion((byte *)(ptr.ToPointer()), x->Width, x->Height,bmpData->Stride, & newW);

                        // Unlock the bits.
                        x->UnlockBits(bmpData);

                        x = gcnew Bitmap(newW, x->Height, newW, System::Drawing::Imaging::PixelFormat::Format8bppIndexed, ptr);
					}
					else
					{
						// Unlock the bits->
						x->UnlockBits(bmpData);
					}

					System::Drawing::Imaging::ColorPalette ^pal = x->Palette;
                    for (int i = 0; i < pal->Entries->Length; i++)
                    {
						pal->Entries[i] = Color::FromArgb(255, i, i, i);
                    }
                    x->Palette = pal;

					// ver 3.1.0.0
					// calculate dimensions of paint box
					System::Drawing::Size WinPaintBoxOriginalSize = System::Drawing::Size(400, 400);
					Point WinPaintBoxOriginalLocation = Point(12, 34);

					System::Drawing::Size WinPaintBoxNewSize;
					Point WinPaintBoxNewLocation;
					this->CalculatePaintBoxSizeAndLocation(x->Width, x->Height, WinPaintBoxOriginalSize,
						WinPaintBoxOriginalLocation, WinPaintBoxNewSize, WinPaintBoxNewLocation);
					this->FingerprintPictureBox->Location = WinPaintBoxNewLocation;
					this->FingerprintPictureBox->Size = WinPaintBoxNewSize;
					// end ver 3.1.0.0

                    this->FingerprintPictureBox->Image = x;
					this->FingerprintPictureBox->SizeMode = PictureBoxSizeMode::StretchImage;

                    this->ImageProcessGroupBox->Enabled = true;

                    this->Text = FD->SafeFileName;

                    ReadyForPaint = false;
                    this->ProcessButton->Enabled = true;
                    ObjTypesCombo->Enabled = true;
                }
            }
        }
		
		// ver 3.1.0.0
		System::Void EnableOptionsCheckBox()
		{
			this->cbGetJointFingerBoundingBox->Enabled = ObjAllowsJointFingerBoundingBoxCalculation;
			this->cbGetMissingDeltaNumber->Enabled = ObjAllowsMissingDeltaCalculation;
			this->cbGetRolledFingerTopCornerPercent->Enabled = ObjAllowsRolledFingerTopCornerPercentCalculation;
			this->cbJointFingerIsThumb->Enabled = ObjAllowsJointFingerIsThumbOption;ObjAllows180DegRotationCheck = false;
			// ver 3.3.0.0
			this->IncompleteSlapDataGenerationCheckBox->Enabled = ObjAllowsIncompleteSlapDetection;
			// end ver 3.3.0.0
			// end ver 3.1.0.0
		}
		// end ver 3.1.0.0
		
		System::Void ObjTypesCombo_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
		{
            String ^SelIt = (String ^)(ObjTypesCombo->SelectedItem);
            ObjAllows180DegRotationCheck = false;
			ObjAllowsMissingFingersMasking = false;
			ObjAllowsIncompleteSlapDetection = false;
			// ver 3.1.0.0
			ObjAllowsJointFingerIsThumbOption = false;
			ObjAllowsMissingDeltaCalculation = false;
			ObjAllowsRolledFingerTopCornerPercentCalculation = false;
			ObjAllowsJointFingerBoundingBoxCalculation = false;
			// end ver 3.1.0.0

			if (SelIt->Equals(ObjectTypes::Left_2_Str))
            {
				// ver 3.1.0.0
				ObjAllowsMissingDeltaCalculation = true;
				// end ver 3.1.0.0
                this->MissingFingersGroupBox->Enabled = false;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_2;
                ObjAllows180DegRotationCheck = true;
            }
            else if (SelIt->Equals(ObjectTypes::Left_4_Str))
            {
				// ver 3.1.0.0
				ObjAllowsMissingDeltaCalculation = true;
				// end ver 3.1.0.0
                this->MissingFingersGroupBox->Enabled = true;
				ObjAllowsMissingFingersMasking = true;
				ObjAllowsIncompleteSlapDetection = true;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_4;
            }
            else if (SelIt->Equals(ObjectTypes::Right_2_Str))
            {
				// ver 3.1.0.0
				ObjAllowsMissingDeltaCalculation = true;
				// end ver 3.1.0.0
                this->MissingFingersGroupBox->Enabled = false;				
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_2;
                ObjAllows180DegRotationCheck = true;
            }
            else if (SelIt->Equals(ObjectTypes::Right_4_Str))
            {
				// ver 3.1.0.0
				ObjAllowsMissingDeltaCalculation = true;
				// end ver 3.1.0.0
                this->MissingFingersGroupBox->Enabled = true;
				ObjAllowsMissingFingersMasking = true;
				ObjAllowsIncompleteSlapDetection = true;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_4;
            }
            else if (SelIt->Equals(ObjectTypes::Single_Str))
            {
				// ver 3.1.0.0
				ObjAllowsMissingDeltaCalculation = true;
				// end ver 3.1.0.0
				// ver 3.1.0.0
				ObjAllowsRolledFingerTopCornerPercentCalculation = true;
				// end ver 3.1.0.0
                this->MissingFingersGroupBox->Enabled = false;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_SINGLE_FINGER;
                ObjAllows180DegRotationCheck = true;
            }
            else if (SelIt->Equals(ObjectTypes::Thmb_2_Str))
            {
				// ver 3.1.0.0
				ObjAllowsMissingDeltaCalculation = true;
				// end ver 3.1.0.0
                this->MissingFingersGroupBox->Enabled = false;
				ObjAllowsIncompleteSlapDetection = true;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_THUMBS_2;
                ObjAllows180DegRotationCheck = true;
            }
            else if (SelIt->Equals(ObjectTypes::FlatSingle_Str))
            {
				// ver 3.1.0.0
				ObjAllowsMissingDeltaCalculation = true;
				// end ver 3.1.0.0
                this->MissingFingersGroupBox->Enabled = false;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_SINGLE_FINGER_FLAT;
                ObjAllows180DegRotationCheck = true;
            }
            // Ver 3.3.0.0
			else if (SelIt->Equals(ObjectTypes::Left_UpperPalm_Str))
            {
                this->MissingFingersGroupBox->Enabled = true;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM_UPPER;
            }
			else if (SelIt->Equals(ObjectTypes::Right_UpperPalm_Str))
            {
                this->MissingFingersGroupBox->Enabled = true;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM_UPPER;
            }
			// end Ver 3.3.0.0
			// ver 3.1.0.0
			else if (SelIt->Equals(ObjectTypes::Left_LowerPalm_Str))
            {
                this->MissingFingersGroupBox->Enabled = false;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM;
            }
			else if (SelIt->Equals(ObjectTypes::Right_LowerPalm_Str))
            {
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM;
            }
			else if (SelIt->Equals(ObjectTypes::Left_WriterPalm_Str))
            {
                this->MissingFingersGroupBox->Enabled = false;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_WRITER_PALM;
            }
			else if (SelIt->Equals(ObjectTypes::Right_WriterPalm_Str))
            {
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_WRITER_PALM;
            }
			else if (SelIt->Equals(ObjectTypes::Left_Thenar_Str))
            {
                this->MissingFingersGroupBox->Enabled = false;
                ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_ROLLED_THENAR;
            }
			else if (SelIt->Equals(ObjectTypes::Right_Thenar_Str))
            {
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_ROLLED_THENAR;
            }
			else if (SelIt->Equals(ObjectTypes::Joint_FV1_Str))
            {
				ObjAllowsJointFingerBoundingBoxCalculation = true;
				ObjAllowsRolledFingerTopCornerPercentCalculation = true;
				ObjAllowsJointFingerIsThumbOption = true;
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_ROLLED_JOINT_FINGER_FV1;
            }
			else if (SelIt->Equals(ObjectTypes::Joint_FV2_Str))
            {
				ObjAllowsJointFingerBoundingBoxCalculation = true;
				ObjAllowsJointFingerIsThumbOption = true;
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_FLAT_JOINT_FINGER_FV2;
            }
			else if (SelIt->Equals(ObjectTypes::Joint_FV3_Str))
            {
				ObjAllowsJointFingerBoundingBoxCalculation = true;
				ObjAllowsJointFingerIsThumbOption = true;
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_FLAT_JOINT_FINGER_FV3;
            }
			else if (SelIt->Equals(ObjectTypes::Joint_FV4_Str))
            {
				ObjAllowsJointFingerBoundingBoxCalculation = true;
				ObjAllowsJointFingerIsThumbOption = true;
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_FLAT_JOINT_FINGER_FV4;
            }
			else if (SelIt->Equals(ObjectTypes::Rolled_Tip_Str))
            {
                this->MissingFingersGroupBox->Enabled = false;
				ObjToDetect = GBFINIMG_INPUT_IMAGE_TYPE_ROLLED_TIP;
            }

			EnableOptionsCheckBox();
			// end ver 3.1.0.0
            this->FastProcessWithSegmentCheckBox_CheckedChanged(nullptr, nullptr);
        }

		System::Void FastProcessCheckBox_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
		{
            if (FastProcessCheckBox->Checked)
            {
                this->EnableSlowProcessOptions(false);
            }
            else
            {
                this->EnableSlowProcessOptions(true);
            }
        }
		
		System::Void FastProcessWithSegmentCheckBox_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
		{
            if (this->FastProcessWithSegmentCheckBox->Checked)
            {
                this->Check180RotationCheckBox->Enabled = false;
				// ver 3.1.0.0
				this->cbGetJointFingerBoundingBox->Enabled = false;
				// end ver 3.1.0.0
            }
            else
            {
                this->Check180RotationCheckBox->Enabled = ObjAllows180DegRotationCheck;
				// ver 3.1.0.0
				this->cbGetJointFingerBoundingBox->Enabled = ObjAllowsJointFingerBoundingBoxCalculation;
				// end ver 3.1.0.0
            }
        }

		// ver 3.1.0.0
		void CalculatePaintBoxSizeAndLocation(
			unsigned int imsx, unsigned int imsy,
				System::Drawing::Size pbOriginalSize, System::Drawing::Point pbOriginalPoint,
				System::Drawing::Size % pbSize, System::Drawing::Point % pbLocation)
		{
			if (imsx == imsy)
			{
				pbLocation = pbOriginalPoint;
				pbSize = pbOriginalSize;
				return;
			}
			if (imsx > imsy)
			{
				pbLocation = pbOriginalPoint;
				double dIsx = (double)imsx, dIsy = (double)imsy,
					orSx = (double)pbOriginalSize.Width, orSy = (double)pbOriginalSize.Height,
					nSx, nsY;

				nSx = orSx;
				nsY = orSy * (dIsy / dIsx);
				pbSize.Width = (int)nSx;
				pbSize.Height = (int)nsY;
				return;
			}
			else
			{
				double dIsx = (double)imsx, dIsy = (double)imsy,
					orSx = (double)pbOriginalSize.Width, orSy = (double)pbOriginalSize.Height,
					nSx, nSy;
				double orLx = (double)pbOriginalPoint.X, orLy = (double)pbOriginalPoint.Y,
					nLx, nLy;

				nSy = orSy;
				nSx = orSx * (dIsx / dIsy);
				pbSize.Width = (int)nSx;
				pbSize.Height = (int)nSy;
				nLy = orLy;
				nLx = orLx + (orSx - nSx) / 2;
				pbLocation.X = (int)nLx;
				pbLocation.Y = (int)nLy;
				return;
			}
		}
		// end ver 3.1.0.0

		System::Void FingerprintPictureBox_Paint(
			System::Object^  sender,
			System::Windows::Forms::PaintEventArgs^  e)
		{
            if (ReadyForPaint)
            {
                Bitmap ^bmp = (Bitmap ^)this->FingerprintPictureBox->Image;
                // Adjust picture box to frame size
                float XFactor = ((float)(this->FingerprintPictureBox->Width) / bmp->Width);
                float YFactor = ((float)(this->FingerprintPictureBox->Height) / bmp->Height);

				// ver 3.3.0.0
                if (
                    PalmPrintInterdigitalAreaBBL > 0 &&
                    PalmPrintInterdigitalAreaBBR > 0 &&
                    PalmPrintInterdigitalAreaBBT > 0 &&
                    PalmPrintInterdigitalAreaBBB > 0
                    )
                {
                    float SegBoundingBoxPosX = PalmPrintInterdigitalAreaBBL * XFactor;
                    float SegBoundingBoxPosY = PalmPrintInterdigitalAreaBBT * YFactor;
                    float SegBoundingBoxSizeX = (PalmPrintInterdigitalAreaBBR - PalmPrintInterdigitalAreaBBL) *
                        XFactor;
                    float SegBoundingBoxSizeY = (PalmPrintInterdigitalAreaBBB - PalmPrintInterdigitalAreaBBT) *
                        YFactor;

					Pen ^ClipPen = gcnew Pen(Color::Aquamarine, (float)3.0);
                    e->Graphics->DrawRectangle(
                        ClipPen,
                        SegBoundingBoxPosX,
                        SegBoundingBoxPosY,
                        SegBoundingBoxSizeX,
                        SegBoundingBoxSizeY
                    );
                }
				if (
					UpperPalmFingerPhalangesBBL > 0 &&
                    UpperPalmFingerPhalangesBBR > 0 &&
                    UpperPalmFingerPhalangesBBT > 0 &&
                    UpperPalmFingerPhalangesBBB > 0
                    )
                {
                    float SegBoundingBoxPosX = UpperPalmFingerPhalangesBBL * XFactor;
                    float SegBoundingBoxPosY = UpperPalmFingerPhalangesBBT * YFactor;
                    float SegBoundingBoxSizeX = (UpperPalmFingerPhalangesBBR - UpperPalmFingerPhalangesBBL) *
                        XFactor;
                    float SegBoundingBoxSizeY = (UpperPalmFingerPhalangesBBB - UpperPalmFingerPhalangesBBT) *
                        YFactor;

					Pen ^ClipPen = gcnew Pen(Color::Fuchsia, (float)3.0);
                    e->Graphics->DrawRectangle(
                        ClipPen,
                        SegBoundingBoxPosX,
                        SegBoundingBoxPosY,
                        SegBoundingBoxSizeX,
                        SegBoundingBoxSizeY
                    );
                }
                // end ver 3.3.0.0

                for (int i = 0; i < this->NumberOfSegmentsDetected; i++)
                {

                    float SegBoundingBoxPosX = BBL[i] * XFactor;
                    float SegBoundingBoxPosY = BBT[i] * YFactor;
                    float SegBoundingBoxSizeX = (BBR[i] - BBL[i]) *
                        XFactor;
                    float SegBoundingBoxSizeY = (BBB[i] - BBT[i]) *
                        YFactor;


                    Pen ^ClipPen = gcnew Pen(this->FingerColorForLegenda[i], (float)3.0);
                    e->Graphics->DrawRectangle(
                        ClipPen,
                        SegBoundingBoxPosX,
                        SegBoundingBoxPosY,
                        SegBoundingBoxSizeX,
                        SegBoundingBoxSizeY
                    );

					// ver 3.1.0.0
					if (this->cbGetJointFingerBoundingBox->Enabled && this->cbGetJointFingerBoundingBox->Checked)
					{
						float mSegBoundingBoxPosX = mBBL[i] * XFactor;
						float mSegBoundingBoxPosY = mBBT[i] * YFactor;
						float mSegBoundingBoxSizeX = (mBBR[i] - mBBL[i]) *
							XFactor;
						float mSegBoundingBoxSizeY = (mBBB[i] - mBBT[i]) *
							YFactor;

						if (mBBL[i] > 0 && mBBT[i] > 0 && mBBR[i] > 0 && mBBB[i] > 0)
						{
							e->Graphics->DrawRectangle(
								ClipPen,
								mSegBoundingBoxPosX,
								mSegBoundingBoxPosY,
								mSegBoundingBoxSizeX,
								mSegBoundingBoxSizeY
							);
						}

						float pSegBoundingBoxPosX = pBBL[i] * XFactor;
						float pSegBoundingBoxPosY = pBBT[i] * YFactor;
						float pSegBoundingBoxSizeX = (pBBR[i] - pBBL[i]) *
							XFactor;
						float pSegBoundingBoxSizeY = (pBBB[i] - pBBT[i]) *
							YFactor;

						if (pBBL[i] > 0 && pBBT[i] > 0 && pBBR[i] > 0 && pBBB[i] > 0)
						{
							e->Graphics->DrawRectangle(
								ClipPen,
								pSegBoundingBoxPosX,
								pSegBoundingBoxPosY,
								pSegBoundingBoxSizeX,
								pSegBoundingBoxSizeY
							);
						}
					}
					// ver 3.1.0.0
                }
            }
        }

		// ver 3.3.0.0
		System::Boolean ObjetcAllowsPalmPrintInterdigitalAreaBoundingBoxCalculation(UInt32 ObjId)
		{
			if (ObjId == GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM) return true;
			if (ObjId == GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM) return true;
			if (ObjId == GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM_UPPER) return true;
			if (ObjId == GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM_UPPER) return true;

			return false;
		}
		System::Boolean ObjetcAllowsUpperPalmFingerPhalangesBoundingBoxCalculation(UInt32 ObjId)
		{
			if (ObjId == GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM_UPPER) return true;
			if (ObjId == GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM_UPPER) return true;

			return false;
		}
		// end ver 3.3.0.0
		
		System::Void ProcessButton_Click(System::Object^  sender, System::EventArgs^  e)
		{
			// ver 3.3.0.0
			// init palmprintinterdigital bound box
			PalmPrintInterdigitalAreaBBL = -1;
			PalmPrintInterdigitalAreaBBR = -1;
			PalmPrintInterdigitalAreaBBT = -1;
			PalmPrintInterdigitalAreaBBB = -1;
			UpperPalmFingerPhalangesBBL = -1;
			UpperPalmFingerPhalangesBBR = -1;
			UpperPalmFingerPhalangesBBT = -1;
			UpperPalmFingerPhalangesBBB = -1;
			// end ver 3.3.0.0
            // Load image from bmp
            Bitmap ^bmp = (Bitmap ^)this->FingerprintPictureBox->Image;

            ReadyForPaint = false;
            this->FingerprintPictureBox->Image = bmp;
            this->Update();
			if (bmp->PixelFormat == System::Drawing::Imaging::PixelFormat::Format8bppIndexed)
            {
                // Lock the bitmap's bits->
				System::Drawing::Rectangle rect = System::Drawing::Rectangle(0, 0, bmp->Width, bmp->Height);
                System::Drawing::Imaging::BitmapData ^bmpData =
                    bmp->LockBits(rect, System::Drawing::Imaging::ImageLockMode::ReadWrite,
                    bmp->PixelFormat);

                // Get the address of the first line->
                IntPtr ptr = bmpData->Scan0;

                // Declare an array to hold the bytes of the bitmap->
                int bytes = bmpData->Stride * bmp->Height;
                byte *rgbValues = new byte[bytes];
				if (rgbValues == NULL)
				{
					MessageBox::Show("ProcessButton_Click: mem alloc error for rgbValues","ERROR");
					return;
				}

                // Copy the RGB values into the array->
				memcpy(rgbValues,ptr.ToPointer(),bytes);

                // Unlock the bits->
                bmp->UnlockBits(bmpData);

				unsigned int ui_segmnum = 0,ui_diagn = 0;
				byte *tempBuffer = new byte[GBFINIMG_MEMORY_BUFFER_SIZE];
				if (tempBuffer == NULL)
				{
					free(rgbValues);
					MessageBox::Show("ProcessButton_Click: mem alloc error for tempBuffer","ERROR");
					return;
				}

				GBFINIMG_SEGMENT_IMAGE_DESCRIPTOR SegmImageList[4];
				for (int i = 0; i < 4; i ++)
				{
					SegmImageList[i].SegmentImagePtr = new byte[bmp->Width * bmp->Height];
					if (SegmImageList[i].SegmentImagePtr == NULL)
					{
						free(rgbValues);
						free(tempBuffer);
						MessageBox::Show("ProcessButton_Click: mem alloc error for SegmentImagePtr","ERROR");
						return;
					}
				}

				// get information on missing fingers
                if (this->MissingFingersGroupBox->Enabled)
                {
                    Byte Mask = 0;
                    if (this->IndexCheckBox->Checked)
                    {
                        Mask |= ((Byte)(GBFINIMG_MISSING_FINGER_SLAP4_INDEX));
                    }
                    if (this->MiddleCheckBox->Checked)
                    {
                        Mask |= ((Byte)(GBFINIMG_MISSING_FINGER_SLAP4_MIDDLE));
                    }
                    if (this->RingCheckBox->Checked)
                    {
                        Mask |= ((Byte)(GBFINIMG_MISSING_FINGER_SLAP4_RING));
                    }
                    if (this->LittleCheckBox->Checked)
                    {
                        Mask |= ((Byte)(GBFINIMG_MISSING_FINGER_SLAP4_LITTLE));
                    }

                    if (Mask != 0)
                    {
                        GBFINIMG_Slap4_MissingFingers(Mask);
                    }
                }

				// get time
				DateTime startTime = DateTime::Now;

				int RetVal = GBFINIMG_ProcessImage(rgbValues,
					bmp->Width,bmp->Height,
					ObjToDetect,
					this->GetProcessOptions(),
					SegmImageList,
					bmp->Width,bmp->Height,
					&ui_segmnum,
					&ui_diagn,
					NULL,0,
					tempBuffer,GBFINIMG_MEMORY_BUFFER_SIZE);

				DateTime stopTime = DateTime::Now;
                TimeSpan duration = stopTime - startTime;

				

				free(rgbValues);
				free(tempBuffer);   
				this->UserMessagesListBox->Items->Clear();

                if (RetVal == GBFINIMG_NO_ERROR)
                {                    
					this->UserMessagesListBox->Items->Add("No Diagnostic: " +
						((ui_diagn == 0) ? "true" : "false"));
					this->UserMessagesListBox->Items->Add("Ambiguous Slap: " +
						((ui_diagn & GBFINIMG_SEGMENTATION_FAIL_AMBIGUOUS_SLAP)? "true" : "false"));
					this->UserMessagesListBox->Items->Add("Incomplete Slap: " +
						((ui_diagn & GBFINIMG_SEGMENTATION_FAIL_INCOMPLETE_SLAP) ? "true" : "false"));
					this->UserMessagesListBox->Items->Add("Left-Right mixup: " +
						((ui_diagn & GBFINIMG_SEGMENTATION_FAIL_LEFT_RIGHT_HAND_MIX) ? "true" : "false"));
					this->UserMessagesListBox->Items->Add("");
					this->UserMessagesListBox->Items->Add("Total duration (in ms): " + duration.TotalMilliseconds);
					this->UserMessagesListBox->Items->Add("");

					this->UserMessagesListBox->Items->Add("Fingerprint Counter: " + GBFINIMG_GetFingerprintCounter());
					this->UserMessagesListBox->Items->Add("");

					if (ui_segmnum != 0)
					{
						this->UserMessagesListBox->Items->Add("Detected segments number: " + ui_segmnum);
						this->UserMessagesListBox->Items->Add("");
						if (!(this->FastProcessCheckBox->Enabled && this->FastProcessCheckBox->Checked))
						{
							for (int i = 0; i < (int)ui_segmnum; i++)
							{
								unsigned int fingID = SegmImageList[i].Finger;
								unsigned int handID = SegmImageList[i].Hand;

								BBL[i] = SegmImageList[i].BoundingBoxL;
								BBR[i] = SegmImageList[i].BoundingBoxR;
								BBT[i] = SegmImageList[i].BoundingBoxT;
								BBB[i] = SegmImageList[i].BoundingBoxB;

								if (handID == GBFINIMG_HAND_LEFT)
								{
									if (fingID == GBFINIMG_FINGER_INDEX)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::IndexColor;
										this->UserMessagesListBox->Items->Add("LEFT_INDEX");
									}
									else if (fingID == GBFINIMG_FINGER_LITTLE)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::LittleColor;
										this->UserMessagesListBox->Items->Add("LEFT_LITTLE");
									}
									else if (fingID == GBFINIMG_FINGER_MIDDLE)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::MiddleColor;
										this->UserMessagesListBox->Items->Add("LEFT_MIDDLE");
									}
									else if (fingID == GBFINIMG_FINGER_RING)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::RingColor;
										this->UserMessagesListBox->Items->Add("LEFT_RING");
									}
									else if (fingID == GBFINIMG_FINGER_THUMB)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::ThumbColor;
										this->UserMessagesListBox->Items->Add("LEFT_THUMB");
									}
									else // undefined
									{
										this->FingerColorForLegenda[i] = Color::Gray;
										this->UserMessagesListBox->Items->Add("LEFT_UNDEFINED");
									}
								}
								else if (handID == GBFINIMG_HAND_RIGHT)
								{
									if (fingID == GBFINIMG_FINGER_INDEX)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::IndexColor;
										this->UserMessagesListBox->Items->Add("RIGHT_INDEX");
									}
									else if (fingID == GBFINIMG_FINGER_LITTLE)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::LittleColor;
										this->UserMessagesListBox->Items->Add("RIGHT_LITTLE");
									}
									else if (fingID == GBFINIMG_FINGER_MIDDLE)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::MiddleColor;
										this->UserMessagesListBox->Items->Add("RIGHT_MIDDLE");
									}
									else if (fingID == GBFINIMG_FINGER_RING)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::RingColor;
										this->UserMessagesListBox->Items->Add("RIGHT_RING");
									}
									else if (fingID == GBFINIMG_FINGER_THUMB)
									{
										this->FingerColorForLegenda[i] = ColorLegenda::ThumbColor;
										this->UserMessagesListBox->Items->Add("RIGHT_THUMB");
									}
									else // undefined
									{
										this->FingerColorForLegenda[i] = Color::Gray;
										this->UserMessagesListBox->Items->Add("RIGHT_UNDEFINED");
									}
								}
								else
								{
									this->FingerColorForLegenda[i] = Color::Gray;
									this->UserMessagesListBox->Items->Add("HAND_UNDEFINED");
								}


								this->UserMessagesListBox->Items->Add("Bounding Box: L " +
									BBL[i] +
									", R " + BBR[i] +
									", T " + BBT[i] +
									", B " + BBB[i]);
								this->UserMessagesListBox->Items->Add("Inclination " + SegmImageList[i].Inclination);
								this->UserMessagesListBox->Items->Add("PatternCompletness " + SegmImageList[i].PatternCompleteness);
								this->UserMessagesListBox->Items->Add("PatternValidity " + SegmImageList[i].PatternValidity);
								this->UserMessagesListBox->Items->Add("SegmQuality " + SegmImageList[i].Quality);
								this->UserMessagesListBox->Items->Add("Size " + SegmImageList[i].Size);
								this->UserMessagesListBox->Items->Add("");

								// ver 3.1.0.0
								if (this->cbGetJointFingerBoundingBox->Enabled && this->cbGetJointFingerBoundingBox->Checked)
								{
									int  MedialJoint_BoundingBoxL, MedialJoint_BoundingBoxR, MedialJoint_BoundingBoxT, MedialJoint_BoundingBoxB, 
										MedialJoint_Completeness,
										ProximalJoint_BoundingBoxL, ProximalJoint_BoundingBoxR, ProximalJoint_BoundingBoxT, ProximalJoint_BoundingBoxB,
										ProximalJoint_Completeness;
									RetVal = GBFINIMG_GetFullFingerMedialProximalJointBoundingBox(
										i,
										&MedialJoint_BoundingBoxL, &MedialJoint_BoundingBoxR,
										&MedialJoint_BoundingBoxT, &MedialJoint_BoundingBoxB, 
										&MedialJoint_Completeness, 
										&ProximalJoint_BoundingBoxL,&ProximalJoint_BoundingBoxR,
										&ProximalJoint_BoundingBoxT,&ProximalJoint_BoundingBoxB,
										&ProximalJoint_Completeness);
									if (RetVal == GBFINIMG_NO_ERROR)
									{
										mBBL[i] = MedialJoint_BoundingBoxL;
										mBBR[i] = MedialJoint_BoundingBoxR;
										mBBT[i] = MedialJoint_BoundingBoxT;
										mBBB[i] = MedialJoint_BoundingBoxB;
										pBBL[i] = ProximalJoint_BoundingBoxL;
										pBBR[i] = ProximalJoint_BoundingBoxR;
										pBBT[i] = ProximalJoint_BoundingBoxT;
										pBBB[i] = ProximalJoint_BoundingBoxB;
										this->UserMessagesListBox->Items->Add("medial Bounding Box: L " +
											mBBL[i] +
											", R " + mBBR[i] +
											", T " + mBBT[i] +
											", B " + mBBB[i]);
										this->UserMessagesListBox->Items->Add("proximal Bounding Box: L " +
											pBBL[i] +
											", R " + pBBR[i] +
											", T " + pBBT[i] +
											", B " + pBBB[i]);
										this->UserMessagesListBox->Items->Add("MedialJoint_Completeness " + MedialJoint_Completeness);
										this->UserMessagesListBox->Items->Add("ProximalJoint_Completeness " + ProximalJoint_Completeness);
									}
									else
									{
										this->UserMessagesListBox->Items->Add("GBFINIMG_GetFullFingerMedialProximalJointBoundingBox for index " 
											+ i + " returned " + RetVal);
									}
								}
								// end ver 3.1.0.0
							}

							// ver 3.3.0.0
							if (this->ObjetcAllowsPalmPrintInterdigitalAreaBoundingBoxCalculation(ObjToDetect))
							{
								int PPL, PPR, PPT, PPB;
								int PpIACompleteness = 0;
								int PpIAQuality = 0;
								GBFINIMG_GetPalmPrintInterdigitalAreaBoundingBox(
									&PPL, &PPR,
									&PPT, &PPB,
									&PpIACompleteness, &PpIAQuality);
								this->UserMessagesListBox->Items->Add("");
								this->UserMessagesListBox->Items->Add("PALM INTERDIGITAL AREA:");
								this->UserMessagesListBox->Items->Add("PpIACompleteness: " + PpIACompleteness);
								this->UserMessagesListBox->Items->Add("PpIAQuality: " + PpIAQuality);
								
								PalmPrintInterdigitalAreaBBL = PPL;
								PalmPrintInterdigitalAreaBBR = PPR;
								PalmPrintInterdigitalAreaBBT = PPT;
								PalmPrintInterdigitalAreaBBB = PPB;
							}
							if (this->ObjetcAllowsUpperPalmFingerPhalangesBoundingBoxCalculation(ObjToDetect))
							{
								int PPL, PPR, PPT, PPB;
								int UpFPCompleteness = 0;
								int UpFPQuality = 0;
								GBFINIMG_GetUpperPalmFingerPhalangesBoundingBox(
									&PPL, &PPR,
									&PPT, &PPB,
									&UpFPCompleteness, &UpFPQuality);
								this->UserMessagesListBox->Items->Add("");
								this->UserMessagesListBox->Items->Add("UPPER PALM FINGER PHALANGES:");
								this->UserMessagesListBox->Items->Add("UpFPCompleteness: " + UpFPCompleteness);
								this->UserMessagesListBox->Items->Add("UpFPQuality: " + UpFPQuality);
								
								UpperPalmFingerPhalangesBBL = PPL;
								UpperPalmFingerPhalangesBBR = PPR;
								UpperPalmFingerPhalangesBBT = PPT;
								UpperPalmFingerPhalangesBBB = PPB;
							}
							// ver 3.3.0.0
							ReadyForPaint = true;
							NumberOfSegmentsDetected = (int)ui_segmnum;
							this->FingerprintPictureBox->Image = bmp;
							this->Update();
						}

						// ver 3.1.0.0
						if (this->cbGetMissingDeltaNumber->Enabled && this->cbGetMissingDeltaNumber->Checked)
						{
							for (int i = 0; i < (int)ui_segmnum; i++)
							{
								unsigned int fingID = SegmImageList[i].Finger;
								unsigned int handID = SegmImageList[i].Hand;

								int MissingDeltaNumber;
								unsigned int MissingDeltaMask;
								RetVal = GBFINIMG_GetMissingDeltaNumber(i, &MissingDeltaNumber, &MissingDeltaMask);
								if (RetVal == GBFINIMG_NO_ERROR)
								{
									if (handID == GBFINIMG_HAND_LEFT)
									{
										if (fingID == GBFINIMG_FINGER_INDEX)
										{
											this->UserMessagesListBox->Items->Add("LEFT_INDEX");
										}
										else if (fingID == GBFINIMG_FINGER_LITTLE)
										{
											this->UserMessagesListBox->Items->Add("LEFT_LITTLE");
										}
										else if (fingID == GBFINIMG_FINGER_MIDDLE)
										{
											this->UserMessagesListBox->Items->Add("LEFT_MIDDLE");
										}
										else if (fingID == GBFINIMG_FINGER_RING)
										{
											this->UserMessagesListBox->Items->Add("LEFT_RING");
										}
										else if (fingID == GBFINIMG_FINGER_THUMB)
										{
											this->UserMessagesListBox->Items->Add("LEFT_THUMB");
										}
										else // undefined
										{
											this->UserMessagesListBox->Items->Add("LEFT_UNDEFINED");
										}
									}
									else if (handID == GBFINIMG_HAND_RIGHT)
									{
										if (fingID == GBFINIMG_FINGER_INDEX)
										{
											this->UserMessagesListBox->Items->Add("RIGHT_INDEX");
										}
										else if (fingID == GBFINIMG_FINGER_LITTLE)
										{
											this->UserMessagesListBox->Items->Add("RIGHT_LITTLE");
										}
										else if (fingID == GBFINIMG_FINGER_MIDDLE)
										{
											this->UserMessagesListBox->Items->Add("RIGHT_MIDDLE");
										}
										else if (fingID == GBFINIMG_FINGER_RING)
										{
											this->UserMessagesListBox->Items->Add("RIGHT_RING");
										}
										else if (fingID == GBFINIMG_FINGER_THUMB)
										{
											this->UserMessagesListBox->Items->Add("RIGHT_THUMB");
										}
										else // undefined
										{
											this->UserMessagesListBox->Items->Add("RIGHT_UNDEFINED");
										}
									}
									else
									{
										this->UserMessagesListBox->Items->Add("GBFINIMG_GetMissingDeltaNumber for index " + i +
											": HAND_UNDEFINED");
									}
									this->UserMessagesListBox->Items->Add(", MissingDeltaNumber = " + MissingDeltaNumber);
									if ((MissingDeltaMask & 0x01) != 0)
										this->UserMessagesListBox->Items->Add(", Left Delta");
									if ((MissingDeltaMask & 0x02) != 0)
										this->UserMessagesListBox->Items->Add(", Right Delta");
									if ((MissingDeltaMask & 0x04) != 0)
										this->UserMessagesListBox->Items->Add(", Unknown Delta");
								}
								else
								{
									this->UserMessagesListBox->Items->Add("GBFINIMG_GetMissingDeltaNumber for index " + i +
										" returned " + RetVal);
								}
							}

						}
						if (this->cbGetRolledFingerTopCornerPercent->Enabled && this->cbGetRolledFingerTopCornerPercent->Checked)
						{
							int LeftTopCornerFillingPercent, RightTopCornerFillingPercent;
							RetVal = GBFINIMG_GetRolledFingerprintTopCornerFillingPercent(
								&LeftTopCornerFillingPercent, &RightTopCornerFillingPercent);
							if (RetVal == GBFINIMG_NO_ERROR)
							{
								this->UserMessagesListBox->Items->Add("LeftTopCornerFillingPercent = " + LeftTopCornerFillingPercent);
								this->UserMessagesListBox->Items->Add("RightTopCornerFillingPercent = " + RightTopCornerFillingPercent);
									
							}
							else
							{
								this->UserMessagesListBox->Items->Add("GBFINIMG_GetRolledFingerprintTopCornerFillingPercent returned " + RetVal);
							}
						}
						// end ver 3.1.0.0
					}
					else
					{
						this->UserMessagesListBox->Items->Add("No segments detected (look carefully at diagnostics)");
					}

					if (this->Check180RotationCheckBox->Enabled && this->Check180RotationCheckBox->Checked)
					{
						int ProbabilityOf180DegRotation;
						byte PatternDiagnostic;
						GBFINIMG_CheckFingerRotation180Degree(&ProbabilityOf180DegRotation, &PatternDiagnostic);
						this->UserMessagesListBox->Items->Add("");
						this->UserMessagesListBox->Items->Add("");
						this->UserMessagesListBox->Items->Add("Probability Of 180 Degrees Rotation = " + ProbabilityOf180DegRotation);
						this->UserMessagesListBox->Items->Add("Pattern Diagnostic = " + PatternDiagnostic);
					}
                }
				else
				{
					this->UserMessagesListBox->Items->Add("GBFINIMG_ProcessImage returned error: " + RetVal);
				}
            }
        }
		System::Void IncompleteSlapDataGenerationCheckBox_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
		{
            if (this->IncompleteSlapDataGenerationCheckBox->Checked)
            {
                this->MissingFingersGroupBox->Enabled = false;
            }
            else
            {
                this->MissingFingersGroupBox->Enabled = ObjAllowsMissingFingersMasking;
            }
		}
		
		// ver 3.1.0.0
		System::Void cbDoNotCorrectAgeCreases_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
			if (this->cbDoNotCorrectAgeCreases->Checked)
			{
				this->RefineDryFingerCheckBox->Checked = true;
			}
		}
		// end ver 3.1.0.0
};
}

