﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

using GBFINIMG_NET_WRAPPER;
using GBFINIMG_Utilities;
using AN2K_NET_WRAPPER;

namespace GbFinImgExample_Cs
{
    public partial class Form1 : Form
    {
        bool SlowProcessOptionsEnabled;
        public uint ObjToDetect;

        public class ColorLegenda
        {
            public static Color IndexColor = Color.Green;
            public static Color MiddleColor = Color.Red;
            public static Color RingColor = Color.Blue;
            public static Color LittleColor = Color.Orange;
            public static Color ThumbColor = Color.Olive;
        }

        private int [] BBL; private int [] BBR;
        private int[] BBT; private int[] BBB;
		// Ver 3.1.0.0
		private int [] mBBL;
		private int [] mBBR;
		private int [] mBBT;
		private int [] mBBB;
		private int [] pBBL;
		private int [] pBBR;
		private int [] pBBT;
		private int [] pBBB;
        // end Ver 3.1.0.0
        // ver 3.3.0.0
        private int PalmPrintInterdigitalAreaBBL;
        private int PalmPrintInterdigitalAreaBBR;
        private int PalmPrintInterdigitalAreaBBT;
        private int PalmPrintInterdigitalAreaBBB;

        private int UpperPalmFingerPhalangesBBL;
        private int UpperPalmFingerPhalangesBBR;
        private int UpperPalmFingerPhalangesBBT;
        private int UpperPalmFingerPhalangesBBB;
        // end ver 3.3.0.0
        // ver 3.2.0.0
        private IntPtr ProcImgTempBuffer, ProcImgImgBuffer, ProcImgSeg1Buffer, ProcImgSeg2Buffer, ProcImgSeg3Buffer, ProcImgSeg4Buffer;
        // end ver 3.2.0.0
        private Color[] FingerColorForLegenda;
        private int NumberOfSegmentsDetected;
        private bool ReadyForPaint;
        private bool ObjAllows180DegRotationCheck;
        private bool ObjAllowsIncompleteSlapDetection;
        private bool ObjAllowsMissingFingersMasking;
        // Ver 3.1.0.0
        bool ObjAllowsJointFingerIsThumbOption;
        bool ObjAllowsMissingDeltaCalculation;
        bool ObjAllowsRolledFingerTopCornerPercentCalculation;
        bool ObjAllowsJointFingerBoundingBoxCalculation;
        // end Ver 3.1.0.0

        public class ObjectTypes
        {
            public const String Left_4_Str = "LEFT 4";
            public const String Left_2_Str = "LEFT 2";
            public const String Right_4_Str = "RIGHT 4";
            public const String Right_2_Str = "RIGHT 2";
            public const String Thmb_2_Str = "THUMBS 2";
            public const String Single_Str = "SINGLE";
            public const String FlatSingle_Str = "FLAT SINGLE";
			// Ver 3.1.0.0
			public const String Left_LowerPalm_Str = "LEFT L-PALM";
			public const String Right_LowerPalm_Str = "RIGHT L-PALM";
			public const String Left_WriterPalm_Str = "LEFT W-PALM";
			public const String Right_WriterPalm_Str = "RIGHT W-PALM";
			public const String Left_Thenar_Str = "LEFT THENAR";
			public const String Right_Thenar_Str = "RIGHT THENAR";
			public const String Joint_FV1_Str = "JOINT FV1";
			public const String Joint_FV2_Str = "JOINT FV2";
			public const String Joint_FV3_Str = "JOINT FV3";
			public const String Joint_FV4_Str = "JOINT FV4";
			public const String Rolled_Tip_Str = "ROLLED TIP";
			// end Ver 3.1.0.0
            // Ver 3.3.0.0
            public const String Left_UpperPalm_Str = "LEFT U-PALM";
            public const String Right_UpperPalm_Str = "RIGHT U-PALM";
            // end Ver 3.3.0.0
        }

        public Form1()
        {
            InitializeComponent();
            this.Text = "GBFinimgExample C#";
            SlowProcessOptionsEnabled = true;

            NumberOfSegmentsDetected = 0;

            ObjAllows180DegRotationCheck = false;
            ObjAllowsIncompleteSlapDetection = false;
            ObjAllowsMissingFingersMasking = false;
            // ver 3.1.0.0
            ObjAllowsJointFingerIsThumbOption = false;
            ObjAllowsMissingDeltaCalculation = false;
            ObjAllowsRolledFingerTopCornerPercentCalculation = false;
            ObjAllowsJointFingerBoundingBoxCalculation = false;
            // end ver 3.1.0.0

            ObjTypesCombo.Items.Clear();
            ObjTypesCombo.Items.Add(ObjectTypes.Left_2_Str);
            ObjTypesCombo.Items.Add(ObjectTypes.Left_4_Str);
            ObjTypesCombo.Items.Add(ObjectTypes.Right_2_Str);
            ObjTypesCombo.Items.Add(ObjectTypes.Right_4_Str);
            ObjTypesCombo.Items.Add(ObjectTypes.Thmb_2_Str);
            ObjTypesCombo.Items.Add(ObjectTypes.Single_Str);
            ObjTypesCombo.Items.Add(ObjectTypes.FlatSingle_Str);
			// Ver 3.1.0.0
			ObjTypesCombo.Items.Add(ObjectTypes.Left_LowerPalm_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Right_LowerPalm_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Left_WriterPalm_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Right_WriterPalm_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Left_Thenar_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Right_Thenar_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Joint_FV1_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Joint_FV2_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Joint_FV3_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Joint_FV4_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Rolled_Tip_Str);
            // Ver 3.3.0.0
			ObjTypesCombo.Items.Add(ObjectTypes.Left_UpperPalm_Str);
			ObjTypesCombo.Items.Add(ObjectTypes.Right_UpperPalm_Str);
            // end Ver 3.3.0.0
			// end Ver 3.1.0.0
            // ver 3.2.0.0
            ProcImgTempBuffer = Marshal.AllocHGlobal((int)GBTempBuffConstants.GBFINIMG_MEMORY_BUFFER_SIZE);
            if (ProcImgTempBuffer == IntPtr.Zero)
            {
                MessageBox.Show("Form1: Memory allocation failure for ProcImgTempBuffer");
                this.Close();
                return;
            }
            ProcImgImgBuffer = Marshal.AllocHGlobal(GBFINIMG_Globals.MAX_INPUT_SIZE_X_500 * GBFINIMG_Globals.MAX_INPUT_SIZE_X_500);
            if (ProcImgImgBuffer == IntPtr.Zero)
            {
                MessageBox.Show("Form1: Memory allocation failure for ProcImgImgBuffer");
                this.Close();
                return;
            }
            ProcImgSeg1Buffer = Marshal.AllocHGlobal(GBFINIMG_Globals.MAX_INPUT_SIZE_X_500 * GBFINIMG_Globals.MAX_INPUT_SIZE_X_500);
            if (ProcImgSeg1Buffer == IntPtr.Zero)
            {
                MessageBox.Show("Form1: Memory allocation failure for ProcImgSeg1Buffer");
                this.Close();
                return;
            }
            ProcImgSeg2Buffer = Marshal.AllocHGlobal(GBFINIMG_Globals.MAX_INPUT_SIZE_X_500 * GBFINIMG_Globals.MAX_INPUT_SIZE_X_500);
            if (ProcImgSeg2Buffer == IntPtr.Zero)
            {
                MessageBox.Show("Form1: Memory allocation failure for ProcImgSeg2Buffer");
                this.Close();
                return;
            }
            ProcImgSeg3Buffer = Marshal.AllocHGlobal(GBFINIMG_Globals.MAX_INPUT_SIZE_X_500 * GBFINIMG_Globals.MAX_INPUT_SIZE_X_500);
            if (ProcImgSeg3Buffer == IntPtr.Zero)
            {
                MessageBox.Show("Form1: Memory allocation failure for ProcImgSeg3Buffer");
                this.Close();
                return;
            }
            ProcImgSeg4Buffer = Marshal.AllocHGlobal(GBFINIMG_Globals.MAX_INPUT_SIZE_X_500 * GBFINIMG_Globals.MAX_INPUT_SIZE_X_500);
            if (ProcImgSeg4Buffer == IntPtr.Zero)
            {
                MessageBox.Show("Form1: Memory allocation failure for ProcImgSeg4Buffer");
                this.Close();
                return;
            }
            
            // end ver 3.2.0.0

            ObjTypesCombo.SelectedIndex = 0;

            this.IndexCheckBox.BackColor = ColorLegenda.IndexColor;
            this.MiddleCheckBox.BackColor = ColorLegenda.MiddleColor;
            this.RingCheckBox.BackColor = ColorLegenda.RingColor;
            this.LittleCheckBox.BackColor = ColorLegenda.LittleColor;

            this.ImageProcessGroupBox.Enabled = false;
            this.ProcessButton.Enabled = false;
            ObjTypesCombo.Enabled = false;
            ReadyForPaint = false;

            BBL = new int[4];
            BBR = new int[4];
            BBT = new int[4];
            BBB = new int[4];

			// ver 3.1.0.0
            mBBL = new int[4];
            mBBR = new int[4];
            mBBT = new int[4];
            mBBB = new int[4];
            pBBL = new int[4];
            pBBR = new int[4];
            pBBT = new int[4];
            pBBB = new int[4];
			// end ver 3.1.0.0

            FingerColorForLegenda = new Color[4];
        }

        private void EnableSlowProcessOptions(bool Enable)
        {
            this.RotationCheckBox.Enabled = Enable;
            this.HaloCheckBox.Enabled = Enable;
            this.PalmQualCheckBox.Enabled = Enable;
            this.DeleteFingersCheckBox.Enabled = Enable;
            this.FastProcessWithSegmentCheckBox.Enabled = Enable;
            // ver 3.1.0.0
            this.cbGetJointFingerBoundingBox.Enabled = ObjAllowsJointFingerBoundingBoxCalculation;
            // end ver 3.1.0.0
            if (Enable)
            {
                if (this.FastProcessWithSegmentCheckBox.Checked)
                {
                    this.Check180RotationCheckBox.Enabled = false;
                    this.IncompleteSlapDataGenerationCheckBox.Enabled = false;
                }
                else
                {
                    this.Check180RotationCheckBox.Enabled = ObjAllows180DegRotationCheck;
                    this.IncompleteSlapDataGenerationCheckBox.Enabled = ObjAllowsIncompleteSlapDetection;
                }
            }
            else
            {
                this.Check180RotationCheckBox.Enabled = false;
                this.IncompleteSlapDataGenerationCheckBox.Enabled = false;
            }
            SlowProcessOptionsEnabled = Enable;
        }

        private void FastProcessCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (FastProcessCheckBox.Checked)
            {
                this.EnableSlowProcessOptions(false);
            }
            else
            {
                this.EnableSlowProcessOptions(true);
            }
        }

        private void FastProcessWithSegmentCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (this.FastProcessWithSegmentCheckBox.Checked)
            {
                this.Check180RotationCheckBox.Enabled = false;
                // ver 3.1.0.0
                this.cbGetJointFingerBoundingBox.Enabled = false;
                // end ver 3.1.0.0
            }
            else
            {
                this.Check180RotationCheckBox.Enabled = ObjAllows180DegRotationCheck;
                // ver 3.1.0.0
                this.cbGetJointFingerBoundingBox.Enabled = ObjAllowsJointFingerBoundingBoxCalculation;
                // end ver 3.1.0.0
            }
        }

		// ver 3.1.0.0
		void CalculatePaintBoxSizeAndLocation(
			uint imsx, uint imsy,
				System.Drawing.Size pbOriginalSize, System.Drawing.Point pbOriginalPoint,
				out System.Drawing.Size pbSize, out System.Drawing.Point pbLocation)
		{
            pbLocation = new Point();
            pbSize = new Size();
			if (imsx == imsy)
			{
				pbLocation = pbOriginalPoint;
				pbSize = pbOriginalSize;
				return;
			}
			if (imsx > imsy)
			{
				pbLocation = pbOriginalPoint;
				double dIsx = (double)imsx, dIsy = (double)imsy,
					orSx = (double)pbOriginalSize.Width, orSy = (double)pbOriginalSize.Height,
					nSx, nsY;

				nSx = orSx;
				nsY = orSy * (dIsy / dIsx);
				pbSize.Width = (int)nSx;
				pbSize.Height = (int)nsY;
				return;
			}
			else
			{
				double dIsx = (double)imsx, dIsy = (double)imsy,
					orSx = (double)pbOriginalSize.Width, orSy = (double)pbOriginalSize.Height,
					nSx, nSy;
				double orLx = (double)pbOriginalPoint.X, orLy = (double)pbOriginalPoint.Y,
					nLx, nLy;

				nSy = orSy;
				nSx = orSx * (dIsx / dIsy);
				pbSize.Width = (int)nSx;
				pbSize.Height = (int)nSy;
				nLy = orLy;
				nLx = orLx + (orSx - nSx) / 2;
				pbLocation.X = (int)nLx;
				pbLocation.Y = (int)nLy;
				return;
			}
		}
		// end ver 3.1.0.0

        uint GetProcessOptions()
        {
            uint RetVal = 0;
            if (SlowProcessOptionsEnabled)
            {
                if (this.RotationCheckBox.Enabled && this.RotationCheckBox.Checked)
                {
                    RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_SEGMENT_VERTICAL_ROTATION;
                }
                if (this.HaloCheckBox.Enabled && this.HaloCheckBox.Checked)
                {
                    RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_HALO_LATENT_ELIMINATION;
                }
                if (this.PalmQualCheckBox.Enabled && this.PalmQualCheckBox.Checked)
                {
                    RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_PALM_PRINT_IMAGE_QUALITY_CALCULATION;
                }
                if (this.DeleteFingersCheckBox.Enabled && this.DeleteFingersCheckBox.Checked)
                {
                    RetVal |=
                        NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_PALM_PRINT_IMAGE_DELETE_FINGER_SEGMENTS;
                }
                if (this.FastProcessWithSegmentCheckBox.Checked)
                {
                    RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_FAST_PROCESSING_PRELIMINARY_SEGMENT_DATA;
                }
                if (this.IncompleteSlapDataGenerationCheckBox.Enabled && this.IncompleteSlapDataGenerationCheckBox.Checked)
                {
                    RetVal |=
                        NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_ALLOW_INCOMPLETE_SLAP_SEGMENTS_DATA_GENERATION;
                    // NW_GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK must be used 
                    RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK;
                }
            }
            else
            {
                if (this.FastProcessCheckBox.Enabled && this.FastProcessCheckBox.Checked)
                {
                    RetVal |=
                        NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_FAST_PROCESSING_SEGMENT_NUMBER_ONLY;
                }
            }
            if (this.ImageRes1000DpiCheckBox.Checked)
            {
                RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_1000DPI_PRINT_IMAGE_PROCESSING;
            }
            if (this.LeftRightCheckBox.Checked)
            {
                RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK;
            }
			if (this.RefineDryFingerCheckBox.Enabled && this.RefineDryFingerCheckBox.Checked)
			{
				RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_REFINE_DRY_FINGERPRINT_IMAGE;
			}
			if (this.RefineFpContrastCleanBgCheckBox.Enabled && this.RefineFpContrastCleanBgCheckBox.Checked)
			{
				RetVal |= 
					NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_REFINE_FINGERPRINT_CONTRAST_AND_CLEAN_BACKGROUND;
            }
            // ver 3.1.0.0
            if (this.cbDoNotCorrectAgeCreases.Enabled && this.cbDoNotCorrectAgeCreases.Checked)
            {
                RetVal |=
                    NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_REFINE_DRY_FINGERPRINT_IMAGE_AGE_CREASES_UNTOUCHED;
            }
            if (this.cbPaperInkPrint.Enabled && this.cbPaperInkPrint.Checked)
            {
                RetVal |=
                    NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_PAPER_CARD_INK_PRINT;
            }
            if (this.cbJointFingerIsThumb.Enabled && this.cbJointFingerIsThumb.Checked)
            {
                RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_JOINT_FINGER_IS_THUMB;
            }
            // end ver 3.1.0.0
            // ver 3.3.0.0
            if (this.cbSegmentAsBB.Checked)
            {
                RetVal |= NW_GBFINIMG_SEGMENTATION_OPTIONS.NW_GBFINIMG_SEGMENT_IMAGE_AS_BOUNDING_BOX;
            }
            // end ver 3.3.0.0
            return RetVal;
        }

        void EliminateStrideDistorsion(byte[] ImgBuffer,
            int bmpW, int bmpS, out int newWidth)
        {
            newWidth = (bmpW / 4) * 4;
            if (bmpW > bmpS)
                return;

            int IndexS = 0, IndexW = 0;
            while ((IndexS + bmpS) < ImgBuffer.Length)
            {
                Array.Copy(ImgBuffer, IndexS, ImgBuffer, IndexW, newWidth);
                IndexS += bmpS;
                IndexW += newWidth;
            }
        }

        private void LoadImageButton_Click(object sender, EventArgs e)
        {
            OpenFileDialog FD = new OpenFileDialog();

            FD.ShowDialog();

            String fn = FD.FileName;
            if (fn != null && fn != "")
            {
                Bitmap x = new Bitmap(fn);

                if ((x != null)  && (x.PixelFormat == System.Drawing.Imaging.PixelFormat.Format8bppIndexed))
                {
                    Rectangle rect = new Rectangle(0, 0, x.Width, x.Height);
                    System.Drawing.Imaging.BitmapData bmpData =
                        x.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadWrite,
                        x.PixelFormat);

                    this.UserMessagesListBox.Items.Add("bitmap width: " + x.Width +
                        "bitmap stride: " + bmpData.Stride);

                    if (bmpData.Stride != x.Width)
                    {
                        IntPtr ptr = bmpData.Scan0;

                        int bytes = bmpData.Stride * x.Height;
                        byte[] rgbValues = new byte[bytes];

                        // Copy the RGB values into the array.
                        Marshal.Copy(ptr, rgbValues, 0, bytes);

                        int newW = 0;

                        EliminateStrideDistorsion(rgbValues, x.Width, bmpData.Stride, out newW);

                        Marshal.Copy(rgbValues, 0, ptr, x.Height * newW);

                        // Unlock the bits.
                        x.UnlockBits(bmpData);

                        x = new Bitmap(newW, x.Height, newW, System.Drawing.Imaging.PixelFormat.Format8bppIndexed, ptr);
                    }
                    else
                    {
                        // Unlock the bits.
                        x.UnlockBits(bmpData);
                    }             
                    System.Drawing.Imaging.ColorPalette pal = x.Palette;
                    for (int i = 0; i < pal.Entries.Length; i++)
                    {
                        pal.Entries[i] = Color.FromArgb(255, i, i, i);
                    }
                    x.Palette = pal;

                    this.UserMessagesListBox.Items.Add("bitmap width: " + x.Width);

					// ver 3.1.0.0
					// calculate dimensions of paint box
					System.Drawing.Size WinPaintBoxOriginalSize = new System.Drawing.Size(400, 400);
					Point WinPaintBoxOriginalLocation = new Point(12, 34);

					System.Drawing.Size WinPaintBoxNewSize;
					Point WinPaintBoxNewLocation;
					this.CalculatePaintBoxSizeAndLocation((uint)x.Width, (uint)x.Height, WinPaintBoxOriginalSize,
						WinPaintBoxOriginalLocation, out WinPaintBoxNewSize, out WinPaintBoxNewLocation);
					this.FingerprintPictureBox.Location = WinPaintBoxNewLocation;
					this.FingerprintPictureBox.Size = WinPaintBoxNewSize;
					// end ver 3.1.0.0

                    this.FingerprintPictureBox.Image = x;
                    this.FingerprintPictureBox.SizeMode = PictureBoxSizeMode.StretchImage;

                    this.ImageProcessGroupBox.Enabled = true;

                    this.Text = FD.SafeFileName;

                    ReadyForPaint = false;
                    this.ProcessButton.Enabled = true;
                    ObjTypesCombo.Enabled = true;
                }
            }
        }

        // ver 3.1.0.0
        void EnableOptionsCheckBox()
        {
            this.cbGetJointFingerBoundingBox.Enabled = ObjAllowsJointFingerBoundingBoxCalculation;
            this.cbGetMissingDeltaNumber.Enabled = ObjAllowsMissingDeltaCalculation;
            this.cbGetRolledFingerTopCornerPercent.Enabled = ObjAllowsRolledFingerTopCornerPercentCalculation;
            this.cbJointFingerIsThumb.Enabled = ObjAllowsJointFingerIsThumbOption;
            // ver 3.3.0.0
            this.IncompleteSlapDataGenerationCheckBox.Enabled = ObjAllowsIncompleteSlapDetection;
            // end ver 3.3.0.0
        }
        // end ver 3.1.0.0

        // ver 3.2.0.0
        public static Byte[] CutImage(
            Byte[] FramePtr,
            int OrigSizeX, int OrigSizeY,
            int ClPosX, int ClPosY,
            int ClSizeX, int ClSizeY
        )
        {
            Byte[] ClippedFrame = new byte[ClSizeX * ClSizeY];
            int ClippedFrameIndex = 0;
            int minx = ClPosX, maxx = ClPosX + ClSizeX - 1;
            int miny = ClPosY, maxy = ClPosY + ClSizeY - 1;

            for (int y = miny; y <= maxy; y++)
            {
                if (y < OrigSizeY)
                {
                    for (int x = minx; x <= maxx; x++)
                    {
                        if (x < OrigSizeX)
                        {
                            ClippedFrame[ClippedFrameIndex++] = FramePtr[y * OrigSizeX + x];
                        }
                        else x = maxx + 1;
                    }
                }
                else y = maxy + 1;
            }

            return ClippedFrame;
        }
        // end ver 3.2.0.0

        // ver 3.3.0.0
        private bool ObjetcAllowsPalmPrintInterdigitalAreaBoundingBoxCalculation(UInt32 ObjId)
        {
            if (ObjId == NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM) return true;
            if (ObjId == NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM) return true;
            if (ObjId == NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM_UPPER) return true;
            if (ObjId == NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM_UPPER) return true;

            return false;
        }
        private bool ObjetcAllowsUpperPalmFingerPhalangesBoundingBoxCalculation(UInt32 ObjId)
        {
            if (ObjId == NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM_UPPER) return true;
            if (ObjId == NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM_UPPER) return true;

            return false;
        }
        // end ver 3.3.0.0

        private void ProcessButton_Click(object sender, EventArgs e)
        {
            // ver 3.3.0.0
            // init palmprintinterdigital bound box
            PalmPrintInterdigitalAreaBBL = -1;
            PalmPrintInterdigitalAreaBBR = -1;
            PalmPrintInterdigitalAreaBBT = -1;
            PalmPrintInterdigitalAreaBBB = -1;
            UpperPalmFingerPhalangesBBL = -1;
            UpperPalmFingerPhalangesBBR = -1;
            UpperPalmFingerPhalangesBBT = -1;
            UpperPalmFingerPhalangesBBB = -1;
            // end ver 3.3.0.0
            // Load image from bmp
            Bitmap bmp = (Bitmap)this.FingerprintPictureBox.Image;

            this.UserMessagesListBox.Items.Clear();

            ReadyForPaint = false;
            this.FingerprintPictureBox.Image = bmp;
            this.Update();
            if (bmp.PixelFormat == System.Drawing.Imaging.PixelFormat.Format8bppIndexed)
            {
                this.UserMessagesListBox.Items.Add("After bmp.PixelFormat");
                // Lock the bitmap's bits.
                Rectangle rect = new Rectangle(0, 0, bmp.Width, bmp.Height);
                System.Drawing.Imaging.BitmapData bmpData =
                    bmp.LockBits(rect, System.Drawing.Imaging.ImageLockMode.ReadWrite,
                    bmp.PixelFormat);

                // Get the address of the first line.
                IntPtr ptr = bmpData.Scan0;

                // Declare an array to hold the bytes of the bitmap.
                int bytes = bmpData.Stride * bmp.Height;
                byte[] rgbValues = new byte[bytes];

                // Copy the RGB values into the array.
                System.Runtime.InteropServices.Marshal.Copy(ptr, rgbValues, 0, bytes);

                // Unlock the bits.
                bmp.UnlockBits(bmpData);

                NW_GBFINIMG_InputData ID = new NW_GBFINIMG_InputData(
                    rgbValues, (uint)(bmp.Width), (uint)(bmp.Height),
                    ObjToDetect,
                    null, this.GetProcessOptions(), (uint)bmp.Width, (uint)bmp.Height);

                this.UserMessagesListBox.Items.Add("After NW_GBFINIMG_InputData");
                

                if (ID != null)
                {
                    try
                    {
                        NW_GBFINIMG_ProcessImage PI = new NW_GBFINIMG_ProcessImage(ID);

                        this.UserMessagesListBox.Items.Add("After new NW_GBFINIMG_ProcessImage");

                        // get information on missing fingers
                        if (this.MissingFingersGroupBox.Enabled)
                        {
                            Byte Mask = 0;
                            if (this.IndexCheckBox.Checked)
                            {
                                Mask |= ((Byte)(NW_GBFINIMG_MISSING_FINGER_SLAP4.NW_GBFINIMG_MISSING_FINGER_SLAP4_INDEX));
                            }
                            if (this.MiddleCheckBox.Checked)
                            {
                                Mask |= ((Byte)(NW_GBFINIMG_MISSING_FINGER_SLAP4.NW_GBFINIMG_MISSING_FINGER_SLAP4_MIDDLE));
                            }
                            if (this.RingCheckBox.Checked)
                            {
                                Mask |= ((Byte)(NW_GBFINIMG_MISSING_FINGER_SLAP4.NW_GBFINIMG_MISSING_FINGER_SLAP4_RING));
                            }
                            if (this.LittleCheckBox.Checked)
                            {
                                Mask |= ((Byte)(NW_GBFINIMG_MISSING_FINGER_SLAP4.NW_GBFINIMG_MISSING_FINGER_SLAP4_LITTLE));
                            }

                            if (Mask != 0)
                            {
                                PI.NW_GBFINIMG_Slap4_MissingFingers(Mask);
                            }
                        }

                        NW_GBFINIMG_OutputData OD = null;

                        // get time
                        DateTime startTime = DateTime.Now;
                        // ver 3.2.0.0
                        NW_GBFINIMG_ProcessImage.NW_GBFINIMG_SetProcessImageTemporaryBuffer(this.ProcImgTempBuffer);
                        NW_GBFINIMG_ProcessImage.NW_GBFINIMG_SetProcessImageBufferForImage(this.ProcImgImgBuffer);
                        NW_GBFINIMG_ProcessImage.NW_GBFINIMG_SetProcessImageBufferForSegmentsBuffers(this.ProcImgSeg1Buffer,this.ProcImgSeg2Buffer,
                            this.ProcImgSeg3Buffer, this.ProcImgSeg4Buffer);
                        // end ver 3.2.0.0
                        if (this.FastProcessCheckBox.Enabled && this.FastProcessCheckBox.Checked)
                        {
                            OD = PI.OutputAfterFastProcess;
                        }
                        else
                        {
                            OD = PI.OutputAfterProcess;
                        }

                        this.UserMessagesListBox.Items.Add("After OutputAfterProcess");

                        DateTime stopTime = DateTime.Now;
                        TimeSpan duration = stopTime - startTime;
                        this.UserMessagesListBox.Items.Add("No Diagnostic: " +
                            ((OD.Diag.NW_GBFINIMG_NET_WRAPPER_NO_DIAG) ? "true" : "false").ToString());
                        this.UserMessagesListBox.Items.Add("Ambiguous Slap: " +
                            ((OD.Diag.NW_GBFINIMG_SEGMENTATION_FAIL_AMBIGUOUS_SLAP) ? "true" : "false").ToString());
                        this.UserMessagesListBox.Items.Add("Incomplete Slap: " +
                            ((OD.Diag.NW_GBFINIMG_SEGMENTATION_FAIL_INCOMPLETE_SLAP) ? "true" : "false").ToString());
                        this.UserMessagesListBox.Items.Add("Left-Right mixup: " +
                            ((OD.Diag.NW_GBFINIMG_SEGMENTATION_FAIL_LEFT_RIGHT_HAND_MIX) ? "true" : "false").ToString());
                        this.UserMessagesListBox.Items.Add("");
                        this.UserMessagesListBox.Items.Add("Total duration (in ms): " + duration.TotalMilliseconds);
                        this.UserMessagesListBox.Items.Add("");

                        this.UserMessagesListBox.Items.Add("Fingerprint Counter: " + PI.NW_GBFINIMG_GetFingerprintCounter());
                        this.UserMessagesListBox.Items.Add("");

                        if (OD.Segment_List != null)
                        {
                            this.UserMessagesListBox.Items.Add("Detected segments number: " + OD.Segment_List.Count);
                            this.UserMessagesListBox.Items.Add("");
                            if (!(this.FastProcessCheckBox.Enabled && this.FastProcessCheckBox.Checked))
                            {
                                for (int i = 0; i < OD.Segment_List.Count; i++)
                                {
                                    String fingID = OD.Segment_List[i].FingerID;

                                    BBL[i] = OD.Segment_List[i].SegBoundingBoxL;
                                    BBR[i] = OD.Segment_List[i].SegBoundingBoxR;
                                    BBT[i] = OD.Segment_List[i].SegBoundingBoxT;
                                    BBB[i] = OD.Segment_List[i].SegBoundingBoxB;
                                    if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_INDEX)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.IndexColor;
                                        this.UserMessagesListBox.Items.Add("LEFT_INDEX");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_LITTLE)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.LittleColor;
                                        this.UserMessagesListBox.Items.Add("LEFT_LITTLE");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_MIDDLE)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.MiddleColor;
                                        this.UserMessagesListBox.Items.Add("LEFT_MIDDLE");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_RING)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.RingColor;
                                        this.UserMessagesListBox.Items.Add("LEFT_RING");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_THUMB)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.ThumbColor;
                                        this.UserMessagesListBox.Items.Add("LEFT_THUMB");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_INDEX)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.IndexColor;
                                        this.UserMessagesListBox.Items.Add("RIGHT_INDEX");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_LITTLE)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.LittleColor;
                                        this.UserMessagesListBox.Items.Add("RIGHT_LITTLE");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_MIDDLE)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.MiddleColor;
                                        this.UserMessagesListBox.Items.Add("RIGHT_MIDDLE");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_RING)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.RingColor;
                                        this.UserMessagesListBox.Items.Add("RIGHT_RING");
                                    }
                                    else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_THUMB)
                                    {
                                        this.FingerColorForLegenda[i] = ColorLegenda.ThumbColor;
                                        this.UserMessagesListBox.Items.Add("RIGHT_THUMB");
                                    }
                                    else
                                    {
                                        this.FingerColorForLegenda[i] = Color.Gray;
                                    }


                                    this.UserMessagesListBox.Items.Add("Bounding Box: L " +
                                        BBL[i] +
                                        ", R " + BBR[i] +
                                        ", T " + BBT[i] +
                                        ", B " + BBB[i]);
                                    this.UserMessagesListBox.Items.Add("Inclination " + OD.Segment_List[i].Inclination);
                                    this.UserMessagesListBox.Items.Add("PatternCompletness " + OD.Segment_List[i].PatternCompletness);
                                    this.UserMessagesListBox.Items.Add("PatternValidity " + OD.Segment_List[i].PatternValidity);
                                    this.UserMessagesListBox.Items.Add("SegmQuality " + OD.Segment_List[i].SegQuality);
                                    this.UserMessagesListBox.Items.Add("Size " + OD.Segment_List[i].Size);
                                    

                                    // ver 3.1.0.0
                                    if (this.cbGetJointFingerBoundingBox.Enabled && this.cbGetJointFingerBoundingBox.Checked)
                                    {
                                        int MedialJoint_BoundingBoxL, MedialJoint_BoundingBoxR, MedialJoint_BoundingBoxT, MedialJoint_BoundingBoxB,
                                            MedialJoint_Completeness,
                                            ProximalJoint_BoundingBoxL, ProximalJoint_BoundingBoxR,
                                            ProximalJoint_BoundingBoxT, ProximalJoint_BoundingBoxB,
                                            ProximalJoint_Completeness;
                                        int RetVal = NW_GBFINIMG_ProcessImage.GBFINIMG_GetFullFingerMedialProximalJointBoundingBox (
                                            i,
                                            out MedialJoint_BoundingBoxL, out MedialJoint_BoundingBoxR,
                                            out MedialJoint_BoundingBoxT, out MedialJoint_BoundingBoxB,
                                            out MedialJoint_Completeness,
                                            out ProximalJoint_BoundingBoxL, out ProximalJoint_BoundingBoxR,
                                            out ProximalJoint_BoundingBoxT, out ProximalJoint_BoundingBoxB,
                                            out ProximalJoint_Completeness);
                                        if (RetVal == NW_GBFINIMG_ErrorCodes.NW_GBFINIMG_NO_ERROR)
                                        {
                                            mBBL[i] = MedialJoint_BoundingBoxL;
                                            mBBR[i] = MedialJoint_BoundingBoxR;
                                            mBBT[i] = MedialJoint_BoundingBoxT;
                                            mBBB[i] = MedialJoint_BoundingBoxB;
                                            pBBL[i] = ProximalJoint_BoundingBoxL;
                                            pBBR[i] = ProximalJoint_BoundingBoxR;
                                            pBBT[i] = ProximalJoint_BoundingBoxT;
                                            pBBB[i] = ProximalJoint_BoundingBoxB;
                                            this.UserMessagesListBox.Items.Add("medial Bounding Box: L " +
                                                mBBL[i] +
                                                ", R " + mBBR[i] +
                                                ", T " + mBBT[i] +
                                                ", B " + mBBB[i]);
                                            this.UserMessagesListBox.Items.Add("proximal Bounding Box: L " +
                                                pBBL[i] +
                                                ", R " + pBBR[i] +
                                                ", T " + pBBT[i] +
                                                ", B " + pBBB[i]);
                                            this.UserMessagesListBox.Items.Add("MedialJoint_Completeness " + MedialJoint_Completeness);
                                            this.UserMessagesListBox.Items.Add("ProximalJoint_Completeness " + ProximalJoint_Completeness);
                                        }
                                        else
                                        {
                                            this.UserMessagesListBox.Items.Add("GBFINIMG_GetFullFingerMedialProximalJointBoundingBox for index "
                                                + i + " returned " + RetVal);
                                        }
                                    }
                                    // end ver 3.1.0.0
                                }

                                // ver 3.3.0.0
                                if (this.ObjetcAllowsPalmPrintInterdigitalAreaBoundingBoxCalculation(ObjToDetect))
                                {
                                    int PpIACompleteness = 0;
                                    int PpIAQuality = 0;
                                    NW_GBFINIMG_ProcessImage.GBFINIMG_GetPalmPrintInterdigitalAreaBoundingBox(
                                        out PalmPrintInterdigitalAreaBBL, out PalmPrintInterdigitalAreaBBR,
                                        out PalmPrintInterdigitalAreaBBT, out PalmPrintInterdigitalAreaBBB,
                                        out PpIACompleteness, out PpIAQuality);
                                    this.UserMessagesListBox.Items.Add("");
                                    this.UserMessagesListBox.Items.Add("PALM INTERDIGITAL AREA:");
                                    this.UserMessagesListBox.Items.Add("PpIACompleteness: " + PpIACompleteness);
                                    this.UserMessagesListBox.Items.Add("PpIAQuality: " + PpIAQuality);
                                }
                                if (this.ObjetcAllowsUpperPalmFingerPhalangesBoundingBoxCalculation(ObjToDetect))
                                {
                                    int UpFPCompleteness = 0;
                                    int UpFPQuality = 0;
                                    NW_GBFINIMG_ProcessImage.GBFINIMG_GetUpperPalmFingerPhalangesBoundingBox(
                                        out UpperPalmFingerPhalangesBBL, out UpperPalmFingerPhalangesBBR,
                                        out UpperPalmFingerPhalangesBBT, out UpperPalmFingerPhalangesBBB,
                                        out UpFPCompleteness, out UpFPQuality);
                                    this.UserMessagesListBox.Items.Add("");
                                    this.UserMessagesListBox.Items.Add("UPPER PALM FINGER PHALANGES:");
                                    this.UserMessagesListBox.Items.Add("UpFPCompleteness: " + UpFPCompleteness);
                                    this.UserMessagesListBox.Items.Add("UpFPQuality: " + UpFPQuality);
                                }
                                // ver 3.3.0.0
                                ReadyForPaint = true;
                                NumberOfSegmentsDetected = (int)OD.Segment_List.Count;
                                this.FingerprintPictureBox.Image = bmp;
                                this.Update();
                            }

                            // ver 3.1.0.0
                            if (this.cbGetMissingDeltaNumber.Enabled && this.cbGetMissingDeltaNumber.Checked)
                            {
                                for (int i = 0; i < (int)OD.Segment_List.Count; i++)
                                {
                                    String fingID = OD.Segment_List[i].FingerID;

                                    int MissingDeltaNumber;
                                    uint MissingDeltaMask;
                                    int RetVal = NW_GBFINIMG_ProcessImage.NW_GBFINIMG_GetMissingDeltaNumber(
                                        i, out MissingDeltaNumber, out MissingDeltaMask);
                                    if (RetVal == NW_GBFINIMG_ErrorCodes.NW_GBFINIMG_NO_ERROR)
                                    {
                                        if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_INDEX)
                                        {
                                            this.UserMessagesListBox.Items.Add("LEFT_INDEX");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_LITTLE)
                                        {
                                            this.UserMessagesListBox.Items.Add("LEFT_LITTLE");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_MIDDLE)
                                        {
                                            this.UserMessagesListBox.Items.Add("LEFT_MIDDLE");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_RING)
                                        {
                                            this.UserMessagesListBox.Items.Add("LEFT_RING");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_LEFT_THUMB)
                                        {
                                            this.UserMessagesListBox.Items.Add("LEFT_THUMB");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_INDEX)
                                        {
                                            this.UserMessagesListBox.Items.Add("RIGHT_INDEX");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_LITTLE)
                                        {
                                            this.UserMessagesListBox.Items.Add("RIGHT_LITTLE");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_MIDDLE)
                                        {
                                            this.UserMessagesListBox.Items.Add("RIGHT_MIDDLE");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_RING)
                                        {
                                            this.UserMessagesListBox.Items.Add("RIGHT_RING");
                                        }
                                        else if (fingID == AN2K_NET_WRAPPER.NW_AN2K_FINGER_POSITIONS.NW_ETFS_14_FGP_RIGHT_THUMB)
                                        {
                                            this.UserMessagesListBox.Items.Add("RIGHT_THUMB");
                                        }
                                        else
                                        {
                                            this.UserMessagesListBox.Items.Add("GBFINIMG_GetMissingDeltaNumber for index " + i +
                                                ": HAND_UNDEFINED");
                                        }

                                        this.UserMessagesListBox.Items.Add(", MissingDeltaNumber = " + MissingDeltaNumber);
                                        if ((MissingDeltaMask & 0x01) != 0)
                                            this.UserMessagesListBox.Items.Add(", Left Delta");
                                        if ((MissingDeltaMask & 0x02) != 0)
                                            this.UserMessagesListBox.Items.Add(", Right Delta");
                                        if ((MissingDeltaMask & 0x04) != 0)
                                            this.UserMessagesListBox.Items.Add(", Unknown Delta");
                                    }
                                    else
                                    {
                                        this.UserMessagesListBox.Items.Add("GBFINIMG_GetMissingDeltaNumber for index " + i +
                                            " returned " + RetVal);
                                    }
                                }

                            }
                            if (this.cbGetRolledFingerTopCornerPercent.Enabled && this.cbGetRolledFingerTopCornerPercent.Checked)
                            {
                                int LeftTopCornerFillingPercent, RightTopCornerFillingPercent;
                                int RetVal = NW_GBFINIMG_ProcessImage.GBFINIMG_GetRolledFingerprintTopCornerFillingPercent(
                                    out LeftTopCornerFillingPercent, out RightTopCornerFillingPercent);
                                if (RetVal == NW_GBFINIMG_ErrorCodes.NW_GBFINIMG_NO_ERROR)
                                {
                                    this.UserMessagesListBox.Items.Add("LeftTopCornerFillingPercent = " + LeftTopCornerFillingPercent);
                                    this.UserMessagesListBox.Items.Add("RightTopCornerFillingPercent = " + RightTopCornerFillingPercent);

                                }
                                else
                                {
                                    this.UserMessagesListBox.Items.Add("GBFINIMG_GetRolledFingerprintTopCornerFillingPercent returned " + RetVal);
                                }
                            }
						    // end ver 3.1.0.0
                        }
                        else
                        {
                            if (this.FastProcessCheckBox.Enabled && this.FastProcessCheckBox.Checked)
                            {
                                this.UserMessagesListBox.Items.Add("Detected segments number: " + OD.Segment_Number);
                            }
                            this.UserMessagesListBox.Items.Add("No segments detected (look carefully at diagnostics)");
                        }

                        if (this.Check180RotationCheckBox.Enabled && this.Check180RotationCheckBox.Checked)
                        {
                            int ProbabilityOf180DegRotation;
                            byte PatternDiagnostic;
                            PI.NW_GBFINIMG_CheckFingerRotation180Degree(out ProbabilityOf180DegRotation, out PatternDiagnostic);
                            this.UserMessagesListBox.Items.Add("");
                            this.UserMessagesListBox.Items.Add("");
                            this.UserMessagesListBox.Items.Add("Probability Of 180 Degrees Rotation = " + ProbabilityOf180DegRotation);
                            this.UserMessagesListBox.Items.Add("Pattern Diagnostic = " + PatternDiagnostic);
                        }
                    }
                    catch (Exception ex)
                    {
                        this.UserMessagesListBox.Items.Add("ProcessButton_Click exception: " + ex.Message );
                    }
                }
            }
        }

        private void ObjTypesCombo_SelectedIndexChanged(object sender, EventArgs e)
        {
            String SelIt = (String)(ObjTypesCombo.SelectedItem);
            ObjAllows180DegRotationCheck = false;
            ObjAllowsMissingFingersMasking = false;
            ObjAllowsIncompleteSlapDetection = false;
            // ver 3.1.0.0
            ObjAllowsJointFingerIsThumbOption = false;
            ObjAllowsMissingDeltaCalculation = false;
            ObjAllowsRolledFingerTopCornerPercentCalculation = false;
            ObjAllowsJointFingerBoundingBoxCalculation = false;
            // end ver 3.1.0.0

            switch (SelIt)
            {
                case (ObjectTypes.Left_2_Str):
                    {
                        // ver 3.1.0.0
                        ObjAllowsMissingDeltaCalculation = true;
                        // end ver 3.1.0.0
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjAllowsMissingFingersMasking = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_2;
                        ObjAllows180DegRotationCheck = true;
                        ObjAllowsIncompleteSlapDetection = false;
                        break;
                    }
                case (ObjectTypes.Left_4_Str):
                    {
                        // ver 3.1.0.0
                        ObjAllowsMissingDeltaCalculation = true;
                        // end ver 3.1.0.0
                        this.MissingFingersGroupBox.Enabled = true;
                        ObjAllowsMissingFingersMasking = true;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_4;
                        ObjAllowsIncompleteSlapDetection = true;
                        break;
                    }
                case (ObjectTypes.Right_2_Str):
                    {
                        // ver 3.1.0.0
                        ObjAllowsMissingDeltaCalculation = true;
                        // end ver 3.1.0.0
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjAllowsMissingFingersMasking = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_2;
                        ObjAllows180DegRotationCheck = true;
                        ObjAllowsIncompleteSlapDetection = false;
                        break;
                    }
                case (ObjectTypes.Right_4_Str):
                    {
                        // ver 3.1.0.0
                        ObjAllowsMissingDeltaCalculation = true;
                        // end ver 3.1.0.0
                        this.MissingFingersGroupBox.Enabled = true;
                        ObjAllowsMissingFingersMasking = true;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_4;
                        ObjAllowsIncompleteSlapDetection = true;
                        break;
                    }
                case (ObjectTypes.Single_Str):
                    {
                        // ver 3.1.0.0
                        ObjAllowsMissingDeltaCalculation = true;
                        // end ver 3.1.0.0
                        // ver 3.1.0.0
                        ObjAllowsRolledFingerTopCornerPercentCalculation = true;
                        // end ver 3.1.0.0
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjAllowsMissingFingersMasking = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_SINGLE_FINGER;
                        ObjAllows180DegRotationCheck = true;
                        ObjAllowsIncompleteSlapDetection = false;
                        break;
                    }
                case (ObjectTypes.Thmb_2_Str):
                    {
                        // ver 3.1.0.0
                        ObjAllowsMissingDeltaCalculation = true;
                        // end ver 3.1.0.0
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjAllowsMissingFingersMasking = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_THUMBS_2;
                        ObjAllows180DegRotationCheck = true;
                        ObjAllowsIncompleteSlapDetection = true;
                        break;
                    }
                case (ObjectTypes.FlatSingle_Str):
                    {
                        // ver 3.1.0.0
                        ObjAllowsMissingDeltaCalculation = true;
                        // end ver 3.1.0.0
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjAllowsMissingFingersMasking = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_SINGLE_FINGER_FLAT;
                        ObjAllows180DegRotationCheck = true;
                        ObjAllowsIncompleteSlapDetection = false;
                        break;
                    }
                // Ver 3.3.0.0
                case (ObjectTypes.Left_UpperPalm_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = true;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM_UPPER;
                        break;
                    }
                case (ObjectTypes.Right_UpperPalm_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = true;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM_UPPER;
                        break;
                    }
                // end Ver 3.3.0.0
                // ver 3.1.0.0
                case (ObjectTypes.Left_LowerPalm_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM;
                        break;
                    }
                case (ObjectTypes.Right_LowerPalm_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM;
                        break;
                    }
                case (ObjectTypes.Left_WriterPalm_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_WRITER_PALM;
                        break;
                    }
                case (ObjectTypes.Right_WriterPalm_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_WRITER_PALM;
                        break;
                    }
                case (ObjectTypes.Left_Thenar_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_ROLLED_THENAR;
                        break;
                    }
                case (ObjectTypes.Right_Thenar_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_ROLLED_THENAR;
                        break;
                    }
                case (ObjectTypes.Joint_FV1_Str):
                    {
                        ObjAllowsJointFingerBoundingBoxCalculation = true;
                        ObjAllowsRolledFingerTopCornerPercentCalculation = true;
                        ObjAllowsJointFingerIsThumbOption = true;
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_ROLLED_JOINT_FINGER_FV1;
                        break;
                    }
                case (ObjectTypes.Joint_FV2_Str):
                    {
                        ObjAllowsJointFingerBoundingBoxCalculation = true;
                        ObjAllowsJointFingerIsThumbOption = true;
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_FLAT_JOINT_FINGER_FV2;
                        break;
                    }
                case (ObjectTypes.Joint_FV3_Str):
                    {
                        ObjAllowsJointFingerBoundingBoxCalculation = true;
                        ObjAllowsJointFingerIsThumbOption = true;
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_FLAT_JOINT_FINGER_FV3;
                        break;
                    }
                case (ObjectTypes.Joint_FV4_Str):
                    {
                        ObjAllowsJointFingerBoundingBoxCalculation = true;
                        ObjAllowsJointFingerIsThumbOption = true;
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_FLAT_JOINT_FINGER_FV4;
                        break;
                    }
                case (ObjectTypes.Rolled_Tip_Str):
                    {
                        this.MissingFingersGroupBox.Enabled = false;
                        ObjToDetect = NW_GBFINIMG_IMAGE_TYPES.NW_GBFINIMG_INPUT_IMAGE_TYPE_ROLLED_TIP;
                        break;
                    }
            }
            EnableOptionsCheckBox();
            // end ver 3.1.0.0
            this.FastProcessWithSegmentCheckBox_CheckedChanged(null, null);
        }

        private void FingerprintPictureBox_Paint(object sender, PaintEventArgs e)
        {
            if (ReadyForPaint)
            {
                Bitmap bmp = (Bitmap)this.FingerprintPictureBox.Image;
                // Adjust picture box to frame size
                float XFactor = ((float)(this.FingerprintPictureBox.Width) / bmp.Width);
                float YFactor = ((float)(this.FingerprintPictureBox.Height) / bmp.Height);

                // ver 3.3.0.0
                if (
                    PalmPrintInterdigitalAreaBBL > 0 &&
                    PalmPrintInterdigitalAreaBBR > 0 &&
                    PalmPrintInterdigitalAreaBBT > 0 &&
                    PalmPrintInterdigitalAreaBBB > 0
                    )
                {
                    float SegBoundingBoxPosX = PalmPrintInterdigitalAreaBBL * XFactor;
                    float SegBoundingBoxPosY = PalmPrintInterdigitalAreaBBT * YFactor;
                    float SegBoundingBoxSizeX = (PalmPrintInterdigitalAreaBBR - PalmPrintInterdigitalAreaBBL) *
                        XFactor;
                    float SegBoundingBoxSizeY = (PalmPrintInterdigitalAreaBBB - PalmPrintInterdigitalAreaBBT) *
                        YFactor;

                    System.Drawing.Pen ClipPen = new Pen(Color.Aquamarine, (float)3.0);
                    e.Graphics.DrawRectangle(
                        ClipPen,
                        SegBoundingBoxPosX,
                        SegBoundingBoxPosY,
                        SegBoundingBoxSizeX,
                        SegBoundingBoxSizeY
                    );
                }
				if (
					UpperPalmFingerPhalangesBBL > 0 &&
                    UpperPalmFingerPhalangesBBR > 0 &&
                    UpperPalmFingerPhalangesBBT > 0 &&
                    UpperPalmFingerPhalangesBBB > 0
                    )
                {
                    float SegBoundingBoxPosX = UpperPalmFingerPhalangesBBL * XFactor;
                    float SegBoundingBoxPosY = UpperPalmFingerPhalangesBBT * YFactor;
                    float SegBoundingBoxSizeX = (UpperPalmFingerPhalangesBBR - UpperPalmFingerPhalangesBBL) *
                        XFactor;
                    float SegBoundingBoxSizeY = (UpperPalmFingerPhalangesBBB - UpperPalmFingerPhalangesBBT) *
                        YFactor;

                    System.Drawing.Pen ClipPen = new Pen(Color.Fuchsia, (float)3.0);
                    e.Graphics.DrawRectangle(
                        ClipPen,
                        SegBoundingBoxPosX,
                        SegBoundingBoxPosY,
                        SegBoundingBoxSizeX,
                        SegBoundingBoxSizeY
                    );
                }
                // end ver 3.3.0.0

                for (int i = 0; i < this.NumberOfSegmentsDetected; i++)
                {

                    float SegBoundingBoxPosX = BBL[i] * XFactor;
                    float SegBoundingBoxPosY = BBT[i] * YFactor;
                    float SegBoundingBoxSizeX = (BBR[i] - BBL[i]) *
                        XFactor;
                    float SegBoundingBoxSizeY = (BBB[i] - BBT[i]) *
                        YFactor;


                    System.Drawing.Pen ClipPen = new Pen(this.FingerColorForLegenda[i], (float)3.0);
                    e.Graphics.DrawRectangle(
                        ClipPen,
                        SegBoundingBoxPosX,
                        SegBoundingBoxPosY,
                        SegBoundingBoxSizeX,
                        SegBoundingBoxSizeY
                    );

                    // ver 3.1.0.0
                    if (this.cbGetJointFingerBoundingBox.Enabled && this.cbGetJointFingerBoundingBox.Checked)
                    {
                        float mSegBoundingBoxPosX = mBBL[i] * XFactor;
                        float mSegBoundingBoxPosY = mBBT[i] * YFactor;
                        float mSegBoundingBoxSizeX = (mBBR[i] - mBBL[i]) *
                            XFactor;
                        float mSegBoundingBoxSizeY = (mBBB[i] - mBBT[i]) *
                            YFactor;

                        if (mBBL[i] > 0 && mBBT[i] > 0 && mBBR[i] > 0 && mBBB[i] > 0)
                        {
                            e.Graphics.DrawRectangle(
                                ClipPen,
                                mSegBoundingBoxPosX,
                                mSegBoundingBoxPosY,
                                mSegBoundingBoxSizeX,
                                mSegBoundingBoxSizeY
                            );
                        }

                        float pSegBoundingBoxPosX = pBBL[i] * XFactor;
                        float pSegBoundingBoxPosY = pBBT[i] * YFactor;
                        float pSegBoundingBoxSizeX = (pBBR[i] - pBBL[i]) *
                            XFactor;
                        float pSegBoundingBoxSizeY = (pBBB[i] - pBBT[i]) *
                            YFactor;

                        if (pBBL[i] > 0 && pBBT[i] > 0 && pBBR[i] > 0 && pBBB[i] > 0)
                        {
                            e.Graphics.DrawRectangle(
                                ClipPen,
                                pSegBoundingBoxPosX,
                                pSegBoundingBoxPosY,
                                pSegBoundingBoxSizeX,
                                pSegBoundingBoxSizeY
                            );
                        }
                    }
                    // ver 3.1.0.0
                }
            }
        }

        private void IncompleteSlapDataGenerationCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (this.IncompleteSlapDataGenerationCheckBox.Checked)
            {
                this.MissingFingersGroupBox.Enabled = false;
            }
            else
            {
                this.MissingFingersGroupBox.Enabled = ObjAllowsMissingFingersMasking;
            }
        }

        // ver 3.1.0.0
        private void cbDoNotCorrectAgeCreases_CheckedChanged(object sender, EventArgs e)
        {
            if (this.cbDoNotCorrectAgeCreases.Checked)
            {
                this.RefineDryFingerCheckBox.Checked = true;
            }
        }
        // end ver 3.1.0.0
    }
}
