#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:
    void on_btnOpenImage_clicked();

    void on_btnOpenFIR_clicked();

private:
    Ui::MainWindow *ui;
    QString LastSelectedDir;

    void DisplayGBFIRError(int ErrorCode, QString FunctionName);
	void LogMessage(QString Message);
	void ClearLog();
	QString FingerPositionToString(int FingerPosition);
	QString ImpressionTypeToString(int ImpressionType);
	QString ImageCompressionAlgorithmToString(int ImageCompressionAlgorithm);
};

#endif // MAINWINDOW_H
