#include "configuration.h"
#include "ui_configuration.h"
#include "GBMSAPI_Library.h"
#include "GBMSGUI_Qt.h"

Configuration::Configuration(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Configuration)
{
    ui->setupUi(this);

    ui->tblObjectSettings->setRowCount(32);
    ui->tblObjectSettings->setColumnWidth(0, 150);

    int i=0;

    SetObjectHeader(GBMSAPI_SO_SLAP_4_LEFT, "SLAP 4 LEFT", i++);
    SetObjectHeader(GBMSAPI_SO_SLAP_4_RIGHT, "SLAP 4 RIGHT", i++);
    SetObjectHeader(GBMSAPI_SO_SLAP_2_THUMBS, "SLAP 2 THUMBS", i++);
    SetObjectHeader(GBMSAPI_SO_SLAP_2_LEFT, "SLAP 2 LEFT", i++);
    SetObjectHeader(GBMSAPI_SO_SLAP_2_RIGHT, "SLAP 2 RIGHT", i++);
    SetObjectHeader(GBMSAPI_SO_SLAP_2_INDEXES, "SLAP 2 INDEXES", i++);

    SetObjectHeader(GBMSAPI_SO_ROLL_LEFT_THUMB, "ROLL LEFT THUMB", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_LEFT_INDEX, "ROLL LEFT INDEX", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_LEFT_MIDDLE, "ROLL LEFT MIDDLE", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_LEFT_RING, "ROLL LEFT RING", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_LEFT_LITTLE, "ROLL LEFT LITTLE", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_RIGHT_THUMB, "ROLL RIGHT THUMB", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_RIGHT_INDEX, "ROLL RIGHT INDEX", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_RIGHT_MIDDLE, "ROLL RIGHT MIDDLE", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_RIGHT_RING, "ROLL RIGHT RING", i++);
    SetObjectHeader(GBMSAPI_SO_ROLL_RIGHT_LITTLE, "ROLL RIGHT LITTLE", i++);

    SetObjectHeader(GBMSAPI_SO_FLAT_LEFT_THUMB, "FLAT LEFT THUMB", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_LEFT_INDEX, "FLAT LEFT INDEX", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_LEFT_MIDDLE, "FLAT LEFT MIDDLE", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_LEFT_RING, "FLAT LEFT RING", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_LEFT_LITTLE, "FLAT LEFT LITTLE", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_RIGHT_THUMB, "FLAT RIGHT THUMB", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_RIGHT_INDEX, "FLAT RIGHT INDEX", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_RIGHT_MIDDLE, "FLAT RIGHT MIDDLE", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_RIGHT_RING, "FLAT RIGHT RING", i++);
    SetObjectHeader(GBMSAPI_SO_FLAT_RIGHT_LITTLE, "FLAT RIGHT LITTLE", i++);

    SetObjectHeader(GBMSAPI_SO_UPPER_HALF_PALM_LEFT, "UPPER HALF PALM LEFT", i++);
    SetObjectHeader(GBMSAPI_SO_UPPER_HALF_PALM_RIGHT, "UPPER HALF PALM RIGHT", i++);
    SetObjectHeader(GBMSAPI_SO_LOWER_HALF_PALM_LEFT, "LOWER HALF PALM LEFT", i++);
    SetObjectHeader(GBMSAPI_SO_LOWER_HALF_PALM_RIGHT, "LOWER HALF PALM RIGHT", i++);
    SetObjectHeader(GBMSAPI_SO_WRITER_PALM_LEFT, "WRITER PALM LEFT", i++);
    SetObjectHeader(GBMSAPI_SO_WRITER_PALM_RIGHT, "WRITER PALM RIGHT", i++);
}

Configuration::~Configuration()
{
    delete ui;
}

void Configuration::SetObjectHeader(int ObjectID, QString ObjectName, int Index)
{
    QTableWidgetItem *newItem = new QTableWidgetItem(ObjectName);
    newItem->setData(Qt::UserRole, ObjectID);
    // title is readonly
    newItem->setFlags(Qt::ItemIsSelectable|Qt::ItemIsEnabled);
    ui->tblObjectSettings->setItem(Index, 0, newItem);
}
