/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Test_Gbfinimg_MainWin.java
 *
 * Created on 19-gen-2012, 17.15.45
 */
package Test_GBFINIMG_Gui;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import java.io.File;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import java.awt.image.Raster;
import java.awt.image.DataBuffer;
import javax.swing.JOptionPane;
import javax.swing.DefaultListModel;
import javax.swing.DefaultComboBoxModel;

import Test_GBFINIMG_Utils.ImageFilter;
import Test_GBFINIMG_Utils.Utils;

import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.Memory;

import GBJPEG_JAVA_Functions.GBJPEG_DllWrapper.GBJPEG_Library;
import GBJPEG_JAVA_Defines.GBJPEG_BitsPerPixel;
import GBJPEG_JAVA_Defines.GBJPEG_ReturnCodes;

import GBNFIQ_JAVA_Defines.GBNFIQ_ReturnCodes;
import GBNFIQ_JAVA_Functions.GBNFIQ_DllWrapper.GBNfiq_Library;

import GBFINIMG_JAVA_Defines.GBFINIMG_InputImageTypes;
import GBFINIMG_JAVA_Defines.GBFINIMG_ProcessingOptions;
import GBFINIMG_JAVA_Defines.GBFINIMG_SegmentImageDescriptor;
import GBFINIMG_JAVA_Defines.GBFINIMG_MissingFingerDefinitions;
import GBFINIMG_JAVA_Defines.GBFINIMG_MemoryBufferSize;
import GBFINIMG_JAVA_Defines.GBFINIMG_ReturnCodes;
import GBFINIMG_JAVA_Functions.GBFINIMG_DllWrapper.GBFinImg_Library;

import Test_GBFINIMG_Utils.TestGbFinImg_Globals;

/**
 *
 * @author andrea
 */
public class Test_Gbfinimg_MainWin extends javax.swing.JFrame {

    private DefaultListModel LogModel;
    private DefaultComboBoxModel ObjTypeListModel;
    
    private boolean ObjAllowsIncompleteSlapDataGeneration;

    private void LogMessage(String messageToShow) {
        LogModel.addElement(messageToShow);
    }

    private boolean PrintRetValForJpeg(int RetVal, String FunctionName) {
        LogMessage("" + FunctionName + " returned: " + RetVal);
        if (RetVal != GBJPEG_ReturnCodes.GBJPEG_OK) {
            return false;
        }
        return true;
    }

    private boolean PrintRetValForNfiq(int RetVal, String FunctionName) {
        LogMessage("" + FunctionName + " returned: " + RetVal);
        if (RetVal != GBNFIQ_ReturnCodes.GBNFIQ_NO_ERROR) {
            return false;
        }
        return true;
    }

    private boolean PrintRetValForGbFinImg(int RetVal, String FunctionName) {
        LogMessage("" + FunctionName + " returned: " + RetVal);
        if (RetVal != GBFINIMG_ReturnCodes.GBFINIMG_NO_ERROR) {
            return false;
        }
        return true;
    }

    public void ShowException(String Function, String exMessage) {
        String MessageToShow = "Exception in function " + Function + ": " + exMessage;
        JOptionPane.showMessageDialog(this, MessageToShow);
        LogMessage(MessageToShow);
    }

    public void EnableMissingMask(boolean enable) {
        this.jCBIndexIsMissing.setEnabled(enable);
        this.jCBLittleIsMissing.setEnabled(enable);
        this.jCBMiddleIsMissing.setEnabled(enable);
        this.jCBRingIsMissing.setEnabled(enable);
    }

    public void EnableProcessOptions(boolean enable) {
        this.jCB1000DPIImage.setEnabled(enable);
        this.jCBCalcPalmQual.setEnabled(enable);
        this.jCBElimFingFromPalm.setEnabled(enable);
        this.jCBFastProcessSegmentsNumOnly.setEnabled(enable);
        this.jCBFastProcessSegmentsData.setEnabled(enable);
        this.jCBHaloLatent.setEnabled(enable);
        this.jCBSegmVertRotation.setEnabled(enable);
        this.jCBLeftRightMix.setEnabled(enable);
        if (enable)
        {
            this.jCBIncompleteSlapDataGeneration.setEnabled(ObjAllowsIncompleteSlapDataGeneration);
        }
        else
        {
            this.jCBIncompleteSlapDataGeneration.setEnabled(false);
        }
    }

    public void InitSegmStrings() {
        this.jLSegm1.setText("Segm 1: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");
        this.jLSegm2.setText("Segm 2: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");
        this.jLSegm3.setText("Segm 3: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");
        this.jLSegm4.setText("Segm 4: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");
    }

    private void InitProcessControls() {
        this.jBLoadImage.setEnabled(true);
        this.jBProcess.setEnabled(false);

        this.jComboBoxObjectsType.setEnabled(false);

        EnableMissingMask(false);
        ObjAllowsIncompleteSlapDataGeneration = false;

        EnableProcessOptions(false);

        this.jLImageSize.setText("Image Size: NA");
        this.jLNistQuality.setText("NIST Quality: NA");

        this.jLDiagnostic.setText("DIAGNOSTIC: NA");
        this.jLSegmentsNumber.setText("Segments Number: 0");

        this.ObjTypeListModel = new DefaultComboBoxModel();
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_NoObj);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_LeftSlap4);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_RightSlap4);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_Thumbs2);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_LeftSlap2);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_RightSlap2);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_RollSingle);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_FlatSingle);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_LeftLowerHalf);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_RightLowerHalf);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_LeftWriter);
        this.ObjTypeListModel.addElement(TestGbFinImg_Globals.ObjType_RightWriter);

        this.jComboBoxObjectsType.setModel(ObjTypeListModel);

        InitSegmStrings();
    }

    /** Creates new form Test_Gbfinimg_MainWin */
    public Test_Gbfinimg_MainWin() {
        initComponents();

        this.jLLog.removeAll();
        this.LogModel = new DefaultListModel();
        this.jLLog.setModel(LogModel);

        this.InitProcessControls();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanInput = new javax.swing.JPanel();
        jBLoadImage = new javax.swing.JButton();
        jLImageSize = new javax.swing.JLabel();
        jLNistQuality = new javax.swing.JLabel();
        jPanOutput = new javax.swing.JPanel();
        jLSegmentsNumber = new javax.swing.JLabel();
        jLSegm1 = new javax.swing.JLabel();
        jLDiagnostic = new javax.swing.JLabel();
        jLSegm2 = new javax.swing.JLabel();
        jLSegm3 = new javax.swing.JLabel();
        jLSegm4 = new javax.swing.JLabel();
        jPanSettings = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jCBIndexIsMissing = new javax.swing.JCheckBox();
        jCBMiddleIsMissing = new javax.swing.JCheckBox();
        jCBRingIsMissing = new javax.swing.JCheckBox();
        jCBLittleIsMissing = new javax.swing.JCheckBox();
        jPanel5 = new javax.swing.JPanel();
        jCBHaloLatent = new javax.swing.JCheckBox();
        jCBSegmVertRotation = new javax.swing.JCheckBox();
        jCBElimFingFromPalm = new javax.swing.JCheckBox();
        jCBCalcPalmQual = new javax.swing.JCheckBox();
        jCB1000DPIImage = new javax.swing.JCheckBox();
        jCBFastProcessSegmentsNumOnly = new javax.swing.JCheckBox();
        jCBLeftRightMix = new javax.swing.JCheckBox();
        jCBFastProcessSegmentsData = new javax.swing.JCheckBox();
        jCBIncompleteSlapDataGeneration = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jComboBoxObjectsType = new javax.swing.JComboBox();
        jBProcess = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jLLog = new javax.swing.JList();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanInput.setBorder(javax.swing.BorderFactory.createTitledBorder("Input Load"));

        jBLoadImage.setText("Load Image");
        jBLoadImage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBLoadImageActionPerformed(evt);
            }
        });

        jLImageSize.setText("Image Size: X, Y");

        jLNistQuality.setText("NIST Quality: Q");

        javax.swing.GroupLayout jPanInputLayout = new javax.swing.GroupLayout(jPanInput);
        jPanInput.setLayout(jPanInputLayout);
        jPanInputLayout.setHorizontalGroup(
            jPanInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanInputLayout.createSequentialGroup()
                .addGroup(jPanInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLImageSize)
                    .addComponent(jBLoadImage)
                    .addComponent(jLNistQuality))
                .addContainerGap(33, Short.MAX_VALUE))
        );
        jPanInputLayout.setVerticalGroup(
            jPanInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanInputLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jBLoadImage)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLImageSize)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 38, Short.MAX_VALUE)
                .addComponent(jLNistQuality)
                .addContainerGap())
        );

        jPanOutput.setBorder(javax.swing.BorderFactory.createTitledBorder("Output Panel"));

        jLSegmentsNumber.setText("Segments Number: X");

        jLSegm1.setText("Segm 1: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");

        jLDiagnostic.setText("Diagnostic: XXXXXXXXXXXXXXX");

        jLSegm2.setText("Segm 2: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");

        jLSegm3.setText("Segm 3: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");

        jLSegm4.setText("Segm 4: FCX, FCY, Qual, Hand, FInger, BBL, BBR, BBT, BBB, PaV, PaC, Inc");

        javax.swing.GroupLayout jPanOutputLayout = new javax.swing.GroupLayout(jPanOutput);
        jPanOutput.setLayout(jPanOutputLayout);
        jPanOutputLayout.setHorizontalGroup(
            jPanOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanOutputLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanOutputLayout.createSequentialGroup()
                        .addComponent(jLSegmentsNumber)
                        .addGap(44, 44, 44)
                        .addComponent(jLDiagnostic))
                    .addComponent(jLSegm1)
                    .addComponent(jLSegm2)
                    .addComponent(jLSegm3)
                    .addComponent(jLSegm4))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanOutputLayout.setVerticalGroup(
            jPanOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanOutputLayout.createSequentialGroup()
                .addContainerGap(23, Short.MAX_VALUE)
                .addGroup(jPanOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLSegmentsNumber)
                    .addComponent(jLDiagnostic))
                .addGap(18, 18, 18)
                .addComponent(jLSegm1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLSegm2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLSegm3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLSegm4))
        );

        jPanSettings.setBorder(javax.swing.BorderFactory.createTitledBorder("Settings"));

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Missing Fingers"));

        jCBIndexIsMissing.setText("Index");

        jCBMiddleIsMissing.setText("Middle");

        jCBRingIsMissing.setText("Ring");

        jCBLittleIsMissing.setText("Little");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCBIndexIsMissing)
                    .addComponent(jCBMiddleIsMissing)
                    .addComponent(jCBRingIsMissing)
                    .addComponent(jCBLittleIsMissing))
                .addContainerGap(38, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jCBIndexIsMissing)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCBMiddleIsMissing)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCBRingIsMissing)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCBLittleIsMissing)
                .addContainerGap(26, Short.MAX_VALUE))
        );

        jCBIndexIsMissing.getAccessibleContext().setAccessibleName("jCBIndexIsMissing");
        jCBMiddleIsMissing.getAccessibleContext().setAccessibleName("jCBMiddleIsMissing");
        jCBRingIsMissing.getAccessibleContext().setAccessibleName("jCBRingIsMissing");
        jCBLittleIsMissing.getAccessibleContext().setAccessibleName("jCBLittleIsMissing");

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Process Options"));

        jCBHaloLatent.setText("Halo Latent Elimination");

        jCBSegmVertRotation.setText("Segment Vert Rotation");

        jCBElimFingFromPalm.setText("Eliminate Fing from Palm");

        jCBCalcPalmQual.setText("Calculate Palm Quality");

        jCB1000DPIImage.setText("1000 DPI Image");

        jCBFastProcessSegmentsNumOnly.setText("Fast Process Segm Num");

        jCBLeftRightMix.setText("Disable Left-Right Mixup");

        jCBFastProcessSegmentsData.setText("Fast Process Segm Data");

        jCBIncompleteSlapDataGeneration.setLabel("Incomplete Slap Data Generation");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCBHaloLatent)
                            .addComponent(jCBSegmVertRotation)
                            .addComponent(jCBElimFingFromPalm)
                            .addComponent(jCBCalcPalmQual))
                        .addGap(62, 62, 62)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCB1000DPIImage)
                            .addComponent(jCBFastProcessSegmentsData)
                            .addComponent(jCBLeftRightMix)
                            .addComponent(jCBFastProcessSegmentsNumOnly)))
                    .addComponent(jCBIncompleteSlapDataGeneration))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCBHaloLatent)
                    .addComponent(jCBFastProcessSegmentsNumOnly))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCBSegmVertRotation)
                    .addComponent(jCBLeftRightMix))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCBElimFingFromPalm)
                    .addComponent(jCBFastProcessSegmentsData))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCBCalcPalmQual)
                    .addComponent(jCB1000DPIImage))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jCBIncompleteSlapDataGeneration))
        );

        jLabel1.setText("Object Type");

        jComboBoxObjectsType.setFont(new java.awt.Font("Courier 10 Pitch", 0, 12)); // NOI18N
        jComboBoxObjectsType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "-------", "SLAP 4", "THUMBS 2", "ROLL", "SINGLE", "PALM", "INDEX 2", "SLAP 2" }));
        jComboBoxObjectsType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxObjectsTypeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanSettingsLayout = new javax.swing.GroupLayout(jPanSettings);
        jPanSettings.setLayout(jPanSettingsLayout);
        jPanSettingsLayout.setHorizontalGroup(
            jPanSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanSettingsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jComboBoxObjectsType, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel1))
                .addGap(18, 18, 18)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(153, Short.MAX_VALUE))
        );
        jPanSettingsLayout.setVerticalGroup(
            jPanSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanSettingsLayout.createSequentialGroup()
                .addGroup(jPanSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanSettingsLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(4, 4, 4)
                        .addComponent(jComboBoxObjectsType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanSettingsLayout.createSequentialGroup()
                        .addGap(1, 1, 1)
                        .addGroup(jPanSettingsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jPanel5, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );

        jBProcess.setText("Process");
        jBProcess.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBProcessActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Log Panel"));

        jScrollPane1.setViewportView(jLLog);

        jButton1.setText("CLEAR");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 642, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(34, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jButton1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap(14, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanSettings, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(jPanInput, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(jBProcess)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanOutput, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(20, 20, 20))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanOutput, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                            .addGap(9, 9, 9)
                            .addComponent(jBProcess, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addComponent(jPanInput, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanSettings, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBLoadImageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBLoadImageActionPerformed
        // TODO add your handling code here:
        try {
            JFileChooser FD = new JFileChooser();
            FD.setFileFilter(new ImageFilter());
            FD.setFileSelectionMode(JFileChooser.FILES_ONLY);
            FD.setCurrentDirectory(new File("./"));
            int RetVal = FD.showOpenDialog(this);

            if (RetVal == JFileChooser.APPROVE_OPTION) {
                File file = FD.getSelectedFile();
                LogMessage("Loading file: " + file.getPath());

                BufferedImage img = null;
                int type;
                try {
                    img = ImageIO.read(file);
                    type = img.getType();

                } catch (Exception e) {
                    ShowException("jBLoadImageActionPerformed", "Exception in opening the image: " + e.getMessage());
                    return;
                }

                if (type != BufferedImage.TYPE_BYTE_GRAY) {
                    ShowException("jBLoadImageActionPerformed", "Bad Image Format");
                    return;
                }

                String ext = Utils.getExtension(file);
                if (ext.equals("bmp")) {
                    Raster rst = img.getData();
                    DataBuffer db = rst.getDataBuffer();
                    //TestGbFinImg_Globals.InputImage = new byte[db.getSize()];
                    TestGbFinImg_Globals.InputImage = new byte[10000000];

                    LogMessage("db.getSize" + db.getSize());
                    LogMessage("rst.getWidth()" + rst.getWidth());
                    LogMessage("rst.getHeight()" + rst.getHeight());

                    rst.getDataElements(0, 0, rst.getWidth(), rst.getHeight(), TestGbFinImg_Globals.InputImage);
                    TestGbFinImg_Globals.InputImageSX = rst.getWidth();
                    TestGbFinImg_Globals.InputImageSY = rst.getHeight();

                    // convert to jpeg and save
                    if (TestGbFinImg_Globals.pJpegImage != Pointer.NULL) {
                        GBJPEG_Library.INSTANCE.GBJPEG_Free(TestGbFinImg_Globals.pJpegImage.getPointer(0));
                    }
                    TestGbFinImg_Globals.pJpegImage = new Memory(Pointer.SIZE);
                    IntByReference BuffLen = new IntByReference();
                    RetVal = GBJPEG_Library.INSTANCE.GBJPEG_JPG_Encode(
                            TestGbFinImg_Globals.pJpegImage, // unsigned char **
                            BuffLen, // unsigned long *
                            TestGbFinImg_Globals.InputImage,
                            TestGbFinImg_Globals.InputImageSX, // unsigned long
                            TestGbFinImg_Globals.InputImageSY, // unsigned long
                            (byte) 8,
                            (short) 500,// unsigned short 
                            (short) 100 // unsigned short 
                            );
                    if (PrintRetValForJpeg(RetVal, "GBJPEG_JPG_Encode") == false) {
                        ShowException("jBLoadImageActionPerformed", "GBJPEG_JPG_Encode failure, exit");
                        InitProcessControls();
                        return;
                    }
                    LogMessage("BuffLen: " + BuffLen.getValue());
                    Utils.WriteAllBytes("x.jpeg", 
                            TestGbFinImg_Globals.pJpegImage.getPointer(0).getByteArray(0, BuffLen.getValue()));
                    
                } else {
                    byte[] CompressedBuffer = Utils.loadFile(file);
                    TestGbFinImg_Globals.InputImage = null;
                    if (TestGbFinImg_Globals.pRawImage != Pointer.NULL) {
                        GBJPEG_Library.INSTANCE.GBJPEG_Free(TestGbFinImg_Globals.pRawImage.getPointer(0));
                    }
                    TestGbFinImg_Globals.pRawImage = new Memory(Pointer.SIZE);
                    IntByReference ImageWidth = new IntByReference(0),
                            ImageHeight = new IntByReference(0);
                    ByteByReference BitsPerPixel = new ByteByReference((byte) 0);

                    RetVal = GBJPEG_Library.INSTANCE.GBJPEG_JPG_Decode(
                            CompressedBuffer, CompressedBuffer.length, TestGbFinImg_Globals.pRawImage, ImageWidth, ImageHeight, BitsPerPixel);
                    if (PrintRetValForJpeg(RetVal, "GBJPEG_JPG_Decode") == false) {
                        ShowException("jBLoadImageActionPerformed", "GBJPEG_JPG_Decode failure, exit");
                        InitProcessControls();
                        return;
                    }

                    LogMessage("ImageWidth: " + ImageWidth.getValue());
                    LogMessage("ImageHeight: " + ImageHeight.getValue());
                    LogMessage("BitsPerPixel: " + BitsPerPixel.getValue());

                    if (BitsPerPixel.getValue() == GBJPEG_BitsPerPixel.GBJPEG_8_BITS_PER_PIXEL) {


                        TestGbFinImg_Globals.InputImage =
                                TestGbFinImg_Globals.pRawImage.getPointer(0).getByteArray(0, ImageWidth.getValue() * ImageHeight.getValue());
                        TestGbFinImg_Globals.InputImageSX = ImageWidth.getValue();
                        TestGbFinImg_Globals.InputImageSY = ImageHeight.getValue();


                    } else {
                        ShowException("jBLoadImageActionPerformed", "Bad Image Format, exit");
                        InitProcessControls();
                        return;
                    }
                }
                this.jLImageSize.setText("Img: " + TestGbFinImg_Globals.InputImageSX
                        + ", " + TestGbFinImg_Globals.InputImageSY);
                IntByReference ImageQuality = new IntByReference();
                RetVal = GBNfiq_Library.INSTANCE.GBNFIQ_GetImageQuality(
                        TestGbFinImg_Globals.InputImage,
                        TestGbFinImg_Globals.InputImageSX, TestGbFinImg_Globals.InputImageSY, ImageQuality, null);
                if (PrintRetValForNfiq(RetVal, "GBNFIQ_GetImageQuality") == false) {
                    ShowException("jBLoadImageActionPerformed", "GBNFIQ_GetImageQuality failure, continue");
                    this.jLNistQuality.setText("NIST Quality: NA");
                } else {
                    this.jLNistQuality.setText("NFIQ Quality: " + ImageQuality.getValue());
                }
                Utils.WriteAllBytes("x.raw", TestGbFinImg_Globals.InputImage);
                this.jComboBoxObjectsType.setEnabled(true);


            }
        } catch (Exception e) {
            ShowException("jBLoadImageActionPerformed", "Exception: " + e.getMessage());
            return;
        }
    }//GEN-LAST:event_jBLoadImageActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        this.jLLog.removeAll();
        this.LogModel = new DefaultListModel();
        this.jLLog.setModel(LogModel);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jComboBoxObjectsTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxObjectsTypeActionPerformed
        // TODO add your handling code here:
        try {
            String SelectedString = (String) this.jComboBoxObjectsType.getSelectedItem();
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_NoObj)) {
                this.EnableMissingMask(false);
                ObjAllowsIncompleteSlapDataGeneration =false;
                this.EnableProcessOptions(false);
                this.jBProcess.setEnabled(false);
                this.InitSegmStrings();
                TestGbFinImg_Globals.InputImageType = 0;
                return;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftSlap4)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightSlap4)) {
                this.EnableMissingMask(true);
                ObjAllowsIncompleteSlapDataGeneration =true;
                this.EnableProcessOptions(true);
                // disable palm controls
                this.jCBCalcPalmQual.setEnabled(false);
                this.jCBElimFingFromPalm.setEnabled(false);
                this.InitSegmStrings();
                this.jBProcess.setEnabled(true);
                if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftSlap4)) {
                    TestGbFinImg_Globals.InputImageType = GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_4;
                } else {
                    TestGbFinImg_Globals.InputImageType = GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_4;
                }
                return;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftSlap2)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightSlap2)) {
                this.EnableMissingMask(false);
                ObjAllowsIncompleteSlapDataGeneration =false;
                this.EnableProcessOptions(true);
                // disable palm controls
                this.jCBCalcPalmQual.setEnabled(false);
                this.jCBElimFingFromPalm.setEnabled(false);
                this.jCBLeftRightMix.setEnabled(false);
                this.InitSegmStrings();
                this.jBProcess.setEnabled(true);
                if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftSlap2)) {
                    TestGbFinImg_Globals.InputImageType = GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_2;
                } else {
                    TestGbFinImg_Globals.InputImageType = GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_2;
                }
                return;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_FlatSingle)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_Thumbs2)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RollSingle)) {
                this.EnableMissingMask(false);
                if (SelectedString.equals(TestGbFinImg_Globals.ObjType_Thumbs2))
                {
                    ObjAllowsIncompleteSlapDataGeneration =true;
                }
                else
                {
                    ObjAllowsIncompleteSlapDataGeneration =false;
                }
                this.EnableProcessOptions(true);
                // disable palm controls
                this.jCBCalcPalmQual.setEnabled(false);
                this.jCBElimFingFromPalm.setEnabled(false);
                this.jCBLeftRightMix.setEnabled(false);
                this.InitSegmStrings();
                this.jBProcess.setEnabled(true);
                if (SelectedString.equals(TestGbFinImg_Globals.ObjType_FlatSingle)) {
                    TestGbFinImg_Globals.InputImageType = GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_SINGLE_FINGER_FLAT;
                } else if (SelectedString.equals(TestGbFinImg_Globals.ObjType_Thumbs2)) {
                    TestGbFinImg_Globals.InputImageType = GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_THUMBS_2;
                } else {
                    TestGbFinImg_Globals.InputImageType = GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_SINGLE_FINGER;
                }
                return;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftLowerHalf)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightLowerHalf)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftWriter)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightWriter)) {
                this.EnableMissingMask(false);
                this.EnableProcessOptions(true);
                // disable palm controls
                this.jCBFastProcessSegmentsData.setEnabled(false);
                this.jCBFastProcessSegmentsNumOnly.setEnabled(false);
                this.jCBLeftRightMix.setEnabled(false);
                this.InitSegmStrings();
                this.jBProcess.setEnabled(true);
                if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftLowerHalf)) {
                    TestGbFinImg_Globals.InputImageType =
                            GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_HALF_PALM;
                } else if (SelectedString.equals(TestGbFinImg_Globals.ObjType_RightLowerHalf)) {
                    TestGbFinImg_Globals.InputImageType =
                            GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_HALF_PALM;
                } else if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftWriter)) {
                    TestGbFinImg_Globals.InputImageType =
                            GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_LEFT_HAND_WRITER_PALM;
                } else {
                    TestGbFinImg_Globals.InputImageType =
                            GBFINIMG_InputImageTypes.GBFINIMG_INPUT_IMAGE_TYPE_RIGHT_HAND_WRITER_PALM;
                }
                return;
            } else {
                this.EnableMissingMask(false);
                this.EnableProcessOptions(false);
                this.jBProcess.setEnabled(false);
                this.InitSegmStrings();
                return;
            }

        } catch (Exception e) {
            ShowException("jComboBoxObjectsTypeActionPerformed", "Exception: " + e.getMessage());
            return;
        }
    }//GEN-LAST:event_jComboBoxObjectsTypeActionPerformed

    private int GetNumberOfExpectedSegments() {
        try {
            String SelectedString = (String) this.jComboBoxObjectsType.getSelectedItem();
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_NoObj)) {
                return 0;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftSlap4)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightSlap4)) {
                return 4;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftSlap2)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightSlap2)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_Thumbs2)) {
                return 2;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_FlatSingle)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RollSingle)) {
                return 1;
            }
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftLowerHalf)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightLowerHalf)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftWriter)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightWriter)) {
                return 1;
            }
            return 0;

        } catch (Exception e) {
            ShowException("GetNumberOfExpectedSegments", "Exception: " + e.getMessage());
            return 0;
        }
    }

    private int GetProcessOptions() {
        try {
            int RetVal = 0;
            if (this.jCB1000DPIImage.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_1000DPI_PRINT_IMAGE_PROCESSING;
            }
            if (this.jCBCalcPalmQual.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_PALM_PRINT_IMAGE_QUALITY_CALCULATION;
            }
            if (this.jCBElimFingFromPalm.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_PALM_PRINT_IMAGE_DELETE_FINGER_SEGMENTS;
            }
            if (this.jCBFastProcessSegmentsData.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_FAST_PROCESSING_PRELIMINARY_SEGMENT_DATA;
            }
            if (this.jCBFastProcessSegmentsNumOnly.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_FAST_PROCESSING_SEGMENT_NUMBER_ONLY;
            }
            if (this.jCBHaloLatent.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_HALO_LATENT_ELIMINATION;
            }
            if (this.jCBSegmVertRotation.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_SEGMENT_VERTICAL_ROTATION;
            }
            if (this.jCBLeftRightMix.isSelected()) {
                RetVal |= GBFINIMG_ProcessingOptions.GBFINIMG_DISABLE_LEFT_RIGHT_HAND_MIXUP_CHECK;
            }
            if (this.jCBIncompleteSlapDataGeneration.isEnabled() &&
                    this.jCBIncompleteSlapDataGeneration.isSelected())
            {
                RetVal |= 
                        GBFINIMG_ProcessingOptions.GBFINIMG_ALLOW_INCOMPLETE_SLAP_SEGMENTS_DATA_GENERATION;
            }
            return RetVal;

        } catch (Exception e) {
            ShowException("GetProcessOptions", "Exception: " + e.getMessage());
            return 0;
        }
    }

    private byte GetMissingFingersMask() {
        try {
            byte RetVal = 0;

            if (this.jCBIndexIsMissing.isSelected()) {
                RetVal |= GBFINIMG_MissingFingerDefinitions.GBFINIMG_MISSING_FINGER_SLAP4_INDEX;
            }
            if (this.jCBLittleIsMissing.isSelected()) {
                RetVal |= GBFINIMG_MissingFingerDefinitions.GBFINIMG_MISSING_FINGER_SLAP4_LITTLE;
            }
            if (this.jCBMiddleIsMissing.isSelected()) {
                RetVal |= GBFINIMG_MissingFingerDefinitions.GBFINIMG_MISSING_FINGER_SLAP4_MIDDLE;
            }
            if (this.jCBRingIsMissing.isSelected()) {
                RetVal |= GBFINIMG_MissingFingerDefinitions.GBFINIMG_MISSING_FINGER_SLAP4_RING;
            }
            return RetVal;

        } catch (Exception e) {
            ShowException("GetMissingFingersMask", "Exception: " + e.getMessage());
            return 0;
        }
    }
    private void jBProcessActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBProcessActionPerformed
        // TODO add your handling code here:
        try {
            /**
             *  Get Options
             */
            int ProcessOptionMask = GetProcessOptions();
            /**
             *  Get NumOfExpectedSegments
             */
            int NumOfExpectedSegments = GetNumberOfExpectedSegments();
            if (NumOfExpectedSegments == 0) {
                ShowException("jBProcessActionPerformed", "GetNumberOfExpectedSegments() returned 0, exit");
                return;
            }
            /**
             *  Create segment list
             */
            GBFINIMG_SegmentImageDescriptor.ByReference MyFirst = new GBFINIMG_SegmentImageDescriptor.ByReference();

            GBFINIMG_SegmentImageDescriptor[] SegmentImageList =
                    (GBFINIMG_SegmentImageDescriptor[]) MyFirst.toArray(
                    NumOfExpectedSegments);
            for (int i = 0; i < NumOfExpectedSegments; i++) {
                SegmentImageList[i].SegmentImagePtr = new Memory(TestGbFinImg_Globals.SegmentImageSizeX
                        * TestGbFinImg_Globals.SegmentImageSizeY);
                SegmentImageList[i].FingerCenterX = i;
            }
            /**
             *  Set missing fingers mask
             */
            String SelectedString = (String) this.jComboBoxObjectsType.getSelectedItem();
            if (SelectedString.equals(TestGbFinImg_Globals.ObjType_LeftSlap4)
                    || SelectedString.equals(TestGbFinImg_Globals.ObjType_RightSlap4)) {
                byte MissingFingersMask = GetMissingFingersMask();
                GBFinImg_Library.INSTANCE.GBFINIMG_Slap4_MissingFingers(MissingFingersMask);
            }
            /**
             * Call process
             */
            IntByReference DetectedSegmNum = new IntByReference(), DetectedDiagn = new IntByReference();
            byte[] TempBuffer = new byte[GBFINIMG_MemoryBufferSize.GBFINIMG_MEMORY_BUFFER_SIZE];
            
            int RetVal = GBFinImg_Library.INSTANCE.GBFINIMG_ProcessImage(
                    TestGbFinImg_Globals.InputImage,
                    TestGbFinImg_Globals.InputImageSX, TestGbFinImg_Globals.InputImageSY,
                    TestGbFinImg_Globals.InputImageType,
                    ProcessOptionMask, MyFirst,
                    TestGbFinImg_Globals.SegmentImageSizeX, TestGbFinImg_Globals.SegmentImageSizeY,
                    DetectedSegmNum, DetectedDiagn,
                    null, 0,
                    TempBuffer, GBFINIMG_MemoryBufferSize.GBFINIMG_MEMORY_BUFFER_SIZE);

            if (PrintRetValForGbFinImg(RetVal, "GBFINIMG_ProcessImage") == false) {
                ShowException("jBProcessActionPerformed", "GBFINIMG_ProcessImage() error, exit");
                return;
            }
            LogMessage("GBFINIMG_ProcessImage: DetectedSegmNum = " + DetectedSegmNum.getValue());
            LogMessage("GBFINIMG_ProcessImage: DetectedDiagn = " + DetectedDiagn.getValue());
            this.jLSegmentsNumber.setText("Segments Number: " + DetectedSegmNum.getValue());
            this.jLDiagnostic.setText("Diagnostic: " + DetectedDiagn.getValue());

            for (int i = 0; i < DetectedSegmNum.getValue(); i++) {
                JLabel refLabel = null;
                GBFINIMG_SegmentImageDescriptor refDesc = SegmentImageList[i];
                if (i == 0) {
                    refLabel = jLSegm1;
                } else if (i == 1) {
                    refLabel = jLSegm2;
                } else if (i == 2) {
                    refLabel = jLSegm3;
                } else if (i == 3) {
                    refLabel = jLSegm4;
                }

                if (refLabel != null) {
                    refLabel.setText("Segm " + i + ": "
                            + refDesc.FingerCenterX + ", "
                            + refDesc.FingerCenterY + ", "
                            + refDesc.Hand + ", "
                            + refDesc.Finger + ", "
                            + refDesc.BoundingBoxL + ", "
                            + refDesc.BoundingBoxR + ", "
                            + refDesc.BoundingBoxT + ", "
                            + refDesc.BoundingBoxB + ", "
                            + refDesc.PatternValidity + ", "
                            + refDesc.PatternCompleteness + ", "
                            + refDesc.Inclination);
                }

            }

        } catch (Exception e) {
            ShowException("jBProcessActionPerformed", "Exception: " + e.getMessage());
            return;
        }

    }//GEN-LAST:event_jBProcessActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Test_Gbfinimg_MainWin.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Test_Gbfinimg_MainWin.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Test_Gbfinimg_MainWin.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Test_Gbfinimg_MainWin.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new Test_Gbfinimg_MainWin().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBLoadImage;
    private javax.swing.JButton jBProcess;
    private javax.swing.JButton jButton1;
    private javax.swing.JCheckBox jCB1000DPIImage;
    private javax.swing.JCheckBox jCBCalcPalmQual;
    private javax.swing.JCheckBox jCBElimFingFromPalm;
    private javax.swing.JCheckBox jCBFastProcessSegmentsData;
    private javax.swing.JCheckBox jCBFastProcessSegmentsNumOnly;
    private javax.swing.JCheckBox jCBHaloLatent;
    private javax.swing.JCheckBox jCBIncompleteSlapDataGeneration;
    private javax.swing.JCheckBox jCBIndexIsMissing;
    private javax.swing.JCheckBox jCBLeftRightMix;
    private javax.swing.JCheckBox jCBLittleIsMissing;
    private javax.swing.JCheckBox jCBMiddleIsMissing;
    private javax.swing.JCheckBox jCBRingIsMissing;
    private javax.swing.JCheckBox jCBSegmVertRotation;
    private javax.swing.JComboBox jComboBoxObjectsType;
    private javax.swing.JLabel jLDiagnostic;
    private javax.swing.JLabel jLImageSize;
    private javax.swing.JList jLLog;
    private javax.swing.JLabel jLNistQuality;
    private javax.swing.JLabel jLSegm1;
    private javax.swing.JLabel jLSegm2;
    private javax.swing.JLabel jLSegm3;
    private javax.swing.JLabel jLSegm4;
    private javax.swing.JLabel jLSegmentsNumber;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanInput;
    private javax.swing.JPanel jPanOutput;
    private javax.swing.JPanel jPanSettings;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
