#ifndef GB_AN2011_h
#define GB_AN2011_h

#include <an2k_dll.h> // for RECORD, FIELD, etc structs
#include <GB_AN_Engine.h> // for GB_AN_ENGINE_String typedefs

#ifndef DllExport_an2k
#ifdef AN2K_COMPILE_FOR_DLL
#define DllExport_an2k __declspec( dllexport )
#else
#define DllExport_an2k
#endif
#endif // DllExport_an2k

//----------------------------------------------------------------------//
//		SECTION 1: TABLES
//----------------------------------------------------------------------//
/***********************************
** Table 4:
** Character encoding
***********************************/
// Index
#define GB_TABLE_AN2011_4_CHAR_ENCODING_INDEX_ASCII		0
#define GB_TABLE_AN2011_4_CHAR_ENCODING_INDEX_UTF_16	2
#define GB_TABLE_AN2011_4_CHAR_ENCODING_INDEX_UTF_8		3
#define GB_TABLE_AN2011_4_CHAR_ENCODING_INDEX_UTF_32	4

// Name
#define GB_TABLE_AN2011_4_CHAR_ENCODING_NAME_ASCII		"ASCII"
#define GB_TABLE_AN2011_4_CHAR_ENCODING_NAME_UTF_16		"UTF-16"
#define GB_TABLE_AN2011_4_CHAR_ENCODING_NAME_UTF_8		"UTF-8"
#define GB_TABLE_AN2011_4_CHAR_ENCODING_NAME_UTF_32		"UTF-32"

/***********************************
** Table 5:
** Device monitoring mode
***********************************/
#define GB_TABLE_AN2011_5_DMM_CONTROLLED	"CONTROLLED"
#define GB_TABLE_AN2011_5_DMM_ASSISTED		"ASSISTED"
#define GB_TABLE_AN2011_5_DMM_OBSERVED		"OBSERVED"
#define GB_TABLE_AN2011_5_DMM_UNATTENDED	"UNATTENDED"
#define GB_TABLE_AN2011_5_DMM_UNKNOWN		"UNKNOWN"

/***********************************
** Table 7:
** Friction ridge impression types
***********************************/
// LIVESCAN UNKNOWN OR UNSPECIFIED
#define GB_TABLE_AN2011_7_FRIT_LS_UNKNOWN_PLAIN						0
#define GB_TABLE_AN2011_7_FRIT_LS_UNKNOWN_ROLLED					1
#define GB_TABLE_AN2011_7_FRIT_LS_UNKNOWN_PALM						10
#define GB_TABLE_AN2011_7_FRIT_LS_UNKNOWN_PLANTAR					30
// LIVESCAN VERTICAL SWIPE
#define GB_TABLE_AN2011_7_FRIT_LS_VERT_SWIPE_PLAIN					8
// LIVESCAN OPTICAL CONTACT
#define GB_TABLE_AN2011_7_FRIT_LS_OPT_CONTACT_PLAIN					20
#define GB_TABLE_AN2011_7_FRIT_LS_OPT_CONTACT_ROLLED				21
// LIVESCAN NON OPTICAL CONTACT
#define GB_TABLE_AN2011_7_FRIT_LS_NON_OPT_CONTACT_PLAIN				22
#define GB_TABLE_AN2011_7_FRIT_LS_NON_OPT_CONTACT_ROLLED			23
// LIVESCAN OPTICAL CONTACTLESS
#define GB_TABLE_AN2011_7_FRIT_LS_OPT_CONTACTLESS_PLAIN				24
#define GB_TABLE_AN2011_7_FRIT_LS_OPT_CONTACTLESS_ROLLED			25
// LIVESCAN NON OPTICAL CONTACTLESS
#define GB_TABLE_AN2011_7_FRIT_LS_NON_OPT_CONTACTLESS_PLAIN			26
#define GB_TABLE_AN2011_7_FRIT_LS_NON_OPT_CONTACTLESS_ROLLED		27
// NON LIVESCAN
#define GB_TABLE_AN2011_7_FRIT_NON_LIVESCAN_PLAIN					2
#define GB_TABLE_AN2011_7_FRIT_NON_LIVESCAN_ROLLED					3
#define GB_TABLE_AN2011_7_FRIT_NON_LIVESCAN_PALM					11
#define GB_TABLE_AN2011_7_FRIT_NON_LIVESCAN_PLANTAR					31
// LATENT IMPRESSION
#define GB_TABLE_AN2011_7_FRIT_LATENT_IMPRESSION_PLAIN				4
#define GB_TABLE_AN2011_7_FRIT_LATENT_IMPRESSION_PALM				12
#define GB_TABLE_AN2011_7_FRIT_LATENT_IMPRESSION_PLANTAR			32
#define GB_TABLE_AN2011_7_FRIT_LATENT_IMPRESSION_UNKNOWN			36
// LATENT TRACING
#define GB_TABLE_AN2011_7_FRIT_LATENT_TRACING_PLAIN					5
#define GB_TABLE_AN2011_7_FRIT_LATENT_TRACING_PALM					13
#define GB_TABLE_AN2011_7_FRIT_LATENT_TRACING_PLANTAR				33
#define GB_TABLE_AN2011_7_FRIT_LATENT_TRACING_UNKNOWN				37
// LATENT PHOTO
#define GB_TABLE_AN2011_7_FRIT_LATENT_PHOTO_PLAIN					6
#define GB_TABLE_AN2011_7_FRIT_LATENT_PHOTO_PALM					14
#define GB_TABLE_AN2011_7_FRIT_LATENT_PHOTO_PLANTAR					34
#define GB_TABLE_AN2011_7_FRIT_LATENT_PHOTO_UNKNOWN					38
// LATENT LIFT
#define GB_TABLE_AN2011_7_FRIT_LATENT_LIFT_PLAIN					7
#define GB_TABLE_AN2011_7_FRIT_LATENT_LIFT_PALM						15
#define GB_TABLE_AN2011_7_FRIT_LATENT_LIFT_PLANTAR					35
#define GB_TABLE_AN2011_7_FRIT_LATENT_LIFT_UNKNOWN					39
// OTHER OR UNKNOWN
#define GB_TABLE_AN2011_7_FRIT_OTHER								28
#define GB_TABLE_AN2011_7_FRIT_UNNKNOWN								29

/***********************************
** Table 8: Finger Positions
***********************************/
#define GB_TABLE_AN2011_8_UNKNOWN	(0)
// FINGER
#define GB_TABLE_AN2011_8_RIGHT_THUMB	(1)
#define GB_TABLE_AN2011_8_RIGHT_INDEX	(2)
#define GB_TABLE_AN2011_8_RIGHT_MIDDLE	(3)
#define GB_TABLE_AN2011_8_RIGHT_RING	(4)
#define GB_TABLE_AN2011_8_RIGHT_LITTLE	(5)
#define GB_TABLE_AN2011_8_LEFT_THUMB	(6)
#define GB_TABLE_AN2011_8_LEFT_INDEX	(7)
#define GB_TABLE_AN2011_8_LEFT_MIDDLE	(8)
#define GB_TABLE_AN2011_8_LEFT_RING	(9)
#define GB_TABLE_AN2011_8_LEFT_LITTLE	(10)
#define GB_TABLE_AN2011_8_PLAIN_RIGHT_THUMB	(11)
#define GB_TABLE_AN2011_8_PLAIN_LEFT_THUMB	(12)
#define GB_TABLE_AN2011_8_PLAIN_RIGHT_SLAP_4	(13)
#define GB_TABLE_AN2011_8_PLAIN_LEFT_SLAP_4	(14)
#define GB_TABLE_AN2011_8_PLAIN_LEFT_THUMBS_2	(15)
#define GB_TABLE_AN2011_8_RIGHT_EXTRA_DIGIT	(16)
#define GB_TABLE_AN2011_8_LEFT_EXTRA_DIGIT	(17)
#define GB_TABLE_AN2011_8_UNKNOWN_FRICTION_RIDGE	(18)
#define GB_TABLE_AN2011_8_EJI_OR_TIP				(19)
// PALM
#define GB_TABLE_AN2011_8_UNKNOWN_PALM	(20)
#define GB_TABLE_AN2011_8_RIGHT_FULL_PALM	(21)
#define GB_TABLE_AN2011_8_RIGHT_WRITERS_PALM	(22)
#define GB_TABLE_AN2011_8_LEFT_FULL_PALM	(23)
#define GB_TABLE_AN2011_8_LEFT_WRITERS_PALM	(24)
#define GB_TABLE_AN2011_8_RIGHT_LOWER_PALM	(25)
#define GB_TABLE_AN2011_8_RIGHT_UPPER_PALM	(26)
#define GB_TABLE_AN2011_8_LEFT_LOWER_PALM	(27)
#define GB_TABLE_AN2011_8_LEFT_UPPER_PALM	(28)
#define GB_TABLE_AN2011_8_RIGHT_OTHER	(29)
#define GB_TABLE_AN2011_8_LEFT_OTHER	(30)
#define GB_TABLE_AN2011_8_RIGHT_INTERDIGITAL	(31)
#define GB_TABLE_AN2011_8_RIGHT_THENAR	(32)
#define GB_TABLE_AN2011_8_RIGHT_HYPOTHENAR	(33)
#define GB_TABLE_AN2011_8_LEFT_INTERDIGITAL	(34)
#define GB_TABLE_AN2011_8_LEFT_THENAR	(35)
#define GB_TABLE_AN2011_8_LEFT_HYPOTHENAR	(36)
#define GB_TABLE_AN2011_8_RIGHT_GRASP	(37)
#define GB_TABLE_AN2011_8_LEFT_GRASP	(38)
#define GB_TABLE_AN2011_8_RIGHT_CARPAL_DELTA_AREA	(81)
#define GB_TABLE_AN2011_8_LEFT_CARPAL_DELTA_AREA	(82)
#define GB_TABLE_AN2011_8_RIGHT_FULL_WRITERS_PALM	(83)
#define GB_TABLE_AN2011_8_LEFT_FULL_WRITERS_PALM	(84)
// FINGER COMBINATION: 2 FINGERS
#define GB_TABLE_AN2011_8_RIGHT_INDEX_MIDDLE	(40)
#define GB_TABLE_AN2011_8_RIGHT_MIDDLE_RING		(41)
#define GB_TABLE_AN2011_8_RIGHT_RING_LITTLE		(42)
#define GB_TABLE_AN2011_8_LEFT_INDEX_MIDDLE		(43)
#define GB_TABLE_AN2011_8_LEFT_MIDDLE_RING		(44)
#define GB_TABLE_AN2011_8_LEFT_RING_LITTLE		(45)
#define GB_TABLE_AN2011_8_RIGHT_LEFT_INDEX		(46)
// FINGER COMBINATION: 3 FINGERS
#define GB_TABLE_AN2011_8_RIGHT_INDEX_MIDDLE_RING	(47)
#define GB_TABLE_AN2011_8_RIGHT_MIDDLE_RING_LITTLE	(48)
#define GB_TABLE_AN2011_8_LEFT_INDEX_MIDDLE_RING	(49)
#define GB_TABLE_AN2011_8_LEFT_MIDDLE_RING_LITTLE	(50)

/***********************************
** Table 9: Joint image segments, 
** tip code and finger view codes
***********************************/
// Entire joint image EJI
#define GB_TABLE_AN2011_9_ENTIRE_JOINT_IMAGE		"EJI"
// FVC OR FIC
#define GB_TABLE_AN2011_9_ROLLED_TIP				"TIP"
#define GB_TABLE_AN2011_9_FULL_FINGER_ROLLED		"FV1"
#define GB_TABLE_AN2011_9_FULL_FINGER_LEFT_SIDE		"FV2"
#define GB_TABLE_AN2011_9_FULL_FINGER_CENTER		"FV3"
#define GB_TABLE_AN2011_9_FULL_FINGER_RIGHT_SIDE	"FV4"
// FVC ONLY
#define GB_TABLE_AN2011_9_FVC_ONLY_NA				"NA"
// LOS OR FIC
#define GB_TABLE_AN2011_9_LOS_PROXIMAL				"PRX"
#define GB_TABLE_AN2011_9_LOS_DISTAL				"DST"
#define GB_TABLE_AN2011_9_LOS_MEDIAL				"MED"
// LOS ONLY
#define GB_TABLE_AN2011_9_LOS_ONLY_NA				"NA"

/***********************************
** Table 12: Subject acquisition 
** profiles for fingerprint 
***********************************/
#define GB_TABLE_AN2011_12_FAP_10				10
#define GB_TABLE_AN2011_12_FAP_20				20
#define GB_TABLE_AN2011_12_FAP_30				30
#define GB_TABLE_AN2011_12_FAP_40				40
#define GB_TABLE_AN2011_12_FAP_45				45
#define GB_TABLE_AN2011_12_FAP_50				50
#define GB_TABLE_AN2011_12_FAP_60				60

/***********************************
** Table 15: Compression codes 
***********************************/
#define GB_TABLE_AN2011_15_CODE_UNCOMPRESSED	0
#define GB_TABLE_AN2011_15_CODE_WSQ20			1
#define GB_TABLE_AN2011_15_CODE_JPEGB			2
#define GB_TABLE_AN2011_15_CODE_JPEGL			3
#define GB_TABLE_AN2011_15_CODE_JP2				4
#define GB_TABLE_AN2011_15_CODE_JP2L			5
#define GB_TABLE_AN2011_15_CODE_PNG				6

//----------------------------------------------------------------------//
//		SECTION 2: STRUCTURES, ENUMS, ETC
//----------------------------------------------------------------------//
#pragma pack(push, 1)
//////////////////////////////////////////////
//	Represents a string formatted this way:
//
//	YYYYMMDDhhmmssZ
//////////////////////////////////////////////
typedef struct GB_AN2011_GMT_TAG {
	int Year;
	int Month;
	int Day;
	int hour;
	int minute;
	int second;
} GB_AN2011_GmtStruct;


//////////////////////////////////////////////
//	Represents a string formatted this way:
//
//	YYYYMMDD
//////////////////////////////////////////////
typedef struct GB_AN2011_DATE_TAG {
	int Year;
	int Month;
	int Day;
} GB_AN2011_DateStruct;


//////////////////////////////////////////////
//
//////////////////////////////////////////////
typedef struct GB_AN2011_ApplicationProfileStruct_TAG {
	GB_AN_ENGINE_String AppProfOrg;
	GB_AN_ENGINE_String AppProfName;
	GB_AN_ENGINE_String AppProfVer;
} GB_AN2011_ApplicationProfileStruct;

//----------------------------------------------------------------------//
//		SECTION 3: TYPE-1
//----------------------------------------------------------------------//
///////////////////////////////////////////////////////////////////////////////////////
// GB_AN2011_CreateAnsiNistStruct
//
// Description
//	Creates an Ansi-Nist ITL 2011 compliant structure, filled with its
//	mandatory type-1 record. For parameters meaning see
//	ANSI/NIST ITL-2011 specifications.
//
// Parameters:
//	<pAnsiNist>: (output) pointer to the structure that will be created
//			Free it by using GB_AN_ENGINE_Free(...) function. Cannot be
//			NULL.
//	<Tot>: (input) Type Of Transaction
//			Min num of chars: 1
//			Max num of chars: 16
//			MANDATORY (cannot be NULL)
//	<Dat>: (input) Date of transaction
//			MANDATORY (cannot be NULL and must be a valid date)
//	<Pry>: (input) Priority (1-9)
//			Cannot be >= 10
//			OPTIONAL: -1 for avoiding item insertion
//	<DestAgency>: (input) 
//			Min num of chars: 1
//			MANDATORY (cannot be NULL)
//	<OrigAgency>: (input) 
//			Min num of chars: 1
//			MANDATORY (cannot be NULL)
//	<TransContrNum>: (input) Transaction control number
//			Min num of chars: 1
//			MANDATORY (cannot be NULL)
//	<TransContrRef>: (input) Transaction control reference
//			Min num of chars: 1
//			Max num of chars: 1000
//			OPTIONAL: NULL for avoiding item insertion
//	<NativeScanRes>: (input) Native Scan Resolution: 00.00 if no type-4 record is present
//			Cannot be >= 100 or < 0
//			MANDATORY
//	<NominalTxRes>: (input) Nominal transmit Resolution: 00.00 if no type-4 record is present
//			Cannot be >= 100
//			OPTIONAL: set to a value < 0 for avoiding insertion
//	<DomainName>: (input) 
//			Min num of chars: 1
//			OPTIONAL: NULL for avoiding item insertion, but must be present
//				if <DomainVersion> != NULL, otherwise DOM field will not be
//				created
//	<DomainVersion>: (input) 
//			Min num of chars: 1
//			OPTIONAL: NULL for avoiding item insertion
//	<Gmt>: (input) Greenwich Mean Time
//			OPTIONAL: NULL for avoiding item insertion
//	<CharEncIndex>: (input) Character encoding set index
//			Values: 0, 2, 3, 4, [128-999] interval
//			OPTIONAL: set to a value < 0 for avoiding item insertion
//	<CharEncName>: (input) Character encoding set name: see Table 4
//			OPTIONAL: NULL for avoiding item insertion, but must be
//				present if <CharEncIndex> has a valid value
//	<CharEncVersion>: (input) Character Encoding set Version
//			Min num of chars: 1
//			Max num of chars: 16
//			OPTIONAL: NULL for avoiding item insertion
//	<Aps>: (input) array of GB_AN2011_ApplicationProfileStruct structures
//			OPTIONAL: NULL for avoiding item insertion, but if present
//				every string into the structures must be valid. APS
//				field will be created only if <Aps> != NULL and
//				<ApsNum> > 0
//	<ApsNum>: (input) number of GB_AN2011_ApplicationProfileStruct structures
//			in <Aps> array
//	<DestAgName>: (input) Destination Agency Name
//			Min num of chars: 1
//			OPTIONAL: NULL for avoiding item insertion
//	<OrigAgName>: (input) Originating Agency Name
//			Min num of chars: 1
//			OPTIONAL: NULL for avoiding item insertion, but if present
//				and <DestAgName> == NULL, ANM field will not be created
///////////////////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_CreateAnsiNistStruct (
	ANSI_NIST				** pAnsiNist,
	GB_AN_ENGINE_String		Tot,
	GB_AN2011_DateStruct	*Dat,
	int						Pry,
	GB_AN_ENGINE_String		DestAgency,
	GB_AN_ENGINE_String		OrigAgency,
	GB_AN_ENGINE_String		TransContrNum,
	GB_AN_ENGINE_String		TransContrRef,
	float					NativeScanRes,
	float					NominalTxRes,
	GB_AN_ENGINE_String		DomainName,
	GB_AN_ENGINE_String		DomainVersion,
	GB_AN2011_GmtStruct		*Gmt,
	int						CharEncIndex,
	GB_AN_ENGINE_String		CharEncName,
	GB_AN_ENGINE_String		CharEncVersion,
	GB_AN2011_ApplicationProfileStruct	*Aps, 
	int						ApsNum,
	GB_AN_ENGINE_String		DestAgName,
	GB_AN_ENGINE_String		OrigAgName
);

///////////////////////////////////////////////////////////////////////////////////////
// GB_AN2011_GetType1RecordInfo
//
// Description
//	Retrieves type-1 record information. Validity and compliance of the retrieved data
//	are up to the application (for example, the CharEncodeIndex and CharEncode name
//	should belong to the table 4 of the ANSI/NIST ITL 2011 specification), since some
//	values could be outside standard in order to fit application needs.
//
//	NOTE: Set to NULL the parameters whose value is not needed to be known
//
// Parameters:
//	<record>: (input) type-1 record where info should be retrieved from
//	<pVersion>: (output) VER field; 0 means no valid value or field not found
//	<pTypeOfTransaction>: (output) TOT field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<Dat>: (output) DAT field; all its items to 0 means no valid value or field not 
//		found
//	<pPriority>: (output) PRY field; -1 means no valid value or field not found
//	<pDestAgency>: (output) DAI field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pOrigAgency>: (output) ORI field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pTransContrNum>: (output) TCR field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pTransContrRef>: (output) TCN field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pNativeScanRes>: (output) NSR field; -1 means no valid value or field not found
//	<pNominalTxRes>: (output) NTR field; -1 means no valid value or field not found
//	<pDomainName>: (output) DNM item in DOM field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pDomainVersion>: (output) DNV item in DOM field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<Gmt>: (output) GMT field; all its items to 0 means no valid value or field not 
//		found
//	<pCharEncIndex>: (output) CSI item of DCS field; -1 means no valid value or field not found
//	<pCharEncName>: (output) CSN item in DCS field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pCharEncVersion>: (output) CSV item in DCS field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pAps>: (output) APS field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it. If
//		valid, an array of <pApsNum> GB_AN2011_ApplicationProfileStruct structures will
//		be allocated and filled
//	<pApsNum>: (output) Number of GB_AN2011_ApplicationProfileStruct structures in <pAps>
//		array; 0 means no valid value or field not found
//	<pDestAgName>: (output) DAN item in ANM field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pOrigAgName>: (output) OAN item in ANM field; NULL means no valid value or field not
//		found. Since the memory for storing this parameter is created inside this
//		function, use GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
///////////////////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_GetType1RecordInfo(
	RECORD					*record,
	int						*pVersion,
	GB_AN_ENGINE_String		*pTypeOfTransaction,
	GB_AN2011_DateStruct	*Dat,
	int						*pPriority,
	GB_AN_ENGINE_String		*pDestAgency,
	GB_AN_ENGINE_String		*pOrigAgency,
	GB_AN_ENGINE_String		*pTransContrNum,
	GB_AN_ENGINE_String		*pTransContrRef,
	float					*pNativeScanRes,
	float					*pNominalTxRes,
	GB_AN_ENGINE_String		*pDomainName,
	GB_AN_ENGINE_String		*pDomainVersion,
	GB_AN2011_GmtStruct		*Gmt,
	int						*pCharEncIndex,
	GB_AN_ENGINE_String		*pCharEncName,
	GB_AN_ENGINE_String		*pCharEncVersion,
	GB_AN2011_ApplicationProfileStruct	**pAps,
	int						*pApsNum,
	GB_AN_ENGINE_String		*pDestAgName,
	GB_AN_ENGINE_String		*pOrigAgName
);


//----------------------------------------------------------------------//
//		SECTION 4: TYPE-4
//----------------------------------------------------------------------//
////////////////////////////////////////////////////////////////////////
// GB_AN2011_CreateType4Record
//
// Description:
//	Creates a type-4 binary record
//
// Parameters:
//	<pRecord>: (output) pointer to the record created by this function.
//		Use GB_AN_ENGINE_Free(...) to deallocate memory for this record.
//		Valid only if AN2K_DLL_NO_ERROR is returned. Cannot be NULL
//	<idc>: (input) Idc of the record to be created. If > 99 an error
//		is returned, if < 0 it's automatically set to 0
//	<impressionType>: (input) IMP field; values allowed:
//		0 <= impressionType <= 3 or
//		impressionType = 8 or 
//		20 <= impressionType <= 29;
//		See Table 7
//	<fgp>: (input) FGP field; just one value can be entered; values allowed:
//		0 <= fgp <= 15 or
//		fgp = 255
//		See Table 8
//	<imageScanResolution>: (input) ISR field; can be 0 (appendix F) or
//		1 (resolution value declared in NSR field of type-1 record
//		in the same transaction)
//	<horizontalNumberOfPixels>: (input) HLL field; can assume values in
//		the [10-65535] range
//	<verticalNumberOfPixels>: (input) VLL field; can assume values in
//		the [10-65535] range
//	<compressionAlgorithm>: (input) CGA field;  values allowed:
//		0 <= compressionAlgorithm <= 1 or
//		2 <= compressionAlgorithm <= 3 (allowed but not encorauged)
//		See Table 15
//	<imageBuffer>: (input) DATA field; it is the image to be stored
//		into the record. Cannot be NULL
//	<imageBufferLen>: (input) length in bytes of <imageBuffer> image.
//		Cannot be <= 0
////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_CreateType4Record(
	RECORD **pRecord,
	int idc,
	int impressionType,
	unsigned char fgp,
	int imageScanResolution,
	int horizontalNumberOfPixels,
	int verticalNumberOfPixels,
	int compressionAlgorithm,
	unsigned char *imageBuffer,
	int imageBufferLen
);

////////////////////////////////////////////////////////////////////////
// GB_AN2011_GetType4RecordInfo
//
// Description:
//	Reads information from a type-4 binary record. Validity and 
//	compliance of the retrieved data are up to the application, since some
//	values could be outside standard in order to fit application needs.
//
//	NOTE: Set to NULL the parameters whose value is not needed to be known
//
//	NOTE2: if a parameter is != NULL and corresponding field is not
//		found, AN2K_DLL_BAD_PARAMETER error is returned
//
// Parameters:
//	<recordToRead>: (input) pointer to the record to be read.
//		Cannot be NULL
//	<pIdc>: (output) Idc of the record to be read
//	<pImpressionType>: (output) IMP field
//	<fgp>: (output) FGP field; for ANSI/NIST ITL-2011 compliance, it's
//		just a byte
//	<pImageScanResolution>: (output) ISR field
//	<pHorizontalNumberOfPixels>: (output) HLL field
//	<pVerticalNumberOfPixels>: (output) VLL field
//	<pCompressionAlgorithm>: (output) CGA field
//	<pImageBuffer>: (output) DATA field; it's created inside the function,
//		therefore it's to be freed with GB_AN_ENGINE_FreeGenericMem(...)
//	<pImageBufferLen>: (output) length in bytes of <pImageBuffer> image.
//		It could be different from 
//		*pHorizontalNumberOfPixels x *pVerticalNumberOfPixels
////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_GetType4RecordInfo(
	RECORD *recordToRead,
	int *pIdc,
	int *pImpressionType,
	unsigned char *fgp,
	int *pImageScanResolution,
	int *pHorizontalNumberOfPixels,
	int *pVerticalNumberOfPixels,
	int *pCompressionAlgorithm,
	unsigned char **pImageBuffer,
	int *pImageBufferLen
);

//----------------------------------------------------------------------//
//		SECTION 5: TYPE-14
//----------------------------------------------------------------------//
typedef struct GB_AN2011_PRINT_POSITION_DESC_TAG
{
	/*****************************************
	** Can assume values in the ranges:
	** [1-10], 16, 17
	** See Table 8
	*****************************************/
	int DecimalFingerPosition;
	/*****************************************
	** Can assume the following values in
	** table 9:
	** EJI, TIP, FV1, ..., FV4, PRX, DST, MED
	*****************************************/
	char FingerImageCode[10];
}GB_AN2011_PrintPositionDescriptorsStruct;

typedef struct GB_AN2011_PRINT_POSITION_COORDINATES_TAG
{
	/*****************************************
	** Can assume the following values in
	** table 9:
	** NA (if LocationOfASegment != NA),
	** TIP, FV1, ..., FV4
	*****************************************/
	char FullFingerView[10];
	/*****************************************
	** Can assume the following values in
	** table 9:
	** NA (if FullFingerView != NA),
	** PRX, DST, MED
	*****************************************/
	char LocationOfASegment[10];
	/*****************************************
	** Can assume values in the ranges:
	** [0-HLL]
	*****************************************/
	int LeftHorizontalCoordinate;
	/*****************************************
	** Can assume values in the ranges:
	** [LeftHorizontalCoordinate-HLL]
	*****************************************/
	int RightHorizontalCoordinate;
	/*****************************************
	** Can assume values in the ranges:
	** [0-VLL]
	*****************************************/
	int TopVerticalCoordinate;
	/*****************************************
	** Can assume values in the ranges:
	** [TopVerticalCoordinate-VLL]
	*****************************************/
	int BottomVerticalCoordinate;
}GB_AN2011_PrintPositionCoordinatesStruct;

typedef struct GB_AN2011_AMP_TAG
{
	/*****************************************
	** Can assume values in the ranges:
	** [1-10], 16, 17 (for type-14 record)
	** [21-38], [81-84] (for type-15 record)
	** See Table 8
	*****************************************/
	int FrictionRidgePosition;
	/*****************************************
	** Can assume the following values:
	** "XX" or "UP"
	*****************************************/
	char AmpBandCode[10];
}GB_AN2011_AmputatedBandagedCodeStruct;

typedef struct GB_AN2011_SEG_TAG
{
	/*****************************************
	** Can assume values in the ranges:
	** [1-10], 16, 17
	** See Table 8
	*****************************************/
	int FrictionRidgePosition;
	/*****************************************
	** Can assume values in the ranges:
	** [0-HLL]
	*****************************************/
	int LeftHorizontalCoordinate;
	/*****************************************
	** Can assume values in the ranges:
	** [LeftHorizontalCoordinate-HLL]
	*****************************************/
	int RightHorizontalCoordinate;
	/*****************************************
	** Can assume values in the ranges:
	** [0-VLL]
	*****************************************/
	int TopVerticalCoordinate;
	/*****************************************
	** Can assume values in the ranges:
	** [TopVerticalCoordinate-VLL]
	*****************************************/
	int BottomVerticalCoordinate;
}GB_AN2011_FingerSegmentPositionStruct;

typedef struct GB_AN2011_NQM_TAG
{
	/*****************************************
	** Can assume values in the ranges:
	** [1-10], 16, 17
	** See Table 8
	*****************************************/
	int FrictionRidgePosition;
	/*****************************************
	** Can assume values in the ranges:
	** [1-5], 254 (No Score), 255 (Failed
	** attempt)
	*****************************************/
	int Quality;
}GB_AN2011_NistQualityMetricStruct;

typedef struct GB_AN2011_FSQM_TAG
{
	/*****************************************
	** Can assume values in the ranges:
	** [1-10], 16, 17 (for type-14 record)
	** [21-38], [81-84] (for type-15 record)
	** See Table 8
	*****************************************/
	int FrictionRidgePosition;
	/*****************************************
	** Can assume values in the ranges:
	** [0-100], 254 (No Score), 255 (Failed
	** attempt)
	*****************************************/
	int QualityValue;
	/*****************************************
	** Can assume values in the ranges:
	** [0x0000-0xFFFF]
	*****************************************/
	int AlgorithmVendorId;
	/*****************************************
	** Can assume values in the ranges:
	** [0x0000-0xFFFF]
	*****************************************/
	int AlgorithmProductId;
}GB_AN2011_FingerOrSegmentQualityMetricStruct;

typedef struct GB_AN2011_POINT_OFFSET_TAG
{
	/*****************************************
	** Can assume values in the ranges:
	** [0-HLL]
	*****************************************/
	int HorizontalPointOffset;
	/*****************************************
	** Can assume values in the ranges:
	** [0-VLL]
	*****************************************/
	int VerticalPointOffset;
}GB_AN2011_PointOffsetStruct;

typedef struct GB_AN2011_ALTERNATE_SEG_POSITION_TAG
{
	/*****************************************
	** Can assume values in the ranges:
	** [1-10], 16, 17
	** See Table 8
	*****************************************/
	int FrictionRidgePosition;
	/*****************************************
	** Can assume values in the ranges:
	** [3-99]
	*****************************************/
	int NumberOfPoints;
	/*****************************************
	** Array of GB_AN2011_PointOffsetStruct
	** structures, representing a polygon.
	** The number of structures is 
	** <NumberOfPoints>
	*****************************************/
	GB_AN2011_PointOffsetStruct * Points;
}GB_AN2011_AlternateSegmentPositionStruct;
#pragma pack(pop)
////////////////////////////////////////////////////////////////////////
// GB_AN2011_CreateType14Record
//
// Description:
//	Creates a type-14 tagged record
//
// Parameters:
//	<pRecord>: (output) pointer to the record created by this function.
//		Use GB_AN_ENGINE_Free(...) to deallocate memory for this record.
//		Valid only if AN2K_DLL_NO_ERROR is returned. Cannot be NULL
//	<idc>: (input) Idc of the record to be created. If > 99 an error
//		is returned, if < 0 it's automatically set to 0
//	<impressionType>: (input) IMP field; values allowed:
//		0 <= impressionType <= 3 or
//		impressionType = 8 or 
//		20 <= impressionType <= 29;
//		See Table 7
//		MANDATORY: Cannot be NULL
//	<sourceAgency>: (input) SRC field; its character type is left free:
//		this means that it could be an ASCII or UTF-x (as defined in
//		Table 4). Anyway the developer must copy here the buffer of
//		bytes in the user-defined string followed by the '\0'
//		terminating character. In general, depending on the type of
//		character encoding:
//
//		ASCII or UTF-8: copy the string as it is and set the last byte
//			as '\0'
//		OTHER CHARACTER ENCODING: the string should be transformed in
//			ASCII by using the base-64 encoding, preceeded by a <STX>
//			(0x02) and a '=' and terminated by a <ETX> (0x03)
//
//		MANDATORY: Cannot be NULL
//	<fingerprintCaptureDate>: (input) FCD field;
//		MANDATORY: Cannot be NULL
//	<horizontalNumberOfPixels>: (input) HLL field; can assume values in
//		the [10-99999] range;
//		MANDATORY
//	<verticalNumberOfPixels>: (input) VLL field; can assume values in
//		the [10-99999] range;
//		MANDATORY
//	<scaleUnits>: (input) SCL field; can assume values in
//		the [0-2] range (0 = unknown; 1 = pixel/Inch; 2= Pixel/cm);
//		MANDATORY
//	<transmittedHorizontalPixelScale>: (input) THPS field; if SCL == 0
//		it should be 500 or 1000; otherwise values in [0-99999] range
//		MANDATORY
//	<transmittedVerticalPixelScale>: (input) TVPS field; if SCL == 0
//		it should be 500 or 1000; otherwise values in [0-99999] range
//		MANDATORY
//	<compressionAlgorithm>: (input) CGA field; can assume values in
//		table 15
//	<bitsPerPixel>: (input) BPX field; can assume values in
//		[0-99] range; 8 identifies a grayscale image
//		MANDATORY
//	<fingerprintPosition>: (input) FGP field;
//		0 <= fingerprintPosition <= 19 or
//		fingerprintPosition = 33 or
//		fingerprintPosition = 36 or
//		40 <= fingerprintPosition <= 50 or
//		fingerprintPosition = 255
//		See Table 8		
//		MANDATORY
//	<ppd>: (input) PPD field (just 1 structure); see struct description
//		for values
//		MANDATORY if <fingerprintPosition> == 19
//	<ppc>: (input) PPC field (it consists of an array containing 
//		<ppcNum> structures); see struct description for values
//		OPTIONAL, it will be considered only if 
//			<fingerprintPosition> == 19; NULL for avoiding insertion
//	<ppcNum>: (input) number of structures in the <ppc> array; it will
//		be considered only if <ppc> != NULL and <ppcNum> will be ranging
//		in the interval	[1-12]
//	<scannedHorizontalPixelScale>: (input) SHPS field; values in 
//		[0-99999] range
//		OPTIONAL, -1 for avoiding insertion
//	<scannedVerticalPixelScale>: (input) SVPS field; values in 
//		[0-99999] range
//		OPTIONAL, -1 for avoiding insertion
//	<amp>: (input) AMP field (it consists of an array containing 
//		<ampNum> structures); see struct description for values
//		OPTIONAL, NULL for avoiding insertion
//	<ampNum>: (input) number of structures in the <amp> array; it will
//		be considered only if <amp> != NULL and <ampNum> will be ranging
//		in the interval	[1-5]
//	<comment>: (input) COM field; its character type is left free:
//		this means that it could be an ASCII or UTF-x (as defined in
//		Table 4). Anyway the developer must copy here the buffer of
//		bytes in the user-defined string followed by the '\0'
//		terminating character. In general, depending on the type of
//		character encoding:
//
//		ASCII or UTF-8: copy the string as it is and set the last byte
//			as '\0'
//		OTHER CHARACTER ENCODING: the string should be transformed in
//			ASCII by using the base-64 encoding, preceeded by a <STX>
//			(0x02) and a '=' and terminated by a <ETX> (0x03)
//
//		OPTIONAL, NULL for avoiding insertion
//	<seg>: (input) SEG field (it consists of an array containing 
//		<segNum> structures); see struct description for values
//		MANDATORY if <fingerprintPosition> ranges in [13-15] or [40-50]
//		intervals, otherwise it will not be stored
//	<segNum>: (input) number of structures in the <seg> array; it will
//		be considered only if <seg> != NULL and <segNum> will be ranging
//		in the interval	[1-5]
//	<nqm>: (input) NQM field (it consists of an array containing 
//		<nqmNum> structures); see struct description for values
//		OPTIONAL, NULL for avoiding insertion
//	<nqmNum>: (input) number of structures in the <nqm> array; it will
//		be considered only if <nqm> != NULL and <nqmNum> will be ranging
//		in the interval	[1-5]
//	<sqm>: (input) SQM field (it consists of an array containing 
//		<sqmNum> structures); see struct description for values
//		OPTIONAL, NULL for avoiding insertion
//	<sqmNum>: (input) number of structures in the <sqm> array; it will
//		be considered only if <sqm> != NULL and <sqmNum> will be ranging
//		in the interval	[1-5]
//	<fqm>: (input) FQM field (it consists of an array containing 
//		<fqmNum> structures); see struct description for values
//		OPTIONAL, NULL for avoiding insertion
//	<fqmNum>: (input) number of structures in the <fqm> array; it will
//		be considered only if <fqm> != NULL and <fqmNum> will be ranging
//		in the interval	[1-5]
//	<aseg>: (input) ASEG field (it consists of an array containing 
//		<asegNum> structures); see struct description for values
//		OPTIONAL, NULL for avoiding insertion
//	<asegNum>: (input) number of structures in the <aseg> array; it will
//		be considered only if <aseg> != NULL and <asegNum> will be ranging
//		in the interval	[1-5]
//	<simultaneousCaptureFingerprint>: (input) SCF field; values in 
//		[1-255] range
//		OPTIONAL, -1 for avoiding insertion
//	<stitchedImageFlag>: (input) SIF field (will be considered only if
//		! FALSE)
//		OPTIONAL, FALSE for avoiding insertion
//	<deviceMonitoringMode>: (input) DMM field; values in 
//		table 5
//		OPTIONAL, NULL for avoiding insertion
//	<fingerprintAcquisitionProfile>: (input) FAP field; values in 
//		table 12
//		OPTIONAL, -1 for avoiding insertion
//	<imageBuffer>: (input) DATA field; it is the image to be stored
//		into the record. 
//		MANDATORY, cannot be NULL
//	<imageBufferLen>: (input) length in bytes of <imageBuffer> image.
//		Cannot be <= 0
////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_CreateType14Record(
	RECORD **pRecord,
	int idc,
	int impressionType,
	GB_AN_ENGINE_String sourceAgency,
	GB_AN2011_DateStruct *fingerprintCaptureDate,
	int horizontalNumberOfPixels,
	int verticalNumberOfPixels,
	int scaleUnits,
	int transmittedHorizontalPixelScale,
	int transmittedVerticalPixelScale,
	int compressionAlgorithm,
	int bitsPerPixel,
	int fingerprintPosition,
	GB_AN2011_PrintPositionDescriptorsStruct *ppd,
	GB_AN2011_PrintPositionCoordinatesStruct *ppc, int ppcNum,
	int scannedHorizontalPixelScale,
	int scannedVerticalPixelScale,
	GB_AN2011_AmputatedBandagedCodeStruct *amp, int ampNum,
	GB_AN_ENGINE_String comment,
	GB_AN2011_FingerSegmentPositionStruct *seg, int segNum,
	GB_AN2011_NistQualityMetricStruct *nqm, int nqmNum,
	GB_AN2011_FingerOrSegmentQualityMetricStruct *sqm, int sqmNum,
	GB_AN2011_FingerOrSegmentQualityMetricStruct *fqm, int fqmNum,
	GB_AN2011_AlternateSegmentPositionStruct *aseg, int asegNum,
	int simultaneousCaptureFingerprint,
	BOOL stitchedImageFlag,
	GB_AN_ENGINE_String deviceMonitoringMode,
	int fingerprintAcquisitionProfile,
	unsigned char *imageBuffer, int imageBufferLen
);

////////////////////////////////////////////////////////////////////////
// GB_AN2011_GetType14RecordInfo
//
// Description
//	Retrieves type-14 record information. Validity and compliance of 
//	the retrieved data are up to the application, since some
//	values could be outside standard in order to fit application needs.
//
//	NOTE: Set to NULL the parameters whose value is not needed to be known
//
// Parameters:
//	<recordToRead>: (input) pointer to the record to be read.
//		Cannot be NULL
//	<pIdc>: (output) IDC field; -1 means no valid value or field not
//		found
//	<pImpressionType>: (output) IMP field; -1 means no valid value or 
//		field not found
//	<pSourceAgency>: (output) SRC field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<palmprintCaptureDate>: (output) PCD field; all its items to 0 
//		means no valid value or field not found
//	<pHorizontalNumberOfPixels>: (output) HLL field; -1 means no valid 
//		value or field not found
//	<pVerticalNumberOfPixels>: (output) VLL field; -1 means no valid 
//		value or field not found
//	<pScaleUnits>: (output) SCL field; -1 means no valid value or 
//		field not found
//	<pTransmittedHorizontalPixelScale>: (output) THPS field; -1 means
//		no valid value or field not found
//	<pTransmittedVerticalPixelScale>: (output) TVPS field; -1 means
//		no valid value or field not found
//	<pCompressionAlgorithm>: (output) CGA field; -1 means no valid 
//		value or field not found
//	<pBitsPerPixel>: (input) BPX field; -1 means no valid 
//		value or field not found
//	<pFingerprintPosition>: (input) FGP field; -1 means no valid 
//		value or field not found
//	<ppd>: (input) PPD field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pPpc>: (input) PPC field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pPpcNum>: (input) number of structures pointed by <pPpc>; -1 means
//		no valid value or field not found
//	<pScannedHorizontalPixelScale>: (input) SHPS field; -1 means
//		no valid value or field not found
//	<pScannedVerticalPixelScale>: (input) SVPS field; -1 means
//		no valid value or field not found
//	<pAmp>: (input) AMP field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pAmpNum>: (input) number of structures pointed by <pAmp>; -1 means
//		no valid value or field not found
//	<pComment>: (input) COM field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pSeg>: (input) SEG field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pSegNum>: (input) number of structures pointed by <pSeg>; -1 means
//		no valid value or field not found
//	<pNqm>: (input) NQM field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pNqmNum>: (input) number of structures pointed by <pNqm>; -1 means
//		no valid value or field not found
//	<pSqm>: (input) SQM field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pNqmNum>: (input) number of structures pointed by <pSqm>; -1 means
//		no valid value or field not found
//	<pFqm>: (input) SQM field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pFqmNum>: (input) number of structures pointed by <pFqm>; -1 means
//		no valid value or field not found
//	<pAseg>: (input) SQM field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN2011_FreeAsegArray(...) function to deallocate it
//	<pAsegNum>: (input) number of structures pointed by <pAseg>; -1 means
//		no valid value or field not found
//	<pSimultaneousCaptureFingerprint>: (input) SCF field; -1 means
//		no valid value or field not found
//	<pStitchedImageFlag>: (input) SIF field; FALSE means
//		no valid value or field not found
//	<pDeviceMonitoringMode>: (input) DMM field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pFingerprintAcquisitionProfile>: (input) FAP field; -1 means
//		no valid value or field not found
//	<pImageBuffer>: (input) DATA field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pImageBufferLen>: (input) length in bytes of <imageBuffer> image.
//		-1 means no valid value or field not found
////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_GetType14RecordInfo(
	RECORD *recordToRead,
	int *pIdc,
	int *pImpressionType,
	GB_AN_ENGINE_String *pSourceAgency,
	GB_AN2011_DateStruct *fingerprintCaptureDate,
	int *pHorizontalNumberOfPixels,
	int *pVerticalNumberOfPixels,
	int *pScaleUnits,
	int *pTransmittedHorizontalPixelScale,
	int *pTransmittedVerticalPixelScale,
	int *pCompressionAlgorithm,
	int *pBitsPerPixel,
	int *pFingerprintPosition,
	GB_AN2011_PrintPositionDescriptorsStruct *ppd,
	GB_AN2011_PrintPositionCoordinatesStruct **pPpc, int *pPpcNum,
	int *pScannedHorizontalPixelScale,
	int *pScannedVerticalPixelScale,
	GB_AN2011_AmputatedBandagedCodeStruct **pAmp, int *pAmpNum,
	GB_AN_ENGINE_String *pComment,
	GB_AN2011_FingerSegmentPositionStruct **pSeg, int *pSegNum,
	GB_AN2011_NistQualityMetricStruct **pNqm, int *pNqmNum,
	GB_AN2011_FingerOrSegmentQualityMetricStruct **pSqm, int *pSqmNum,
	GB_AN2011_FingerOrSegmentQualityMetricStruct **pFqm, int *pFqmNum,
	GB_AN2011_AlternateSegmentPositionStruct **pAseg, int *pAsegNum,
	int *pSimultaneousCaptureFingerprint,
	BOOL *pStitchedImageFlag,
	GB_AN_ENGINE_String *pDeviceMonitoringMode,
	int *pFingerprintAcquisitionProfile,
	unsigned char **pImageBuffer, int *pImageBufferLen
);

////////////////////////////////////////////////////////////////////////
// GB_AN2011_FreeAsegArray
//
// Description:
//	Frees GB_AN2011_AlternateSegmentPositionStruct arrays allocated by this dll
//
// NOTE1: do not use GB_AN2011_FreeAsegArray for memory allocated
//	outside this dll
//
// Parameters:
//	<asegArray>: (input) array to be freed.
//	<asegNum>: (input) number of GB_AN2011_AlternateSegmentPositionStruct
//		structures contained into <asegArray>.
////////////////////////////////////////////////////////////////////////
DllExport_an2k void GB_AN2011_FreeAsegArray (GB_AN2011_AlternateSegmentPositionStruct * asegArray, int asegNum);

////////////////////////////////////////////////////////////////////////
// GB_AN2011_CreateType15Record
//
// Description:
//	Creates a type-15 tagged record
//
// Parameters:
//	<pRecord>: (output) pointer to the record created by this function.
//		Use GB_AN_ENGINE_Free(...) to deallocate memory for this record.
//		Valid only if AN2K_DLL_NO_ERROR is returned. Cannot be NULL
//	<idc>: (input) Idc of the record to be created. If > 99 an error
//		is returned, if < 0 it's automatically set to 0
//	<impressionType>: (input) IMP field; values allowed:
//		10 <= impressionType <= 11 or
//		20 <= impressionType <= 29;
//		See Table 7
//	<sourceAgency>: (input) SRC field; its character type is left free:
//		this means that it could be an ASCII or UTF-x (as defined in
//		Table 4). Anyway the developer must copy here the buffer of
//		bytes in the user-defined string followed by the '\0'
//		terminating character. In general, depending on the type of
//		character encoding:
//
//		ASCII or UTF-8: copy the string as it is and set the last byte
//			as '\0'
//		OTHER CHARACTER ENCODING: the string should be transformed in
//			ASCII by using the base-64 encoding, preceeded by a <STX>
//			(0x02) and a '=' and terminated by a <ETX> (0x03)
//
//		MANDATORY: Cannot be NULL
//	<palmprintCaptureDate>: (input) PCD field;
//		MANDATORY: Cannot be NULL
//	<horizontalNumberOfPixels>: (input) HLL field; can assume values in
//		the [10-99999] range;
//		MANDATORY
//	<verticalNumberOfPixels>: (input) VLL field; can assume values in
//		the [10-99999] range;
//		MANDATORY
//	<scaleUnits>: (input) SCL field; can assume values in
//		the [0-2] range (0 = unknown; 1 = pixel/Inch; 2= Pixel/cm);
//		MANDATORY
//	<transmittedHorizontalPixelScale>: (input) THPS field; if SCL == 0
//		it should be 500 or 1000; otherwise values in [0-99999] range
//		MANDATORY
//	<transmittedVerticalPixelScale>: (input) TVPS field; if SCL == 0
//		it should be 500 or 1000; otherwise values in [0-99999] range
//		MANDATORY
//	<compressionAlgorithm>: (input) CGA field; can assume values in
//		table 15
//	<bitsPerPixel>: (input) BPX field; can assume values in
//		[0-99] range; 8 identifies a grayscale image
//		MANDATORY
//	<fingerprintPosition>: (input) FGP field;
//		20 <= FGP <= 38 or 81 <= FGP <= 84
//		See Table 8		
//		MANDATORY
//	<scannedHorizontalPixelScale>: (input) SHPS field; values in 
//		[0-99999] range
//		OPTIONAL, -1 for avoiding insertion
//	<scannedVerticalPixelScale>: (input) SVPS field; values in 
//		[0-99999] range
//		OPTIONAL, -1 for avoiding insertion
//	<amp>: (input) AMP field (it consists of an array containing 
//		<ampNum> structures); see struct description for values
//		OPTIONAL, NULL for avoiding insertion
//	<ampNum>: (input) number of structures in the <amp> array; it will
//		be considered only if <amp> != NULL and <ampNum> will be ranging
//		in the interval	[1-5]
//	<comment>: (input) COM field; its character type is left free:
//		this means that it could be an ASCII or UTF-x (as defined in
//		Table 4). Anyway the developer must copy here the buffer of
//		bytes in the user-defined string followed by the '\0'
//		terminating character. In general, depending on the type of
//		character encoding:
//
//		ASCII or UTF-8: copy the string as it is and set the last byte
//			as '\0'
//		OTHER CHARACTER ENCODING: the string should be transformed in
//			ASCII by using the base-64 encoding, preceeded by a <STX>
//			(0x02) and a '=' and terminated by a <ETX> (0x03)
//
//		OPTIONAL, NULL for avoiding insertion
//	<pqm>: (input) PQM field (it consists of an array containing 
//		<pqmNum> structures); see struct description for values
//		OPTIONAL, NULL for avoiding insertion
//	<pqmNum>: (input) number of structures in the <pqm> array; it will
//		be considered only if <pqm> != NULL and <pqmNum> will be ranging
//		in the interval	[1-9]
//	<deviceMonitoringMode>: (input) DMM field; values in 
//		table 5
//		OPTIONAL, NULL for avoiding insertion
//	<imageBuffer>: (input) DATA field; it is the image to be stored
//		into the record. 
//		MANDATORY, cannot be NULL
//	<imageBufferLen>: (input) length in bytes of <imageBuffer> image.
//		Cannot be <= 0
////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_CreateType15Record(
	RECORD **pRecord,
	int idc,
	int impressionType,
	GB_AN_ENGINE_String sourceAgency,
	GB_AN2011_DateStruct *palmprintCaptureDate,
	int horizontalNumberOfPixels,
	int verticalNumberOfPixels,
	int scaleUnits,
	int transmittedHorizontalPixelScale,
	int transmittedVerticalPixelScale,
	int compressionAlgorithm,
	int bitsPerPixel,
	int fingerprintPosition,
	int scannedHorizontalPixelScale,
	int scannedVerticalPixelScale,
	GB_AN2011_AmputatedBandagedCodeStruct *amp, int ampNum,
	GB_AN_ENGINE_String comment,
	GB_AN2011_FingerOrSegmentQualityMetricStruct *pqm, int pqmNum,
	GB_AN_ENGINE_String deviceMonitoringMode,
	unsigned char *imageBuffer, int imageBufferLen
);

////////////////////////////////////////////////////////////////////////
// GB_AN2011_GetType15RecordInfo
//
// Description
//	Retrieves type-15 record information. Validity and compliance of 
//	the retrieved data are up to the application, since some
//	values could be outside standard in order to fit application needs.
//
//	NOTE: Set to NULL the parameters whose value is not needed to be known
//
// Parameters:
//	<recordToRead>: (input) pointer to the record to be read.
//		Cannot be NULL
//	<pIdc>: (output) IDC field; -1 means no valid value or field not
//		found
//	<pImpressionType>: (output) IMP field; -1 means no valid value or 
//		field not found
//	<pSourceAgency>: (output) SRC field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<palmprintCaptureDate>: (output) PCD field; all its items to 0 
//		means no valid value or field not found
//	<pHorizontalNumberOfPixels>: (output) HLL field; -1 means no valid 
//		value or field not found
//	<pVerticalNumberOfPixels>: (output) VLL field; -1 means no valid 
//		value or field not found
//	<pScaleUnits>: (output) SCL field; -1 means no valid value or 
//		field not found
//	<pTransmittedHorizontalPixelScale>: (output) THPS field; -1 means
//		no valid value or field not found
//	<pTransmittedVerticalPixelScale>: (output) TVPS field; -1 means
//		no valid value or field not found
//	<pCompressionAlgorithm>: (output) CGA field; -1 means no valid 
//		value or field not found
//	<pBitsPerPixel>: (input) BPX field; -1 means no valid 
//		value or field not found
//	<pFingerprintPosition>: (input) FGP field; -1 means no valid 
//		value or field not found
//	<pScannedHorizontalPixelScale>: (input) SHPS field; -1 means
//		no valid value or field not found
//	<pScannedVerticalPixelScale>: (input) SVPS field; -1 means
//		no valid value or field not found
//	<pAmp>: (input) AMP field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pAmpNum>: (input) number of structures pointed by <pAmp>; -1 means
//		no valid value or field not found
//	<pComment>: (input) COM field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pPqm>: (input) PQM field;  NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pPqmNum>: (input) number of structures pointed by <pPqm>; -1 means
//		no valid value or field not found
//	<pDeviceMonitoringMode>: (input) DMM field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pImageBuffer>: (input) DATA field; NULL means no valid value or 
//		field not found. Since the memory for storing this parameter 
//		is created inside this function, use 
//		GB_AN_ENGINE_FreeGenericMem(...) function to deallocate it
//	<pImageBufferLen>: (input) length in bytes of <imageBuffer> image.
//		-1 means no valid value or field not found
////////////////////////////////////////////////////////////////////////
DllExport_an2k int GB_AN2011_GetType15RecordInfo(
	RECORD *recordToRead,
	int *pIdc,
	int *pImpressionType,
	GB_AN_ENGINE_String *pSourceAgency,
	GB_AN2011_DateStruct *fingerprintCaptureDate,
	int *pHorizontalNumberOfPixels,
	int *pVerticalNumberOfPixels,
	int *pScaleUnits,
	int *pTransmittedHorizontalPixelScale,
	int *pTransmittedVerticalPixelScale,
	int *pCompressionAlgorithm,
	int *pBitsPerPixel,
	int *pFingerprintPosition,
	int *pScannedHorizontalPixelScale,
	int *pScannedVerticalPixelScale,
	GB_AN2011_AmputatedBandagedCodeStruct **pAmp, int *pAmpNum,
	GB_AN_ENGINE_String *pComment,
	GB_AN2011_FingerOrSegmentQualityMetricStruct **pPqm, int *pPqmNum,
	GB_AN_ENGINE_String *pDeviceMonitoringMode,
	unsigned char **pImageBuffer, int *pImageBufferLen
);
#endif //GB_AN2011_h
