// DSBeep.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "DSBeep.h"
#include "DSBeeper.h"
#include "GB_WinVer.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif

bool InitCalled = false;
bool IsBeepSupported = true;
bool ForceDirectSound = false;
DSBeeper *beeper = NULL;
DWORD CoInitValue = COINIT_APARTMENTTHREADED;

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		//beeper = new DSBeeper;	// non si puo' chiamare CoInitializeEx nel DllMain....
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		if (beeper)
		{
			delete beeper;
			beeper = NULL;
		}
		break;
	}
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

extern BOOL IsWow64();

DSBEEP_API bool __stdcall DSInit(unsigned int CoInit, bool ForceDS)
{
	//if (InitCalled)
	if (beeper != NULL)
		return true;

	InitCalled = true;

	ForceDirectSound = ForceDS;

	// determine if Beep is supported
	OSVERSIONINFOEX osvi;

    ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

    if (GetVersionEx((OSVERSIONINFO *)(&(osvi))))
	{
		if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
		{
			// if x64 or WinVer>=Win7 => Beep not supported
			if (((osvi.dwMajorVersion >= 6) && (osvi.dwMinorVersion >= 1))
				|| IsWow64())
				IsBeepSupported = false;
		}
	}

	if (!IsBeepSupported || ForceDirectSound)
	{
		CoInitValue = CoInit;

		if (beeper == NULL)
			beeper = new DSBeeper(CoInitValue);
	}

	return true;
}


DSBEEP_API bool __stdcall DSBeep(int Frequency, int Duration)
{
	// if Init not called, init by default with COINIT_APARTMENTTHREADED
	if (!InitCalled)
		DSInit(COINIT_APARTMENTTHREADED, false);

	if (!IsBeepSupported || ForceDirectSound)
		return beeper->Beep(Frequency, Duration);
	else
		return Beep(Frequency, Duration);
}

DSBEEP_API void __stdcall DSDeInit()
{
	delete beeper;
	beeper = NULL;
}