/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GBAN2K_2011_LibraryFunctions;

import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.ptr.FloatByReference;

import GBAN2K_2011_Structures.*;

/**
 *
 * @author andrea
 */
public class GBAN2K_2011_DllWrapper {

    public interface GBAN2K_Library extends Library {

        /**
         * Inherited for loading native dll
         */
        GBAN2K_Library INSTANCE = (GBAN2K_Library) Native.loadLibrary("AN2K_LIB", GBAN2K_Library.class);

        int GB_AN2011_CreateAnsiNistStruct(
                Pointer pAnsiNist, // ANSI_NIST **
                String Tot,
                An2k2011_DateStruct Dat,
                int Pry,
                String DestAgency,
                String OrigAgency,
                String TransContrNum,
                String TransContrRef,
                float NativeScanRes,
                float NominalTxRes,
                String DomainName,
                String DomainVersion,
                An2k2011_GmtStruct Gmt,
                int CharEncIndex,
                String CharEncName,
                String CharEncVersion,
                An2k2011_ApplicationProfileStruct[] Aps,
                int ApsNum,
                String DestAgName,
                String OrigAgName
        );

        int GB_AN2011_GetType1RecordInfo(
                Pointer record, // RECORD *
                IntByReference pVersion, // IntByReference
                PointerByReference pTypeOfTransaction, // char **
                An2k2011_DateStruct Dat, // An2k2011_DateStruct *
                IntByReference pPriority, // IntByReference
                PointerByReference pDestAgency, // char **
                PointerByReference pOrigAgency, // char **
                PointerByReference pTransContrNum, // char **
                PointerByReference pTransContrRef, // char **
                FloatByReference pNativeScanRes, // float*
                FloatByReference pNominalTxRes, // float*
                PointerByReference pDomainName, // char **
                PointerByReference pDomainVersion, // char **
                An2k2011_GmtStruct Gmt, // An2k2011_GmtStruct *
                IntByReference pCharEncIndex, // IntByReference
                PointerByReference pCharEncName, // char **
                PointerByReference pCharEncVersion, // char **
                PointerByReference pAps, // An2k2011_ApplicationProfileStruct **
                IntByReference pApsNum, // IntByReference
                PointerByReference pDestAgName, // char **
                PointerByReference pOrigAgName // char **
        );

        int GB_AN2011_CreateType4Record(
                Pointer pRecord, //RECORD **
                int idc,
                int impressionType,
                byte fgp,
                int imageScanResolution,
                int horizontalNumberOfPixels,
                int verticalNumberOfPixels,
                int compressionAlgorithm,
                byte[] imageBuffer,
                int imageBufferLen
        );

        int GB_AN2011_GetType4RecordInfo(
                Pointer recordToRead, // RECORD *
                IntByReference pIdc,
                IntByReference pImpressionType,
                ByteByReference fgp,
                IntByReference pImageScanResolution,
                IntByReference pHorizontalNumberOfPixels,
                IntByReference pVerticalNumberOfPixels,
                IntByReference pCompressionAlgorithm,
                PointerByReference pImageBuffer, // unsigned char **
                IntByReference pImageBufferLen
        );

        int GB_AN2011_CreateType14Record(
                Pointer pRecord, //RECORD **
                int idc,
                int impressionType,
                String sourceAgency,
                An2k2011_DateStruct fingerprintCaptureDate,
                int horizontalNumberOfPixels,
                int verticalNumberOfPixels,
                int scaleUnits,
                int transmittedHorizontalPixelScale,
                int transmittedVerticalPixelScale,
                int compressionAlgorithm,
                int bitsPerPixel,
                int fingerprintPosition,
                An2k2011_PrintPositionDescriptorsStruct ppd,
                An2k2011_PrintPositionCoordinatesStruct[] ppc, int ppcNum,
                int scannedHorizontalPixelScale,
                int scannedVerticalPixelScale,
                An2k2011_AmputatedBandagedCodeStruct[] amp, int ampNum,
                String comment,
                An2k2011_FingerSegmentPositionStruct[] seg, int segNum,
                An2k2011_NistQualityMetricStruct[] nqm, int nqmNum,
                An2k2011_FingerOrSegmentQualityMetricStruct[] sqm, int sqmNum,
                An2k2011_FingerOrSegmentQualityMetricStruct[] fqm, int fqmNum,
                An2k2011_AlternateSegmentPositionStruct[] aseg, int asegNum,
                int simultaneousCaptureFingerprint,
                int stitchedImageFlag,
                String deviceMonitoringMode,
                int fingerprintAcquisitionProfile,
                byte[] imageBuffer,
                int imageBufferLen
        );

        int GB_AN2011_GetType14RecordInfo(
                Pointer recordToRead, // RECORD *
                IntByReference pIdc,
                IntByReference pImpressionType,
                PointerByReference pSourceAgency, // char **
                An2k2011_DateStruct fingerprintCaptureDate, // An2k2011_DateStruct *
                IntByReference pHorizontalNumberOfPixels,
                IntByReference pVerticalNumberOfPixels,
                IntByReference pScaleUnits,
                IntByReference pTransmittedHorizontalPixelScale,
                IntByReference pTransmittedVerticalPixelScale,
                IntByReference pCompressionAlgorithm,
                IntByReference pBitsPerPixel,
                IntByReference pFingerprintPosition,
                An2k2011_PrintPositionDescriptorsStruct ppd,
                PointerByReference pPpc, IntByReference pPpcNum, // GB_AN2011_PrintPositionCoordinatesStruct **
                IntByReference pScannedHorizontalPixelScale,
                IntByReference pScannedVerticalPixelScale,
                PointerByReference pAmp, IntByReference pAmpNum, // GB_AN2011_AmputatedBandagedCodeStruct **
                PointerByReference pComment, // char **
                PointerByReference pSeg, IntByReference pSegNum, // GB_AN2011_FingerSegmentPositionStruct **
                PointerByReference pNqm, IntByReference pNqmNum, // GB_AN2011_NistQualityMetricStruct **
                PointerByReference pSqm, IntByReference pSqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
                PointerByReference pFqm, IntByReference pFqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
                PointerByReference pAseg, IntByReference pAsegNum, // GB_AN2011_AlternateSegmentPositionStruct **
                IntByReference pSimultaneousCaptureFingerprint,
                IntByReference pStitchedImageFlag,
                PointerByReference pDeviceMonitoringMode, // char **
                IntByReference pFingerprintAcquisitionProfile,
                PointerByReference pImageBuffer, // unsigned char **
                IntByReference pImageBufferLen
        );
        
        void GB_AN2011_FreeAsegArray (Pointer asegArray, int asegNum);

        int GB_AN2011_CreateType15Record(
                Pointer pRecord, //RECORD **
                int idc,
                int impressionType,
                String sourceAgency,
                An2k2011_DateStruct palmprintCaptureDate,
                int horizontalNumberOfPixels,
                int verticalNumberOfPixels,
                int scaleUnits,
                int transmittedHorizontalPixelScale,
                int transmittedVerticalPixelScale,
                int compressionAlgorithm,
                int bitsPerPixel,
                int fingerprintPosition,
                int scannedHorizontalPixelScale,
                int scannedVerticalPixelScale,
                An2k2011_AmputatedBandagedCodeStruct[] amp, int ampNum,
                String comment,
                An2k2011_FingerOrSegmentQualityMetricStruct[] pqm, int pqmNum,
                String deviceMonitoringMode,
                byte[] imageBuffer,
                int imageBufferLen
        );

        int GB_AN2011_GetType15RecordInfo(
                Pointer recordToRead, // RECORD *
                IntByReference pIdc,
                IntByReference pImpressionType,
                PointerByReference pSourceAgency, // char **
                An2k2011_DateStruct fingerprintCaptureDate, // An2k2011_DateStruct *
                IntByReference pHorizontalNumberOfPixels,
                IntByReference pVerticalNumberOfPixels,
                IntByReference pScaleUnits,
                IntByReference pTransmittedHorizontalPixelScale,
                IntByReference pTransmittedVerticalPixelScale,
                IntByReference pCompressionAlgorithm,
                IntByReference pBitsPerPixel,
                IntByReference pFingerprintPosition,
                IntByReference pScannedHorizontalPixelScale,
                IntByReference pScannedVerticalPixelScale,
                PointerByReference pAmp, IntByReference pAmpNum, // GB_AN2011_AmputatedBandagedCodeStruct **
                PointerByReference pComment, // char **
                PointerByReference pPqm, IntByReference pPqmNum,
                PointerByReference pDeviceMonitoringMode, // char **
                PointerByReference pImageBuffer, // unsigned char **
                IntByReference pImageBufferLen
        );
    }
}
