/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GBAN2K_ENGINE_LibraryFunctions;

import GBAN2K_JAVA_Structures.*;
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.ptr.FloatByReference;

/**
 *
 * @author andrea
 */
public class GBAN2K_ENGINE_DllWrapper {

    public interface GBAN2K_Library extends Library {

        /**
         * Inherited for loading native dll
         */
        GBAN2K_Library INSTANCE = (GBAN2K_Library) Native.loadLibrary("AN2K_LIB", GBAN2K_Library.class);

        int GB_AN_ENGINE_CreateSubFieldFromValuesForTaggedRecords(
                PointerByReference outSubField,
                String[] valuesToInsertArray,
                int numOfValuesToInsert
        );

        int GB_AN_ENGINE_CreateEmptyFieldForTaggedRecords(
                PointerByReference outField, // FIELD **
                int recordType,
                int fieldId
        );

        int GB_AN_ENGINE_InsertSubfieldIntoFieldForTaggedRecords(
                GBAN2K_FieldStructure fieldToUpdate,
                GBAN2K_SubfieldStructure subfieldToInsert
        );

        int GB_AN_ENGINE_CreateFieldFromValuesForTaggedRecords(
                PointerByReference outField, // FIELD **
                int recordType,
                int fieldId,
                String[] valuesToInsertArray,
                int numOfValuesToInsert
        );

        int GB_AN_ENGINE_CreateImageFieldForTaggedRecord(
                PointerByReference outField, // FIELD **
                int recordType,
                byte[] imageBuffer,
                int imageBufferLen
        );

        int GB_AN_ENGINE_CreateEmptyTaggedRecord(
                PointerByReference outRecord, // RECORD **
                int recordType,
                int Idc
        );

        int GB_AN_ENGINE_InsertFieldIntoTaggedRecord(
                GBAN2K_RecordStructure recordToUpdate,
                GBAN2K_FieldStructure fieldToInsert
        );

        int GB_AN_ENGINE_CreateBinaryRecord(
                PointerByReference outRecord, // RECORD **
                int recordType,
                int idc,
                int impressionType,
                byte[] fgp, // length >= 6
                int imageScanResolution,
                int horizontalNumberOfPixels,
                int verticalNumberOfPixels,
                int compressionAlgorithm,
                byte[] imageBuffer,
                int imageBufferLen
        );

        int GB_AN_ENGINE_InsertRecordInAnsiNist(
                GBAN2K_RecordStructure RecordToBeInserted,
                GBAN2K_AnsiNistStructure ansi_nist,
                int RecordIndex,
                int AutomaticIDC
        );

        int GB_AN_ENGINE_SearchFieldInTaggedRecord(
                GBAN2K_RecordStructure recordToLookup,
                int FieldId,
                PointerByReference FoundField // FIELD **
        );

        int GB_AN_ENGINE_GetValuesFromFieldForTaggedRecords(
                GBAN2K_FieldStructure inField,
                PointerByReference pValuesToGet, // char ***, that is pointer to String []
                IntByReference pNumOfValuesToGet
        );

        int GB_AN_ENGINE_GetValuesFromSubfieldForTaggedRecords(
                GBAN2K_SubfieldStructure inSubField,
                PointerByReference pValuesToGet, // char ***, that is pointer to String []
                IntByReference pNumOfValuesToGet
        );

        int GB_AN_ENGINE_GetImageFieldFromTaggedRecord(
                GBAN2K_RecordStructure recordToRead,
                PointerByReference pImageBuffer, // unsigned char **
                IntByReference pImageBufferLen
        );

        int GB_AN_ENGINE_GetBinaryRecordInfo(
                GBAN2K_RecordStructure recordToRead,
                IntByReference pRecordType,
                IntByReference pIdc,
                IntByReference pImpressionType,
                byte[] fgp,
                IntByReference pImageScanResolution,
                IntByReference pHorizontalNumberOfPixels,
                IntByReference pVerticalNumberOfPixels,
                IntByReference pCompressionAlgorithm,
                PointerByReference pImageBuffer, // unsigned char **
                IntByReference pImageBufferLen
        );

        int GB_AN_ENGINE_DeleteFieldFromTaggedRecord(
                GBAN2K_RecordStructure recToBeUpdated,
                int fieldId
        );

        int GB_AN_ENGINE_DeleteFieldFromTaggedRecordInAnsiNist(
                GBAN2K_AnsiNistStructure anStructToBeUpdated,
                int recordIndex,
                int fieldId
        );

        void GB_AN_ENGINE_Free(
                GBAN2K_AnsiNistStructure anStructToBeFreed,
                GBAN2K_RecordStructure recordToBeFreed,
                GBAN2K_FieldStructure fieldToBeFreed,
                GBAN2K_SubfieldStructure subfieldToBeFreed,
                GBAN2K_ItemStructure itemToBeFreed
        );

        int GB_AN_ENGINE_FreeStringArray(
                Pointer ValuesToFree,
                int numOfValuesToFree
        );

        void GB_AN_ENGINE_FreeGenericMem(
                Pointer MemToFree
        );
    }

}
