/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBAN2K_JAVA_Structures;

import com.sun.jna.Structure;
import com.sun.jna.Pointer;

/**
 *
 * @author andrea
 */
public class GBAN2K_AnsiNistStructure extends Structure {

    public int version; // uint
    public int num_bytes;
    public int num_records;
    public int alloc_records;
    public Pointer records; // RECORD **

    @Override
    public Pointer getPointer() {
        this.write();
        Pointer ret = super.getPointer();
        return ret;
    }

    public GBAN2K_AnsiNistStructure() {
        super();
        setAlignType(ALIGN_NONE);
        version = 0;
        num_bytes = 0;
        num_records = 0;
        alloc_records = 0;
        records = Pointer.NULL;
    }

    /**
     *
     * @param p NB: use the free_ANSI_NIST() function on p, not on the structure
     * created with this function
     */
    public GBAN2K_AnsiNistStructure(Pointer p) {
        this();
        if (p == Pointer.NULL) {
            return;
        }
        useMemory(p);
        read();
    }
    
    public GBAN2K_RecordStructure [] GetRecordsArray()
    {
        if (records == null) return null;
        Pointer[] myp = (Pointer[])(records.getPointerArray(0,num_records));
        GBAN2K_RecordStructure[] ret = new GBAN2K_RecordStructure[num_records];
        for (int i = 0; i < num_records; i++)
        {
            ret[i] = new GBAN2K_RecordStructure(myp[i]);
        }
        return ret;
    }
}
