/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GBAN2K_JAVA_Structures;

import com.sun.jna.Structure;
import com.sun.jna.Pointer;
import static com.sun.jna.Structure.ALIGN_NONE;

/**
 *
 * @author andrea
 */
public class GBAN2K_FieldStructure extends Structure {

    public Pointer id;
    public int record_type; // UInt32
    public int field_int; // UInt32
    public int num_bytes;
    public int num_subfields;
    public int alloc_subfields;
    public Pointer subfields; // SUBFIELD **
    public int gs_char;

    @Override
    public Pointer getPointer() {
        this.write();
        Pointer ret = super.getPointer();
        return ret;
    }
    
    public GBAN2K_FieldStructure()
    {
        super();
        setAlignType(ALIGN_NONE);
        id = null;
        num_bytes = 0;
        field_int = 0;
        num_subfields = 0;
        alloc_subfields = 0;
        subfields = Pointer.NULL;
        gs_char = 0;
    }

    public GBAN2K_FieldStructure(Pointer p) {
        this();
        if (p == Pointer.NULL) {
            return;
        }
        useMemory(p);
        read();
    }
    
    public GBAN2K_SubfieldStructure [] GetSubfieldsArray()
    {
        if (subfields == null) return null;
        Pointer[] myp = (Pointer[])(subfields.getPointerArray(0,num_subfields));
        GBAN2K_SubfieldStructure[] ret = new GBAN2K_SubfieldStructure[num_subfields];
        for (int i = 0; i < num_subfields; i++)
        {
            ret[i] = new GBAN2K_SubfieldStructure(myp[i]);
        }
        return ret;
    }
    
    public String getId()
    {
        String ret = id.getString(0,false);
        return ret;
    }
}
