/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package GBAN2K_JAVA_Structures;

import com.sun.jna.Structure;
import com.sun.jna.Pointer;
import static com.sun.jna.Structure.ALIGN_NONE;

/**
 *
 * @author andrea
 */
public class GBAN2K_SubfieldStructure extends Structure {

    public int num_bytes;
    public int num_items;
    public int alloc_items;
    public Pointer items; // ITEM **
    public int rs_char;
    
    public static class ByReference extends GBAN2K_SubfieldStructure implements Structure.ByReference {}

    @Override
    public Pointer getPointer() {
        this.write();
        Pointer ret = super.getPointer();
        return ret;
    }
    
    public GBAN2K_SubfieldStructure()
    {
        super();
        setAlignType(ALIGN_NONE);
        num_bytes = 0;
        num_items = 0;
        alloc_items = 0;
        items = Pointer.NULL;
        rs_char = 0;
    }

    public GBAN2K_SubfieldStructure(Pointer p) {
        this();
        if (p == Pointer.NULL) {
            return;
        }
        useMemory(p);
        read();
    }
    
    public GBAN2K_ItemStructure [] GetItemsArray()
    {
        if (items == null) return null;
        Pointer[] myp = (Pointer[])(items.getPointerArray(0,num_items));
        GBAN2K_ItemStructure[] ret = new GBAN2K_ItemStructure[num_items];
        for (int i = 0; i < num_items; i++)
        {
            ret[i] = new GBAN2K_ItemStructure(myp[i]);
        }
        return ret;
    }
}
