/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBFINIMG_JAVA_Functions;

import GBFINIMG_JAVA_Defines.GBFINIMG_LicenseUSbScannerCheck;
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.NativeLong;
import com.sun.jna.ptr.IntByReference;
import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.ptr.PointerByReference;
import com.sun.jna.ptr.DoubleByReference;
import com.sun.jna.ptr.FloatByReference;
import com.sun.jna.ptr.ShortByReference;
import com.sun.jna.WString;
import java.nio.ByteBuffer;

import GBFINIMG_JAVA_Defines.GBFINIMG_MissingFingerDefinitions;
import GBFINIMG_JAVA_Defines.GBFINIMG_SegmentImageDescriptor;
import GBFINIMG_JAVA_Defines.GBFINIMG_SegmentImageExternalInfo;

/**
 *
 * @author andrea
 */
public class GBFINIMG_DllWrapper {

    public interface GBFinImg_Library extends Library {

        GBFinImg_Library INSTANCE
                = (GBFinImg_Library) Native.loadLibrary("GBFINIMG", GBFinImg_Library.class);

        // Ver 3.3.0.0
        /**
         *
         * @param RotationBuffer: pointer to a auxiliary buffer allocated by
         * application with size <RotationBufferSize>
         * @param RotationBufferSize specifies the size of the auxiliary buffer,
         * should be calculated as follows:
         * <RotationBufferSize>=<InputSizeX>*<InputSizeY>*
         * GBFINIMG_JAVA_Defines.GBFINIMG_MemoryBufferSize.GBFINIMG_ROTATION_BUFFER_FACTOR;
         * where <InputSizeX> and <InputSizeY> are input parameters of
         * GBFINIMG_ProcessImage() that define processed image dimensions. NOTE:
         * if <RotationBufferSize> will be insufficient to perform rotation
         * operation, function GBFINIMG_ProcessImage() will return error code
         * GBFINIMG_ERROR_NO_MEMORY
         */
        void GBFINIMG_SetRotationBuffer1000DPI(Pointer RotationBuffer, int RotationBufferSize);

//        /**
//         *
//         * @param SegmentIndex input parameter, index of fingerprint segment in
//         * <SegmentImageList> (see GBFINIMG_ProcessImage). Valid values are from
//         * 0 till (excluding) <DetectedSegmentImageNumber> (see
//         * GBFINIMG_ProcessImage). Use this parameter to obtain delta
//         * information for the required segment for both multi-finger and
//         * single-finger input image types.
//         * @param MissingDeltaNumber output parameter, returns the difference
//         * between expected and actually detected number of deltas in the
//         * specified fingerprint segment: 0 - all expected deltas are found (or
//         * impossible to detect pattern) 1 - one delta is missing 2 - two deltas
//         * are missing
//         * @param MissingDeltaMask output parameter containing bit masks that
//         * specify missing delta type(s): 0x01 - left delta (information is
//         * available only for "Whorl" pattern ) 0x02 - right delta (information
//         * is available only for "Whorl" pattern ) 0x04 - unknown delta type
//         * (information is available for other pattern types)
//         * @return
//         */
//        int GBFINIMG_GetMissingDeltaNumber(int SegmentIndex,
//                IntByReference MissingDeltaNumber,
//                IntByReference MissingDeltaMask);
//
//        /**
//         * 
//         * @param LeftTopCornerFillingPercent output parameter, [0-100]%; returns the percentage of filling of the
//         * left-top corner with good-quality fingerprint ridges.
//         * @param RightTopCornerFillingPercent output parameter, [0-100]%; returns the percentage of filling of the
//         * right-top corner with good-quality fingerprint ridges.
//         * @return 
//         */
//        int GBFINIMG_GetRolledFingerprintTopCornerFillingPercent(IntByReference LeftTopCornerFillingPercent,
//                IntByReference RightTopCornerFillingPercent
//        );
//
//        /**
//         * 
//         * @param FingerIndex 
//         * @param MedialJoint_BoundingBoxL
//         * @param MedialJoint_BoundingBoxR
//         * @param MedialJoint_BoundingBoxT
//         * @param MedialJoint_BoundingBoxB
//         * @param MedialJoint_Completeness
//         * @param ProximalJoint_BoundingBoxL
//         * @param ProximalJoint_BoundingBoxR
//         * @param ProximalJoint_BoundingBoxT
//         * @param ProximalJoint_BoundingBoxB
//         * @param ProximalJoint_Completeness
//         * @return 
//         */
//        int GBFINIMG_GetFullFingerMedialProximalJointBoundingBox(
//                int FingerIndex,
//                IntByReference MedialJoint_BoundingBoxL,
//                IntByReference MedialJoint_BoundingBoxR,
//                IntByReference MedialJoint_BoundingBoxT,
//                IntByReference MedialJoint_BoundingBoxB,
//                IntByReference MedialJoint_Completeness,
//                IntByReference ProximalJoint_BoundingBoxL,
//                IntByReference ProximalJoint_BoundingBoxR,
//                IntByReference ProximalJoint_BoundingBoxT,
//                IntByReference ProximalJoint_BoundingBoxB,
//                IntByReference ProximalJoint_Completeness);
//        
//        void GBFINIMG_GetLicenseInfo(GBFINIMG_LicenseUSbScannerCheck.ByReference ScannerBasedLicense);
        // end Ver 3.3.0.0

        /**
         *
         * @param MissingFingerMask
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_MissingFingerDefinitions
         */
        void GBFINIMG_Slap4_MissingFingers(byte MissingFingerMask);

        /**
         *
         * @param InputImage
         * @param InputSizeX
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_InputImageSizeLimits
         * @param InputSizeY
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_InputImageSizeLimits
         * @param InputImageType
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_InputImageTypes
         * @param ImageProcessingOption
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_ProcessingOptions
         * @param SegmentImageList
         * @param SegmentImageSizeX
         * @param SegmentImageSizeY
         * @param DetectedSegmentImageNumber
         * @param DetectionFailureDiagnostic
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_SegmentationDiagnostics
         * @param ExternalInfoList
         * @param ExternalInfoListSize
         * @param TempBuffer
         * @param TempBufferSize
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_MemoryBufferSize
         * @return
         * @see GBFINIMG_JAVA_Defines.GBFINIMG_ReturnCodes
         */
        int GBFINIMG_ProcessImage(
                byte[] InputImage,
                int InputSizeX,
                int InputSizeY,
                int InputImageType,
                int ImageProcessingOption,
                GBFINIMG_SegmentImageDescriptor.ByReference SegmentImageList,
                int SegmentImageSizeX,
                int SegmentImageSizeY,
                IntByReference DetectedSegmentImageNumber,
                IntByReference DetectionFailureDiagnostic,
                GBFINIMG_SegmentImageExternalInfo[] ExternalInfoList,
                int ExternalInfoListSize,
                byte[] TempBuffer,
                int TempBufferSize);

        /**
         *
         * @return detected fingerprints number
         */
        int GBFINIMG_GetFingerprintCounter();

        /**
         *
         * @param Probability
         * @param PatternDiagnostic
         */
        void GBFINIMG_CheckFingerRotation180Degree(
                IntByReference Probability,
                ByteByReference PatternDiagnostic);
    }
}
