/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GBLFS_JAVA_Defines;

import com.sun.jna.Structure;
import com.sun.jna.Pointer;

/**
 *
 * @author andrea
 */
public class GBLFS_Minutia extends Structure {
    @Override
    public Pointer getPointer() {
        this.write();
        Pointer ret = super.getPointer();
        return ret;
    }

    public GBLFS_Minutia(Pointer p) {
        this();
        if (p == Pointer.NULL) {
            return;
        }
        useMemory(p);
        read();
    }

    public GBLFS_Minutia() {
        super();
        setAlignType(ALIGN_NONE);
        x = 0;
        y = 0;
        direction = 0;
        reliability = 0;
        type = 0;
        appearing = 0;
        feature_id = 0;
        nbrs = Pointer.NULL;
        ridge_counts = Pointer.NULL;
        num_nbrs = 0;
    }

    // the pixel x-coordinate of the detected minutia.
    public int x;
    // the pixel y-coordinate of the detected minutia.
    public int y;
    // reserved
    public int ex;
    // reserved
    public int ey;
		// the direction of the detected minutia. Minutia direction is starting at 
    // vertical pointing up with unit 0 and increasing clockwise in increments
    // of 11.25 degrees completing a full circle. Using this scheme, the angle
    // of a detected minutia is quantized into the range 0 to 31 with 8 
    // representing horizontal to the right, 16 representing vertical pointing
    // down, and 24 representing horizontal to the left.
    public int direction;
		// The reliability measure assigned to the detected minutia is a floating
    // point value in the range 0.0 to 1.0, with 0.0 representing the lowest
    // minutia quality and 1.0 representing the highest minutia quality.
    public double reliability;
		// It is the type of the detected minutia:
    // 0 - bifurcation
    // 1 - ridge ending
    public int type;
    // reserved
    public int appearing;
    // reserved
    public int feature_id;
    // reserved
    public Pointer nbrs;
    // reserved
    public Pointer ridge_counts;
    // reserved
    public int num_nbrs;
}
