#ifndef CLIPRECTITEM_H
#define CLIPRECTITEM_H

#include <QObject>
#include <QtGui>

enum SizeOperations     // size operations for clipping rectangle and bounding boxes
{
    SizeOperationNone,
    SizeOperationRight,
    SizeOperationLeft,
    SizeOperationTop,
    SizeOperationBottom,
    SizeOperationMove,
	// PROVA - corners
	SizeOperationNE,
	SizeOperationSE,
	SizeOperationSW,
	SizeOperationNW
};
enum SizeOptions
{
	None = 0x00,
    AllowResize = 0x01,
    AllowMove = 0x02
};

class QClipRectItem : public QObject, public QGraphicsRectItem
{
    Q_OBJECT
public:
    //explicit QClipRectItem(QObject *parent = 0);
    //explicit QClipRectItem(QColor PenColor=Qt::black, int PenWidth=1, Qt::PenStyle PenStyle=Qt::SolidLine);
    explicit QClipRectItem(QColor PenColor=Qt::black, int PenWidth=1, Qt::PenStyle PenStyle=Qt::SolidLine, bool SemiTransparent=true);
    ~QClipRectItem();
    //void SetSizeOption(SizeOptions SizeOption);
    void SetSizeOption(unsigned int SizeOption);
    void SetEnabled(bool Enabled);
	void SetSelectable(bool Selectable);
    void paint ( QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget * widget = 0 );
    void SetText(QString Value);
    void SetQuality(int Value, QColor Color);
    void SetDiagIcon(QPixmap Icon);
	void SetMinSize(QSize Size);
	void SetMaxSize(QSize Size);
	void SetAmpCode(QString AmpCode);	// PROVA

protected:
    QVariant itemChange ( GraphicsItemChange change, const QVariant & value );
    void hoverMoveEvent(QGraphicsSceneHoverEvent *event);
    void mousePressEvent ( QGraphicsSceneMouseEvent * event );
    void mouseMoveEvent ( QGraphicsSceneMouseEvent *event );
    void mouseReleaseEvent ( QGraphicsSceneMouseEvent *event );
private:
    bool resizing;
    bool mEnabled;
    SizeOperations mSizeOperation;
    //SizeOptions mSizeOption;
    unsigned int mSizeOption;	
    QBrush mBrush;
    QPen mPen;
    QString Text;
    int QualityValue;
    QColor QualityColor;
    QPixmap DiagIcon;
	QSize mMinSize;
	QSize mMaxSize;
	QString AmpCode;	// PROVA

signals:
    void Changed();

public slots:

};

#endif // CLIPRECTITEM_H
