#include "UnavailabilityReasonForm.h"
#include "ui_UnavailabilityReasonForm.h"
#include "GBMSGUI_Qt.h"
#include <QMessageBox>

UnavailabilityReasonForm::UnavailabilityReasonForm(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::UnavailabilityReasonForm)
{
    ui->setupUi(this);

    setWindowTitle(tr("Specify Unavailability Reason"));

    ui->wdgItem1->setVisible(false);
    ui->wdgItem2->setVisible(false);
    ui->wdgItem3->setVisible(false);
    ui->wdgItem4->setVisible(false);

}

UnavailabilityReasonForm::~UnavailabilityReasonForm()
{
    delete ui;
}

void UnavailabilityReasonForm::AddItem(QString Name)
{
    UnavailabilityReason Item;
    Item.Name = Name;
    Item.Reason = 0;

    UnavailabilityReasonList.append(Item);
}

void UnavailabilityReasonForm::showEvent(QShowEvent * event)
{
    int NumItems = UnavailabilityReasonList.count();

    if (NumItems > 0)
    {
        ui->wdgItem1->setVisible(true);
        ui->lblFinger1->setText(UnavailabilityReasonList[0].Name);
        ui->cmbReason1->addItem("", 0);
        ui->cmbReason1->addItem(tr("Amputated"), GBMSGUI_UR_AMPUTATED);
        ui->cmbReason1->addItem(tr("Bandaged"), GBMSGUI_UR_UNPRINTABLE);
    }
    if (NumItems > 1)
    {
        ui->wdgItem2->setVisible(true);
        ui->lblFinger2->setText(UnavailabilityReasonList[1].Name);
        ui->cmbReason2->addItem("", 0);
        ui->cmbReason2->addItem(tr("Amputated"), GBMSGUI_UR_AMPUTATED);
        ui->cmbReason2->addItem(tr("Bandaged"), GBMSGUI_UR_UNPRINTABLE);
    }
    if (NumItems > 2)
    {
        ui->wdgItem3->setVisible(true);
        ui->lblFinger3->setText(UnavailabilityReasonList[2].Name);
        ui->cmbReason3->addItem("", 0);
        ui->cmbReason3->addItem(tr("Amputated"), GBMSGUI_UR_AMPUTATED);
        ui->cmbReason3->addItem(tr("Bandaged"), GBMSGUI_UR_UNPRINTABLE);
    }
    if (NumItems > 3)
    {
        ui->wdgItem4->setVisible(true);
        ui->lblFinger4->setText(UnavailabilityReasonList[3].Name);
        ui->cmbReason4->addItem("", 0);
        ui->cmbReason4->addItem(tr("Amputated"), GBMSGUI_UR_AMPUTATED);
        ui->cmbReason4->addItem(tr("Bandaged"), GBMSGUI_UR_UNPRINTABLE);
    }

    QWidget::showEvent(event);
}

int UnavailabilityReasonForm::GetReason(int Index)
{
    return UnavailabilityReasonList[Index].Reason;
}

void UnavailabilityReasonForm::done(int r)
{
    if(QDialog::Accepted == r)  // ok was pressed
    {
        bool AllSpecified = true;

        for (int i=0; i<UnavailabilityReasonList.count(); i++)
        {
            if (UnavailabilityReasonList[i].Reason == 0)
            {
                AllSpecified = false;
                break;
            }
        }

        if (!AllSpecified)
        {
            QMessageBox::warning(this, tr("Confirm"), tr("Specify Unavailability Reason"),  QMessageBox::Ok);
            return;
        }
    }

    QDialog::done(r);
}

void UnavailabilityReasonForm::on_cmbReason1_currentIndexChanged(int index)
{
    UnavailabilityReasonList[0].Reason = ui->cmbReason1->itemData(index).toInt();
}

void UnavailabilityReasonForm::on_cmbReason2_currentIndexChanged(int index)
{
    UnavailabilityReasonList[1].Reason = ui->cmbReason1->itemData(index).toInt();
}

void UnavailabilityReasonForm::on_cmbReason3_currentIndexChanged(int index)
{
    UnavailabilityReasonList[2].Reason = ui->cmbReason1->itemData(index).toInt();
}

void UnavailabilityReasonForm::on_cmbReason4_currentIndexChanged(int index)
{
    UnavailabilityReasonList[3].Reason = ui->cmbReason1->itemData(index).toInt();
}
