using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace GBMSGUI_NET
{
    // Implements a control for showing thresholds and evaluation rules
    public partial class ThresholdsLegend : UserControl
    {
        private int Threshold1;
        private int Threshold2;

        public enum Direction
        {
            SmallerThan,
            GreatherThan
        }

        public ThresholdsLegend()
        {
            InitializeComponent();
        }

        public void SetThresholds(int Threshold1, int Threshold2, int Dir)
        {
            this.Threshold1 = Threshold1;
            this.Threshold2 = Threshold2;

            if (Dir == (int)Direction.SmallerThan)
            {
                lblGoodRule.Text = (Char)0x2264 + Threshold1.ToString();
                lblMediumRule.Text = (Char)0x2264 + Threshold2.ToString();
                lblBadRule.Text = "> " + Threshold2.ToString();
            }
            else
            {
                lblBadRule.Text = "< " + Threshold1.ToString();
                lblMediumRule.Text = (Char)0x2265 + Threshold1.ToString();
                lblGoodRule.Text = (Char)0x2265 + Threshold2.ToString();
            }

            if (Threshold1 == Threshold2)
            {
                if ((Threshold1 == 0) || (Threshold1 == -1))
                {
                    // no thresholds
                    GreenBox.Visible = false;
                    lblGoodRule.Visible = false;
                    YellowBox.Visible = false;
                    lblMediumRule.Visible = false;
                    RedBox.Visible = false;
                    lblBadRule.Visible = false;
                }
                else
                {
                    // one threshold
                    YellowBox.Visible = false;
                    lblMediumRule.Visible = false;
                    RedBox.Left = YellowBox.Left;
                    lblBadRule.Left = lblMediumRule.Left;
                }
            }

        }
    }
}
