﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

using AN2K_NET_WRAPPER;
using An2k_Net_Wrapper_Utilities;
using An2k_Engine_Net_Wrapper_Utilities;
using An2k_Engine_Net_Wrapper;
using An2k_2011_NetWrapper;
using An2k_2011_Net_Wrapper_Utilities;

namespace An2k_2011_Net_Wrapper_Utilities
{
	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_GmtStruct
	{
		public int Year;
		public int Month;
		public int Day;
		public int hour;
		public int minute;
		public int second;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_DateStruct
	{
		public int Year;
		public int Month;
		public int Day;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_ApplicationProfileStruct
	{
		public String AppProfOrg;
		public String AppProfName;
		public String AppProfVer;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_PrintPositionDescriptorsStruct
	{
		public int DecimalFingerPosition;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 10)]
		public String FingerImageCode;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_PrintPositionCoordinatesStruct
	{
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 10)]
		public String FullFingerView;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 10)]
		public String LocationOfASegment;
		public int LeftHorizontalCoordinate;
		public int RightHorizontalCoordinate;
		public int TopVerticalCoordinate;
		public int BottomVerticalCoordinate;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_AmputatedBandagedCodeStruct
	{
		public int FrictionRidgePosition;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 10)]
		public String AmpBandCode;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_FingerSegmentPositionStruct
	{
		public int FrictionRidgePosition;
		public int LeftHorizontalCoordinate;
		public int RightHorizontalCoordinate;
		public int TopVerticalCoordinate;
		public int BottomVerticalCoordinate;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_NistQualityMetricStruct
	{
		public int FrictionRidgePosition;
		public int Quality;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_FingerOrSegmentQualityMetricStruct
	{
		public int FrictionRidgePosition;
		public int Quality;
		public int AlgorithmVendorId;
		public int AlgorithmProductId;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_PointOffsetStruct
	{
		public int HorizontalPointOffset;
		public int VerticalPointOffset;
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
	public struct An2k2011_AlternateSegmentPositionStruct
	{
		public int FrictionRidgePosition;
		public int NumberOfPoints;
		public IntPtr Points; // An2k2011_PointOffsetStruct *
	}

	public class An2k2011_NetWrapper
	{
		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_CreateAnsiNistStruct", CharSet = CharSet.Ansi)]
		public static extern int GB_AN2011_CreateAnsiNistStruct(
			IntPtr pAnsiNist, // ANSI_NIST **
			String Tot,
			ref An2k2011_DateStruct Dat, //An2k2011_DateStruct *
			int Pry,
			String DestAgency,
			String OrigAgency,
			String TransContrNum,
			String TransContrRef,
			float NativeScanRes,
			float NominalTxRes,
			String DomainName,
			String DomainVersion,
			ref An2k2011_GmtStruct Gmt, // An2k2011_GmtStruct *
			int CharEncIndex,
			String CharEncName,
			String CharEncVersion,
			An2k2011_ApplicationProfileStruct[] aps, // An2k2011_ApplicationProfileStruct *
			int ApsNum,
			String DestAgName,
			String OrigAgName
			);
		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_GetType1RecordInfo", CharSet = CharSet.Ansi)]
		public static extern int GB_AN2011_GetType1RecordInfo(
			IntPtr record, // RECORD*
			out int pVersion,
			IntPtr pTypeOfTransaction, // String *
			ref An2k2011_DateStruct Dat, //GB_AN2011_DateStruct*
			out int pPriority,
            IntPtr pDestAgency, // String *
            IntPtr pOrigAgency, // String *
            IntPtr pTransContrNum, // String *
            IntPtr pTransContrRef, // String *
			out float pNativeScanRes,
			out float pNominalTxRes,
            IntPtr pDomainName, // String *
            IntPtr pDomainVersion, // String *
			ref An2k2011_GmtStruct Gmt, // GB_AN2011_GmtStruct*
			out int pCharEncIndex,
            IntPtr pCharEncName, // String *
            IntPtr pCharEncVersion, // String *
			IntPtr pAps, // GB_AN2011_ApplicationProfileStruct**
			out int pApsNum,
            IntPtr pDestAgName, // String *
            IntPtr pOrigAgName // String *
			);
		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_GetType4RecordInfo", CharSet = CharSet.Ansi)]
		public static extern int GB_AN2011_GetType4RecordInfo(
			IntPtr record, // RECORD*
			out int pIdc,
			out int pImpressionType,
			out byte fgp,
			out int pImageScanResolution,
			out int pHorizontalNumberOfPixels,
			out int pVerticalNumberOfPixels,
			out int pCompressionAlgorithm,
			IntPtr pImageBuffer, // unsigned char **
			out int pImageBufferLen
			);

		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_CreateType14Record", CharSet = CharSet.Ansi)]
		public static extern int GB_AN2011_CreateType14Record(
			IntPtr pRecord, // RECORD **
			int idc, int impressionType,
			String sourceAgency,
			ref An2k2011_DateStruct fingerprintCaptureDate, //An2k2011_DateStruct *
			int horizontalNumberOfPixels, int verticalNumberOfPixels, int scaleUnits,
			int transmittedHorizontalPixelScale, int transmittedVerticalPixelScale,
			int compressionAlgorithm,
			int bitsPerPixel,
			int fingerprintPosition,
			IntPtr ppd, //GB_AN2011_PrintPositionDescriptorsStruct *
			An2k2011_PrintPositionCoordinatesStruct[] ppc, int ppcNum,
			int scannedHorizontalPixelScale, int scannedVerticalPixelScale,
			An2k2011_AmputatedBandagedCodeStruct[] amp, int ampNum,
			String comment,
			An2k2011_FingerSegmentPositionStruct[] seg, int segNum,
			An2k2011_NistQualityMetricStruct[] nqm, int nqmNum,
			An2k2011_FingerOrSegmentQualityMetricStruct[] sqm, int sqmNum,
			An2k2011_FingerOrSegmentQualityMetricStruct[] fqm, int fqmNum,
			IntPtr aseg, //GB_AN2011_AlternateSegmentPositionStruct *
			int asegNum,
			int simultaneousCaptureFingerprint,
			int stitchedImageFlag,
			String deviceMonitoringMode,
			int fingerprintAcquisitionProfile,
			IntPtr imageBuffer, // unsigned char *
			int imageBufferLen
			);

		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_GetType14RecordInfo", CharSet = CharSet.Ansi)]
		public static extern int GB_AN2011_GetType14RecordInfo(
			IntPtr record, // RECORD*
			out int pIdc,
            out int pImpressionType,
            IntPtr pSourceAgency, // String *
			ref An2k2011_DateStruct fingerprintCaptureDate, //GB_AN2011_DateStruct*
			out int pHorizontalNumberOfPixels,
			out int pVerticalNumberOfPixels,
			out int pScaleUnits,
			out int pTransmittedHorizontalPixelScale,
			out int pTransmittedVerticalPixelScale,
			out int pCompressionAlgorithm,
			out int pBitsPerPixel,
			out int pFingerprintPosition,
			ref An2k2011_PrintPositionDescriptorsStruct ppd, // GB_AN2011_PrintPositionDescriptorsStruct *
			IntPtr pPpc, out int pPpcNum, // GB_AN2011_PrintPositionCoordinatesStruct **
			out int pScannedHorizontalPixelScale,
			out int pScannedVerticalPixelScale,
            IntPtr pAmp, out int pAmpNum, // GB_AN2011_AmputatedBandagedCodeStruct **
            IntPtr pComment, // String *
			IntPtr pSeg, out int pSegNum, // GB_AN2011_FingerSegmentPositionStruct **
			IntPtr pNqm, out int pNqmNum, // GB_AN2011_NistQualityMetricStruct **
			IntPtr pSqm, out int pSqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
			IntPtr pFqm, out int pFqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
			IntPtr pAseg, out int pAsegNum, // GB_AN2011_AlternateSegmentPositionStruct **
			out int pSimultaneousCaptureFingerprint,
            out int pStitchedImageFlag, // BOOL 
            IntPtr pDeviceMonitoringMode, // String *
			out int pFingerprintAcquisitionProfile,
			IntPtr pImageBuffer, // unsigned char **
			out int pImageBufferLen
			);

		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_CreateType15Record", CharSet = CharSet.Ansi)]
		public static extern int GB_AN2011_CreateType15Record(
			IntPtr pRecord, // RECORD **
			int idc, int impressionType,
			String sourceAgency,
			ref An2k2011_DateStruct palmprintCaptureDate, //An2k2011_DateStruct *
			int horizontalNumberOfPixels, int verticalNumberOfPixels, int scaleUnits,
			int transmittedHorizontalPixelScale, int transmittedVerticalPixelScale,
			int compressionAlgorithm,
			int bitsPerPixel,
			int fingerprintPosition,
			int scannedHorizontalPixelScale, int scannedVerticalPixelScale,
			An2k2011_AmputatedBandagedCodeStruct[] amp, int ampNum,
			String comment,
			An2k2011_FingerOrSegmentQualityMetricStruct[] pqm, int pqmNum,
			String deviceMonitoringMode,
			IntPtr imageBuffer, // unsigned char *
			int imageBufferLen
			);

		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_GetType15RecordInfo", CharSet = CharSet.Ansi)]
		public static extern int GB_AN2011_GetType15RecordInfo(
			IntPtr record, // RECORD*
			out int pIdc,
            out int pImpressionType,
            IntPtr pSourceAgency, // String *
			ref An2k2011_DateStruct PalmprintCaptureDate, //GB_AN2011_DateStruct*
			out int pHorizontalNumberOfPixels,
			out int pVerticalNumberOfPixels,
			out int pScaleUnits,
			out int pTransmittedHorizontalPixelScale,
			out int pTransmittedVerticalPixelScale,
			out int pCompressionAlgorithm,
			out int pBitsPerPixel,
			out int pFingerprintPosition,
			out int pScannedHorizontalPixelScale,
			out int pScannedVerticalPixelScale,
            IntPtr pAmp, out int pAmpNum, // GB_AN2011_AmputatedBandagedCodeStruct **
            IntPtr pComment, // String *
            IntPtr pPqm, out int pPqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
            IntPtr pDeviceMonitoringMode, // String *
			IntPtr pImageBuffer, // unsigned char **
			out int pImageBufferLen
			);

		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN_ENGINE_FreeGenericMem", CharSet = CharSet.Ansi)]
		public static extern void GB_AN_ENGINE_FreeGenericMem(
			IntPtr MemToFree
			);

		[DllImport("AN2K_LIB.dll", EntryPoint = "GB_AN2011_FreeAsegArray", CharSet = CharSet.Ansi)]
		public static extern void GB_AN2011_FreeAsegArray(
			IntPtr asegArray, // GB_AN2011_AlternateSegmentPositionStruct*
			int asegNum
			);
	}
}

namespace An2k_2011_NetWrapper
{
	public class An2k2011_Table4
	{
		// Char encoding Index
		public const int CHAR_ENCODING_INDEX_ASCII = 0;
		public const int CHAR_ENCODING_INDEX_UTF_16 = 2;
		public const int CHAR_ENCODING_INDEX_UTF_8 = 3;
		public const int CHAR_ENCODING_INDEX_UTF_32 = 4;

		// Char encoding names
		public const String CHAR_ENCODING_NAME_ASCII = "ASCII";
		public const String CHAR_ENCODING_NAME_UTF_16 = "UTF-16";
		public const String CHAR_ENCODING_NAME_UTF_8 = "UTF-8";
		public const String CHAR_ENCODING_NAME_UTF_32 = "UTF-32";
	}

	public class An2k2011_Table5
	{
		// Device Monitoring Mode
		public const String DMM_CONTROLLED = "CONTROLLED";
		public const String DMM_ASSISTED = "ASSISTED";
		public const String DMM_OBSERVED = "OBSERVED";
		public const String DMM_UNATTENDED = "UNATTENDED";
		public const String DMM_UNKNOWN = "UNKNOWN";
	}

	/// <summary>
	/// Friction Ridge Impression types
	/// </summary>
	public class An2k2011_Table7
	{
		// LIVESCAN UNKNOWN OR UNSPECIFIED
		public const int FRIT_LS_UNKNOWN_PLAIN = 0;
		public const int FRIT_LS_UNKNOWN_ROLLED = 1;
		public const int FRIT_LS_UNKNOWN_PALM = 10;
		public const int FRIT_LS_UNKNOWN_PLANTAR = 30;

		// LIVESCAN VERTICAL SWIPE
		public const int FRIT_LS_VERT_SWIPE_PLAIN = 8;

		// LIVESCAN OPTICAL CONTACT
		public const int FRIT_LS_OPT_CONTACT_PLAIN = 20;
		public const int FRIT_LS_OPT_CONTACT_ROLLED = 21;

		// LIVESCAN NON OPTICAL CONTACT
		public const int FRIT_LS_NON_OPT_CONTACT_PLAIN = 22;
		public const int FRIT_LS_NON_OPT_CONTACT_ROLLED = 23;

		// LIVESCAN OPTICAL CONTACTLESS
		public const int FRIT_LS_OPT_CONTACTLESS_PLAIN = 24;
		public const int FRIT_LS_OPT_CONTACTLESS_ROLLED = 25;

		// LIVESCAN NON OPTICAL CONTACTLESS
		public const int FRIT_LS_NON_OPT_CONTACTLESS_PLAIN = 26;
		public const int FRIT_LS_NON_OPT_CONTACTLESS_ROLLED = 27;

		// NON LIVESCAN
		public const int FRIT_NON_LIVESCAN_PLAIN = 2;
		public const int FRIT_NON_LIVESCAN_ROLLED = 3;
		public const int FRIT_NON_LIVESCAN_PALM = 11;
		public const int FRIT_NON_LIVESCAN_PLANTAR = 31;

		// LATENT IMPRESSION
		public const int FRIT_LATENT_IMPRESSION_PLAIN = 4;
		public const int FRIT_LATENT_IMPRESSION_PALM = 12;
		public const int FRIT_LATENT_IMPRESSION_PLANTAR = 32;
		public const int FRIT_LATENT_IMPRESSION_UNKNOWN = 36;

		// LATENT TRACING
		public const int FRIT_LATENT_TRACING_PLAIN = 5;
		public const int FRIT_LATENT_TRACING_PALM = 13;
		public const int FRIT_LATENT_TRACING_PLANTAR = 33;
		public const int FRIT_LATENT_TRACING_UNKNOWN = 37;

		// LATENT PHOTO
		public const int FRIT_LATENT_PHOTO_PLAIN = 6;
		public const int FRIT_LATENT_PHOTO_PALM = 14;
		public const int FRIT_LATENT_PHOTO_PLANTAR = 34;
		public const int FRIT_LATENT_PHOTO_UNKNOWN = 38;

		// LATENT LIFT
		public const int FRIT_LATENT_LIFT_PLAIN = 7;
		public const int FRIT_LATENT_LIFT_PALM = 15;
		public const int FRIT_LATENT_LIFT_PLANTAR = 35;
		public const int FRIT_LATENT_LIFT_UNKNOWN = 39;

		// OTHER OR UNKNOWN
		public const int FRIT_OTHER = 28;
		public const int FRIT_UNNKNOWN = 29;
	}

	/// <summary>
	/// Table 8: Finger Positions
	/// </summary>
	public class An2k2011_Table8
	{
		public const int UNKNOWN = 0;
		// FINGER
		public const int RIGHT_THUMB = 1;
		public const int RIGHT_INDEX = 2;
		public const int RIGHT_MIDDLE = 3;
		public const int RIGHT_RING = 4;
		public const int RIGHT_LITTLE = 5;
		public const int LEFT_THUMB = 6;
		public const int LEFT_INDEX = 7;
		public const int LEFT_MIDDLE = 8;
		public const int LEFT_RING = 9;
		public const int LEFT_LITTLE = 10;
		public const int PLAIN_RIGHT_THUMB = 11;
		public const int PLAIN_LEFT_THUMB = 12;
		public const int PLAIN_RIGHT_SLAP_4 = 13;
		public const int PLAIN_LEFT_SLAP_4 = 14;
		public const int PLAIN_LEFT_THUMBS_2 = 15;
		public const int RIGHT_EXTRA_DIGIT = 16;
		public const int LEFT_EXTRA_DIGIT = 17;
		public const int UNKNOWN_FRICTION_RIDGE = 18;
		public const int EJI_OR_TIP = 19;
		// PALM
		public const int UNKNOWN_PALM = 20;
		public const int RIGHT_FULL_PALM = 21;
		public const int RIGHT_WRITERS_PALM = 22;
		public const int LEFT_FULL_PALM = 23;
		public const int LEFT_WRITERS_PALM = 24;
		public const int RIGHT_LOWER_PALM = 25;
		public const int RIGHT_UPPER_PALM = 26;
		public const int LEFT_LOWER_PALM = 27;
		public const int LEFT_UPPER_PALM = 28;
		public const int RIGHT_OTHER = 29;
		public const int LEFT_OTHER = 30;
		public const int RIGHT_INTERDIGITAL = 31;
		public const int RIGHT_THENAR = 32;
		public const int RIGHT_HYPOTHENAR = 33;
		public const int LEFT_INTERDIGITAL = 34;
		public const int LEFT_THENAR = 35;
		public const int LEFT_HYPOTHENAR = 36;
		public const int RIGHT_GRASP = 37;
		public const int LEFT_GRASP = 38;
		public const int RIGHT_CARPAL_DELTA_AREA = 81;
		public const int LEFT_CARPAL_DELTA_AREA = 82;
		public const int RIGHT_FULL_WRITERS_PALM = 83;
		public const int LEFT_FULL_WRITERS_PALM = 84;
		// FINGER COMBINATION: 2 FINGERS
		public const int RIGHT_INDEX_MIDDLE = 40;
		public const int RIGHT_MIDDLE_RING = 41;
		public const int RIGHT_RING_LITTLE = 42;
		public const int LEFT_INDEX_MIDDLE = 43;
		public const int LEFT_MIDDLE_RING = 44;
		public const int LEFT_RING_LITTLE = 45;
		public const int RIGHT_LEFT_INDEX = 46;
		// FINGER COMBINATION: 3 FINGERS
		public const int RIGHT_INDEX_MIDDLE_RING = 47;
		public const int RIGHT_MIDDLE_RING_LITTLE = 48;
		public const int LEFT_INDEX_MIDDLE_RING = 49;
		public const int LEFT_MIDDLE_RING_LITTLE = 50;
	}

	/// <summary>
	/// Table 9: Joint image segments, 
	/// tip code and finger view codes
	/// </summary>
	public class An2k2011_Table9
	{
		// Entire joint image EJI
		public const String ENTIRE_JOINT_IMAGE = "EJI";
		// FVC OR FIC
		public const String ROLLED_TIP = "TIP";
		public const String FULL_FINGER_ROLLED = "FV1";
		public const String FULL_FINGER_LEFT_SIDE = "FV2";
		public const String FULL_FINGER_CENTER = "FV3";
		public const String FULL_FINGER_RIGHT_SIDE = "FV4";
		// FVC ONLY
		public const String FVC_ONLY_NA = "NA";
		// LOS OR FIC
		public const String LOS_PROXIMAL = "PRX";
		public const String LOS_DISTAL = "DST";
		public const String LOS_MEDIAL = "MED";
		// LOS ONLY
		public const String LOS_ONLY_NA = "NA";
	}

	/// <summary>
	/// Table 12: Subject acquisition
	/// profiles for fingerprint
	/// </summary>
	public class An2k2011_Table12
	{
		public const int FAP_10 = 10;
		public const int FAP_20 = 20;
		public const int FAP_30 = 30;
		public const int FAP_40 = 40;
		public const int FAP_45 = 45;
		public const int FAP_50 = 50;
		public const int FAP_60 = 60;
	}

	/// <summary>
	/// Table 15: Compression codes
	/// </summary>
	public class An2k2011_Table15
	{
		public const int CODE_UNCOMPRESSED = 0;
		public const int CODE_WSQ20 = 1;
		public const int CODE_JPEGB = 2;
		public const int CODE_JPEGL = 3;
		public const int CODE_JP2 = 4;
		public const int CODE_JP2L = 5;
		public const int CODE_PNG = 6;
	}

	/// <summary>
	/// class representing a date
	/// </summary>
	public class An2k2011_Date
	{
		public int Year;
		public int Month;
		public int Day;

		public An2k2011_DateStruct ToCStruct()
		{
			An2k2011_DateStruct ret = new An2k2011_DateStruct();
			ret.Day = Day;
			ret.Month = Month;
			ret.Year = Year;

			return ret;
		}

		public void FromCStruct(An2k2011_DateStruct input)
		{
			this.Day = input.Day;
			this.Month = input.Month;
			this.Year = input.Year;
		}

		public An2k2011_Date()
		{
			Init();
		}

		public void Init()
		{
			Year = 0;
			Month = 0;
			Day = 0;
		}

		public An2k2011_Date(int y, int m, int d)
		{
			this.Year = y; this.Month = m; this.Day = d;
		}

		/// <summary>
		/// parses a string representing a date formatted this way
		/// "YYYYMMDD"
		/// </summary>
		/// <param name="date">string to be parsed</param>
		/// <returns>see NW_AN2K_ERRORS</returns>
		public int Parse(string date)
		{
			try
			{
				if (date.Length < 8) return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				string year = date.Substring(0, 4);
				string month = date.Substring(4, 2);
				string day = date.Substring(6, 2);
				if ((!int.TryParse(year, out Year)) ||
					(!int.TryParse(month, out Month)) ||
					(!int.TryParse(day, out Day)))
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				}
				return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
			}
			catch (Exception ex)
			{
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Date.Parse: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
		}
	}
	/// <summary>
	/// class representing a gmt timestamp
	/// </summary>
	public class An2k2011_Gmt
	{
		public int Year;
		public int Month;
		public int Day;
		public int hour;
		public int minute;
		public int second;

		public An2k2011_GmtStruct ToCStruct()
		{
			An2k2011_GmtStruct ret = new An2k2011_GmtStruct();
			ret.Day = this.Day;
			ret.Month = this.Month;
			ret.Year = this.Year;
			ret.hour = this.hour;
			ret.minute = this.minute;
			ret.second = this.second;
			return ret;
		}

		public void FromCStruct(An2k2011_GmtStruct input)
		{
			this.Day = input.Day;
			this.Month = input.Month;
			this.Year = input.Year;
			this.hour = input.hour;
			this.minute = input.minute;
			this.second = input.second;
		}

		public An2k2011_Gmt()
		{
			Init();
		}

		public void Init()
		{
			Year = 0;
			Month = 0;
			Day = 0;
			hour = 0;
			minute = 0;
			second = 0;
		}

		/// <summary>
		/// parses a gmt timestamp from a string formatted this way
		/// "YYYYMMDDHHMMSSZ"
		/// </summary>
		/// <param name="date"></param>
		/// <returns></returns>
		public int Parse(string date)
		{
			try
			{
				if (date.Length < 14) return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				string year = date.Substring(0, 4);
				string month = date.Substring(4, 2);
				string day = date.Substring(6, 2);
				string h = date.Substring(8, 2);
				string m = date.Substring(10, 2);
				string s = date.Substring(12, 2);
				if ((!int.TryParse(year, out Year)) ||
					(!int.TryParse(month, out Month)) ||
					(!int.TryParse(day, out Day)) ||
					(!int.TryParse(h, out hour)) ||
					(!int.TryParse(m, out minute)) ||
					(!int.TryParse(s, out second)))
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				}
				return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
			}
			catch (Exception ex)
			{
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Gmt.Parse: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
		}
	}

	/// <summary>
	/// class that collects information for APS field in record 1
	/// </summary>
	public class An2k2011_ApplicationProfile
	{
		public String AppProfOrg;
		public String AppProfName;
		public String AppProfVer;

		public An2k2011_ApplicationProfile()
		{
			AppProfOrg = null;
			AppProfName = null;
			AppProfVer = null;
		}

		public An2k2011_ApplicationProfile(string org, string name, string ver)
		{
			AppProfOrg = org;
			AppProfName = name;
			AppProfVer = ver;
		}

		public An2k2011_ApplicationProfileStruct ToCStruct()
		{
			An2k2011_ApplicationProfileStruct arrElement = new An2k2011_ApplicationProfileStruct();
			arrElement.AppProfName = AppProfName;
			arrElement.AppProfOrg = AppProfOrg;
			arrElement.AppProfVer = AppProfVer;

			return arrElement;
		}

		public static An2k2011_ApplicationProfileStruct[] FromNetArrayToCArray(An2k2011_ApplicationProfile[] ppc)
		{
			if (ppc == null || ppc.Length == 0) return null;
			An2k2011_ApplicationProfileStruct[] ret = new An2k2011_ApplicationProfileStruct[ppc.Length];
			for (int i = 0; i < ppc.Length; i++)
			{
				ret[i] = ppc[i].ToCStruct();
			}
			return ret;
		}

		public static An2k2011_ApplicationProfile[] FromCArrayToNetArray(IntPtr apsStructArray, int apsStructArrayNum)
		{
			if (apsStructArray == IntPtr.Zero || apsStructArrayNum == 0) return null;
			IntPtr[] apsArray = new IntPtr[apsStructArrayNum];
			IntPtr apsPointer = (IntPtr)(An2k_Utils.MarshalToStruct(apsStructArray, typeof(IntPtr)));
			for (int i = 0; i < apsStructArrayNum; i++)
			{
				apsArray[i] = new IntPtr(apsPointer.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_ApplicationProfileStruct))));
			}
			An2k2011_ApplicationProfile[] a = new An2k2011_ApplicationProfile[apsStructArrayNum];

			// create pointers
			for (int i = 0; i < apsStructArrayNum; i++)
			{
				An2k2011_ApplicationProfileStruct ListElement =
					(An2k2011_ApplicationProfileStruct)(An2k_Utils.MarshalToStruct(apsArray[i], typeof(An2k2011_ApplicationProfileStruct)));

				a[i] = new An2k2011_ApplicationProfile(ListElement.AppProfOrg, ListElement.AppProfName, ListElement.AppProfVer);
			}
			return a;
		}
	}

	/// <summary>
	/// class that represents an ansi_nist struct filled with
	/// a type-1 record
	/// </summary>
	public class An2k2011_Type1Record : An2kEngineNw_AnsiNist
	{
		public String typeOfTransaction;
		public An2k2011_Date dateOfTransaction;
		public int priority;
		public int version;
		public String destinationAgency;
		public String originatingAgency;
		public String transactionControlNumber;
		public String transactionControlReference;
		public float nativeScanResolution;
		public float nominalTransmitResolution;
		public String domainName;
		public String domainVersion;
		public An2k2011_Gmt gmt;
		public int charEncodeIndex;
		public String charEncodeName;
		public String charEncodeVersion;
		An2k2011_ApplicationProfile[] aps;
		public String destinationAgencyName;
		public String originatingAgencyName;

		/// <summary>
		/// constructor
		/// </summary>
		public An2k2011_Type1Record()
		{
			this.Init();
		}

		/// <summary>
		/// init of class properties
		/// </summary>
		public void Init()
		{
			this.buffer = IntPtr.Zero;
			typeOfTransaction = null;
			dateOfTransaction = null;
			priority = -1;
			version = -1;
			destinationAgency = null;
			originatingAgency = null;
			transactionControlNumber = null;
			transactionControlReference = null;
			nativeScanResolution = -1;
			nominalTransmitResolution = -1;
			domainName = null;
			domainVersion = null;
			gmt = null;
			charEncodeIndex = -1;
			charEncodeName = null;
			charEncodeVersion = null;
			aps = null;
			destinationAgencyName = null;
			originatingAgencyName = null;
		}

		/// <summary>
		/// see "GB_AN2011_CreateAnsiNistStruct" in C library
		/// </summary>
		/// <param name="Tot"></param>
		/// <param name="Dat"></param>
		/// <param name="Pry"></param>
		/// <param name="DestAgency"></param>
		/// <param name="OrigAgency"></param>
		/// <param name="TransContrNum"></param>
		/// <param name="TransContrRef"></param>
		/// <param name="NativeScanRes"></param>
		/// <param name="NominalTxRes"></param>
		/// <param name="DomainName"></param>
		/// <param name="DomainVersion"></param>
		/// <param name="Gmt"></param>
		/// <param name="CharEncIndex"></param>
		/// <param name="CharEncName"></param>
		/// <param name="CharEncVersion"></param>
		/// <param name="Aps"></param>
		/// <param name="DestAgName"></param>
		/// <param name="OrigAgName"></param>
		/// <returns>see NW_AN2K_ERRORS class</returns>
		public int Create(String Tot, An2k2011_Date Dat, int Pry, String DestAgency, String OrigAgency,
			String TransContrNum, String TransContrRef, float NativeScanRes, float NominalTxRes,
			String DomainName, String DomainVersion, An2k2011_Gmt Gmt,
			int CharEncIndex, String CharEncName, String CharEncVersion, An2k2011_ApplicationProfile[] Aps,
			String DestAgName, String OrigAgName
			)
		{
			try
			{
				IntPtr pBuffer = An2k_Utils.MarshalToPointer(this.buffer);
				if (pBuffer == IntPtr.Zero)
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				An2k2011_DateStruct ds = Dat.ToCStruct();
				An2k2011_GmtStruct gs = Gmt.ToCStruct();
                int apslen = (Aps != null) ? Aps.Length : 0;
				int RetVal = An2k2011_NetWrapper.GB_AN2011_CreateAnsiNistStruct(pBuffer, Tot, ref ds, Pry, DestAgency, OrigAgency,
					TransContrNum, TransContrRef, NativeScanRes, NominalTxRes, DomainName, DomainVersion, ref gs,
					CharEncIndex, CharEncName, CharEncVersion,
                    An2k2011_ApplicationProfile.FromNetArrayToCArray(Aps), apslen,
					DestAgName, OrigAgName);

				//////////////////////////////////////
				// free allocated memory
				//////////////////////////////////////
				
				//////////////////////////////////////
				// check RetVal
				//////////////////////////////////////
				if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					// init everything
					return RetVal;
				}
				//////////////////////////////////////
				// store values
				//////////////////////////////////////
				this.buffer = (IntPtr)An2k_Utils.MarshalToStruct(pBuffer, typeof(IntPtr));
				this.typeOfTransaction = Tot;
				this.dateOfTransaction = Dat;
				this.priority = Pry;
				this.destinationAgency = DestAgency;
				this.originatingAgency = OrigAgency;
				this.transactionControlNumber = TransContrNum;
				this.transactionControlReference = TransContrRef;
				this.nativeScanResolution = NativeScanRes;
				this.nominalTransmitResolution = NominalTxRes;
				this.domainName = DomainName;
				this.domainVersion = DomainVersion;
				this.gmt = Gmt;
				this.charEncodeIndex = CharEncIndex;
				this.charEncodeName = CharEncName;
				this.charEncodeVersion = CharEncVersion;
				this.aps = Aps;
				this.destinationAgencyName = DestAgName;
				this.originatingAgencyName = OrigAgName;

				return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
			}
			catch (Exception ex)
			{
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type1Record.Create: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
		}

		public int Create(byte[] binaryBuffer)
		{
			if (this.buffer != IntPtr.Zero)
			{
				An2k_Engine_NetWrapper.GB_AN_ENGINE_Free(this.buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
			}
			this.Init();
			IntPtr pBuffer = An2k_Utils.MarshalToPointer(this.buffer);
			if (pBuffer == IntPtr.Zero)
			{
				return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
			}
			IntPtr anFilePtr = Marshal.AllocHGlobal(binaryBuffer.Length);
			if (anFilePtr == IntPtr.Zero)
			{
				Marshal.FreeHGlobal(pBuffer);
				return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
			}
			Marshal.Copy(binaryBuffer, 0, anFilePtr, binaryBuffer.Length);
			int RetVal = An2kdll_NetWrapper.read_ANSI_NIST_buffer(anFilePtr, binaryBuffer.Length, pBuffer);
			Marshal.FreeHGlobal(anFilePtr);
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				Marshal.FreeHGlobal(pBuffer);
				return RetVal;
			}
			this.buffer = (IntPtr)An2k_Utils.MarshalToStruct(pBuffer, typeof(IntPtr));
			Marshal.FreeHGlobal(pBuffer);

			// check that type-1 record is present and that it's an an2011
			An2kEngineNw_Record app = this.GetRecordFromListAtIndex(0);
			if (app == null || app.recordType != 1)
			{
				An2k_Engine_NetWrapper.GB_AN_ENGINE_Free(this.buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			int ApsNum;
			An2k2011_DateStruct d = new An2k2011_DateStruct();
			An2k2011_GmtStruct g = new An2k2011_GmtStruct();
			IntPtr pAps = new IntPtr(), ppAps = An2k_Utils.MarshalToPointer(pAps);
			if (ppAps == IntPtr.Zero)
			{
				return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
			}
            IntPtr pTot = new IntPtr(), ppTot = An2k_Utils.MarshalToPointer(pTot);
            if (ppTot == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr pdestinationAgency = new IntPtr(), ppdestinationAgency = An2k_Utils.MarshalToPointer(pdestinationAgency);
            if (ppdestinationAgency == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr poriginatingAgency = new IntPtr(), pporiginatingAgency = An2k_Utils.MarshalToPointer(poriginatingAgency);
            if (pporiginatingAgency == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr ptransactionControlNumber = new IntPtr(), pptransactionControlNumber = An2k_Utils.MarshalToPointer(ptransactionControlNumber);
            if (pptransactionControlNumber == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr ptransactionControlReference = new IntPtr(), pptransactionControlReference = 
                An2k_Utils.MarshalToPointer(ptransactionControlReference);
            if (pptransactionControlReference == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr pdomainName = new IntPtr(), ppdomainName = An2k_Utils.MarshalToPointer(pdomainName);
            if (ppdomainName == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr pdomainVersion = new IntPtr(), ppdomainVersion = An2k_Utils.MarshalToPointer(pdomainVersion);
            if (ppdomainVersion == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr pcharEncodeName = new IntPtr(), ppcharEncodeName = An2k_Utils.MarshalToPointer(pcharEncodeName);
            if (ppcharEncodeName == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr pcharEncodeVersion = new IntPtr(), ppcharEncodeVersion = An2k_Utils.MarshalToPointer(pcharEncodeVersion);
            if (ppcharEncodeVersion == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr pdestinationAgencyName = new IntPtr(), ppdestinationAgencyName = An2k_Utils.MarshalToPointer(pdestinationAgencyName);
            if (ppdestinationAgencyName == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
            IntPtr poriginatingAgencyName = new IntPtr(), pporiginatingAgencyName = An2k_Utils.MarshalToPointer(poriginatingAgencyName);
            if (pporiginatingAgencyName == IntPtr.Zero)
            {
                return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
            }
			RetVal = An2k2011_NetWrapper.GB_AN2011_GetType1RecordInfo(
					app.GetBuffer(), // RECORD*
					out this.version,
                    ppTot,
					ref d, //GB_AN2011_DateStruct*
					out this.priority,
                    ppdestinationAgency,
                    pporiginatingAgency,
                    pptransactionControlNumber,
                    pptransactionControlReference,
					out this.nativeScanResolution,
					out this.nominalTransmitResolution,
                    ppdomainName,
                    ppdomainVersion,
					ref g, // GB_AN2011_GmtStruct* 
					out this.charEncodeIndex,
                    ppcharEncodeName,
                    ppcharEncodeVersion,
					ppAps, // GB_AN2011_ApplicationProfileStruct**
					out ApsNum,
                    ppdestinationAgencyName,
                    pporiginatingAgencyName
					);
			/////////////////////////////////
			// get externally allocated
            // values
            /////////////////////////////////
            pTot = (IntPtr)(An2k_Utils.MarshalToStruct(ppTot, typeof(IntPtr)));
            Marshal.FreeHGlobal(ppTot);
            pdestinationAgency = (IntPtr)(An2k_Utils.MarshalToStruct(ppdestinationAgency, typeof(IntPtr)));
            Marshal.FreeHGlobal(ppdestinationAgency);
            poriginatingAgency = (IntPtr)(An2k_Utils.MarshalToStruct(pporiginatingAgency, typeof(IntPtr)));
            Marshal.FreeHGlobal(pporiginatingAgency);
            ptransactionControlNumber = (IntPtr)(An2k_Utils.MarshalToStruct(pptransactionControlNumber, typeof(IntPtr)));
            Marshal.FreeHGlobal(pptransactionControlNumber);
            ptransactionControlReference = (IntPtr)(An2k_Utils.MarshalToStruct(pptransactionControlReference, typeof(IntPtr)));
            Marshal.FreeHGlobal(pptransactionControlReference);
            pdomainName = (IntPtr)(An2k_Utils.MarshalToStruct(ppdomainName, typeof(IntPtr)));
            Marshal.FreeHGlobal(ppdomainName);
            pdomainVersion = (IntPtr)(An2k_Utils.MarshalToStruct(ppdomainVersion, typeof(IntPtr)));
            Marshal.FreeHGlobal(ppdomainVersion);
            pcharEncodeName = (IntPtr)(An2k_Utils.MarshalToStruct(ppcharEncodeName, typeof(IntPtr)));
            Marshal.FreeHGlobal(ppcharEncodeName);
            pcharEncodeVersion = (IntPtr)(An2k_Utils.MarshalToStruct(ppcharEncodeVersion, typeof(IntPtr)));
            Marshal.FreeHGlobal(ppcharEncodeVersion);
            pdestinationAgencyName = (IntPtr)(An2k_Utils.MarshalToStruct(ppdestinationAgencyName, typeof(IntPtr)));
            Marshal.FreeHGlobal(ppdestinationAgencyName);
            poriginatingAgencyName = (IntPtr)(An2k_Utils.MarshalToStruct(pporiginatingAgencyName, typeof(IntPtr)));
            Marshal.FreeHGlobal(pporiginatingAgencyName);
            if (pTot != IntPtr.Zero)
            {
                this.typeOfTransaction = An2k_Utils.GetStringFromIntPtr(pTot, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(pTot);
            }
            else this.typeOfTransaction = null;
            if (pdestinationAgency != IntPtr.Zero)
            {
                this.destinationAgency = An2k_Utils.GetStringFromIntPtr(pdestinationAgency, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdestinationAgency);
            }
            else this.destinationAgency = null;
            if (poriginatingAgency != IntPtr.Zero)
            {
                this.originatingAgency = An2k_Utils.GetStringFromIntPtr(poriginatingAgency, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(poriginatingAgency);
            }
            else this.originatingAgency = null;
            if (ptransactionControlNumber != IntPtr.Zero)
            {
                this.transactionControlNumber = An2k_Utils.GetStringFromIntPtr(ptransactionControlNumber, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(ptransactionControlNumber);
            }
            else this.transactionControlNumber = null;
            if (ptransactionControlReference != IntPtr.Zero)
            {
                this.transactionControlReference = An2k_Utils.GetStringFromIntPtr(ptransactionControlReference, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(ptransactionControlReference);
            }
            else this.transactionControlReference = null;
            if (pdomainName != IntPtr.Zero)
            {
                this.domainName = An2k_Utils.GetStringFromIntPtr(pdomainName, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdomainName);
            }
            else this.domainName = null;
            if (pdomainVersion != IntPtr.Zero)
            {
                this.domainVersion = An2k_Utils.GetStringFromIntPtr(pdomainVersion, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdomainVersion);
            }
            else this.domainVersion = null;
            if (pcharEncodeName != IntPtr.Zero)
            {
                this.charEncodeName = An2k_Utils.GetStringFromIntPtr(pcharEncodeName, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(pcharEncodeName);
            }
            else this.charEncodeName = null;
            if (pcharEncodeVersion != IntPtr.Zero)
            {
                this.charEncodeVersion = An2k_Utils.GetStringFromIntPtr(pcharEncodeVersion, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(pcharEncodeVersion);
            }
            else this.charEncodeVersion = null;
            if (pdestinationAgencyName != IntPtr.Zero)
            {
                this.destinationAgencyName = An2k_Utils.GetStringFromIntPtr(pdestinationAgencyName, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdestinationAgencyName);
            }
            else this.destinationAgencyName = null;
            if (poriginatingAgencyName != IntPtr.Zero)
            {
                this.originatingAgencyName = An2k_Utils.GetStringFromIntPtr(poriginatingAgencyName, 0);
                An2kdll_NetWrapper.free_ANSI_NIST_buffer(poriginatingAgencyName);
            }
            else this.originatingAgencyName = null;
            this.aps = An2k2011_ApplicationProfile.FromCArrayToNetArray(ppAps, ApsNum);
            if (aps != null)
            {
                Marshal.FreeHGlobal(pAps); Marshal.FreeHGlobal(ppAps);
            }

            /////////////////////////////////
            // check retval
            /////////////////////////////////
			if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
			{
				An2k_Engine_NetWrapper.GB_AN_ENGINE_Free(this.buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
				this.Init();
				return RetVal;
			}
			if (version < 500)
			{
				An2k_Engine_NetWrapper.GB_AN_ENGINE_Free(this.buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
				this.Init();
				return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
			}
			this.dateOfTransaction = new An2k2011_Date();
			dateOfTransaction.FromCStruct(d);
			this.gmt = new An2k2011_Gmt();
			gmt.FromCStruct(g);
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}

		/// <summary>
		/// see "GB_AN2011_GetType1RecordInfo" in C library 
		/// </summary>
		/// <param name="AnVersion"></param>
		/// <param name="Tot"></param>
		/// <param name="Dat"></param>
		/// <param name="Pry"></param>
		/// <param name="DestAgency"></param>
		/// <param name="OrigAgency"></param>
		/// <param name="TransContrNum"></param>
		/// <param name="TransContrRef"></param>
		/// <param name="NativeScanRes"></param>
		/// <param name="NominalTxRes"></param>
		/// <param name="DomainName"></param>
		/// <param name="DomainVersion"></param>
		/// <param name="Gmt"></param>
		/// <param name="CharEncIndex"></param>
		/// <param name="CharEncName"></param>
		/// <param name="CharEncVersion"></param>
		/// <param name="Aps"></param>
		/// <param name="DestAgName"></param>
		/// <param name="OrigAgName"></param>
		/// <returns>see NW_AN2K_ERRORS class</returns>
		public int GetInfo(out int AnVersion,
			out String Tot, out An2k2011_Date Dat, out int Pry,
			out String DestAgency, out String OrigAgency,
			out String TransContrNum, out String TransContrRef,
			out float NativeScanRes, out float NominalTxRes,
			out String DomainName, out String DomainVersion, out An2k2011_Gmt Gmt,
			out int CharEncIndex, out String CharEncName, out String CharEncVersion,
			out An2k2011_ApplicationProfile[] Aps,
			out String DestAgName, out String OrigAgName
			)
		{
			AnVersion = 0;
			Tot = null;
			Dat = null;
			Pry = -1;
			DestAgency = null;
			OrigAgency = null;
			TransContrNum = null;
			TransContrRef = null;
			NativeScanRes = -1;
			NominalTxRes = -1;
			DomainName = null;
			DomainVersion = null;
			Gmt = null;
			CharEncIndex = -1;
			CharEncName = null;
			CharEncVersion = null;
			Aps = null;
			DestAgName = null;
			OrigAgName = null;
			try
			{
				An2kEngineNw_Record app = this.GetRecordFromListAtIndex(0);
				if (app == null || app.recordType != 1)
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				}
				int ApsNum;
				An2k2011_DateStruct d = new An2k2011_DateStruct();
				An2k2011_GmtStruct g = new An2k2011_GmtStruct();
				IntPtr pAps = new IntPtr(), ppAps = An2k_Utils.MarshalToPointer(pAps);
				if (ppAps == IntPtr.Zero)
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pTot = new IntPtr(), ppTot = An2k_Utils.MarshalToPointer(pTot);
                if (ppTot == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pdestinationAgency = new IntPtr(), ppdestinationAgency = An2k_Utils.MarshalToPointer(pdestinationAgency);
                if (ppdestinationAgency == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr poriginatingAgency = new IntPtr(), pporiginatingAgency = An2k_Utils.MarshalToPointer(poriginatingAgency);
                if (pporiginatingAgency == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr ptransactionControlNumber = new IntPtr(), pptransactionControlNumber = An2k_Utils.MarshalToPointer(ptransactionControlNumber);
                if (pptransactionControlNumber == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr ptransactionControlReference = new IntPtr(), pptransactionControlReference = 
                    An2k_Utils.MarshalToPointer(ptransactionControlReference);
                if (pptransactionControlReference == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pdomainName = new IntPtr(), ppdomainName = An2k_Utils.MarshalToPointer(pdomainName);
                if (ppdomainName == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pdomainVersion = new IntPtr(), ppdomainVersion = An2k_Utils.MarshalToPointer(pdomainVersion);
                if (ppdomainVersion == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pcharEncodeName = new IntPtr(), ppcharEncodeName = An2k_Utils.MarshalToPointer(pcharEncodeName);
                if (ppcharEncodeName == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pcharEncodeVersion = new IntPtr(), ppcharEncodeVersion = An2k_Utils.MarshalToPointer(pcharEncodeVersion);
                if (ppcharEncodeVersion == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pdestinationAgencyName = new IntPtr(), ppdestinationAgencyName = An2k_Utils.MarshalToPointer(pdestinationAgencyName);
                if (ppdestinationAgencyName == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr poriginatingAgencyName = new IntPtr(), pporiginatingAgencyName = An2k_Utils.MarshalToPointer(poriginatingAgencyName);
                if (pporiginatingAgencyName == IntPtr.Zero)
                {
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
				int RetVal = An2k2011_NetWrapper.GB_AN2011_GetType1RecordInfo(
					app.GetBuffer(), // RECORD*
					out AnVersion,
					ppTot,
					ref d, //GB_AN2011_DateStruct*
					out Pry,
					ppdestinationAgency,
					pporiginatingAgency,
					pptransactionControlNumber,
					pptransactionControlReference,
					out NativeScanRes,
					out NominalTxRes,
					ppdomainName,
					ppdomainVersion,
					ref g, // GB_AN2011_GmtStruct* 
					out CharEncIndex,
					ppcharEncodeName,
					ppcharEncodeVersion,
					ppAps, // GB_AN2011_ApplicationProfileStruct**
					out ApsNum,
					ppdestinationAgencyName,
					pporiginatingAgencyName
                    );
                /////////////////////////////////
                // get externally allocated
                // values
                /////////////////////////////////
                pTot = (IntPtr)(An2k_Utils.MarshalToStruct(ppTot, typeof(IntPtr)));
                Marshal.FreeHGlobal(ppTot);
                pdestinationAgency = (IntPtr)(An2k_Utils.MarshalToStruct(ppdestinationAgency, typeof(IntPtr)));
                Marshal.FreeHGlobal(ppdestinationAgency);
                poriginatingAgency = (IntPtr)(An2k_Utils.MarshalToStruct(pporiginatingAgency, typeof(IntPtr)));
                Marshal.FreeHGlobal(pporiginatingAgency);
                ptransactionControlNumber = (IntPtr)(An2k_Utils.MarshalToStruct(pptransactionControlNumber, typeof(IntPtr)));
                Marshal.FreeHGlobal(pptransactionControlNumber);
                ptransactionControlReference = (IntPtr)(An2k_Utils.MarshalToStruct(pptransactionControlReference, typeof(IntPtr)));
                Marshal.FreeHGlobal(pptransactionControlReference);
                pdomainName = (IntPtr)(An2k_Utils.MarshalToStruct(ppdomainName, typeof(IntPtr)));
                Marshal.FreeHGlobal(ppdomainName);
                pdomainVersion = (IntPtr)(An2k_Utils.MarshalToStruct(ppdomainVersion, typeof(IntPtr)));
                Marshal.FreeHGlobal(ppdomainVersion);
                pcharEncodeName = (IntPtr)(An2k_Utils.MarshalToStruct(ppcharEncodeName, typeof(IntPtr)));
                Marshal.FreeHGlobal(ppcharEncodeName);
                pcharEncodeVersion = (IntPtr)(An2k_Utils.MarshalToStruct(ppcharEncodeVersion, typeof(IntPtr)));
                Marshal.FreeHGlobal(ppcharEncodeVersion);
                pdestinationAgencyName = (IntPtr)(An2k_Utils.MarshalToStruct(ppdestinationAgencyName, typeof(IntPtr)));
                Marshal.FreeHGlobal(ppdestinationAgencyName);
                poriginatingAgencyName = (IntPtr)(An2k_Utils.MarshalToStruct(pporiginatingAgencyName, typeof(IntPtr)));
                Marshal.FreeHGlobal(pporiginatingAgencyName);

                if (pTot != IntPtr.Zero)
                {
                    Tot = An2k_Utils.GetStringFromIntPtr(pTot, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pTot);
                }
                else Tot = null;
                if (pdestinationAgency != IntPtr.Zero)
                {
                    DestAgency = An2k_Utils.GetStringFromIntPtr(pdestinationAgency, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdestinationAgency);
                }
                else DestAgency = null;
                if (poriginatingAgency != IntPtr.Zero)
                {
                    OrigAgency = An2k_Utils.GetStringFromIntPtr(poriginatingAgency, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(poriginatingAgency);
                }
                else OrigAgency = null;

                if (ptransactionControlNumber != IntPtr.Zero)
                {
                    TransContrNum = An2k_Utils.GetStringFromIntPtr(ptransactionControlNumber, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(ptransactionControlNumber);
                }
                else TransContrNum = null;
                if (ptransactionControlReference != IntPtr.Zero)
                {
                    TransContrRef = An2k_Utils.GetStringFromIntPtr(ptransactionControlReference, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(ptransactionControlReference);
                }
                else TransContrRef = null;
                if (pdomainName != IntPtr.Zero)
                {
                    DomainName = An2k_Utils.GetStringFromIntPtr(pdomainName, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdomainName);
                }
                else DomainName = null;
                if (pdomainVersion != IntPtr.Zero)
                {
                    DomainVersion = An2k_Utils.GetStringFromIntPtr(pdomainVersion, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdomainVersion);
                }
                else DomainVersion = null;

                if (pcharEncodeName != IntPtr.Zero)
                {
                    CharEncName = An2k_Utils.GetStringFromIntPtr(pcharEncodeName, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pcharEncodeName);
                }
                else CharEncName = null;
                if (pcharEncodeVersion != IntPtr.Zero)
                {
                    CharEncVersion = An2k_Utils.GetStringFromIntPtr(pcharEncodeVersion, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pcharEncodeVersion);
                }
                else CharEncVersion = null;
                if (pdestinationAgencyName != IntPtr.Zero)
                {
                    DestAgName = An2k_Utils.GetStringFromIntPtr(pdestinationAgencyName, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pdestinationAgencyName);
                }
                else DestAgName = null;
                if (poriginatingAgencyName != IntPtr.Zero)
                {
                    OrigAgName = An2k_Utils.GetStringFromIntPtr(poriginatingAgencyName, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(poriginatingAgencyName);
                }
                else OrigAgName = null;
                this.aps = An2k2011_ApplicationProfile.FromCArrayToNetArray(ppAps, ApsNum);
                if (aps != null)
                {
                    Marshal.FreeHGlobal(pAps); Marshal.FreeHGlobal(ppAps);
                }

                /////////////////////////////////
                // check retval
                /////////////////////////////////
				if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					return RetVal;
				}

				Dat = new An2k2011_Date();
				Dat.FromCStruct(d);
				Gmt = new An2k2011_Gmt();
				Gmt.FromCStruct(g);
			}
			catch (Exception ex)
			{
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type1Record.GetInfo: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}

			this.version = AnVersion;
			this.dateOfTransaction = Dat;
			this.priority = Pry;
			this.typeOfTransaction = Tot;
			this.destinationAgency = DestAgency;
			this.originatingAgency = OrigAgency;
			this.transactionControlNumber = TransContrNum;
			this.transactionControlReference = TransContrRef;
			this.nativeScanResolution = NativeScanRes;
			this.nominalTransmitResolution = NominalTxRes;
			this.domainName = DomainName;
			this.domainVersion = DomainVersion;
			this.gmt = Gmt;
			this.charEncodeIndex = CharEncIndex;
			this.charEncodeName = CharEncName;
            this.charEncodeVersion = CharEncVersion;
			this.aps = Aps;
			this.destinationAgencyName = DestAgName;
			this.originatingAgencyName = OrigAgName;

			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}
	}

	/// <summary>
	/// class that represents a type-4 record
	/// </summary>
	public class An2k2011_Type4Record : An2kEngineNw_BinaryRecord
	{
		/// <summary>
		/// see "GB_AN2011_CreateType4Record" in C library
		/// </summary>
		/// <param name="idc"></param>
		/// <param name="impressionType"></param>
		/// <param name="fgp"></param>
		/// <param name="imageScanResolution"></param>
		/// <param name="horizontalNumberOfPixels"></param>
		/// <param name="verticalNumberOfPixels"></param>
		/// <param name="compressionAlgorithm"></param>
		/// <param name="imageBuffer"></param>
		/// <returns>see NW_AN2K_ERRORS class</returns>
		public int Create(int idc, int impressionType, byte fgp,
			int imageScanResolution, int horizontalNumberOfPixels, int verticalNumberOfPixels,
			int compressionAlgorithm, byte[] imageBuffer)
		{
			try
			{
				byte[] fgpArray = new byte[6];
				fgpArray[0] = fgp;
				for (int i = 1; i < 6; i++)
				{
					fgpArray[i] = 255;
				}
				return base.Create(4, idc, impressionType, fgpArray, imageScanResolution, horizontalNumberOfPixels, verticalNumberOfPixels,
					compressionAlgorithm, imageBuffer);
			}
			catch (Exception ex)
			{
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type4Record.Create: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
		}

		/// <summary>
		/// see "GB_AN2011_GetType4RecordInfo" in C library
		/// </summary>
		/// <param name="Idc"></param>
		/// <param name="ImpressionType"></param>
		/// <param name="Fgp"></param>
		/// <param name="ImageScanResolution"></param>
		/// <param name="HorizontalNumberOfPixels"></param>
		/// <param name="VerticalNumberOfPixels"></param>
		/// <param name="CompressionAlgorithm"></param>
		/// <param name="ImageBuffer"></param>
		/// <returns></returns>
		public int GetInfo(out int Idc, out int ImpressionType, out byte Fgp, out int ImageScanResolution,
			out int HorizontalNumberOfPixels, out int VerticalNumberOfPixels, out int CompressionAlgorithm,
			out byte[] ImageBuffer)
		{
			Idc = -1;
			ImpressionType = -1;
			Fgp = 0;
			ImageScanResolution = -1;
			HorizontalNumberOfPixels = -1;
			VerticalNumberOfPixels = -1;
			CompressionAlgorithm = -1;
			ImageBuffer = null;

			try
			{
				IntPtr ImagePtr = new IntPtr(), pImagePtr = An2k_Utils.MarshalToPointer(ImagePtr);
				if (pImagePtr == IntPtr.Zero)
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				int imageBufferLen;

				int RetVal = An2k2011_NetWrapper.GB_AN2011_GetType4RecordInfo(this.buffer, out Idc, out ImpressionType,
					out Fgp, out ImageScanResolution, out HorizontalNumberOfPixels, out VerticalNumberOfPixels,
					out CompressionAlgorithm, pImagePtr, out imageBufferLen);
				if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					return RetVal;
				}
				ImagePtr = (IntPtr)An2k_Utils.MarshalToStruct(pImagePtr, typeof(IntPtr));
				ImageBuffer = new Byte[imageBufferLen];
				if (ImageBuffer == null)
				{
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				Marshal.Copy(ImagePtr, ImageBuffer, 0, imageBufferLen);
				Marshal.FreeHGlobal(pImagePtr);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(ImagePtr);
			}
			catch (Exception ex)
			{
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type4Record.GetInfo: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
			this.recordCompressionAlgorithm = CompressionAlgorithm;
			this.recordFgp[0] = Fgp; for (int i = 1; i < 6; i++) this.recordFgp[i] = 255;
			this.recordHorizontalNumberOfPixels = HorizontalNumberOfPixels;
			this.recordIdc = Idc;
			this.recordImageBuffer = new byte[ImageBuffer.Length];
			if (recordImageBuffer == null)
			{
				return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
			}
			Array.Copy(ImageBuffer, this.recordImageBuffer, ImageBuffer.Length);
			this.recordImageScanResolution = ImageScanResolution;
			this.recordImpressionType = ImpressionType;
			this.recordType = 4;
			this.recordVerticalNumberOfPixels = VerticalNumberOfPixels;

			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}
	}

	/// <summary>
	/// class representing a print position descriptor
	/// see "GB_AN2011_PrintPositionDescriptorsStruct" 
	/// struct in C library
	/// </summary>
	public class An2k2011_PrintPositionDescriptors
	{
		public int DecimalFingerPosition;
		public string FingerImageCode;

		public An2k2011_PrintPositionDescriptorsStruct ToCStruct()
		{
			An2k2011_PrintPositionDescriptorsStruct ret = new An2k2011_PrintPositionDescriptorsStruct();
			ret.DecimalFingerPosition = DecimalFingerPosition;
			if (FingerImageCode!= null && FingerImageCode.Length > 9)
			{
				this.FingerImageCode = this.FingerImageCode.Substring(0, 9);
			}

			ret.FingerImageCode = string.Copy(this.FingerImageCode);
			return ret;
		}

		public void FromCStruct(An2k2011_PrintPositionDescriptorsStruct input)
		{
			this.DecimalFingerPosition = input.DecimalFingerPosition;
			if (input.FingerImageCode != null)
			{
				this.FingerImageCode = string.Copy(input.FingerImageCode);
				if (FingerImageCode.Length > 9)
				{
					this.FingerImageCode = this.FingerImageCode.Substring(0, 9);
				}
			}
			else
			{
				this.FingerImageCode = null;
			}
		}
	}

	/// <summary>
	/// class representing the print position coordinates
	/// see "GB_AN2011_PrintPositionCoordinatesStruct" 
	/// struct in C library
	/// </summary>
	public class An2k2011_PrintPositionCoordinates
	{
		public string FullFingerView;
		public string LocationOfASegment;
		public int LeftHorizontalCoordinate;
		public int RightHorizontalCoordinate;
		public int TopVerticalCoordinate;
		public int BottomVerticalCoordinate;

		public An2k2011_PrintPositionCoordinates()
		{
		}

		public An2k2011_PrintPositionCoordinates(string ffv, string los, int lhc, int rhc, int tvc, int bvc)
		{
			this.FullFingerView = ffv;
			this.LocationOfASegment = los;
			this.LeftHorizontalCoordinate = lhc;
			this.RightHorizontalCoordinate = rhc;
			this.TopVerticalCoordinate = tvc;
			this.BottomVerticalCoordinate = bvc;
		}

		public An2k2011_PrintPositionCoordinatesStruct ToCStruct()
		{
			An2k2011_PrintPositionCoordinatesStruct ret = new An2k2011_PrintPositionCoordinatesStruct();
			if (this.FullFingerView != null)
			{
				if (FullFingerView.Length > 9)
				{
					this.FullFingerView = this.FullFingerView.Substring(0, 9);
				}
				ret.FullFingerView = string.Copy(this.FullFingerView);
			}
			else
			{
				ret.FullFingerView = null;
			}
			if (this.LocationOfASegment != null)
			{
				if (LocationOfASegment.Length > 9)
				{
					this.LocationOfASegment = this.LocationOfASegment.Substring(0, 9);
				}
				ret.LocationOfASegment = string.Copy(this.LocationOfASegment);
			}
			else
			{
				ret.LocationOfASegment = null;
			}
			ret.LeftHorizontalCoordinate = this.LeftHorizontalCoordinate;
			ret.RightHorizontalCoordinate = this.RightHorizontalCoordinate;
			ret.TopVerticalCoordinate = this.TopVerticalCoordinate;
			ret.BottomVerticalCoordinate = this.BottomVerticalCoordinate;
			return ret;
		}

		public void FromCStruct(An2k2011_PrintPositionCoordinatesStruct input)
		{
			this.LeftHorizontalCoordinate = input.LeftHorizontalCoordinate;
			this.RightHorizontalCoordinate = input.RightHorizontalCoordinate;
			this.TopVerticalCoordinate = input.TopVerticalCoordinate;
			this.BottomVerticalCoordinate = input.BottomVerticalCoordinate;
			if (input.FullFingerView != null)
			{
				this.FullFingerView = string.Copy(input.FullFingerView);
				if (FullFingerView.Length > 9)
				{
					this.FullFingerView = this.FullFingerView.Substring(0, 9);
				}
			}
			else
			{
				this.FullFingerView = null;
			}

			if (input.LocationOfASegment != null)
			{
				this.LocationOfASegment = string.Copy(input.LocationOfASegment);
				if (LocationOfASegment.Length > 9)
				{
					this.LocationOfASegment = this.LocationOfASegment.Substring(0, 9);
				}
			}
			else
			{
				this.LocationOfASegment = null;
			}
		}

		public static An2k2011_PrintPositionCoordinatesStruct[] FromNetArrayToCArray(An2k2011_PrintPositionCoordinates[] ppc)
		{
			if (ppc == null || ppc.Length == 0) return null;
			An2k2011_PrintPositionCoordinatesStruct[] ret = new An2k2011_PrintPositionCoordinatesStruct[ppc.Length];
			for (int i = 0; i < ppc.Length; i++)
			{
				ret[i] = ppc[i].ToCStruct();
			}
			return ret;
		}

		public static An2k2011_PrintPositionCoordinates[] FromCArrayToNetArray(IntPtr ppcStructArray, int ppcStructArrayNum)
		{
			if (ppcStructArray == IntPtr.Zero || ppcStructArrayNum <= 0) return null;
			IntPtr[] ppcArray = new IntPtr[ppcStructArrayNum];
			if (ppcArray == null) return null;
			IntPtr ppcPointer = (IntPtr)(An2k_Utils.MarshalToStruct(ppcStructArray, typeof(IntPtr)));
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				ppcArray[i] = new IntPtr(
					ppcPointer.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_PrintPositionCoordinatesStruct))));
			}
			An2k2011_PrintPositionCoordinates[] a = new An2k2011_PrintPositionCoordinates[ppcStructArrayNum];
			if (a == null) return null;

			// create pointers
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				An2k2011_PrintPositionCoordinatesStruct ListElement =
					(An2k2011_PrintPositionCoordinatesStruct)(An2k_Utils.MarshalToStruct(
					ppcArray[i], typeof(An2k2011_PrintPositionCoordinatesStruct)));

				a[i] = new An2k2011_PrintPositionCoordinates();
				a[i].FromCStruct(ListElement);
			}
			return a;
		}
	}

	/// <summary>
	/// class representing an amputated/bandaged finger
	/// see "GB_AN2011_AmputatedBandagedCodeStruct" 
	/// struct in C library
	/// </summary>
	public class An2k2011_AmputatedBandagedCode
	{
		public int FrictionRidgePosition;
		public string AmpBandCode;

		public An2k2011_AmputatedBandagedCode()
		{
		}

		public An2k2011_AmputatedBandagedCode(int frp, string abc)
		{
			FrictionRidgePosition = frp;
			AmpBandCode = abc;
		}

		public An2k2011_AmputatedBandagedCodeStruct ToCStruct()
		{
			An2k2011_AmputatedBandagedCodeStruct ret = new An2k2011_AmputatedBandagedCodeStruct();
			ret.FrictionRidgePosition = FrictionRidgePosition;
			if (AmpBandCode != null)
			{
				if (AmpBandCode.Length > 9)
				{
					this.AmpBandCode = this.AmpBandCode.Substring(0, 9);
				}
				ret.AmpBandCode = string.Copy(this.AmpBandCode);
			}
			else
			{
				ret.AmpBandCode = null;
			}
			return ret;
		}

		public void FromCStruct(An2k2011_AmputatedBandagedCodeStruct input)
		{
			this.FrictionRidgePosition = input.FrictionRidgePosition;
			if (input.AmpBandCode != null)
			{
				this.AmpBandCode = string.Copy(input.AmpBandCode);
				if (AmpBandCode.Length > 9)
				{
					this.AmpBandCode = this.AmpBandCode.Substring(0, 9);
				}
			}
			else
			{
				this.AmpBandCode = null;
			}
		}

		public static An2k2011_AmputatedBandagedCodeStruct[] FromNetArrayToCArray(An2k2011_AmputatedBandagedCode[] ppc)
		{
			if (ppc == null || ppc.Length == 0) return null;
			An2k2011_AmputatedBandagedCodeStruct[] ret = new An2k2011_AmputatedBandagedCodeStruct[ppc.Length];
			if (ret == null) return null;
			for (int i = 0; i < ppc.Length; i++)
			{
				ret[i] = ppc[i].ToCStruct();
			}

			return ret;
		}

		public static An2k2011_AmputatedBandagedCode[] FromCArrayToNetArray(IntPtr ppcStructArray, int ppcStructArrayNum)
		{
			if (ppcStructArray == IntPtr.Zero || ppcStructArrayNum <= 0) return null;
			IntPtr[] ppcArray = new IntPtr[ppcStructArrayNum];
			if (ppcArray == null) return null;
			IntPtr ppcPointer = (IntPtr)(An2k_Utils.MarshalToStruct(ppcStructArray, typeof(IntPtr)));
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				ppcArray[i] = new IntPtr(
					ppcPointer.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_AmputatedBandagedCodeStruct))));
			}
			An2k2011_AmputatedBandagedCode[] a = new An2k2011_AmputatedBandagedCode[ppcStructArrayNum];
			if (a == null) return null;

			// create pointers
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				An2k2011_AmputatedBandagedCodeStruct ListElement =
					(An2k2011_AmputatedBandagedCodeStruct)(An2k_Utils.MarshalToStruct(
					ppcArray[i], typeof(An2k2011_AmputatedBandagedCodeStruct)));

				a[i] = new An2k2011_AmputatedBandagedCode();
				a[i].FromCStruct(ListElement);
			}
			return a;
		}
	}

	/// <summary>
	/// class representing a finger segment
	/// see "GB_AN2011_FingerSegmentPositionStruct" 
	/// struct in C library 
	/// </summary>
	public class An2k2011_FingerSegmentPosition
	{
		public int FrictionRidgePosition;
		public int LeftHorizontalCoordinate;
		public int RightHorizontalCoordinate;
		public int TopVerticalCoordinate;
		public int BottomVerticalCoordinate;

		public An2k2011_FingerSegmentPosition()
		{
		}

		public An2k2011_FingerSegmentPosition(int frp, int lhc, int rhc, int tvc, int bvc)
		{
			this.FrictionRidgePosition = frp;
			this.LeftHorizontalCoordinate = lhc;
			this.RightHorizontalCoordinate = rhc;
			this.TopVerticalCoordinate = tvc;
			this.BottomVerticalCoordinate = bvc;
		}

		public An2k2011_FingerSegmentPositionStruct ToCStruct()
		{
			An2k2011_FingerSegmentPositionStruct ret = new An2k2011_FingerSegmentPositionStruct();
			ret.FrictionRidgePosition = FrictionRidgePosition;
			ret.LeftHorizontalCoordinate = this.LeftHorizontalCoordinate;
			ret.RightHorizontalCoordinate = this.RightHorizontalCoordinate;
			ret.TopVerticalCoordinate = this.TopVerticalCoordinate;
			ret.BottomVerticalCoordinate = this.BottomVerticalCoordinate;
			return ret;
		}

		public void FromCStruct(An2k2011_FingerSegmentPositionStruct input)
		{
			this.FrictionRidgePosition = input.FrictionRidgePosition;
			this.LeftHorizontalCoordinate = input.LeftHorizontalCoordinate;
			this.RightHorizontalCoordinate = input.RightHorizontalCoordinate;
			this.TopVerticalCoordinate = input.TopVerticalCoordinate;
			this.BottomVerticalCoordinate = input.BottomVerticalCoordinate;
		}

		public static An2k2011_FingerSegmentPositionStruct[] FromNetArrayToCArray(An2k2011_FingerSegmentPosition[] ppc)
		{
			if (ppc == null || ppc.Length == 0) return null;
			An2k2011_FingerSegmentPositionStruct[] ret = new An2k2011_FingerSegmentPositionStruct[ppc.Length];
			if (ret == null) return null;
			for (int i = 0; i < ppc.Length; i++)
			{
				ret[i] = ppc[i].ToCStruct();
			}
			return ret;
		}

		public static An2k2011_FingerSegmentPosition[] FromCArrayToNetArray(IntPtr ppcStructArray, int ppcStructArrayNum)
		{
			if (ppcStructArray == IntPtr.Zero || ppcStructArrayNum <= 0) return null;
			IntPtr[] ppcArray = new IntPtr[ppcStructArrayNum];
			if (ppcArray == null) return null;
			IntPtr ppcPointer = (IntPtr)(An2k_Utils.MarshalToStruct(ppcStructArray, typeof(IntPtr)));
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				ppcArray[i] = new IntPtr(
					ppcPointer.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_FingerSegmentPositionStruct))));
			}
			An2k2011_FingerSegmentPosition[] a = new An2k2011_FingerSegmentPosition[ppcStructArrayNum];
			if (a == null) return null;

			// create pointers
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				An2k2011_FingerSegmentPositionStruct ListElement =
					(An2k2011_FingerSegmentPositionStruct)(An2k_Utils.MarshalToStruct(
					ppcArray[i], typeof(An2k2011_FingerSegmentPositionStruct)));

				a[i] = new An2k2011_FingerSegmentPosition();
				a[i].FromCStruct(ListElement);
			}
			return a;
		}
	}

	/// <summary>
	/// class representing the NIST finger quality assessment
	/// see "GB_AN2011_NistQualityMetricStruct" 
	/// struct in C library
	/// </summary>
	public class An2k2011_NistQualityMetric
	{
		public int FrictionRidgePosition;
		public int Quality;

		public An2k2011_NistQualityMetric()
		{
		}

		public An2k2011_NistQualityMetric(int frp, int abc)
		{
			FrictionRidgePosition = frp;
			Quality = abc;
		}

		public An2k2011_NistQualityMetricStruct ToCStruct()
		{
			An2k2011_NistQualityMetricStruct ret = new An2k2011_NistQualityMetricStruct();
			ret.FrictionRidgePosition = FrictionRidgePosition;
			ret.Quality = this.Quality;
			return ret;
		}

		public void FromCStruct(An2k2011_NistQualityMetricStruct input)
		{
			this.FrictionRidgePosition = input.FrictionRidgePosition;
			this.Quality = input.Quality;
		}

		public static An2k2011_NistQualityMetricStruct []FromNetArrayToCArray(An2k2011_NistQualityMetric[] ppc)
		{
			if (ppc == null || ppc.Length == 0) return null;
			An2k2011_NistQualityMetricStruct[] ret = new An2k2011_NistQualityMetricStruct[ppc.Length];
			if (ret == null) return null;
			for (int i = 0; i < ppc.Length; i++)
			{
				ret[i] = ppc[i].ToCStruct();
			}
			return ret;
		}

		public static An2k2011_NistQualityMetric[] FromCArrayToNetArray(IntPtr ppcStructArray, int ppcStructArrayNum)
		{
			if (ppcStructArray == IntPtr.Zero || ppcStructArrayNum <= 0) return null;
			IntPtr[] ppcArray = new IntPtr[ppcStructArrayNum];
			if (ppcArray == null) return null;
			IntPtr ppcPointer = (IntPtr)(An2k_Utils.MarshalToStruct(ppcStructArray, typeof(IntPtr)));
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				ppcArray[i] = new IntPtr(
					ppcPointer.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_NistQualityMetricStruct))));
			}
			An2k2011_NistQualityMetric[] a = new An2k2011_NistQualityMetric[ppcStructArrayNum];
			if (a == null) return null;

			// create pointers
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				An2k2011_NistQualityMetricStruct ListElement =
					(An2k2011_NistQualityMetricStruct)(An2k_Utils.MarshalToStruct(
					ppcArray[i], typeof(An2k2011_NistQualityMetricStruct)));

				a[i] = new An2k2011_NistQualityMetric();
				a[i].FromCStruct(ListElement);
			}
			return a;
		}
	}

	/// <summary>
	/// class representing the proprietary finger quality assessment
	/// see "GB_AN2011_FingerOrSegmentQualityMetricStruct" 
	/// struct in C library
	/// </summary>
	public class An2k2011_FingerOrSegmentQualityMetric
	{
		public int FrictionRidgePosition;
		public int Quality;
		public int AlgorithmVendorId;
		public int AlgorithmProductId;

		public An2k2011_FingerOrSegmentQualityMetric()
		{
		}

		public An2k2011_FingerOrSegmentQualityMetric(int frp, int abc, int avi, int api)
		{
			FrictionRidgePosition = frp;
			Quality = abc;
			AlgorithmVendorId = avi;
			AlgorithmProductId = api;
		}

		public An2k2011_FingerOrSegmentQualityMetricStruct ToCStruct()
		{
			An2k2011_FingerOrSegmentQualityMetricStruct ret = new An2k2011_FingerOrSegmentQualityMetricStruct();
			ret.FrictionRidgePosition = FrictionRidgePosition;
			ret.AlgorithmVendorId = AlgorithmVendorId;
			ret.AlgorithmProductId = AlgorithmProductId;
			ret.Quality = this.Quality;
			return ret;
		}

		public void FromCStruct(An2k2011_FingerOrSegmentQualityMetricStruct input)
		{
			this.FrictionRidgePosition = input.FrictionRidgePosition;
			this.Quality = input.Quality;
			this.AlgorithmVendorId = input.AlgorithmVendorId;
			this.AlgorithmProductId = input.AlgorithmProductId;
		}

		public static An2k2011_FingerOrSegmentQualityMetricStruct[] FromNetArrayToCArray(An2k2011_FingerOrSegmentQualityMetric[] ppc)
		{
			if (ppc == null || ppc.Length == 0) return null;
			An2k2011_FingerOrSegmentQualityMetricStruct[] ret = new An2k2011_FingerOrSegmentQualityMetricStruct[ppc.Length];
			if (ret == null) return null;
			for (int i = 0; i < ppc.Length; i++)
			{
				ret[i] = ppc[i].ToCStruct();

			}
			return ret;
		}

		public static An2k2011_FingerOrSegmentQualityMetric[] FromCArrayToNetArray(IntPtr ppcStructArray, int ppcStructArrayNum)
		{
			if (ppcStructArray == IntPtr.Zero || ppcStructArrayNum <= 0) return null;
			IntPtr[] ppcArray = new IntPtr[ppcStructArrayNum];
			if (ppcArray == null) return null;
			IntPtr ppcPointer = (IntPtr)(An2k_Utils.MarshalToStruct(ppcStructArray, typeof(IntPtr)));
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				ppcArray[i] = new IntPtr(
					ppcPointer.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_FingerOrSegmentQualityMetricStruct))));
			}
			An2k2011_FingerOrSegmentQualityMetric[] a = new An2k2011_FingerOrSegmentQualityMetric[ppcStructArrayNum];
			if (a == null) return null;

			// create pointers
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				An2k2011_FingerOrSegmentQualityMetricStruct ListElement =
					(An2k2011_FingerOrSegmentQualityMetricStruct)(An2k_Utils.MarshalToStruct(
					ppcArray[i], typeof(An2k2011_FingerOrSegmentQualityMetricStruct)));

				a[i] = new An2k2011_FingerOrSegmentQualityMetric();
				a[i].FromCStruct(ListElement);
			}
			return a;
		}
	}

	/// <summary>
	/// class representing the coordinates of the
	/// points for an alternate description of the
	/// finger segment
	/// see "GB_AN2011_PointOffsetStruct" 
	/// struct in C library
	/// </summary>
	public class An2k2011_PointOffset
	{
		public int HorizontalPointOffset;
		public int VerticalPointOffset;

		public An2k2011_PointOffset()
		{
		}

		public An2k2011_PointOffset(int hpo, int vpo)
		{
			HorizontalPointOffset = hpo;
			VerticalPointOffset = vpo;
		}

		public An2k2011_PointOffsetStruct ToCStruct()
		{
			An2k2011_PointOffsetStruct ret = new An2k2011_PointOffsetStruct();
			ret.HorizontalPointOffset = HorizontalPointOffset;
			ret.VerticalPointOffset = VerticalPointOffset;
			return ret;
		}

		public void FromCStruct(An2k2011_PointOffsetStruct input)
		{
			this.HorizontalPointOffset = input.HorizontalPointOffset;
			this.VerticalPointOffset = input.VerticalPointOffset;
		}
	}

	/// <summary>
	/// class representing the alternate description
	/// for finger segment
	/// see "GB_AN2011_AlternateSegmentPositionStruct" 
	/// struct in C library
	/// </summary>
	public class An2k2011_AlternateSegmentPosition
	{
		public int FrictionRidgePosition;
		public int NumberOfPoints;
		public An2k2011_PointOffset[] Points;

		public An2k2011_AlternateSegmentPosition()
		{
		}

		public An2k2011_AlternateSegmentPosition(int frp, An2k2011_PointOffset[] p)
		{
			FrictionRidgePosition = frp;
			if (p != null)
			{
				NumberOfPoints = p.Length;
				Points = p;
			}
			else
			{
				NumberOfPoints = 0;
				Points = null;
			}
		}

		public An2k2011_AlternateSegmentPositionStruct ToCStruct()
		{
			An2k2011_AlternateSegmentPositionStruct ret = new An2k2011_AlternateSegmentPositionStruct();
			ret.FrictionRidgePosition = FrictionRidgePosition;
			ret.NumberOfPoints = NumberOfPoints;
			if (NumberOfPoints > 0 && Points != null)
			{
				Byte[] App = new Byte[(Marshal.SizeOf(typeof(An2k2011_PointOffsetStruct))) * (NumberOfPoints)];
				// create pointers
				for (int i = 0; i < NumberOfPoints; i++)
				{
					An2k2011_PointOffsetStruct PoElement = Points[i].ToCStruct();

					IntPtr AppPtr = An2k_Utils.MarshalToPointer(PoElement);

					Marshal.Copy(AppPtr, App, (Marshal.SizeOf(typeof(An2k2011_PointOffsetStruct))) * i,
						(Marshal.SizeOf(typeof(An2k2011_PointOffsetStruct))));
				}

				ret.Points = Marshal.AllocHGlobal(App.Length);
				Marshal.Copy(App, 0, ret.Points, App.Length);
			}
			else
			{
				ret.Points = IntPtr.Zero;
				ret.NumberOfPoints = 0;
			}
			return ret;
		}

		public void FromCStruct(An2k2011_AlternateSegmentPositionStruct input)
		{
			this.FrictionRidgePosition = input.FrictionRidgePosition;
			this.NumberOfPoints = input.NumberOfPoints;
			if (NumberOfPoints > 0 && input.Points != IntPtr.Zero)
			{
				IntPtr[] pointsArray = new IntPtr[NumberOfPoints];
				for (int i = 0; i < NumberOfPoints; i++)
				{
					pointsArray[i] = new IntPtr(
						input.Points.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_PointOffsetStruct))));
				}
				this.Points = new An2k2011_PointOffset[NumberOfPoints];

				// create pointers
				for (int i = 0; i < NumberOfPoints; i++)
				{
					An2k2011_PointOffsetStruct ListElement =
						(An2k2011_PointOffsetStruct)(An2k_Utils.MarshalToStruct(pointsArray[i], typeof(An2k2011_PointOffsetStruct)));
					An2k2011_PointOffset PoElement = new An2k2011_PointOffset();
					PoElement.FromCStruct(ListElement);

					this.Points[i] = PoElement;
				}
			}
			else
			{
				this.Points = null;
				this.NumberOfPoints = 0;
			}
		}

		public static IntPtr FromNetArrayToCArray(An2k2011_AlternateSegmentPosition[] ppc)
		{
			if (ppc == null || ppc.Length == 0) return IntPtr.Zero;
			Byte[] App = new Byte[Marshal.SizeOf(typeof(An2k2011_AlternateSegmentPositionStruct)) * (ppc.Length)];
			if (App == null) return IntPtr.Zero;

			for (int i = 0; i < ppc.Length; i++)
			{
				An2k2011_AlternateSegmentPositionStruct arrElement = ppc[i].ToCStruct();

				IntPtr AppPtr = An2k_Utils.MarshalToPointer(arrElement);
				if (AppPtr == IntPtr.Zero) return IntPtr.Zero;

				Marshal.Copy(AppPtr, App, 0 + Marshal.SizeOf(arrElement) * i, Marshal.SizeOf(arrElement));

			}
			IntPtr ret = Marshal.AllocHGlobal(App.Length);
			if (ret == IntPtr.Zero) return IntPtr.Zero;
			Marshal.Copy(App, 0, ret, App.Length);

			return ret;
		}

		public static void FreeMemoryForAspArrayStruct(IntPtr pToAspStruct, int NumOfAspElements)
		{
			if (pToAspStruct == IntPtr.Zero || NumOfAspElements <= 0) return;
			IntPtr[] ppcArray = new IntPtr[NumOfAspElements];
			if (ppcArray == null) return;
			// create pointers
			for (int i = 0; i < NumOfAspElements; i++)
			{
				ppcArray[i] = new IntPtr(
					pToAspStruct.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_AlternateSegmentPositionStruct))));
			}

			for (int i = 0; i < NumOfAspElements; i++)
			{
				An2k2011_AlternateSegmentPositionStruct ListElement =
					(An2k2011_AlternateSegmentPositionStruct)(An2k_Utils.MarshalToStruct(
					ppcArray[i], typeof(An2k2011_AlternateSegmentPositionStruct)));
				Marshal.FreeHGlobal(ListElement.Points);
			}
			Marshal.FreeHGlobal(pToAspStruct);
			return;
		}

		public static An2k2011_AlternateSegmentPosition[] FromCArrayToNetArray(IntPtr ppcStructArray, int ppcStructArrayNum)
		{
			if (ppcStructArray == IntPtr.Zero || ppcStructArrayNum <= 0) return null;
			IntPtr[] ppcArray = new IntPtr[ppcStructArrayNum];
			if (ppcArray == null) return null;
			IntPtr ppcPointer = (IntPtr)(An2k_Utils.MarshalToStruct(ppcStructArray, typeof(IntPtr)));
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				ppcArray[i] = new IntPtr(
					ppcPointer.ToInt64() + (long)(i * Marshal.SizeOf(typeof(An2k2011_AlternateSegmentPositionStruct))));
			}
			An2k2011_AlternateSegmentPosition[] a = new An2k2011_AlternateSegmentPosition[ppcStructArrayNum];
			if (a == null) return null;

			// create pointers
			for (int i = 0; i < ppcStructArrayNum; i++)
			{
				An2k2011_AlternateSegmentPositionStruct ListElement =
					(An2k2011_AlternateSegmentPositionStruct)(An2k_Utils.MarshalToStruct(
					ppcArray[i], typeof(An2k2011_AlternateSegmentPositionStruct)));

				a[i] = new An2k2011_AlternateSegmentPosition();
				a[i].FromCStruct(ListElement);
			}
			return a;
		}
	}

	/// <summary>
	/// class that represents a type-14 record
	/// </summary>
	public class An2k2011_Type14Record : An2kEngineNw_TaggedRecord
	{
		public int impressionType;
		public String sourceAgency;
		public An2k2011_Date fingerprintCaptureDate;
		public int horizontalNumberOfPixels;
		public int verticalNumberOfPixels;
		public int scaleUnits;
		public int transmittedHorizontalPixelScale;
		public int transmittedVerticalPixelScale;
		public int compressionAlgorithm;
		int bitsPerPixel;
		public int fingerprintPosition;
		public An2k2011_PrintPositionDescriptors ppd;
		public An2k2011_PrintPositionCoordinates[] ppc;
		public int scannedHorizontalPixelScale;
		public int scannedVerticalPixelScale;
		public An2k2011_AmputatedBandagedCode[] amp;
		public String comment;
		public An2k2011_FingerSegmentPosition[] seg;
		public An2k2011_NistQualityMetric[] nqm;
		public An2k2011_FingerOrSegmentQualityMetric[] sqm;
		public An2k2011_FingerOrSegmentQualityMetric[] fqm;
		public An2k2011_AlternateSegmentPosition[] aseg;
		public int simultaneousCaptureFingerprint;
		public bool stitchedImageFlag;
		public String deviceMonitoringMode;
		public int fingerprintAcquisitionProfile;
		public byte[] imageBuffer;

		/// <summary>
		/// initializes the class properties
		/// </summary>
		public override void Init()
		{
			base.Init();
			this.recordType = 14;
			this.impressionType = -1;
			this.sourceAgency = null;
			this.fingerprintCaptureDate = null; ;
			this.horizontalNumberOfPixels = -1;
			this.verticalNumberOfPixels = -1;
			this.scaleUnits = -1;
			this.transmittedHorizontalPixelScale = -1;
			this.transmittedVerticalPixelScale = -1;
			this.compressionAlgorithm = -1;
			this.bitsPerPixel = -1;
			this.fingerprintPosition = -1;
			this.ppd = null;
			this.ppc = null;
			this.scannedHorizontalPixelScale = -1;
			this.scannedVerticalPixelScale = -1;
			this.amp = null;
			this.comment = null;
			this.seg = null;
			this.nqm = null;
			this.sqm = null;
			this.fqm = null;
			this.aseg = null;
			this.simultaneousCaptureFingerprint = -1;
			this.stitchedImageFlag = false;
			this.deviceMonitoringMode = null;
			this.fingerprintAcquisitionProfile = -1;
			this.imageBuffer = null;
		}

		/// <summary>
		/// see "GB_AN2011_CreateType14Record" in C library 
		/// </summary>
		/// <param name="Idc"></param>
		/// <param name="ImpressionType"></param>
		/// <param name="SourceAgency"></param>
		/// <param name="FingerprintCaptureDate"></param>
		/// <param name="HorizontalNumberOfPixels"></param>
		/// <param name="VerticalNumberOfPixels"></param>
		/// <param name="ScaleUnits"></param>
		/// <param name="TransmittedHorizontalPixelScale"></param>
		/// <param name="TransmittedVerticalPixelScale"></param>
		/// <param name="CompressionAlgorithm"></param>
		/// <param name="BitsPerPixel"></param>
		/// <param name="FingerprintPosition"></param>
		/// <param name="Ppd"></param>
		/// <param name="Ppc"></param>
		/// <param name="ScannedHorizontalPixelScale"></param>
		/// <param name="ScannedVerticalPixelScale"></param>
		/// <param name="Amp"></param>
		/// <param name="Comment"></param>
		/// <param name="Seg"></param>
		/// <param name="Nqm"></param>
		/// <param name="Sqm"></param>
		/// <param name="Fqm"></param>
		/// <param name="Aseg"></param>
		/// <param name="SimultaneousCaptureFingerprint"></param>
		/// <param name="StitchedImageFlag"></param>
		/// <param name="DeviceMonitoringMode"></param>
		/// <param name="FingerprintAcquisitionProfile"></param>
		/// <param name="ImageBuffer"></param>
		/// <returns>see NW_AN2K_ERRORS class</returns>
		public int Create(
			int Idc, int ImpressionType, String SourceAgency,
			An2k2011_Date FingerprintCaptureDate,
			int HorizontalNumberOfPixels, int VerticalNumberOfPixels,
			int ScaleUnits,
			int TransmittedHorizontalPixelScale, int TransmittedVerticalPixelScale,
			int CompressionAlgorithm, int BitsPerPixel,
			int FingerprintPosition,
			An2k2011_PrintPositionDescriptors Ppd,
			An2k2011_PrintPositionCoordinates[] Ppc,
			int ScannedHorizontalPixelScale,
			int ScannedVerticalPixelScale,
			An2k2011_AmputatedBandagedCode[] Amp,
			String Comment,
			An2k2011_FingerSegmentPosition[] Seg,
			An2k2011_NistQualityMetric[] Nqm,
			An2k2011_FingerOrSegmentQualityMetric[] Sqm,
			An2k2011_FingerOrSegmentQualityMetric[] Fqm,
			An2k2011_AlternateSegmentPosition[] Aseg,
			int SimultaneousCaptureFingerprint, bool StitchedImageFlag, String DeviceMonitoringMode,
			int FingerprintAcquisitionProfile,
			byte[] ImageBuffer
		)
		{
			try
			{
				// image
				IntPtr pBuffer = An2k_Utils.MarshalToPointer(this.buffer);
                // ver 3.3.0.0
                IntPtr ImagePtr = IntPtr.Zero;
                int ImageLen = 0;
                if (ImageBuffer == null)
                {
                    // only if amp is present and amp[0].code == UP
                    if (Amp == null || Amp.Length != 1 || (!( Amp[0].AmpBandCode.Equals("UP"))))
                    {
                        this.Init();
                        return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
                    }
                }
                else
                {
                    ImagePtr = Marshal.AllocHGlobal(ImageBuffer.Length);
                    if (ImagePtr == IntPtr.Zero)
                    {
                        this.Init();
                        return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                    }
                    ImageLen = ImageBuffer.Length;
                    Marshal.Copy(ImageBuffer, 0, ImagePtr, ImageBuffer.Length);
                }
                // end ver 3.3.0.0
				// ref
				An2k2011_DateStruct datC = FingerprintCaptureDate.ToCStruct();
				An2k2011_PrintPositionDescriptorsStruct ppdC;
                IntPtr pppdC;
                if (Ppd != null)
                {
                    ppdC = Ppd.ToCStruct();
                    pppdC = (IntPtr)An2k_Utils.MarshalToPointer(ppdC);
                }
                else
                {
                    pppdC = IntPtr.Zero;
                }
				// bool
				int sif = StitchedImageFlag ? 1 : 0;
				IntPtr asegArr = An2k2011_AlternateSegmentPosition.FromNetArrayToCArray(Aseg);
				int ppclen = (Ppc != null) ? Ppc.Length : 0;
				int amplen = (Amp != null) ? Amp.Length : 0;
				int seglen = (Seg != null) ? Seg.Length : 0;
				int nqmlen = (Nqm != null) ? Nqm.Length : 0;
				int sqmlen = (Sqm != null) ? Sqm.Length : 0;
				int fqmlen = (Fqm != null) ? Fqm.Length : 0;
				int aseglen = (Aseg != null) ? Aseg.Length : 0;

				// call C library
                int RetVal;
                if (Ppd != null)
                {
                    RetVal = An2k2011_NetWrapper.GB_AN2011_CreateType14Record(
                        pBuffer, Idc, ImpressionType, SourceAgency,
                        ref datC,
                        HorizontalNumberOfPixels, VerticalNumberOfPixels, ScaleUnits,
                        TransmittedHorizontalPixelScale, TransmittedVerticalPixelScale, CompressionAlgorithm,
                        BitsPerPixel, FingerprintPosition,
                        pppdC,
                        An2k2011_PrintPositionCoordinates.FromNetArrayToCArray(Ppc), ppclen,
                        ScannedHorizontalPixelScale, ScannedVerticalPixelScale,
                        An2k2011_AmputatedBandagedCode.FromNetArrayToCArray(Amp), amplen,
                        Comment,
                        An2k2011_FingerSegmentPosition.FromNetArrayToCArray(Seg), seglen,
                        An2k2011_NistQualityMetric.FromNetArrayToCArray(Nqm), nqmlen,
                        An2k2011_FingerOrSegmentQualityMetric.FromNetArrayToCArray(Sqm), sqmlen,
                        An2k2011_FingerOrSegmentQualityMetric.FromNetArrayToCArray(Fqm), fqmlen,
                        asegArr, aseglen,
                        SimultaneousCaptureFingerprint, sif, DeviceMonitoringMode,
                        FingerprintAcquisitionProfile, ImagePtr, ImageLen);
                }
                else
                {
                    RetVal = An2k2011_NetWrapper.GB_AN2011_CreateType14Record(
                        pBuffer, Idc, ImpressionType, SourceAgency,
                        ref datC,
                        HorizontalNumberOfPixels, VerticalNumberOfPixels, ScaleUnits,
                        TransmittedHorizontalPixelScale, TransmittedVerticalPixelScale, CompressionAlgorithm,
                        BitsPerPixel, FingerprintPosition,
                        pppdC,
                        An2k2011_PrintPositionCoordinates.FromNetArrayToCArray(Ppc), ppclen,
                        ScannedHorizontalPixelScale, ScannedVerticalPixelScale,
                        An2k2011_AmputatedBandagedCode.FromNetArrayToCArray(Amp), amplen,
                        Comment,
                        An2k2011_FingerSegmentPosition.FromNetArrayToCArray(Seg), seglen,
                        An2k2011_NistQualityMetric.FromNetArrayToCArray(Nqm), nqmlen,
                        An2k2011_FingerOrSegmentQualityMetric.FromNetArrayToCArray(Sqm), sqmlen,
                        An2k2011_FingerOrSegmentQualityMetric.FromNetArrayToCArray(Fqm), fqmlen,
                        asegArr, aseglen,
                        SimultaneousCaptureFingerprint, sif, DeviceMonitoringMode,
                        FingerprintAcquisitionProfile, ImagePtr, ImageBuffer.Length);
                }
				////////////////////////////////////////
				// free allocated memory
				////////////////////////////////////////
				if (asegArr != IntPtr.Zero)
				{
					An2k2011_AlternateSegmentPosition.FreeMemoryForAspArrayStruct(asegArr, Aseg.Length);
				}
				////////////////////////////////////////
				// check retval
				////////////////////////////////////////
				if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					this.Init();
					return RetVal;
				}
				this.buffer = (IntPtr)An2k_Utils.MarshalToStruct(pBuffer, typeof(IntPtr));
				Marshal.FreeHGlobal(pBuffer);
				if (this.buffer == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				}
			}
			catch (Exception ex)
			{
				this.Init();
                NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type4Record.Create: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
			this.recordType = 14;
			this.impressionType = ImpressionType;
			this.sourceAgency = SourceAgency;
			this.fingerprintCaptureDate = FingerprintCaptureDate;
			this.horizontalNumberOfPixels = HorizontalNumberOfPixels;
			this.verticalNumberOfPixels = VerticalNumberOfPixels;
			this.scaleUnits = ScaleUnits;
			this.transmittedHorizontalPixelScale = TransmittedHorizontalPixelScale;
			this.transmittedVerticalPixelScale = TransmittedVerticalPixelScale;
			this.compressionAlgorithm = CompressionAlgorithm;
			this.bitsPerPixel = BitsPerPixel;
			this.fingerprintPosition = FingerprintPosition;
			this.ppd = Ppd;
			this.ppc = Ppc;
			this.scannedHorizontalPixelScale = ScannedHorizontalPixelScale;
			this.scannedVerticalPixelScale = ScannedVerticalPixelScale;
			this.amp = Amp;
			this.comment = Comment;
			this.seg = Seg;
			this.nqm = Nqm;
			this.sqm = Sqm;
			this.fqm = Fqm;
			this.aseg = Aseg;
			this.simultaneousCaptureFingerprint = SimultaneousCaptureFingerprint;
			this.stitchedImageFlag = StitchedImageFlag;
			this.deviceMonitoringMode = DeviceMonitoringMode;
			this.fingerprintAcquisitionProfile = FingerprintAcquisitionProfile;
			this.imageBuffer = ImageBuffer;
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}

		/// <summary>
		/// see "GB_AN2011_GetType14RecordInfo" in C library 
		/// </summary>
		/// <param name="Idc"></param>
		/// <param name="ImpressionType"></param>
		/// <param name="SourceAgency"></param>
		/// <param name="FingerprintCaptureDate"></param>
		/// <param name="HorizontalNumberOfPixels"></param>
		/// <param name="VerticalNumberOfPixels"></param>
		/// <param name="ScaleUnits"></param>
		/// <param name="TransmittedHorizontalPixelScale"></param>
		/// <param name="TransmittedVerticalPixelScale"></param>
		/// <param name="CompressionAlgorithm"></param>
		/// <param name="BitsPerPixel"></param>
		/// <param name="FingerprintPosition"></param>
		/// <param name="Ppd"></param>
		/// <param name="Ppc"></param>
		/// <param name="ScannedHorizontalPixelScale"></param>
		/// <param name="ScannedVerticalPixelScale"></param>
		/// <param name="Amp"></param>
		/// <param name="Comment"></param>
		/// <param name="Seg"></param>
		/// <param name="Nqm"></param>
		/// <param name="Sqm"></param>
		/// <param name="Fqm"></param>
		/// <param name="Aseg"></param>
		/// <param name="SimultaneousCaptureFingerprint"></param>
		/// <param name="StitchedImageFlag"></param>
		/// <param name="DeviceMonitoringMode"></param>
		/// <param name="FingerprintAcquisitionProfile"></param>
		/// <param name="ImageBuffer"></param>
		/// <returns>see NW_AN2K_ERRORS class</returns>
		public int GetInfo(
			out int Idc,
			out int ImpressionType,
			out String SourceAgency,
			out An2k2011_Date FingerprintCaptureDate,
			out int HorizontalNumberOfPixels,
			out int VerticalNumberOfPixels,
			out int ScaleUnits,
			out int TransmittedHorizontalPixelScale,
			out int TransmittedVerticalPixelScale,
			out int CompressionAlgorithm,
			out int BitsPerPixel,
			out int FingerprintPosition,
			out An2k2011_PrintPositionDescriptors Ppd,
			out An2k2011_PrintPositionCoordinates[] Ppc,
			out int ScannedHorizontalPixelScale,
			out int ScannedVerticalPixelScale,
			out An2k2011_AmputatedBandagedCode[] Amp,
			out String Comment, // String *
			out An2k2011_FingerSegmentPosition[] Seg,
			out An2k2011_NistQualityMetric[] Nqm,
			out An2k2011_FingerOrSegmentQualityMetric[] Sqm,
			out An2k2011_FingerOrSegmentQualityMetric[] Fqm,
			out An2k2011_AlternateSegmentPosition[] Aseg,
			out int SimultaneousCaptureFingerprint,
			out bool StitchedImageFlag,
			out String DeviceMonitoringMode,
			out int FingerprintAcquisitionProfile,
			out byte[] ImageBuffer)
		{
			Idc = -1; ImpressionType = -1; SourceAgency = null; FingerprintCaptureDate = null; HorizontalNumberOfPixels = -1;
			VerticalNumberOfPixels = -1; ScaleUnits = -1; TransmittedHorizontalPixelScale = -1;
			TransmittedVerticalPixelScale = -1; CompressionAlgorithm = -1; BitsPerPixel = -1; FingerprintPosition = -1;
			Ppd = null; Ppc = null; ScannedHorizontalPixelScale = -1; ScannedVerticalPixelScale = -1; Amp = null;
			Comment = null; Seg = null; Nqm = null; Sqm = null; Fqm = null; Aseg = null; SimultaneousCaptureFingerprint = -1;
			StitchedImageFlag = false; DeviceMonitoringMode = null; FingerprintAcquisitionProfile = -1; ImageBuffer = null;

			try
			{
				An2k2011_DateStruct d = new An2k2011_DateStruct();
				An2k2011_PrintPositionDescriptorsStruct p = new An2k2011_PrintPositionDescriptorsStruct();
				IntPtr pPpc = new IntPtr(), ppPpc = An2k_Utils.MarshalToPointer(pPpc); int pPpcNum;
				if (ppPpc == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr pAmp = new IntPtr(), ppAmp = An2k_Utils.MarshalToPointer(pAmp); int pAmpNum;
				if (ppAmp == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr pSeg = new IntPtr(), ppSeg = An2k_Utils.MarshalToPointer(pSeg); int pSegNum;
				if (ppSeg == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr pNqm = new IntPtr(), ppNqm = An2k_Utils.MarshalToPointer(pNqm); int pNqmNum;
				if (ppNqm == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr pSqm = new IntPtr(), ppSqm = An2k_Utils.MarshalToPointer(pSqm); int pSqmNum;
				if (ppSqm == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr pFqm = new IntPtr(), ppFqm = An2k_Utils.MarshalToPointer(pFqm); int pFqmNum;
				if (ppFqm == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr pAseg = new IntPtr(), ppAseg = An2k_Utils.MarshalToPointer(pAseg); int pAsegNum;
				if (ppAseg == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				int pStitchedImageFlag;
				IntPtr ImagePtr = new IntPtr(), pImagePtr = An2k_Utils.MarshalToPointer(ImagePtr);
				if (pImagePtr == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
                int pImageBufferLen;
                IntPtr pSourceAgency = new IntPtr(), ppSourceAgency = An2k_Utils.MarshalToPointer(pSourceAgency);
                if (ppSourceAgency == IntPtr.Zero)
                {
                    this.Init();
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pComment = new IntPtr(), ppComment = An2k_Utils.MarshalToPointer(pComment);
                if (ppComment == IntPtr.Zero)
                {
                    this.Init();
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pDeviceMonitoringMode = new IntPtr(), ppDeviceMonitoringMode = An2k_Utils.MarshalToPointer(pDeviceMonitoringMode);
                if (ppDeviceMonitoringMode == IntPtr.Zero)
                {
                    this.Init();
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }

				int RetVal = An2k2011_NetWrapper.GB_AN2011_GetType14RecordInfo(
					this.buffer, out Idc,
                    out ImpressionType, ppSourceAgency, ref d, out HorizontalNumberOfPixels, out VerticalNumberOfPixels,
					out ScaleUnits, out TransmittedHorizontalPixelScale, out TransmittedVerticalPixelScale,
					out CompressionAlgorithm, out BitsPerPixel, out FingerprintPosition,
					ref p,
					ppPpc, out pPpcNum, // GB_AN2011_PrintPositionCoordinatesStruct **
					out ScannedHorizontalPixelScale, out ScannedVerticalPixelScale,
					ppAmp, out pAmpNum, // GB_AN2011_AmputatedBandagedCodeStruct **
                    ppComment, // String *
					ppSeg, out pSegNum, // GB_AN2011_FingerSegmentPositionStruct **
					ppNqm, out pNqmNum, // GB_AN2011_NistQualityMetricStruct **
					ppSqm, out pSqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
					ppFqm, out pFqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
					ppAseg, out pAsegNum, // GB_AN2011_AlternateSegmentPositionStruct **
					out SimultaneousCaptureFingerprint, out pStitchedImageFlag, // BOOL 
                    ppDeviceMonitoringMode, // String *
					out FingerprintAcquisitionProfile,
					pImagePtr, out pImageBufferLen
					);
				if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					this.Init();
					return RetVal;
				}
				if (pStitchedImageFlag != 0) StitchedImageFlag = true;
				else StitchedImageFlag = false;

				ImagePtr = (IntPtr)An2k_Utils.MarshalToStruct(pImagePtr, typeof(IntPtr));
				ImageBuffer = new Byte[pImageBufferLen];
				if (ImageBuffer == null)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				Marshal.Copy(ImagePtr, ImageBuffer, 0, pImageBufferLen);
                pSourceAgency = (IntPtr)An2k_Utils.MarshalToStruct(ppSourceAgency, typeof(IntPtr));
                Marshal.FreeHGlobal(ppSourceAgency);
                if (pSourceAgency != IntPtr.Zero)
                {
                    SourceAgency = An2k_Utils.GetStringFromIntPtr(pSourceAgency, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pSourceAgency);
                }
                else SourceAgency = null;
                pComment = (IntPtr)An2k_Utils.MarshalToStruct(ppComment, typeof(IntPtr));
                Marshal.FreeHGlobal(ppComment);
                if (pComment != IntPtr.Zero)
                {
                    Comment = An2k_Utils.GetStringFromIntPtr(pComment, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pComment);
                }
                else Comment = null;
                pDeviceMonitoringMode = (IntPtr)An2k_Utils.MarshalToStruct(ppDeviceMonitoringMode, typeof(IntPtr));
                Marshal.FreeHGlobal(ppDeviceMonitoringMode);
                if (pDeviceMonitoringMode != IntPtr.Zero)
                {
                    DeviceMonitoringMode = An2k_Utils.GetStringFromIntPtr(pDeviceMonitoringMode, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pDeviceMonitoringMode);
                }
                else DeviceMonitoringMode = null;

				Ppd = new An2k2011_PrintPositionDescriptors();
				Ppd.FromCStruct(p);
				Ppc = An2k2011_PrintPositionCoordinates.FromCArrayToNetArray(ppPpc, pPpcNum);
				Amp = An2k2011_AmputatedBandagedCode.FromCArrayToNetArray(ppAmp, pAmpNum);
				Seg = An2k2011_FingerSegmentPosition.FromCArrayToNetArray(ppSeg, pSegNum);
				Nqm = An2k2011_NistQualityMetric.FromCArrayToNetArray(ppNqm, pNqmNum);
				Sqm = An2k2011_FingerOrSegmentQualityMetric.FromCArrayToNetArray(ppSqm, pSqmNum);
				Fqm = An2k2011_FingerOrSegmentQualityMetric.FromCArrayToNetArray(ppFqm, pFqmNum);
				Aseg = An2k2011_AlternateSegmentPosition.FromCArrayToNetArray(ppAseg, pAsegNum);

				//////////////////////////////////////
				// free allocated memory
				//////////////////////////////////////
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(ImagePtr);
				Marshal.FreeHGlobal(pImagePtr);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pPpc);
				Marshal.FreeHGlobal(ppPpc);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pAmp);
				Marshal.FreeHGlobal(ppAmp);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pSeg);
				Marshal.FreeHGlobal(ppSeg);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pNqm);
				Marshal.FreeHGlobal(ppNqm);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pSqm);
				Marshal.FreeHGlobal(ppSqm);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pFqm);
				Marshal.FreeHGlobal(ppFqm);
				An2k2011_NetWrapper.GB_AN2011_FreeAsegArray(pAseg, pAsegNum);
				Marshal.FreeHGlobal(ppAseg);
			}
			catch (Exception ex)
			{
				this.Init();
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type14Record.GetInfo: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
			this.recordType = 14; this.impressionType = ImpressionType;
			this.sourceAgency = SourceAgency; this.fingerprintCaptureDate = FingerprintCaptureDate;
			this.horizontalNumberOfPixels = HorizontalNumberOfPixels; this.verticalNumberOfPixels = VerticalNumberOfPixels;
			this.scaleUnits = ScaleUnits; this.transmittedHorizontalPixelScale = TransmittedHorizontalPixelScale;
			this.transmittedVerticalPixelScale = TransmittedVerticalPixelScale; this.compressionAlgorithm = CompressionAlgorithm;
			this.bitsPerPixel = BitsPerPixel; this.fingerprintPosition = FingerprintPosition;
			this.ppd = Ppd; this.ppc = Ppc;
			this.scannedHorizontalPixelScale = TransmittedHorizontalPixelScale;
			this.scannedVerticalPixelScale = TransmittedVerticalPixelScale;
			this.amp = Amp; this.comment = Comment;
			this.seg = Seg;
			this.nqm = Nqm;
			this.sqm = Sqm;
			this.fqm = Fqm;
			this.aseg = Aseg;
			this.simultaneousCaptureFingerprint = SimultaneousCaptureFingerprint;
			this.stitchedImageFlag = StitchedImageFlag;
			this.deviceMonitoringMode = DeviceMonitoringMode;
			this.fingerprintAcquisitionProfile = FingerprintAcquisitionProfile;
			this.imageBuffer = ImageBuffer;
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}
	}

	/// <summary>
	/// class that represents a type-15 record
	/// </summary>
	public class An2k2011_Type15Record : An2kEngineNw_TaggedRecord
	{
		public int impressionType;
		public String sourceAgency;
		public An2k2011_Date palmprintCaptureDate;
		public int horizontalNumberOfPixels;
		public int verticalNumberOfPixels;
		public int scaleUnits;
		public int transmittedHorizontalPixelScale;
		public int transmittedVerticalPixelScale;
		public int compressionAlgorithm;
		int bitsPerPixel;
		public int fingerprintPosition;
		public int scannedHorizontalPixelScale;
		public int scannedVerticalPixelScale;
		public An2k2011_AmputatedBandagedCode[] amp;
		public String comment;
		public An2k2011_FingerOrSegmentQualityMetric[] pqm;
		public String deviceMonitoringMode;
		public byte[] imageBuffer;

		/// <summary>
		/// initializes class properties
		/// </summary>
		public override void Init()
		{
			base.Init();
			this.recordType = 15;
			this.impressionType = -1;
			this.sourceAgency = null;
			this.palmprintCaptureDate = null; ;
			this.horizontalNumberOfPixels = -1;
			this.verticalNumberOfPixels = -1;
			this.scaleUnits = -1;
			this.transmittedHorizontalPixelScale = -1;
			this.transmittedVerticalPixelScale = -1;
			this.compressionAlgorithm = -1;
			this.bitsPerPixel = -1;
			this.fingerprintPosition = -1;
			this.scannedHorizontalPixelScale = -1;
			this.scannedVerticalPixelScale = -1;
			this.amp = null;
			this.comment = null;
			this.pqm = null;
			this.deviceMonitoringMode = null;
			this.imageBuffer = null;
		}
		
		/// <summary>
		/// see "GB_AN2011_CreateType15Record" in C library 
		/// </summary>
		/// <param name="Idc"></param>
		/// <param name="ImpressionType"></param>
		/// <param name="SourceAgency"></param>
		/// <param name="PalmprintCaptureDate"></param>
		/// <param name="HorizontalNumberOfPixels"></param>
		/// <param name="VerticalNumberOfPixels"></param>
		/// <param name="ScaleUnits"></param>
		/// <param name="TransmittedHorizontalPixelScale"></param>
		/// <param name="TransmittedVerticalPixelScale"></param>
		/// <param name="CompressionAlgorithm"></param>
		/// <param name="BitsPerPixel"></param>
		/// <param name="FingerprintPosition"></param>
		/// <param name="ScannedHorizontalPixelScale"></param>
		/// <param name="ScannedVerticalPixelScale"></param>
		/// <param name="Amp"></param>
		/// <param name="Comment"></param>
		/// <param name="Pqm"></param>
		/// <param name="DeviceMonitoringMode"></param>
		/// <param name="ImageBuffer"></param>
		/// <returns>see NW_AN2K_ERRORS class</returns>
		public int Create(
			int Idc, int ImpressionType, String SourceAgency,
			An2k2011_Date PalmprintCaptureDate,
			int HorizontalNumberOfPixels, int VerticalNumberOfPixels,
			int ScaleUnits,
			int TransmittedHorizontalPixelScale, int TransmittedVerticalPixelScale,
			int CompressionAlgorithm, int BitsPerPixel,
			int FingerprintPosition,
			int ScannedHorizontalPixelScale,
			int ScannedVerticalPixelScale,
			An2k2011_AmputatedBandagedCode[] Amp,
			String Comment,
			An2k2011_FingerOrSegmentQualityMetric[] Pqm,
			String DeviceMonitoringMode,
			byte[] ImageBuffer
		)
		{
			try
			{
				IntPtr pBuffer = An2k_Utils.MarshalToPointer(this.buffer);
				if (ImageBuffer == null)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				}
				IntPtr ImagePtr = Marshal.AllocHGlobal(ImageBuffer.Length);
				if (ImagePtr == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				Marshal.Copy(ImageBuffer, 0, ImagePtr, ImageBuffer.Length);
				int amplen = (Amp != null) ? Amp.Length : 0;
				int pqmlen = (Pqm != null) ? Pqm.Length : 0;

				An2k2011_DateStruct datC = PalmprintCaptureDate.ToCStruct();
				int RetVal = An2k2011_NetWrapper.GB_AN2011_CreateType15Record(
					pBuffer, Idc, ImpressionType, SourceAgency,
					ref datC,
					HorizontalNumberOfPixels, VerticalNumberOfPixels, ScaleUnits,
					TransmittedHorizontalPixelScale, TransmittedVerticalPixelScale, CompressionAlgorithm,
					BitsPerPixel, FingerprintPosition,
					ScannedHorizontalPixelScale, ScannedVerticalPixelScale,
					An2k2011_AmputatedBandagedCode.FromNetArrayToCArray(Amp), amplen,
					Comment,
					An2k2011_FingerOrSegmentQualityMetric.FromNetArrayToCArray(Pqm), pqmlen,
					DeviceMonitoringMode, ImagePtr, ImageBuffer.Length);
				//////////////////////////////////////////
				// free allocated memory
				//////////////////////////////////////////
				Marshal.FreeHGlobal(ImagePtr);
				//////////////////////////////////////////
				// check retval
				//////////////////////////////////////////
				if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					this.Init();
					return RetVal;
				}
				this.buffer = (IntPtr)An2k_Utils.MarshalToStruct(pBuffer, typeof(IntPtr));
				Marshal.FreeHGlobal(pBuffer);
				if (this.buffer == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_BAD_PARAMETER;
				}
			}
			catch (Exception ex)
			{
				this.Init();
                NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type15Record.Create: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
			this.recordType = 15;
			this.impressionType = ImpressionType;
			this.sourceAgency = SourceAgency;
			this.palmprintCaptureDate = PalmprintCaptureDate;
			this.horizontalNumberOfPixels = HorizontalNumberOfPixels;
			this.verticalNumberOfPixels = VerticalNumberOfPixels;
			this.scaleUnits = ScaleUnits;
			this.transmittedHorizontalPixelScale = TransmittedHorizontalPixelScale;
			this.transmittedVerticalPixelScale = TransmittedVerticalPixelScale;
			this.compressionAlgorithm = CompressionAlgorithm;
			this.bitsPerPixel = BitsPerPixel;
			this.fingerprintPosition = FingerprintPosition;
			this.scannedHorizontalPixelScale = ScannedHorizontalPixelScale;
			this.scannedVerticalPixelScale = ScannedVerticalPixelScale;
			this.amp = Amp;
			this.comment = Comment;
			this.pqm = Pqm;
			this.deviceMonitoringMode = DeviceMonitoringMode;
			this.imageBuffer = ImageBuffer;
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}

		/// <summary>
		/// see "GB_AN2011_GetType15RecordInfo" in C library 
		/// </summary>
		/// <param name="Idc"></param>
		/// <param name="ImpressionType"></param>
		/// <param name="SourceAgency"></param>
		/// <param name="PalmprintCaptureDate"></param>
		/// <param name="HorizontalNumberOfPixels"></param>
		/// <param name="VerticalNumberOfPixels"></param>
		/// <param name="ScaleUnits"></param>
		/// <param name="TransmittedHorizontalPixelScale"></param>
		/// <param name="TransmittedVerticalPixelScale"></param>
		/// <param name="CompressionAlgorithm"></param>
		/// <param name="BitsPerPixel"></param>
		/// <param name="FingerprintPosition"></param>
		/// <param name="ScannedHorizontalPixelScale"></param>
		/// <param name="ScannedVerticalPixelScale"></param>
		/// <param name="Amp"></param>
		/// <param name="Comment"></param>
		/// <param name="Pqm"></param>
		/// <param name="DeviceMonitoringMode"></param>
		/// <param name="ImageBuffer"></param>
		/// <returns>see NW_AN2K_ERRORS class</returns>
		public int GetInfo(
			out int Idc,
			out int ImpressionType,
			out String SourceAgency,
			out An2k2011_Date PalmprintCaptureDate,
			out int HorizontalNumberOfPixels,
			out int VerticalNumberOfPixels,
			out int ScaleUnits,
			out int TransmittedHorizontalPixelScale,
			out int TransmittedVerticalPixelScale,
			out int CompressionAlgorithm,
			out int BitsPerPixel,
			out int FingerprintPosition,
			out int ScannedHorizontalPixelScale,
			out int ScannedVerticalPixelScale,
			out An2k2011_AmputatedBandagedCode[] Amp,
			out String Comment, // String *
			out An2k2011_FingerOrSegmentQualityMetric[] Pqm,
			out String DeviceMonitoringMode,
			out byte[] ImageBuffer)
		{
			Idc = -1; ImpressionType = -1; SourceAgency = null; PalmprintCaptureDate = null; HorizontalNumberOfPixels = -1;
			VerticalNumberOfPixels = -1; ScaleUnits = -1; TransmittedHorizontalPixelScale = -1;
			TransmittedVerticalPixelScale = -1; CompressionAlgorithm = -1; BitsPerPixel = -1; FingerprintPosition = -1;
			ScannedHorizontalPixelScale = -1; ScannedVerticalPixelScale = -1; Amp = null;
			Comment = null; Pqm = null; DeviceMonitoringMode = null; ImageBuffer = null;

			try
			{
				An2k2011_DateStruct d = new An2k2011_DateStruct();
				IntPtr pAmp = new IntPtr(), ppAmp = An2k_Utils.MarshalToPointer(pAmp); int pAmpNum;
				if (ppAmp == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr pPqm = new IntPtr(), ppPqm = An2k_Utils.MarshalToPointer(pPqm); int pPqmNum;
				if (ppPqm == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				IntPtr ImagePtr = new IntPtr(), pImagePtr = An2k_Utils.MarshalToPointer(ImagePtr);
				if (pImagePtr == IntPtr.Zero)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
                int pImageBufferLen;
                IntPtr pSourceAgency = new IntPtr(), ppSourceAgency = An2k_Utils.MarshalToPointer(pSourceAgency);
                if (ppSourceAgency == IntPtr.Zero)
                {
                    this.Init();
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pComment = new IntPtr(), ppComment = An2k_Utils.MarshalToPointer(pComment);
                if (ppComment == IntPtr.Zero)
                {
                    this.Init();
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }
                IntPtr pDeviceMonitoringMode = new IntPtr(), ppDeviceMonitoringMode = An2k_Utils.MarshalToPointer(pDeviceMonitoringMode);
                if (ppDeviceMonitoringMode == IntPtr.Zero)
                {
                    this.Init();
                    return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
                }

				int RetVal = An2k2011_NetWrapper.GB_AN2011_GetType15RecordInfo(
					this.buffer, out Idc,
					out ImpressionType, ppSourceAgency, ref d, out HorizontalNumberOfPixels, out VerticalNumberOfPixels,
					out ScaleUnits, out TransmittedHorizontalPixelScale, out TransmittedVerticalPixelScale,
					out CompressionAlgorithm, out BitsPerPixel, out FingerprintPosition,
					out ScannedHorizontalPixelScale, out ScannedVerticalPixelScale,
					ppAmp, out pAmpNum, // GB_AN2011_AmputatedBandagedCodeStruct **
					ppComment, // String *
					ppPqm, out pPqmNum, // GB_AN2011_FingerOrSegmentQualityMetricStruct **
					ppDeviceMonitoringMode, // String *
					pImagePtr, out pImageBufferLen
					);
				if (RetVal != NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR)
				{
					this.Init();
					return RetVal;
                }
                pSourceAgency = (IntPtr)An2k_Utils.MarshalToStruct(ppSourceAgency, typeof(IntPtr));
                Marshal.FreeHGlobal(ppSourceAgency);
                if (pSourceAgency != IntPtr.Zero)
                {
                    SourceAgency = An2k_Utils.GetStringFromIntPtr(pSourceAgency, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pSourceAgency);
                }
                else SourceAgency = null;
                pComment = (IntPtr)An2k_Utils.MarshalToStruct(ppComment, typeof(IntPtr));
                Marshal.FreeHGlobal(ppComment);
                if (pComment != IntPtr.Zero)
                {
                    Comment = An2k_Utils.GetStringFromIntPtr(pComment, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pComment);
                }
                else Comment = null;
                pDeviceMonitoringMode = (IntPtr)An2k_Utils.MarshalToStruct(ppDeviceMonitoringMode, typeof(IntPtr));
                Marshal.FreeHGlobal(ppDeviceMonitoringMode);
                if (pDeviceMonitoringMode != IntPtr.Zero)
                {
                    DeviceMonitoringMode = An2k_Utils.GetStringFromIntPtr(pDeviceMonitoringMode, 0);
                    An2kdll_NetWrapper.free_ANSI_NIST_buffer(pDeviceMonitoringMode);
                }
                else DeviceMonitoringMode = null;

				ImagePtr = (IntPtr)An2k_Utils.MarshalToStruct(pImagePtr, typeof(IntPtr));
				ImageBuffer = new Byte[pImageBufferLen];
				if (ImageBuffer == null)
				{
					this.Init();
					return NW_AN2K_ERRORS.NW_AN2K_DLL_MEMORY;
				}
				Marshal.Copy(ImagePtr, ImageBuffer, 0, pImageBufferLen);

				Amp = An2k2011_AmputatedBandagedCode.FromCArrayToNetArray(ppAmp, pAmpNum);
				Pqm = An2k2011_FingerOrSegmentQualityMetric.FromCArrayToNetArray(ppPqm, pPqmNum);
				////////////////////////////////////////////////
				// free allocated memory
				////////////////////////////////////////////////
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(ImagePtr);
				Marshal.FreeHGlobal(pImagePtr);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pAmp);
				Marshal.FreeHGlobal(ppAmp);
				An2k2011_NetWrapper.GB_AN_ENGINE_FreeGenericMem(pPqm);
				Marshal.FreeHGlobal(ppPqm);
			}
			catch (Exception ex)
			{
				this.Init();
				NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION_STRING = "An2k2011_Type15Record.GetInfo: " + ex.Message;
				return NW_AN2K_ERRORS.NW_AN2K_DLL_EXCEPTION;
			}
			this.recordType = 15; this.impressionType = ImpressionType;
			this.sourceAgency = SourceAgency; this.palmprintCaptureDate = PalmprintCaptureDate;
			this.horizontalNumberOfPixels = HorizontalNumberOfPixels; this.verticalNumberOfPixels = VerticalNumberOfPixels;
			this.scaleUnits = ScaleUnits; this.transmittedHorizontalPixelScale = TransmittedHorizontalPixelScale;
			this.transmittedVerticalPixelScale = TransmittedVerticalPixelScale; this.compressionAlgorithm = CompressionAlgorithm;
			this.bitsPerPixel = BitsPerPixel; this.fingerprintPosition = FingerprintPosition;
			this.scannedHorizontalPixelScale = TransmittedHorizontalPixelScale;
			this.scannedVerticalPixelScale = TransmittedVerticalPixelScale;
			this.amp = Amp; this.comment = Comment;
			this.pqm = Pqm;
			this.deviceMonitoringMode = DeviceMonitoringMode;
			this.imageBuffer = ImageBuffer;
			return NW_AN2K_ERRORS.NW_AN2K_DLL_NO_ERROR;
		}
	}
}