using System;
using System.Runtime.InteropServices;

namespace GBFIR_NET_WRAPPER
{
	public class GBFIR_ReturnCodes
	{
		public const int GBFIR_RET_SUCCESS = 0;
		public const int GBFIR_RET_ERROR_PARAMETER = 1;
		public const int GBFIR_RET_ERROR_FIR_UNDEFINED = 2;
		public const int GBFIR_RET_ERROR_MEMORY = 3;
		public const int GBFIR_RET_ERROR_PARSING = 4;
	}

	public class GBFIR_Formats
	{
		public const int GBFIR_FORMAT_ISO = 1;
		public const int GBFIR_FORMAT_ANSI = 2;
	}

	public class GBFIR_Constants
	{
		public const int CBEFF_PRODUCT_ID_LEN = 4;
	}

	public class GBFIR_ScaleUnits
	{
		public const byte GBFIR_SU_PIXEL_PER_INCH = 0x01;
		public const byte GBFIR_SU_PIXEL_PER_CM = 0x02;
	}

	public class GBFIR_CompressionAlgorithms
	{
		public const byte GBFIR_CA_UNCOMPRESSED_NO_BIT_PACKING = 0;
		public const byte GBFIR_CA_UNCOMPRESSED_BIT_PACKED = 1;
		public const byte GBFIR_CA_COMPRESSED_WSQ = 2;
		public const byte GBFIR_CA_COMPRESSED_JPEG = 3;
		public const byte GBFIR_CA_COMPRESSED_JPEG2000 = 4;
		public const byte GBFIR_CA_PNG = 5;
	}

	public class GBFIR_FingerPositions
	{
		public const int GBFIR_FP_UNKNOWN = 0;
		public const int GBFIR_FP_RIGHT_THUMB = 1;
		public const int GBFIR_FP_RIGHT_INDEX = 2;
		public const int GBFIR_FP_RIGHT_MIDDLE = 3;
		public const int GBFIR_FP_RIGHT_RING = 4;
		public const int GBFIR_FP_RIGHT_LITTLE = 5;
		public const int GBFIR_FP_LEFT_THUMB = 6;
		public const int GBFIR_FP_LEFT_INDEX = 7;
		public const int GBFIR_FP_LEFT_MIDDLE = 8;
		public const int GBFIR_FP_LEFT_RING = 9;
		public const int GBFIR_FP_LEFT_LITTLE = 10;
		public const int GBFIR_FP_RIGHT_FOUR_FINGERS = 13;
		public const int GBFIR_FP_LEFT_FOUR_FINGERS = 14;
		public const int GBFIR_FP_TWO_THUMBS = 15;
	}

	public class GBFIR_Palmpositions
	{
		public const int GBFIR_PP_UNKNOWN_PALM = 20;
		public const int GBFIR_PP_RIGHT_FULL_PALM = 21;
		public const int GBFIR_PP_RIGHT_WRITERS_PALM = 22;
		public const int GBFIR_PP_LEFT_FULL_PALM = 23;
		public const int GBFIR_PP_LEFT_WRITERS_PALM = 24;
		public const int GBFIR_PP_RIGHT_LOWER_PALM = 25;
		public const int GBFIR_PP_RIGHT_UPPER_PALM = 26;
		public const int GBFIR_PP_LEFT_LOWER_PALM = 27;
		public const int GBFIR_PP_LEFT_UPPER_PALM = 28;
		public const int GBFIR_PP_RIGHT_OTHER = 29;
		public const int GBFIR_PP_LEFT_OTHER = 30;
		public const int GBFIR_PP_RIGHT_INTERDIGITAL = 31;
		public const int GBFIR_PP_RIGHT_THENAR = 32;
		public const int GBFIR_PP_RIGHT_HYPOTHENAR = 33;
		public const int GBFIR_PP_LEFT_INTERDIGITAL = 34;
		public const int GBFIR_PP_LEFT_THENAR = 35;
		public const int GBFIR_PP_LEFT_HYPOTHENAR = 36;
	}

	public class GBFIR_ImpressionTypes
	{
		public const int GBFIR_IT_LIVE_SCAN_PLAIN = 0;
		public const int GBFIR_IT_LIVE_SCAN_ROLLED = 1;
		public const int GBFIR_IT_NONLIVE_SCAN_PLAIN = 2;
		public const int GBFIR_IT_NONLIVE_SCAN_ROLLED = 3;
		public const int GBFIR_IT_LATENT = 7;
		public const int GBFIR_IT_SWIPE = 8;
		public const int GBFIR_IT_LIVE_SCAN_CONTACTLESS = 9;
	}

	public class GBFIR_DllWrapper
	{

		public GBFIR_DllWrapper ()
		{
			
		}

		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_CreateFIR")]
		public static extern int GBFIR_CreateFIR (
			int Type, 
			ushort ImageAcquisitionLevel,
			IntPtr CBEFFProductId, 
			ushort CaptureDeviceID, 
			byte ScaleUnits, 
			ushort ScanResolutionH,
			ushort ScanResolutionV,
			ushort ImageResolutionH,
			ushort ImageResolutionV,
			byte PixelDepth,
			byte ImageCompressionAlgorithm);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_AddImageToFIR")]
		public static extern int GBFIR_AddImageToFIR(IntPtr ImageBuffer, 
			int BufferLen, int ImageWidth, int ImageHeight, 
			byte CountView, 
			byte ViewNumber,
			int ImageQuality, int FingerPosition, int ImpressionType);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_GetFIRLen")]
		public static extern int GBFIR_GetFIRLen();
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_WriteFIRToBuffer")]
		public static extern int GBFIR_WriteFIRToBuffer(IntPtr FIRBuffer);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_ReadFIRFromBuffer")]
		public static extern int GBFIR_ReadFIRFromBuffer(
			IntPtr FIRBuffer, int BufferLen, int Type);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_GetFIRHeaderFields")]
		public static extern int GBFIR_GetFIRHeaderFields(
			out ushort ImageAcquisitionLevel,
			IntPtr CBEFFProductId, out ushort CaptureDeviceID,
			out byte ScaleUnits, 
			out ushort ScanResolutionH,out ushort ScanResolutionV,
			out ushort ImageResolutionH,out ushort ImageResolutionV,
			out byte PixelDepth, out byte ImageCompressionAlgorithm);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_GetNumberOfFingers")]
		public static extern int GBFIR_GetNumberOfFingers ();
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_GetFingerRecordHeaderFields")]
		public static extern int GBFIR_GetFingerRecordHeaderFields(
			int Index, 
			out byte CountView, 
			out byte ViewNumber, 
			out int ImageQuality,
			out int FingerPosition,
			out int ImpressionType);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_GetFingerImageSize")]
		public static extern int GBFIR_GetFingerImageSize (int Index, out int ImageBufferSize);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_GetFingerImage")]
		public static extern int GBFIR_GetFingerImage(
			int Index, IntPtr ImageBuffer, 
			out int ImageWidth, out int ImaheHeight);
		
		[DllImport("GBFIR.dll", EntryPoint = "GBFIR_FreeFIR")]
		public static extern void GBFIR_FreeFIR (); 
	}
}

